(function(global2, factory) {
  typeof exports === "object" && typeof module !== "undefined" ? factory(exports) : typeof define === "function" && define.amd ? define(["exports"], factory) : (global2 = typeof globalThis !== "undefined" ? globalThis : global2 || self, factory(global2.highlightSearch = {}));
})(this, function(exports2) {
  "use strict";var __defProp = Object.defineProperty;
var __defNormalProp = (obj, key, value) => key in obj ? __defProp(obj, key, { enumerable: true, configurable: true, writable: true, value }) : obj[key] = value;
var __publicField = (obj, key, value) => {
  __defNormalProp(obj, typeof key !== "symbol" ? key + "" : key, value);
  return value;
};

  /**
  * @vue/shared v3.4.15
  * (c) 2018-present Yuxi (Evan) You and Vue contributors
  * @license MIT
  **/
  function makeMap(str, expectsLowerCase) {
    const set2 = new Set(str.split(","));
    return expectsLowerCase ? (val) => set2.has(val.toLowerCase()) : (val) => set2.has(val);
  }
  const EMPTY_OBJ = !!(process.env.NODE_ENV !== "production") ? Object.freeze({}) : {};
  const EMPTY_ARR = !!(process.env.NODE_ENV !== "production") ? Object.freeze([]) : [];
  const NOOP = () => {
  };
  const NO = () => false;
  const isOn = (key) => key.charCodeAt(0) === 111 && key.charCodeAt(1) === 110 && // uppercase letter
  (key.charCodeAt(2) > 122 || key.charCodeAt(2) < 97);
  const isModelListener = (key) => key.startsWith("onUpdate:");
  const extend = Object.assign;
  const remove = (arr, el) => {
    const i2 = arr.indexOf(el);
    if (i2 > -1) {
      arr.splice(i2, 1);
    }
  };
  const hasOwnProperty$1 = Object.prototype.hasOwnProperty;
  const hasOwn = (val, key) => hasOwnProperty$1.call(val, key);
  const isArray = Array.isArray;
  const isMap = (val) => toTypeString(val) === "[object Map]";
  const isSet = (val) => toTypeString(val) === "[object Set]";
  const isFunction = (val) => typeof val === "function";
  const isString = (val) => typeof val === "string";
  const isSymbol = (val) => typeof val === "symbol";
  const isObject = (val) => val !== null && typeof val === "object";
  const isPromise = (val) => {
    return (isObject(val) || isFunction(val)) && isFunction(val.then) && isFunction(val.catch);
  };
  const objectToString = Object.prototype.toString;
  const toTypeString = (value) => objectToString.call(value);
  const toRawType = (value) => {
    return toTypeString(value).slice(8, -1);
  };
  const isPlainObject = (val) => toTypeString(val) === "[object Object]";
  const isIntegerKey = (key) => isString(key) && key !== "NaN" && key[0] !== "-" && "" + parseInt(key, 10) === key;
  const isReservedProp = /* @__PURE__ */ makeMap(
    // the leading comma is intentional so empty string "" is also included
    ",key,ref,ref_for,ref_key,onVnodeBeforeMount,onVnodeMounted,onVnodeBeforeUpdate,onVnodeUpdated,onVnodeBeforeUnmount,onVnodeUnmounted"
  );
  const isBuiltInDirective = /* @__PURE__ */ makeMap(
    "bind,cloak,else-if,else,for,html,if,model,on,once,pre,show,slot,text,memo"
  );
  const cacheStringFunction = (fn2) => {
    const cache = /* @__PURE__ */ Object.create(null);
    return (str) => {
      const hit = cache[str];
      return hit || (cache[str] = fn2(str));
    };
  };
  const camelizeRE = /-(\w)/g;
  const camelize = cacheStringFunction((str) => {
    return str.replace(camelizeRE, (_2, c2) => c2 ? c2.toUpperCase() : "");
  });
  const hyphenateRE = /\B([A-Z])/g;
  const hyphenate = cacheStringFunction(
    (str) => str.replace(hyphenateRE, "-$1").toLowerCase()
  );
  const capitalize = cacheStringFunction((str) => {
    return str.charAt(0).toUpperCase() + str.slice(1);
  });
  const toHandlerKey = cacheStringFunction((str) => {
    const s2 = str ? `on${capitalize(str)}` : ``;
    return s2;
  });
  const hasChanged = (value, oldValue) => !Object.is(value, oldValue);
  const invokeArrayFns = (fns, arg) => {
    for (let i2 = 0; i2 < fns.length; i2++) {
      fns[i2](arg);
    }
  };
  const def = (obj, key, value) => {
    Object.defineProperty(obj, key, {
      configurable: true,
      enumerable: false,
      value
    });
  };
  const looseToNumber = (val) => {
    const n2 = parseFloat(val);
    return isNaN(n2) ? val : n2;
  };
  let _globalThis;
  const getGlobalThis = () => {
    return _globalThis || (_globalThis = typeof globalThis !== "undefined" ? globalThis : typeof self !== "undefined" ? self : typeof window !== "undefined" ? window : typeof global !== "undefined" ? global : {});
  };
  function normalizeStyle(value) {
    if (isArray(value)) {
      const res = {};
      for (let i2 = 0; i2 < value.length; i2++) {
        const item = value[i2];
        const normalized = isString(item) ? parseStringStyle(item) : normalizeStyle(item);
        if (normalized) {
          for (const key in normalized) {
            res[key] = normalized[key];
          }
        }
      }
      return res;
    } else if (isString(value) || isObject(value)) {
      return value;
    }
  }
  const listDelimiterRE = /;(?![^(]*\))/g;
  const propertyDelimiterRE = /:([^]+)/;
  const styleCommentRE = /\/\*[^]*?\*\//g;
  function parseStringStyle(cssText) {
    const ret = {};
    cssText.replace(styleCommentRE, "").split(listDelimiterRE).forEach((item) => {
      if (item) {
        const tmp = item.split(propertyDelimiterRE);
        tmp.length > 1 && (ret[tmp[0].trim()] = tmp[1].trim());
      }
    });
    return ret;
  }
  function normalizeClass(value) {
    let res = "";
    if (isString(value)) {
      res = value;
    } else if (isArray(value)) {
      for (let i2 = 0; i2 < value.length; i2++) {
        const normalized = normalizeClass(value[i2]);
        if (normalized) {
          res += normalized + " ";
        }
      }
    } else if (isObject(value)) {
      for (const name in value) {
        if (value[name]) {
          res += name + " ";
        }
      }
    }
    return res.trim();
  }
  const HTML_TAGS = "html,body,base,head,link,meta,style,title,address,article,aside,footer,header,hgroup,h1,h2,h3,h4,h5,h6,nav,section,div,dd,dl,dt,figcaption,figure,picture,hr,img,li,main,ol,p,pre,ul,a,b,abbr,bdi,bdo,br,cite,code,data,dfn,em,i,kbd,mark,q,rp,rt,ruby,s,samp,small,span,strong,sub,sup,time,u,var,wbr,area,audio,map,track,video,embed,object,param,source,canvas,script,noscript,del,ins,caption,col,colgroup,table,thead,tbody,td,th,tr,button,datalist,fieldset,form,input,label,legend,meter,optgroup,option,output,progress,select,textarea,details,dialog,menu,summary,template,blockquote,iframe,tfoot";
  const SVG_TAGS = "svg,animate,animateMotion,animateTransform,circle,clipPath,color-profile,defs,desc,discard,ellipse,feBlend,feColorMatrix,feComponentTransfer,feComposite,feConvolveMatrix,feDiffuseLighting,feDisplacementMap,feDistantLight,feDropShadow,feFlood,feFuncA,feFuncB,feFuncG,feFuncR,feGaussianBlur,feImage,feMerge,feMergeNode,feMorphology,feOffset,fePointLight,feSpecularLighting,feSpotLight,feTile,feTurbulence,filter,foreignObject,g,hatch,hatchpath,image,line,linearGradient,marker,mask,mesh,meshgradient,meshpatch,meshrow,metadata,mpath,path,pattern,polygon,polyline,radialGradient,rect,set,solidcolor,stop,switch,symbol,text,textPath,title,tspan,unknown,use,view";
  const MATH_TAGS = "annotation,annotation-xml,maction,maligngroup,malignmark,math,menclose,merror,mfenced,mfrac,mfraction,mglyph,mi,mlabeledtr,mlongdiv,mmultiscripts,mn,mo,mover,mpadded,mphantom,mprescripts,mroot,mrow,ms,mscarries,mscarry,msgroup,msline,mspace,msqrt,msrow,mstack,mstyle,msub,msubsup,msup,mtable,mtd,mtext,mtr,munder,munderover,none,semantics";
  const isHTMLTag = /* @__PURE__ */ makeMap(HTML_TAGS);
  const isSVGTag = /* @__PURE__ */ makeMap(SVG_TAGS);
  const isMathMLTag = /* @__PURE__ */ makeMap(MATH_TAGS);
  const specialBooleanAttrs = `itemscope,allowfullscreen,formnovalidate,ismap,nomodule,novalidate,readonly`;
  const isSpecialBooleanAttr = /* @__PURE__ */ makeMap(specialBooleanAttrs);
  function includeBooleanAttr(value) {
    return !!value || value === "";
  }
  /**
  * @vue/reactivity v3.4.15
  * (c) 2018-present Yuxi (Evan) You and Vue contributors
  * @license MIT
  **/
  function warn$2(msg, ...args) {
    console.warn(`[Vue warn] ${msg}`, ...args);
  }
  let activeEffectScope;
  class EffectScope {
    constructor(detached = false) {
      this.detached = detached;
      this._active = true;
      this.effects = [];
      this.cleanups = [];
      this.parent = activeEffectScope;
      if (!detached && activeEffectScope) {
        this.index = (activeEffectScope.scopes || (activeEffectScope.scopes = [])).push(
          this
        ) - 1;
      }
    }
    get active() {
      return this._active;
    }
    run(fn2) {
      if (this._active) {
        const currentEffectScope = activeEffectScope;
        try {
          activeEffectScope = this;
          return fn2();
        } finally {
          activeEffectScope = currentEffectScope;
        }
      } else if (!!(process.env.NODE_ENV !== "production")) {
        warn$2(`cannot run an inactive effect scope.`);
      }
    }
    /**
     * This should only be called on non-detached scopes
     * @internal
     */
    on() {
      activeEffectScope = this;
    }
    /**
     * This should only be called on non-detached scopes
     * @internal
     */
    off() {
      activeEffectScope = this.parent;
    }
    stop(fromParent) {
      if (this._active) {
        let i2, l2;
        for (i2 = 0, l2 = this.effects.length; i2 < l2; i2++) {
          this.effects[i2].stop();
        }
        for (i2 = 0, l2 = this.cleanups.length; i2 < l2; i2++) {
          this.cleanups[i2]();
        }
        if (this.scopes) {
          for (i2 = 0, l2 = this.scopes.length; i2 < l2; i2++) {
            this.scopes[i2].stop(true);
          }
        }
        if (!this.detached && this.parent && !fromParent) {
          const last = this.parent.scopes.pop();
          if (last && last !== this) {
            this.parent.scopes[this.index] = last;
            last.index = this.index;
          }
        }
        this.parent = void 0;
        this._active = false;
      }
    }
  }
  function recordEffectScope(effect, scope = activeEffectScope) {
    if (scope && scope.active) {
      scope.effects.push(effect);
    }
  }
  function getCurrentScope() {
    return activeEffectScope;
  }
  let activeEffect;
  class ReactiveEffect {
    constructor(fn2, trigger2, scheduler, scope) {
      this.fn = fn2;
      this.trigger = trigger2;
      this.scheduler = scheduler;
      this.active = true;
      this.deps = [];
      this._dirtyLevel = 2;
      this._trackId = 0;
      this._runnings = 0;
      this._shouldSchedule = false;
      this._depsLength = 0;
      recordEffectScope(this, scope);
    }
    get dirty() {
      if (this._dirtyLevel === 1) {
        pauseTracking();
        for (let i2 = 0; i2 < this._depsLength; i2++) {
          const dep = this.deps[i2];
          if (dep.computed) {
            triggerComputed(dep.computed);
            if (this._dirtyLevel >= 2) {
              break;
            }
          }
        }
        if (this._dirtyLevel < 2) {
          this._dirtyLevel = 0;
        }
        resetTracking();
      }
      return this._dirtyLevel >= 2;
    }
    set dirty(v2) {
      this._dirtyLevel = v2 ? 2 : 0;
    }
    run() {
      this._dirtyLevel = 0;
      if (!this.active) {
        return this.fn();
      }
      let lastShouldTrack = shouldTrack;
      let lastEffect = activeEffect;
      try {
        shouldTrack = true;
        activeEffect = this;
        this._runnings++;
        preCleanupEffect(this);
        return this.fn();
      } finally {
        postCleanupEffect(this);
        this._runnings--;
        activeEffect = lastEffect;
        shouldTrack = lastShouldTrack;
      }
    }
    stop() {
      var _a;
      if (this.active) {
        preCleanupEffect(this);
        postCleanupEffect(this);
        (_a = this.onStop) == null ? void 0 : _a.call(this);
        this.active = false;
      }
    }
  }
  function triggerComputed(computed2) {
    return computed2.value;
  }
  function preCleanupEffect(effect2) {
    effect2._trackId++;
    effect2._depsLength = 0;
  }
  function postCleanupEffect(effect2) {
    if (effect2.deps && effect2.deps.length > effect2._depsLength) {
      for (let i2 = effect2._depsLength; i2 < effect2.deps.length; i2++) {
        cleanupDepEffect(effect2.deps[i2], effect2);
      }
      effect2.deps.length = effect2._depsLength;
    }
  }
  function cleanupDepEffect(dep, effect2) {
    const trackId = dep.get(effect2);
    if (trackId !== void 0 && effect2._trackId !== trackId) {
      dep.delete(effect2);
      if (dep.size === 0) {
        dep.cleanup();
      }
    }
  }
  let shouldTrack = true;
  let pauseScheduleStack = 0;
  const trackStack = [];
  function pauseTracking() {
    trackStack.push(shouldTrack);
    shouldTrack = false;
  }
  function resetTracking() {
    const last = trackStack.pop();
    shouldTrack = last === void 0 ? true : last;
  }
  function pauseScheduling() {
    pauseScheduleStack++;
  }
  function resetScheduling() {
    pauseScheduleStack--;
    while (!pauseScheduleStack && queueEffectSchedulers.length) {
      queueEffectSchedulers.shift()();
    }
  }
  function trackEffect(effect2, dep, debuggerEventExtraInfo) {
    var _a;
    if (dep.get(effect2) !== effect2._trackId) {
      dep.set(effect2, effect2._trackId);
      const oldDep = effect2.deps[effect2._depsLength];
      if (oldDep !== dep) {
        if (oldDep) {
          cleanupDepEffect(oldDep, effect2);
        }
        effect2.deps[effect2._depsLength++] = dep;
      } else {
        effect2._depsLength++;
      }
      if (!!(process.env.NODE_ENV !== "production")) {
        (_a = effect2.onTrack) == null ? void 0 : _a.call(effect2, extend({ effect: effect2 }, debuggerEventExtraInfo));
      }
    }
  }
  const queueEffectSchedulers = [];
  function triggerEffects(dep, dirtyLevel, debuggerEventExtraInfo) {
    var _a;
    pauseScheduling();
    for (const effect2 of dep.keys()) {
      if (effect2._dirtyLevel < dirtyLevel && dep.get(effect2) === effect2._trackId) {
        const lastDirtyLevel = effect2._dirtyLevel;
        effect2._dirtyLevel = dirtyLevel;
        if (lastDirtyLevel === 0) {
          effect2._shouldSchedule = true;
          if (!!(process.env.NODE_ENV !== "production")) {
            (_a = effect2.onTrigger) == null ? void 0 : _a.call(effect2, extend({ effect: effect2 }, debuggerEventExtraInfo));
          }
          effect2.trigger();
        }
      }
    }
    scheduleEffects(dep);
    resetScheduling();
  }
  function scheduleEffects(dep) {
    for (const effect2 of dep.keys()) {
      if (effect2.scheduler && effect2._shouldSchedule && (!effect2._runnings || effect2.allowRecurse) && dep.get(effect2) === effect2._trackId) {
        effect2._shouldSchedule = false;
        queueEffectSchedulers.push(effect2.scheduler);
      }
    }
  }
  const createDep = (cleanup, computed2) => {
    const dep = /* @__PURE__ */ new Map();
    dep.cleanup = cleanup;
    dep.computed = computed2;
    return dep;
  };
  const targetMap = /* @__PURE__ */ new WeakMap();
  const ITERATE_KEY = Symbol(!!(process.env.NODE_ENV !== "production") ? "iterate" : "");
  const MAP_KEY_ITERATE_KEY = Symbol(!!(process.env.NODE_ENV !== "production") ? "Map key iterate" : "");
  function track(target, type, key) {
    if (shouldTrack && activeEffect) {
      let depsMap = targetMap.get(target);
      if (!depsMap) {
        targetMap.set(target, depsMap = /* @__PURE__ */ new Map());
      }
      let dep = depsMap.get(key);
      if (!dep) {
        depsMap.set(key, dep = createDep(() => depsMap.delete(key)));
      }
      trackEffect(
        activeEffect,
        dep,
        !!(process.env.NODE_ENV !== "production") ? {
          target,
          type,
          key
        } : void 0
      );
    }
  }
  function trigger(target, type, key, newValue, oldValue, oldTarget) {
    const depsMap = targetMap.get(target);
    if (!depsMap) {
      return;
    }
    let deps = [];
    if (type === "clear") {
      deps = [...depsMap.values()];
    } else if (key === "length" && isArray(target)) {
      const newLength = Number(newValue);
      depsMap.forEach((dep, key2) => {
        if (key2 === "length" || !isSymbol(key2) && key2 >= newLength) {
          deps.push(dep);
        }
      });
    } else {
      if (key !== void 0) {
        deps.push(depsMap.get(key));
      }
      switch (type) {
        case "add":
          if (!isArray(target)) {
            deps.push(depsMap.get(ITERATE_KEY));
            if (isMap(target)) {
              deps.push(depsMap.get(MAP_KEY_ITERATE_KEY));
            }
          } else if (isIntegerKey(key)) {
            deps.push(depsMap.get("length"));
          }
          break;
        case "delete":
          if (!isArray(target)) {
            deps.push(depsMap.get(ITERATE_KEY));
            if (isMap(target)) {
              deps.push(depsMap.get(MAP_KEY_ITERATE_KEY));
            }
          }
          break;
        case "set":
          if (isMap(target)) {
            deps.push(depsMap.get(ITERATE_KEY));
          }
          break;
      }
    }
    pauseScheduling();
    for (const dep of deps) {
      if (dep) {
        triggerEffects(
          dep,
          2,
          !!(process.env.NODE_ENV !== "production") ? {
            target,
            type,
            key,
            newValue,
            oldValue,
            oldTarget
          } : void 0
        );
      }
    }
    resetScheduling();
  }
  const isNonTrackableKeys = /* @__PURE__ */ makeMap(`__proto__,__v_isRef,__isVue`);
  const builtInSymbols = new Set(
    /* @__PURE__ */ Object.getOwnPropertyNames(Symbol).filter((key) => key !== "arguments" && key !== "caller").map((key) => Symbol[key]).filter(isSymbol)
  );
  const arrayInstrumentations = /* @__PURE__ */ createArrayInstrumentations();
  function createArrayInstrumentations() {
    const instrumentations = {};
    ["includes", "indexOf", "lastIndexOf"].forEach((key) => {
      instrumentations[key] = function(...args) {
        const arr = toRaw(this);
        for (let i2 = 0, l2 = this.length; i2 < l2; i2++) {
          track(arr, "get", i2 + "");
        }
        const res = arr[key](...args);
        if (res === -1 || res === false) {
          return arr[key](...args.map(toRaw));
        } else {
          return res;
        }
      };
    });
    ["push", "pop", "shift", "unshift", "splice"].forEach((key) => {
      instrumentations[key] = function(...args) {
        pauseTracking();
        pauseScheduling();
        const res = toRaw(this)[key].apply(this, args);
        resetScheduling();
        resetTracking();
        return res;
      };
    });
    return instrumentations;
  }
  function hasOwnProperty(key) {
    const obj = toRaw(this);
    track(obj, "has", key);
    return obj.hasOwnProperty(key);
  }
  class BaseReactiveHandler {
    constructor(_isReadonly = false, _shallow = false) {
      this._isReadonly = _isReadonly;
      this._shallow = _shallow;
    }
    get(target, key, receiver) {
      const isReadonly2 = this._isReadonly, shallow = this._shallow;
      if (key === "__v_isReactive") {
        return !isReadonly2;
      } else if (key === "__v_isReadonly") {
        return isReadonly2;
      } else if (key === "__v_isShallow") {
        return shallow;
      } else if (key === "__v_raw") {
        if (receiver === (isReadonly2 ? shallow ? shallowReadonlyMap : readonlyMap : shallow ? shallowReactiveMap : reactiveMap).get(target) || // receiver is not the reactive proxy, but has the same prototype
        // this means the reciever is a user proxy of the reactive proxy
        Object.getPrototypeOf(target) === Object.getPrototypeOf(receiver)) {
          return target;
        }
        return;
      }
      const targetIsArray = isArray(target);
      if (!isReadonly2) {
        if (targetIsArray && hasOwn(arrayInstrumentations, key)) {
          return Reflect.get(arrayInstrumentations, key, receiver);
        }
        if (key === "hasOwnProperty") {
          return hasOwnProperty;
        }
      }
      const res = Reflect.get(target, key, receiver);
      if (isSymbol(key) ? builtInSymbols.has(key) : isNonTrackableKeys(key)) {
        return res;
      }
      if (!isReadonly2) {
        track(target, "get", key);
      }
      if (shallow) {
        return res;
      }
      if (isRef(res)) {
        return targetIsArray && isIntegerKey(key) ? res : res.value;
      }
      if (isObject(res)) {
        return isReadonly2 ? readonly(res) : reactive(res);
      }
      return res;
    }
  }
  class MutableReactiveHandler extends BaseReactiveHandler {
    constructor(shallow = false) {
      super(false, shallow);
    }
    set(target, key, value, receiver) {
      let oldValue = target[key];
      if (!this._shallow) {
        const isOldValueReadonly = isReadonly(oldValue);
        if (!isShallow(value) && !isReadonly(value)) {
          oldValue = toRaw(oldValue);
          value = toRaw(value);
        }
        if (!isArray(target) && isRef(oldValue) && !isRef(value)) {
          if (isOldValueReadonly) {
            return false;
          } else {
            oldValue.value = value;
            return true;
          }
        }
      }
      const hadKey = isArray(target) && isIntegerKey(key) ? Number(key) < target.length : hasOwn(target, key);
      const result = Reflect.set(target, key, value, receiver);
      if (target === toRaw(receiver)) {
        if (!hadKey) {
          trigger(target, "add", key, value);
        } else if (hasChanged(value, oldValue)) {
          trigger(target, "set", key, value, oldValue);
        }
      }
      return result;
    }
    deleteProperty(target, key) {
      const hadKey = hasOwn(target, key);
      const oldValue = target[key];
      const result = Reflect.deleteProperty(target, key);
      if (result && hadKey) {
        trigger(target, "delete", key, void 0, oldValue);
      }
      return result;
    }
    has(target, key) {
      const result = Reflect.has(target, key);
      if (!isSymbol(key) || !builtInSymbols.has(key)) {
        track(target, "has", key);
      }
      return result;
    }
    ownKeys(target) {
      track(
        target,
        "iterate",
        isArray(target) ? "length" : ITERATE_KEY
      );
      return Reflect.ownKeys(target);
    }
  }
  class ReadonlyReactiveHandler extends BaseReactiveHandler {
    constructor(shallow = false) {
      super(true, shallow);
    }
    set(target, key) {
      if (!!(process.env.NODE_ENV !== "production")) {
        warn$2(
          `Set operation on key "${String(key)}" failed: target is readonly.`,
          target
        );
      }
      return true;
    }
    deleteProperty(target, key) {
      if (!!(process.env.NODE_ENV !== "production")) {
        warn$2(
          `Delete operation on key "${String(key)}" failed: target is readonly.`,
          target
        );
      }
      return true;
    }
  }
  const mutableHandlers = /* @__PURE__ */ new MutableReactiveHandler();
  const readonlyHandlers = /* @__PURE__ */ new ReadonlyReactiveHandler();
  const shallowReactiveHandlers = /* @__PURE__ */ new MutableReactiveHandler(
    true
  );
  const shallowReadonlyHandlers = /* @__PURE__ */ new ReadonlyReactiveHandler(true);
  const toShallow = (value) => value;
  const getProto = (v2) => Reflect.getPrototypeOf(v2);
  function get(target, key, isReadonly2 = false, isShallow3 = false) {
    target = target["__v_raw"];
    const rawTarget = toRaw(target);
    const rawKey = toRaw(key);
    if (!isReadonly2) {
      if (hasChanged(key, rawKey)) {
        track(rawTarget, "get", key);
      }
      track(rawTarget, "get", rawKey);
    }
    const { has: has2 } = getProto(rawTarget);
    const wrap = isShallow3 ? toShallow : isReadonly2 ? toReadonly : toReactive;
    if (has2.call(rawTarget, key)) {
      return wrap(target.get(key));
    } else if (has2.call(rawTarget, rawKey)) {
      return wrap(target.get(rawKey));
    } else if (target !== rawTarget) {
      target.get(key);
    }
  }
  function has(key, isReadonly2 = false) {
    const target = this["__v_raw"];
    const rawTarget = toRaw(target);
    const rawKey = toRaw(key);
    if (!isReadonly2) {
      if (hasChanged(key, rawKey)) {
        track(rawTarget, "has", key);
      }
      track(rawTarget, "has", rawKey);
    }
    return key === rawKey ? target.has(key) : target.has(key) || target.has(rawKey);
  }
  function size(target, isReadonly2 = false) {
    target = target["__v_raw"];
    !isReadonly2 && track(toRaw(target), "iterate", ITERATE_KEY);
    return Reflect.get(target, "size", target);
  }
  function add(value) {
    value = toRaw(value);
    const target = toRaw(this);
    const proto = getProto(target);
    const hadKey = proto.has.call(target, value);
    if (!hadKey) {
      target.add(value);
      trigger(target, "add", value, value);
    }
    return this;
  }
  function set(key, value) {
    value = toRaw(value);
    const target = toRaw(this);
    const { has: has2, get: get2 } = getProto(target);
    let hadKey = has2.call(target, key);
    if (!hadKey) {
      key = toRaw(key);
      hadKey = has2.call(target, key);
    } else if (!!(process.env.NODE_ENV !== "production")) {
      checkIdentityKeys(target, has2, key);
    }
    const oldValue = get2.call(target, key);
    target.set(key, value);
    if (!hadKey) {
      trigger(target, "add", key, value);
    } else if (hasChanged(value, oldValue)) {
      trigger(target, "set", key, value, oldValue);
    }
    return this;
  }
  function deleteEntry(key) {
    const target = toRaw(this);
    const { has: has2, get: get2 } = getProto(target);
    let hadKey = has2.call(target, key);
    if (!hadKey) {
      key = toRaw(key);
      hadKey = has2.call(target, key);
    } else if (!!(process.env.NODE_ENV !== "production")) {
      checkIdentityKeys(target, has2, key);
    }
    const oldValue = get2 ? get2.call(target, key) : void 0;
    const result = target.delete(key);
    if (hadKey) {
      trigger(target, "delete", key, void 0, oldValue);
    }
    return result;
  }
  function clear() {
    const target = toRaw(this);
    const hadItems = target.size !== 0;
    const oldTarget = !!(process.env.NODE_ENV !== "production") ? isMap(target) ? new Map(target) : new Set(target) : void 0;
    const result = target.clear();
    if (hadItems) {
      trigger(target, "clear", void 0, void 0, oldTarget);
    }
    return result;
  }
  function createForEach(isReadonly2, isShallow3) {
    return function forEach(callback, thisArg) {
      const observed = this;
      const target = observed["__v_raw"];
      const rawTarget = toRaw(target);
      const wrap = isShallow3 ? toShallow : isReadonly2 ? toReadonly : toReactive;
      !isReadonly2 && track(rawTarget, "iterate", ITERATE_KEY);
      return target.forEach((value, key) => {
        return callback.call(thisArg, wrap(value), wrap(key), observed);
      });
    };
  }
  function createIterableMethod(method, isReadonly2, isShallow3) {
    return function(...args) {
      const target = this["__v_raw"];
      const rawTarget = toRaw(target);
      const targetIsMap = isMap(rawTarget);
      const isPair = method === "entries" || method === Symbol.iterator && targetIsMap;
      const isKeyOnly = method === "keys" && targetIsMap;
      const innerIterator = target[method](...args);
      const wrap = isShallow3 ? toShallow : isReadonly2 ? toReadonly : toReactive;
      !isReadonly2 && track(
        rawTarget,
        "iterate",
        isKeyOnly ? MAP_KEY_ITERATE_KEY : ITERATE_KEY
      );
      return {
        // iterator protocol
        next() {
          const { value, done } = innerIterator.next();
          return done ? { value, done } : {
            value: isPair ? [wrap(value[0]), wrap(value[1])] : wrap(value),
            done
          };
        },
        // iterable protocol
        [Symbol.iterator]() {
          return this;
        }
      };
    };
  }
  function createReadonlyMethod(type) {
    return function(...args) {
      if (!!(process.env.NODE_ENV !== "production")) {
        const key = args[0] ? `on key "${args[0]}" ` : ``;
        console.warn(
          `${capitalize(type)} operation ${key}failed: target is readonly.`,
          toRaw(this)
        );
      }
      return type === "delete" ? false : type === "clear" ? void 0 : this;
    };
  }
  function createInstrumentations() {
    const mutableInstrumentations2 = {
      get(key) {
        return get(this, key);
      },
      get size() {
        return size(this);
      },
      has,
      add,
      set,
      delete: deleteEntry,
      clear,
      forEach: createForEach(false, false)
    };
    const shallowInstrumentations2 = {
      get(key) {
        return get(this, key, false, true);
      },
      get size() {
        return size(this);
      },
      has,
      add,
      set,
      delete: deleteEntry,
      clear,
      forEach: createForEach(false, true)
    };
    const readonlyInstrumentations2 = {
      get(key) {
        return get(this, key, true);
      },
      get size() {
        return size(this, true);
      },
      has(key) {
        return has.call(this, key, true);
      },
      add: createReadonlyMethod("add"),
      set: createReadonlyMethod("set"),
      delete: createReadonlyMethod("delete"),
      clear: createReadonlyMethod("clear"),
      forEach: createForEach(true, false)
    };
    const shallowReadonlyInstrumentations2 = {
      get(key) {
        return get(this, key, true, true);
      },
      get size() {
        return size(this, true);
      },
      has(key) {
        return has.call(this, key, true);
      },
      add: createReadonlyMethod("add"),
      set: createReadonlyMethod("set"),
      delete: createReadonlyMethod("delete"),
      clear: createReadonlyMethod("clear"),
      forEach: createForEach(true, true)
    };
    const iteratorMethods = ["keys", "values", "entries", Symbol.iterator];
    iteratorMethods.forEach((method) => {
      mutableInstrumentations2[method] = createIterableMethod(
        method,
        false,
        false
      );
      readonlyInstrumentations2[method] = createIterableMethod(
        method,
        true,
        false
      );
      shallowInstrumentations2[method] = createIterableMethod(
        method,
        false,
        true
      );
      shallowReadonlyInstrumentations2[method] = createIterableMethod(
        method,
        true,
        true
      );
    });
    return [
      mutableInstrumentations2,
      readonlyInstrumentations2,
      shallowInstrumentations2,
      shallowReadonlyInstrumentations2
    ];
  }
  const [
    mutableInstrumentations,
    readonlyInstrumentations,
    shallowInstrumentations,
    shallowReadonlyInstrumentations
  ] = /* @__PURE__ */ createInstrumentations();
  function createInstrumentationGetter(isReadonly2, shallow) {
    const instrumentations = shallow ? isReadonly2 ? shallowReadonlyInstrumentations : shallowInstrumentations : isReadonly2 ? readonlyInstrumentations : mutableInstrumentations;
    return (target, key, receiver) => {
      if (key === "__v_isReactive") {
        return !isReadonly2;
      } else if (key === "__v_isReadonly") {
        return isReadonly2;
      } else if (key === "__v_raw") {
        return target;
      }
      return Reflect.get(
        hasOwn(instrumentations, key) && key in target ? instrumentations : target,
        key,
        receiver
      );
    };
  }
  const mutableCollectionHandlers = {
    get: /* @__PURE__ */ createInstrumentationGetter(false, false)
  };
  const shallowCollectionHandlers = {
    get: /* @__PURE__ */ createInstrumentationGetter(false, true)
  };
  const readonlyCollectionHandlers = {
    get: /* @__PURE__ */ createInstrumentationGetter(true, false)
  };
  const shallowReadonlyCollectionHandlers = {
    get: /* @__PURE__ */ createInstrumentationGetter(true, true)
  };
  function checkIdentityKeys(target, has2, key) {
    const rawKey = toRaw(key);
    if (rawKey !== key && has2.call(target, rawKey)) {
      const type = toRawType(target);
      console.warn(
        `Reactive ${type} contains both the raw and reactive versions of the same object${type === `Map` ? ` as keys` : ``}, which can lead to inconsistencies. Avoid differentiating between the raw and reactive versions of an object and only use the reactive version if possible.`
      );
    }
  }
  const reactiveMap = /* @__PURE__ */ new WeakMap();
  const shallowReactiveMap = /* @__PURE__ */ new WeakMap();
  const readonlyMap = /* @__PURE__ */ new WeakMap();
  const shallowReadonlyMap = /* @__PURE__ */ new WeakMap();
  function targetTypeMap(rawType) {
    switch (rawType) {
      case "Object":
      case "Array":
        return 1;
      case "Map":
      case "Set":
      case "WeakMap":
      case "WeakSet":
        return 2;
      default:
        return 0;
    }
  }
  function getTargetType(value) {
    return value["__v_skip"] || !Object.isExtensible(value) ? 0 : targetTypeMap(toRawType(value));
  }
  function reactive(target) {
    if (isReadonly(target)) {
      return target;
    }
    return createReactiveObject(
      target,
      false,
      mutableHandlers,
      mutableCollectionHandlers,
      reactiveMap
    );
  }
  function shallowReactive(target) {
    return createReactiveObject(
      target,
      false,
      shallowReactiveHandlers,
      shallowCollectionHandlers,
      shallowReactiveMap
    );
  }
  function readonly(target) {
    return createReactiveObject(
      target,
      true,
      readonlyHandlers,
      readonlyCollectionHandlers,
      readonlyMap
    );
  }
  function shallowReadonly(target) {
    return createReactiveObject(
      target,
      true,
      shallowReadonlyHandlers,
      shallowReadonlyCollectionHandlers,
      shallowReadonlyMap
    );
  }
  function createReactiveObject(target, isReadonly2, baseHandlers, collectionHandlers, proxyMap) {
    if (!isObject(target)) {
      if (!!(process.env.NODE_ENV !== "production")) {
        console.warn(`value cannot be made reactive: ${String(target)}`);
      }
      return target;
    }
    if (target["__v_raw"] && !(isReadonly2 && target["__v_isReactive"])) {
      return target;
    }
    const existingProxy = proxyMap.get(target);
    if (existingProxy) {
      return existingProxy;
    }
    const targetType = getTargetType(target);
    if (targetType === 0) {
      return target;
    }
    const proxy = new Proxy(
      target,
      targetType === 2 ? collectionHandlers : baseHandlers
    );
    proxyMap.set(target, proxy);
    return proxy;
  }
  function isReactive(value) {
    if (isReadonly(value)) {
      return isReactive(value["__v_raw"]);
    }
    return !!(value && value["__v_isReactive"]);
  }
  function isReadonly(value) {
    return !!(value && value["__v_isReadonly"]);
  }
  function isShallow(value) {
    return !!(value && value["__v_isShallow"]);
  }
  function isProxy(value) {
    return isReactive(value) || isReadonly(value);
  }
  function toRaw(observed) {
    const raw = observed && observed["__v_raw"];
    return raw ? toRaw(raw) : observed;
  }
  function markRaw(value) {
    def(value, "__v_skip", true);
    return value;
  }
  const toReactive = (value) => isObject(value) ? reactive(value) : value;
  const toReadonly = (value) => isObject(value) ? readonly(value) : value;
  class ComputedRefImpl {
    constructor(getter, _setter, isReadonly2, isSSR) {
      this._setter = _setter;
      this.dep = void 0;
      this.__v_isRef = true;
      this["__v_isReadonly"] = false;
      this.effect = new ReactiveEffect(
        () => getter(this._value),
        () => triggerRefValue(this, 1),
        () => this.dep && scheduleEffects(this.dep)
      );
      this.effect.computed = this;
      this.effect.active = this._cacheable = !isSSR;
      this["__v_isReadonly"] = isReadonly2;
    }
    get value() {
      const self2 = toRaw(this);
      if (!self2._cacheable || self2.effect.dirty) {
        if (hasChanged(self2._value, self2._value = self2.effect.run())) {
          triggerRefValue(self2, 2);
        }
      }
      trackRefValue(self2);
      if (self2.effect._dirtyLevel >= 1) {
        triggerRefValue(self2, 1);
      }
      return self2._value;
    }
    set value(newValue) {
      this._setter(newValue);
    }
    // #region polyfill _dirty for backward compatibility third party code for Vue <= 3.3.x
    get _dirty() {
      return this.effect.dirty;
    }
    set _dirty(v2) {
      this.effect.dirty = v2;
    }
    // #endregion
  }
  function computed$1(getterOrOptions, debugOptions, isSSR = false) {
    let getter;
    let setter;
    const onlyGetter = isFunction(getterOrOptions);
    if (onlyGetter) {
      getter = getterOrOptions;
      setter = !!(process.env.NODE_ENV !== "production") ? () => {
        console.warn("Write operation failed: computed value is readonly");
      } : NOOP;
    } else {
      getter = getterOrOptions.get;
      setter = getterOrOptions.set;
    }
    const cRef = new ComputedRefImpl(getter, setter, onlyGetter || !setter, isSSR);
    if (!!(process.env.NODE_ENV !== "production") && debugOptions && !isSSR) {
      cRef.effect.onTrack = debugOptions.onTrack;
      cRef.effect.onTrigger = debugOptions.onTrigger;
    }
    return cRef;
  }
  function trackRefValue(ref2) {
    if (shouldTrack && activeEffect) {
      ref2 = toRaw(ref2);
      trackEffect(
        activeEffect,
        ref2.dep || (ref2.dep = createDep(
          () => ref2.dep = void 0,
          ref2 instanceof ComputedRefImpl ? ref2 : void 0
        )),
        !!(process.env.NODE_ENV !== "production") ? {
          target: ref2,
          type: "get",
          key: "value"
        } : void 0
      );
    }
  }
  function triggerRefValue(ref2, dirtyLevel = 2, newVal) {
    ref2 = toRaw(ref2);
    const dep = ref2.dep;
    if (dep) {
      triggerEffects(
        dep,
        dirtyLevel,
        !!(process.env.NODE_ENV !== "production") ? {
          target: ref2,
          type: "set",
          key: "value",
          newValue: newVal
        } : void 0
      );
    }
  }
  function isRef(r2) {
    return !!(r2 && r2.__v_isRef === true);
  }
  function ref(value) {
    return createRef(value, false);
  }
  function createRef(rawValue, shallow) {
    if (isRef(rawValue)) {
      return rawValue;
    }
    return new RefImpl(rawValue, shallow);
  }
  class RefImpl {
    constructor(value, __v_isShallow) {
      this.__v_isShallow = __v_isShallow;
      this.dep = void 0;
      this.__v_isRef = true;
      this._rawValue = __v_isShallow ? value : toRaw(value);
      this._value = __v_isShallow ? value : toReactive(value);
    }
    get value() {
      trackRefValue(this);
      return this._value;
    }
    set value(newVal) {
      const useDirectValue = this.__v_isShallow || isShallow(newVal) || isReadonly(newVal);
      newVal = useDirectValue ? newVal : toRaw(newVal);
      if (hasChanged(newVal, this._rawValue)) {
        this._rawValue = newVal;
        this._value = useDirectValue ? newVal : toReactive(newVal);
        triggerRefValue(this, 2, newVal);
      }
    }
  }
  function unref(ref2) {
    return isRef(ref2) ? ref2.value : ref2;
  }
  const shallowUnwrapHandlers = {
    get: (target, key, receiver) => unref(Reflect.get(target, key, receiver)),
    set: (target, key, value, receiver) => {
      const oldValue = target[key];
      if (isRef(oldValue) && !isRef(value)) {
        oldValue.value = value;
        return true;
      } else {
        return Reflect.set(target, key, value, receiver);
      }
    }
  };
  function proxyRefs(objectWithRefs) {
    return isReactive(objectWithRefs) ? objectWithRefs : new Proxy(objectWithRefs, shallowUnwrapHandlers);
  }
  /**
  * @vue/runtime-core v3.4.15
  * (c) 2018-present Yuxi (Evan) You and Vue contributors
  * @license MIT
  **/
  const stack = [];
  function pushWarningContext(vnode) {
    stack.push(vnode);
  }
  function popWarningContext() {
    stack.pop();
  }
  function warn$1(msg, ...args) {
    pauseTracking();
    const instance = stack.length ? stack[stack.length - 1].component : null;
    const appWarnHandler = instance && instance.appContext.config.warnHandler;
    const trace = getComponentTrace();
    if (appWarnHandler) {
      callWithErrorHandling(
        appWarnHandler,
        instance,
        11,
        [
          msg + args.join(""),
          instance && instance.proxy,
          trace.map(
            ({ vnode }) => `at <${formatComponentName(instance, vnode.type)}>`
          ).join("\n"),
          trace
        ]
      );
    } else {
      const warnArgs = [`[Vue warn]: ${msg}`, ...args];
      if (trace.length && // avoid spamming console during tests
      true) {
        warnArgs.push(`
`, ...formatTrace(trace));
      }
      console.warn(...warnArgs);
    }
    resetTracking();
  }
  function getComponentTrace() {
    let currentVNode = stack[stack.length - 1];
    if (!currentVNode) {
      return [];
    }
    const normalizedStack = [];
    while (currentVNode) {
      const last = normalizedStack[0];
      if (last && last.vnode === currentVNode) {
        last.recurseCount++;
      } else {
        normalizedStack.push({
          vnode: currentVNode,
          recurseCount: 0
        });
      }
      const parentInstance = currentVNode.component && currentVNode.component.parent;
      currentVNode = parentInstance && parentInstance.vnode;
    }
    return normalizedStack;
  }
  function formatTrace(trace) {
    const logs = [];
    trace.forEach((entry, i2) => {
      logs.push(...i2 === 0 ? [] : [`
`], ...formatTraceEntry(entry));
    });
    return logs;
  }
  function formatTraceEntry({ vnode, recurseCount }) {
    const postfix = recurseCount > 0 ? `... (${recurseCount} recursive calls)` : ``;
    const isRoot = vnode.component ? vnode.component.parent == null : false;
    const open = ` at <${formatComponentName(
      vnode.component,
      vnode.type,
      isRoot
    )}`;
    const close = `>` + postfix;
    return vnode.props ? [open, ...formatProps(vnode.props), close] : [open + close];
  }
  function formatProps(props) {
    const res = [];
    const keys = Object.keys(props);
    keys.slice(0, 3).forEach((key) => {
      res.push(...formatProp(key, props[key]));
    });
    if (keys.length > 3) {
      res.push(` ...`);
    }
    return res;
  }
  function formatProp(key, value, raw) {
    if (isString(value)) {
      value = JSON.stringify(value);
      return raw ? value : [`${key}=${value}`];
    } else if (typeof value === "number" || typeof value === "boolean" || value == null) {
      return raw ? value : [`${key}=${value}`];
    } else if (isRef(value)) {
      value = formatProp(key, toRaw(value.value), true);
      return raw ? value : [`${key}=Ref<`, value, `>`];
    } else if (isFunction(value)) {
      return [`${key}=fn${value.name ? `<${value.name}>` : ``}`];
    } else {
      value = toRaw(value);
      return raw ? value : [`${key}=`, value];
    }
  }
  const ErrorTypeStrings$1 = {
    ["sp"]: "serverPrefetch hook",
    ["bc"]: "beforeCreate hook",
    ["c"]: "created hook",
    ["bm"]: "beforeMount hook",
    ["m"]: "mounted hook",
    ["bu"]: "beforeUpdate hook",
    ["u"]: "updated",
    ["bum"]: "beforeUnmount hook",
    ["um"]: "unmounted hook",
    ["a"]: "activated hook",
    ["da"]: "deactivated hook",
    ["ec"]: "errorCaptured hook",
    ["rtc"]: "renderTracked hook",
    ["rtg"]: "renderTriggered hook",
    [0]: "setup function",
    [1]: "render function",
    [2]: "watcher getter",
    [3]: "watcher callback",
    [4]: "watcher cleanup function",
    [5]: "native event handler",
    [6]: "component event handler",
    [7]: "vnode hook",
    [8]: "directive hook",
    [9]: "transition hook",
    [10]: "app errorHandler",
    [11]: "app warnHandler",
    [12]: "ref function",
    [13]: "async component loader",
    [14]: "scheduler flush. This is likely a Vue internals bug. Please open an issue at https://github.com/vuejs/core ."
  };
  function callWithErrorHandling(fn2, instance, type, args) {
    let res;
    try {
      res = args ? fn2(...args) : fn2();
    } catch (err) {
      handleError(err, instance, type);
    }
    return res;
  }
  function callWithAsyncErrorHandling(fn2, instance, type, args) {
    if (isFunction(fn2)) {
      const res = callWithErrorHandling(fn2, instance, type, args);
      if (res && isPromise(res)) {
        res.catch((err) => {
          handleError(err, instance, type);
        });
      }
      return res;
    }
    const values = [];
    for (let i2 = 0; i2 < fn2.length; i2++) {
      values.push(callWithAsyncErrorHandling(fn2[i2], instance, type, args));
    }
    return values;
  }
  function handleError(err, instance, type, throwInDev = true) {
    const contextVNode = instance ? instance.vnode : null;
    if (instance) {
      let cur = instance.parent;
      const exposedInstance = instance.proxy;
      const errorInfo = !!(process.env.NODE_ENV !== "production") ? ErrorTypeStrings$1[type] : `https://vuejs.org/error-reference/#runtime-${type}`;
      while (cur) {
        const errorCapturedHooks = cur.ec;
        if (errorCapturedHooks) {
          for (let i2 = 0; i2 < errorCapturedHooks.length; i2++) {
            if (errorCapturedHooks[i2](err, exposedInstance, errorInfo) === false) {
              return;
            }
          }
        }
        cur = cur.parent;
      }
      const appErrorHandler = instance.appContext.config.errorHandler;
      if (appErrorHandler) {
        callWithErrorHandling(
          appErrorHandler,
          null,
          10,
          [err, exposedInstance, errorInfo]
        );
        return;
      }
    }
    logError(err, type, contextVNode, throwInDev);
  }
  function logError(err, type, contextVNode, throwInDev = true) {
    if (!!(process.env.NODE_ENV !== "production")) {
      const info = ErrorTypeStrings$1[type];
      if (contextVNode) {
        pushWarningContext(contextVNode);
      }
      warn$1(`Unhandled error${info ? ` during execution of ${info}` : ``}`);
      if (contextVNode) {
        popWarningContext();
      }
      if (throwInDev) {
        throw err;
      } else {
        console.error(err);
      }
    } else {
      console.error(err);
    }
  }
  let isFlushing = false;
  let isFlushPending = false;
  const queue = [];
  let flushIndex = 0;
  const pendingPostFlushCbs = [];
  let activePostFlushCbs = null;
  let postFlushIndex = 0;
  const resolvedPromise = /* @__PURE__ */ Promise.resolve();
  let currentFlushPromise = null;
  const RECURSION_LIMIT = 100;
  function nextTick(fn2) {
    const p2 = currentFlushPromise || resolvedPromise;
    return fn2 ? p2.then(this ? fn2.bind(this) : fn2) : p2;
  }
  function findInsertionIndex(id) {
    let start = flushIndex + 1;
    let end = queue.length;
    while (start < end) {
      const middle = start + end >>> 1;
      const middleJob = queue[middle];
      const middleJobId = getId(middleJob);
      if (middleJobId < id || middleJobId === id && middleJob.pre) {
        start = middle + 1;
      } else {
        end = middle;
      }
    }
    return start;
  }
  function queueJob(job) {
    if (!queue.length || !queue.includes(
      job,
      isFlushing && job.allowRecurse ? flushIndex + 1 : flushIndex
    )) {
      if (job.id == null) {
        queue.push(job);
      } else {
        queue.splice(findInsertionIndex(job.id), 0, job);
      }
      queueFlush();
    }
  }
  function queueFlush() {
    if (!isFlushing && !isFlushPending) {
      isFlushPending = true;
      currentFlushPromise = resolvedPromise.then(flushJobs);
    }
  }
  function invalidateJob(job) {
    const i2 = queue.indexOf(job);
    if (i2 > flushIndex) {
      queue.splice(i2, 1);
    }
  }
  function queuePostFlushCb(cb) {
    if (!isArray(cb)) {
      if (!activePostFlushCbs || !activePostFlushCbs.includes(
        cb,
        cb.allowRecurse ? postFlushIndex + 1 : postFlushIndex
      )) {
        pendingPostFlushCbs.push(cb);
      }
    } else {
      pendingPostFlushCbs.push(...cb);
    }
    queueFlush();
  }
  function flushPreFlushCbs(instance, seen, i2 = isFlushing ? flushIndex + 1 : 0) {
    if (!!(process.env.NODE_ENV !== "production")) {
      seen = seen || /* @__PURE__ */ new Map();
    }
    for (; i2 < queue.length; i2++) {
      const cb = queue[i2];
      if (cb && cb.pre) {
        if (instance && cb.id !== instance.uid) {
          continue;
        }
        if (!!(process.env.NODE_ENV !== "production") && checkRecursiveUpdates(seen, cb)) {
          continue;
        }
        queue.splice(i2, 1);
        i2--;
        cb();
      }
    }
  }
  function flushPostFlushCbs(seen) {
    if (pendingPostFlushCbs.length) {
      const deduped = [...new Set(pendingPostFlushCbs)].sort(
        (a2, b2) => getId(a2) - getId(b2)
      );
      pendingPostFlushCbs.length = 0;
      if (activePostFlushCbs) {
        activePostFlushCbs.push(...deduped);
        return;
      }
      activePostFlushCbs = deduped;
      if (!!(process.env.NODE_ENV !== "production")) {
        seen = seen || /* @__PURE__ */ new Map();
      }
      for (postFlushIndex = 0; postFlushIndex < activePostFlushCbs.length; postFlushIndex++) {
        if (!!(process.env.NODE_ENV !== "production") && checkRecursiveUpdates(seen, activePostFlushCbs[postFlushIndex])) {
          continue;
        }
        activePostFlushCbs[postFlushIndex]();
      }
      activePostFlushCbs = null;
      postFlushIndex = 0;
    }
  }
  const getId = (job) => job.id == null ? Infinity : job.id;
  const comparator = (a2, b2) => {
    const diff = getId(a2) - getId(b2);
    if (diff === 0) {
      if (a2.pre && !b2.pre)
        return -1;
      if (b2.pre && !a2.pre)
        return 1;
    }
    return diff;
  };
  function flushJobs(seen) {
    isFlushPending = false;
    isFlushing = true;
    if (!!(process.env.NODE_ENV !== "production")) {
      seen = seen || /* @__PURE__ */ new Map();
    }
    queue.sort(comparator);
    const check = !!(process.env.NODE_ENV !== "production") ? (job) => checkRecursiveUpdates(seen, job) : NOOP;
    try {
      for (flushIndex = 0; flushIndex < queue.length; flushIndex++) {
        const job = queue[flushIndex];
        if (job && job.active !== false) {
          if (!!(process.env.NODE_ENV !== "production") && check(job)) {
            continue;
          }
          callWithErrorHandling(job, null, 14);
        }
      }
    } finally {
      flushIndex = 0;
      queue.length = 0;
      flushPostFlushCbs(seen);
      isFlushing = false;
      currentFlushPromise = null;
      if (queue.length || pendingPostFlushCbs.length) {
        flushJobs(seen);
      }
    }
  }
  function checkRecursiveUpdates(seen, fn2) {
    if (!seen.has(fn2)) {
      seen.set(fn2, 1);
    } else {
      const count = seen.get(fn2);
      if (count > RECURSION_LIMIT) {
        const instance = fn2.ownerInstance;
        const componentName = instance && getComponentName(instance.type);
        handleError(
          `Maximum recursive updates exceeded${componentName ? ` in component <${componentName}>` : ``}. This means you have a reactive effect that is mutating its own dependencies and thus recursively triggering itself. Possible sources include component template, render function, updated hook or watcher source function.`,
          null,
          10
        );
        return true;
      } else {
        seen.set(fn2, count + 1);
      }
    }
  }
  let isHmrUpdating = false;
  const hmrDirtyComponents = /* @__PURE__ */ new Set();
  if (!!(process.env.NODE_ENV !== "production")) {
    getGlobalThis().__VUE_HMR_RUNTIME__ = {
      createRecord: tryWrap(createRecord),
      rerender: tryWrap(rerender),
      reload: tryWrap(reload)
    };
  }
  const map$1 = /* @__PURE__ */ new Map();
  function registerHMR(instance) {
    const id = instance.type.__hmrId;
    let record = map$1.get(id);
    if (!record) {
      createRecord(id, instance.type);
      record = map$1.get(id);
    }
    record.instances.add(instance);
  }
  function unregisterHMR(instance) {
    map$1.get(instance.type.__hmrId).instances.delete(instance);
  }
  function createRecord(id, initialDef) {
    if (map$1.has(id)) {
      return false;
    }
    map$1.set(id, {
      initialDef: normalizeClassComponent(initialDef),
      instances: /* @__PURE__ */ new Set()
    });
    return true;
  }
  function normalizeClassComponent(component) {
    return isClassComponent(component) ? component.__vccOpts : component;
  }
  function rerender(id, newRender) {
    const record = map$1.get(id);
    if (!record) {
      return;
    }
    record.initialDef.render = newRender;
    [...record.instances].forEach((instance) => {
      if (newRender) {
        instance.render = newRender;
        normalizeClassComponent(instance.type).render = newRender;
      }
      instance.renderCache = [];
      isHmrUpdating = true;
      instance.effect.dirty = true;
      instance.update();
      isHmrUpdating = false;
    });
  }
  function reload(id, newComp) {
    const record = map$1.get(id);
    if (!record)
      return;
    newComp = normalizeClassComponent(newComp);
    updateComponentDef(record.initialDef, newComp);
    const instances = [...record.instances];
    for (const instance of instances) {
      const oldComp = normalizeClassComponent(instance.type);
      if (!hmrDirtyComponents.has(oldComp)) {
        if (oldComp !== record.initialDef) {
          updateComponentDef(oldComp, newComp);
        }
        hmrDirtyComponents.add(oldComp);
      }
      instance.appContext.propsCache.delete(instance.type);
      instance.appContext.emitsCache.delete(instance.type);
      instance.appContext.optionsCache.delete(instance.type);
      if (instance.ceReload) {
        hmrDirtyComponents.add(oldComp);
        instance.ceReload(newComp.styles);
        hmrDirtyComponents.delete(oldComp);
      } else if (instance.parent) {
        instance.parent.effect.dirty = true;
        queueJob(instance.parent.update);
      } else if (instance.appContext.reload) {
        instance.appContext.reload();
      } else if (typeof window !== "undefined") {
        window.location.reload();
      } else {
        console.warn(
          "[HMR] Root or manually mounted instance modified. Full reload required."
        );
      }
    }
    queuePostFlushCb(() => {
      for (const instance of instances) {
        hmrDirtyComponents.delete(
          normalizeClassComponent(instance.type)
        );
      }
    });
  }
  function updateComponentDef(oldComp, newComp) {
    extend(oldComp, newComp);
    for (const key in oldComp) {
      if (key !== "__file" && !(key in newComp)) {
        delete oldComp[key];
      }
    }
  }
  function tryWrap(fn2) {
    return (id, arg) => {
      try {
        return fn2(id, arg);
      } catch (e) {
        console.error(e);
        console.warn(
          `[HMR] Something went wrong during Vue component hot-reload. Full reload required.`
        );
      }
    };
  }
  let devtools$1;
  let buffer = [];
  let devtoolsNotInstalled = false;
  function emit$1(event, ...args) {
    if (devtools$1) {
      devtools$1.emit(event, ...args);
    } else if (!devtoolsNotInstalled) {
      buffer.push({ event, args });
    }
  }
  function setDevtoolsHook$1(hook, target) {
    var _a, _b;
    devtools$1 = hook;
    if (devtools$1) {
      devtools$1.enabled = true;
      buffer.forEach(({ event, args }) => devtools$1.emit(event, ...args));
      buffer = [];
    } else if (
      // handle late devtools injection - only do this if we are in an actual
      // browser environment to avoid the timer handle stalling test runner exit
      // (#4815)
      typeof window !== "undefined" && // some envs mock window but not fully
      window.HTMLElement && // also exclude jsdom
      !((_b = (_a = window.navigator) == null ? void 0 : _a.userAgent) == null ? void 0 : _b.includes("jsdom"))
    ) {
      const replay = target.__VUE_DEVTOOLS_HOOK_REPLAY__ = target.__VUE_DEVTOOLS_HOOK_REPLAY__ || [];
      replay.push((newHook) => {
        setDevtoolsHook$1(newHook, target);
      });
      setTimeout(() => {
        if (!devtools$1) {
          target.__VUE_DEVTOOLS_HOOK_REPLAY__ = null;
          devtoolsNotInstalled = true;
          buffer = [];
        }
      }, 3e3);
    } else {
      devtoolsNotInstalled = true;
      buffer = [];
    }
  }
  function devtoolsInitApp(app, version2) {
    emit$1("app:init", app, version2, {
      Fragment,
      Text: Text$1,
      Comment,
      Static
    });
  }
  function devtoolsUnmountApp(app) {
    emit$1("app:unmount", app);
  }
  const devtoolsComponentAdded = /* @__PURE__ */ createDevtoolsComponentHook(
    "component:added"
    /* COMPONENT_ADDED */
  );
  const devtoolsComponentUpdated = /* @__PURE__ */ createDevtoolsComponentHook(
    "component:updated"
    /* COMPONENT_UPDATED */
  );
  const _devtoolsComponentRemoved = /* @__PURE__ */ createDevtoolsComponentHook(
    "component:removed"
    /* COMPONENT_REMOVED */
  );
  const devtoolsComponentRemoved = (component) => {
    if (devtools$1 && typeof devtools$1.cleanupBuffer === "function" && // remove the component if it wasn't buffered
    !devtools$1.cleanupBuffer(component)) {
      _devtoolsComponentRemoved(component);
    }
  };
  function createDevtoolsComponentHook(hook) {
    return (component) => {
      emit$1(
        hook,
        component.appContext.app,
        component.uid,
        component.parent ? component.parent.uid : void 0,
        component
      );
    };
  }
  const devtoolsPerfStart = /* @__PURE__ */ createDevtoolsPerformanceHook(
    "perf:start"
    /* PERFORMANCE_START */
  );
  const devtoolsPerfEnd = /* @__PURE__ */ createDevtoolsPerformanceHook(
    "perf:end"
    /* PERFORMANCE_END */
  );
  function createDevtoolsPerformanceHook(hook) {
    return (component, type, time) => {
      emit$1(hook, component.appContext.app, component.uid, component, type, time);
    };
  }
  function devtoolsComponentEmit(component, event, params) {
    emit$1(
      "component:emit",
      component.appContext.app,
      component,
      event,
      params
    );
  }
  function emit(instance, event, ...rawArgs) {
    if (instance.isUnmounted)
      return;
    const props = instance.vnode.props || EMPTY_OBJ;
    if (!!(process.env.NODE_ENV !== "production")) {
      const {
        emitsOptions,
        propsOptions: [propsOptions]
      } = instance;
      if (emitsOptions) {
        if (!(event in emitsOptions) && true) {
          if (!propsOptions || !(toHandlerKey(event) in propsOptions)) {
            warn$1(
              `Component emitted event "${event}" but it is neither declared in the emits option nor as an "${toHandlerKey(event)}" prop.`
            );
          }
        } else {
          const validator = emitsOptions[event];
          if (isFunction(validator)) {
            const isValid = validator(...rawArgs);
            if (!isValid) {
              warn$1(
                `Invalid event arguments: event validation failed for event "${event}".`
              );
            }
          }
        }
      }
    }
    let args = rawArgs;
    const isModelListener2 = event.startsWith("update:");
    const modelArg = isModelListener2 && event.slice(7);
    if (modelArg && modelArg in props) {
      const modifiersKey = `${modelArg === "modelValue" ? "model" : modelArg}Modifiers`;
      const { number, trim } = props[modifiersKey] || EMPTY_OBJ;
      if (trim) {
        args = rawArgs.map((a2) => isString(a2) ? a2.trim() : a2);
      }
      if (number) {
        args = rawArgs.map(looseToNumber);
      }
    }
    if (!!(process.env.NODE_ENV !== "production") || false) {
      devtoolsComponentEmit(instance, event, args);
    }
    if (!!(process.env.NODE_ENV !== "production")) {
      const lowerCaseEvent = event.toLowerCase();
      if (lowerCaseEvent !== event && props[toHandlerKey(lowerCaseEvent)]) {
        warn$1(
          `Event "${lowerCaseEvent}" is emitted in component ${formatComponentName(
            instance,
            instance.type
          )} but the handler is registered for "${event}". Note that HTML attributes are case-insensitive and you cannot use v-on to listen to camelCase events when using in-DOM templates. You should probably use "${hyphenate(
            event
          )}" instead of "${event}".`
        );
      }
    }
    let handlerName;
    let handler = props[handlerName = toHandlerKey(event)] || // also try camelCase event handler (#2249)
    props[handlerName = toHandlerKey(camelize(event))];
    if (!handler && isModelListener2) {
      handler = props[handlerName = toHandlerKey(hyphenate(event))];
    }
    if (handler) {
      callWithAsyncErrorHandling(
        handler,
        instance,
        6,
        args
      );
    }
    const onceHandler = props[handlerName + `Once`];
    if (onceHandler) {
      if (!instance.emitted) {
        instance.emitted = {};
      } else if (instance.emitted[handlerName]) {
        return;
      }
      instance.emitted[handlerName] = true;
      callWithAsyncErrorHandling(
        onceHandler,
        instance,
        6,
        args
      );
    }
  }
  function normalizeEmitsOptions(comp, appContext, asMixin = false) {
    const cache = appContext.emitsCache;
    const cached = cache.get(comp);
    if (cached !== void 0) {
      return cached;
    }
    const raw = comp.emits;
    let normalized = {};
    let hasExtends = false;
    if (!isFunction(comp)) {
      const extendEmits = (raw2) => {
        const normalizedFromExtend = normalizeEmitsOptions(raw2, appContext, true);
        if (normalizedFromExtend) {
          hasExtends = true;
          extend(normalized, normalizedFromExtend);
        }
      };
      if (!asMixin && appContext.mixins.length) {
        appContext.mixins.forEach(extendEmits);
      }
      if (comp.extends) {
        extendEmits(comp.extends);
      }
      if (comp.mixins) {
        comp.mixins.forEach(extendEmits);
      }
    }
    if (!raw && !hasExtends) {
      if (isObject(comp)) {
        cache.set(comp, null);
      }
      return null;
    }
    if (isArray(raw)) {
      raw.forEach((key) => normalized[key] = null);
    } else {
      extend(normalized, raw);
    }
    if (isObject(comp)) {
      cache.set(comp, normalized);
    }
    return normalized;
  }
  function isEmitListener(options, key) {
    if (!options || !isOn(key)) {
      return false;
    }
    key = key.slice(2).replace(/Once$/, "");
    return hasOwn(options, key[0].toLowerCase() + key.slice(1)) || hasOwn(options, hyphenate(key)) || hasOwn(options, key);
  }
  let currentRenderingInstance = null;
  let currentScopeId = null;
  function setCurrentRenderingInstance(instance) {
    const prev = currentRenderingInstance;
    currentRenderingInstance = instance;
    currentScopeId = instance && instance.type.__scopeId || null;
    return prev;
  }
  function withCtx(fn2, ctx = currentRenderingInstance, isNonScopedSlot) {
    if (!ctx)
      return fn2;
    if (fn2._n) {
      return fn2;
    }
    const renderFnWithContext = (...args) => {
      if (renderFnWithContext._d) {
        setBlockTracking(-1);
      }
      const prevInstance = setCurrentRenderingInstance(ctx);
      let res;
      try {
        res = fn2(...args);
      } finally {
        setCurrentRenderingInstance(prevInstance);
        if (renderFnWithContext._d) {
          setBlockTracking(1);
        }
      }
      if (!!(process.env.NODE_ENV !== "production") || false) {
        devtoolsComponentUpdated(ctx);
      }
      return res;
    };
    renderFnWithContext._n = true;
    renderFnWithContext._c = true;
    renderFnWithContext._d = true;
    return renderFnWithContext;
  }
  let accessedAttrs = false;
  function markAttrsAccessed() {
    accessedAttrs = true;
  }
  function renderComponentRoot(instance) {
    const {
      type: Component2,
      vnode,
      proxy,
      withProxy,
      props,
      propsOptions: [propsOptions],
      slots,
      attrs,
      emit: emit2,
      render,
      renderCache,
      data,
      setupState,
      ctx,
      inheritAttrs
    } = instance;
    let result;
    let fallthroughAttrs;
    const prev = setCurrentRenderingInstance(instance);
    if (!!(process.env.NODE_ENV !== "production")) {
      accessedAttrs = false;
    }
    try {
      if (vnode.shapeFlag & 4) {
        const proxyToUse = withProxy || proxy;
        const thisProxy = !!(process.env.NODE_ENV !== "production") && setupState.__isScriptSetup ? new Proxy(proxyToUse, {
          get(target, key, receiver) {
            warn$1(
              `Property '${String(
                key
              )}' was accessed via 'this'. Avoid using 'this' in templates.`
            );
            return Reflect.get(target, key, receiver);
          }
        }) : proxyToUse;
        result = normalizeVNode(
          render.call(
            thisProxy,
            proxyToUse,
            renderCache,
            props,
            setupState,
            data,
            ctx
          )
        );
        fallthroughAttrs = attrs;
      } else {
        const render2 = Component2;
        if (!!(process.env.NODE_ENV !== "production") && attrs === props) {
          markAttrsAccessed();
        }
        result = normalizeVNode(
          render2.length > 1 ? render2(
            props,
            !!(process.env.NODE_ENV !== "production") ? {
              get attrs() {
                markAttrsAccessed();
                return attrs;
              },
              slots,
              emit: emit2
            } : { attrs, slots, emit: emit2 }
          ) : render2(
            props,
            null
            /* we know it doesn't need it */
          )
        );
        fallthroughAttrs = Component2.props ? attrs : getFunctionalFallthrough(attrs);
      }
    } catch (err) {
      blockStack.length = 0;
      handleError(err, instance, 1);
      result = createVNode$1(Comment);
    }
    let root = result;
    let setRoot = void 0;
    if (!!(process.env.NODE_ENV !== "production") && result.patchFlag > 0 && result.patchFlag & 2048) {
      [root, setRoot] = getChildRoot(result);
    }
    if (fallthroughAttrs && inheritAttrs !== false) {
      const keys = Object.keys(fallthroughAttrs);
      const { shapeFlag } = root;
      if (keys.length) {
        if (shapeFlag & (1 | 6)) {
          if (propsOptions && keys.some(isModelListener)) {
            fallthroughAttrs = filterModelListeners(
              fallthroughAttrs,
              propsOptions
            );
          }
          root = cloneVNode(root, fallthroughAttrs);
        } else if (!!(process.env.NODE_ENV !== "production") && !accessedAttrs && root.type !== Comment) {
          const allAttrs = Object.keys(attrs);
          const eventAttrs = [];
          const extraAttrs = [];
          for (let i2 = 0, l2 = allAttrs.length; i2 < l2; i2++) {
            const key = allAttrs[i2];
            if (isOn(key)) {
              if (!isModelListener(key)) {
                eventAttrs.push(key[2].toLowerCase() + key.slice(3));
              }
            } else {
              extraAttrs.push(key);
            }
          }
          if (extraAttrs.length) {
            warn$1(
              `Extraneous non-props attributes (${extraAttrs.join(", ")}) were passed to component but could not be automatically inherited because component renders fragment or text root nodes.`
            );
          }
          if (eventAttrs.length) {
            warn$1(
              `Extraneous non-emits event listeners (${eventAttrs.join(", ")}) were passed to component but could not be automatically inherited because component renders fragment or text root nodes. If the listener is intended to be a component custom event listener only, declare it using the "emits" option.`
            );
          }
        }
      }
    }
    if (vnode.dirs) {
      if (!!(process.env.NODE_ENV !== "production") && !isElementRoot(root)) {
        warn$1(
          `Runtime directive used on component with non-element root node. The directives will not function as intended.`
        );
      }
      root = cloneVNode(root);
      root.dirs = root.dirs ? root.dirs.concat(vnode.dirs) : vnode.dirs;
    }
    if (vnode.transition) {
      if (!!(process.env.NODE_ENV !== "production") && !isElementRoot(root)) {
        warn$1(
          `Component inside <Transition> renders non-element root node that cannot be animated.`
        );
      }
      root.transition = vnode.transition;
    }
    if (!!(process.env.NODE_ENV !== "production") && setRoot) {
      setRoot(root);
    } else {
      result = root;
    }
    setCurrentRenderingInstance(prev);
    return result;
  }
  const getChildRoot = (vnode) => {
    const rawChildren = vnode.children;
    const dynamicChildren = vnode.dynamicChildren;
    const childRoot = filterSingleRoot(rawChildren, false);
    if (!childRoot) {
      return [vnode, void 0];
    } else if (!!(process.env.NODE_ENV !== "production") && childRoot.patchFlag > 0 && childRoot.patchFlag & 2048) {
      return getChildRoot(childRoot);
    }
    const index = rawChildren.indexOf(childRoot);
    const dynamicIndex = dynamicChildren ? dynamicChildren.indexOf(childRoot) : -1;
    const setRoot = (updatedRoot) => {
      rawChildren[index] = updatedRoot;
      if (dynamicChildren) {
        if (dynamicIndex > -1) {
          dynamicChildren[dynamicIndex] = updatedRoot;
        } else if (updatedRoot.patchFlag > 0) {
          vnode.dynamicChildren = [...dynamicChildren, updatedRoot];
        }
      }
    };
    return [normalizeVNode(childRoot), setRoot];
  };
  function filterSingleRoot(children, recurse = true) {
    let singleRoot;
    for (let i2 = 0; i2 < children.length; i2++) {
      const child = children[i2];
      if (isVNode(child)) {
        if (child.type !== Comment || child.children === "v-if") {
          if (singleRoot) {
            return;
          } else {
            singleRoot = child;
            if (!!(process.env.NODE_ENV !== "production") && recurse && singleRoot.patchFlag > 0 && singleRoot.patchFlag & 2048) {
              return filterSingleRoot(singleRoot.children);
            }
          }
        }
      } else {
        return;
      }
    }
    return singleRoot;
  }
  const getFunctionalFallthrough = (attrs) => {
    let res;
    for (const key in attrs) {
      if (key === "class" || key === "style" || isOn(key)) {
        (res || (res = {}))[key] = attrs[key];
      }
    }
    return res;
  };
  const filterModelListeners = (attrs, props) => {
    const res = {};
    for (const key in attrs) {
      if (!isModelListener(key) || !(key.slice(9) in props)) {
        res[key] = attrs[key];
      }
    }
    return res;
  };
  const isElementRoot = (vnode) => {
    return vnode.shapeFlag & (6 | 1) || vnode.type === Comment;
  };
  function shouldUpdateComponent(prevVNode, nextVNode, optimized) {
    const { props: prevProps, children: prevChildren, component } = prevVNode;
    const { props: nextProps, children: nextChildren, patchFlag } = nextVNode;
    const emits = component.emitsOptions;
    if (!!(process.env.NODE_ENV !== "production") && (prevChildren || nextChildren) && isHmrUpdating) {
      return true;
    }
    if (nextVNode.dirs || nextVNode.transition) {
      return true;
    }
    if (optimized && patchFlag >= 0) {
      if (patchFlag & 1024) {
        return true;
      }
      if (patchFlag & 16) {
        if (!prevProps) {
          return !!nextProps;
        }
        return hasPropsChanged(prevProps, nextProps, emits);
      } else if (patchFlag & 8) {
        const dynamicProps = nextVNode.dynamicProps;
        for (let i2 = 0; i2 < dynamicProps.length; i2++) {
          const key = dynamicProps[i2];
          if (nextProps[key] !== prevProps[key] && !isEmitListener(emits, key)) {
            return true;
          }
        }
      }
    } else {
      if (prevChildren || nextChildren) {
        if (!nextChildren || !nextChildren.$stable) {
          return true;
        }
      }
      if (prevProps === nextProps) {
        return false;
      }
      if (!prevProps) {
        return !!nextProps;
      }
      if (!nextProps) {
        return true;
      }
      return hasPropsChanged(prevProps, nextProps, emits);
    }
    return false;
  }
  function hasPropsChanged(prevProps, nextProps, emitsOptions) {
    const nextKeys = Object.keys(nextProps);
    if (nextKeys.length !== Object.keys(prevProps).length) {
      return true;
    }
    for (let i2 = 0; i2 < nextKeys.length; i2++) {
      const key = nextKeys[i2];
      if (nextProps[key] !== prevProps[key] && !isEmitListener(emitsOptions, key)) {
        return true;
      }
    }
    return false;
  }
  function updateHOCHostEl({ vnode, parent }, el) {
    while (parent) {
      const root = parent.subTree;
      if (root.suspense && root.suspense.activeBranch === vnode) {
        root.el = vnode.el;
      }
      if (root === vnode) {
        (vnode = parent.vnode).el = el;
        parent = parent.parent;
      } else {
        break;
      }
    }
  }
  const COMPONENTS = "components";
  const NULL_DYNAMIC_COMPONENT = Symbol.for("v-ndc");
  function resolveDynamicComponent(component) {
    if (isString(component)) {
      return resolveAsset(COMPONENTS, component, false) || component;
    } else {
      return component || NULL_DYNAMIC_COMPONENT;
    }
  }
  function resolveAsset(type, name, warnMissing = true, maybeSelfReference = false) {
    const instance = currentRenderingInstance || currentInstance;
    if (instance) {
      const Component2 = instance.type;
      if (type === COMPONENTS) {
        const selfName = getComponentName(
          Component2,
          false
        );
        if (selfName && (selfName === name || selfName === camelize(name) || selfName === capitalize(camelize(name)))) {
          return Component2;
        }
      }
      const res = (
        // local registration
        // check instance[type] first which is resolved for options API
        resolve(instance[type] || Component2[type], name) || // global registration
        resolve(instance.appContext[type], name)
      );
      if (!res && maybeSelfReference) {
        return Component2;
      }
      if (!!(process.env.NODE_ENV !== "production") && warnMissing && !res) {
        const extra = type === COMPONENTS ? `
If this is a native custom element, make sure to exclude it from component resolution via compilerOptions.isCustomElement.` : ``;
        warn$1(`Failed to resolve ${type.slice(0, -1)}: ${name}${extra}`);
      }
      return res;
    } else if (!!(process.env.NODE_ENV !== "production")) {
      warn$1(
        `resolve${capitalize(type.slice(0, -1))} can only be used in render() or setup().`
      );
    }
  }
  function resolve(registry, name) {
    return registry && (registry[name] || registry[camelize(name)] || registry[capitalize(camelize(name))]);
  }
  const isSuspense = (type) => type.__isSuspense;
  function queueEffectWithSuspense(fn2, suspense) {
    if (suspense && suspense.pendingBranch) {
      if (isArray(fn2)) {
        suspense.effects.push(...fn2);
      } else {
        suspense.effects.push(fn2);
      }
    } else {
      queuePostFlushCb(fn2);
    }
  }
  const ssrContextKey = Symbol.for("v-scx");
  const useSSRContext = () => {
    {
      const ctx = inject(ssrContextKey);
      if (!ctx) {
        !!(process.env.NODE_ENV !== "production") && warn$1(
          `Server rendering context not provided. Make sure to only call useSSRContext() conditionally in the server build.`
        );
      }
      return ctx;
    }
  };
  const INITIAL_WATCHER_VALUE = {};
  function watch(source, cb, options) {
    if (!!(process.env.NODE_ENV !== "production") && !isFunction(cb)) {
      warn$1(
        `\`watch(fn, options?)\` signature has been moved to a separate API. Use \`watchEffect(fn, options?)\` instead. \`watch\` now only supports \`watch(source, cb, options?) signature.`
      );
    }
    return doWatch(source, cb, options);
  }
  function doWatch(source, cb, {
    immediate,
    deep,
    flush,
    once,
    onTrack,
    onTrigger
  } = EMPTY_OBJ) {
    if (cb && once) {
      const _cb = cb;
      cb = (...args) => {
        _cb(...args);
        unwatch();
      };
    }
    if (!!(process.env.NODE_ENV !== "production") && deep !== void 0 && typeof deep === "number") {
      warn$1(
        `watch() "deep" option with number value will be used as watch depth in future versions. Please use a boolean instead to avoid potential breakage.`
      );
    }
    if (!!(process.env.NODE_ENV !== "production") && !cb) {
      if (immediate !== void 0) {
        warn$1(
          `watch() "immediate" option is only respected when using the watch(source, callback, options?) signature.`
        );
      }
      if (deep !== void 0) {
        warn$1(
          `watch() "deep" option is only respected when using the watch(source, callback, options?) signature.`
        );
      }
      if (once !== void 0) {
        warn$1(
          `watch() "once" option is only respected when using the watch(source, callback, options?) signature.`
        );
      }
    }
    const warnInvalidSource = (s2) => {
      warn$1(
        `Invalid watch source: `,
        s2,
        `A watch source can only be a getter/effect function, a ref, a reactive object, or an array of these types.`
      );
    };
    const instance = currentInstance;
    const reactiveGetter = (source2) => deep === true ? source2 : (
      // for deep: false, only traverse root-level properties
      traverse(source2, deep === false ? 1 : void 0)
    );
    let getter;
    let forceTrigger = false;
    let isMultiSource = false;
    if (isRef(source)) {
      getter = () => source.value;
      forceTrigger = isShallow(source);
    } else if (isReactive(source)) {
      getter = () => reactiveGetter(source);
      forceTrigger = true;
    } else if (isArray(source)) {
      isMultiSource = true;
      forceTrigger = source.some((s2) => isReactive(s2) || isShallow(s2));
      getter = () => source.map((s2) => {
        if (isRef(s2)) {
          return s2.value;
        } else if (isReactive(s2)) {
          return reactiveGetter(s2);
        } else if (isFunction(s2)) {
          return callWithErrorHandling(s2, instance, 2);
        } else {
          !!(process.env.NODE_ENV !== "production") && warnInvalidSource(s2);
        }
      });
    } else if (isFunction(source)) {
      if (cb) {
        getter = () => callWithErrorHandling(source, instance, 2);
      } else {
        getter = () => {
          if (cleanup) {
            cleanup();
          }
          return callWithAsyncErrorHandling(
            source,
            instance,
            3,
            [onCleanup]
          );
        };
      }
    } else {
      getter = NOOP;
      !!(process.env.NODE_ENV !== "production") && warnInvalidSource(source);
    }
    if (cb && deep) {
      const baseGetter = getter;
      getter = () => traverse(baseGetter());
    }
    let cleanup;
    let onCleanup = (fn2) => {
      cleanup = effect2.onStop = () => {
        callWithErrorHandling(fn2, instance, 4);
        cleanup = effect2.onStop = void 0;
      };
    };
    let ssrCleanup;
    if (isInSSRComponentSetup) {
      onCleanup = NOOP;
      if (!cb) {
        getter();
      } else if (immediate) {
        callWithAsyncErrorHandling(cb, instance, 3, [
          getter(),
          isMultiSource ? [] : void 0,
          onCleanup
        ]);
      }
      if (flush === "sync") {
        const ctx = useSSRContext();
        ssrCleanup = ctx.__watcherHandles || (ctx.__watcherHandles = []);
      } else {
        return NOOP;
      }
    }
    let oldValue = isMultiSource ? new Array(source.length).fill(INITIAL_WATCHER_VALUE) : INITIAL_WATCHER_VALUE;
    const job = () => {
      if (!effect2.active || !effect2.dirty) {
        return;
      }
      if (cb) {
        const newValue = effect2.run();
        if (deep || forceTrigger || (isMultiSource ? newValue.some((v2, i2) => hasChanged(v2, oldValue[i2])) : hasChanged(newValue, oldValue)) || false) {
          if (cleanup) {
            cleanup();
          }
          callWithAsyncErrorHandling(cb, instance, 3, [
            newValue,
            // pass undefined as the old value when it's changed for the first time
            oldValue === INITIAL_WATCHER_VALUE ? void 0 : isMultiSource && oldValue[0] === INITIAL_WATCHER_VALUE ? [] : oldValue,
            onCleanup
          ]);
          oldValue = newValue;
        }
      } else {
        effect2.run();
      }
    };
    job.allowRecurse = !!cb;
    let scheduler;
    if (flush === "sync") {
      scheduler = job;
    } else if (flush === "post") {
      scheduler = () => queuePostRenderEffect(job, instance && instance.suspense);
    } else {
      job.pre = true;
      if (instance)
        job.id = instance.uid;
      scheduler = () => queueJob(job);
    }
    const effect2 = new ReactiveEffect(getter, NOOP, scheduler);
    const scope = getCurrentScope();
    const unwatch = () => {
      effect2.stop();
      if (scope) {
        remove(scope.effects, effect2);
      }
    };
    if (!!(process.env.NODE_ENV !== "production")) {
      effect2.onTrack = onTrack;
      effect2.onTrigger = onTrigger;
    }
    if (cb) {
      if (immediate) {
        job();
      } else {
        oldValue = effect2.run();
      }
    } else if (flush === "post") {
      queuePostRenderEffect(
        effect2.run.bind(effect2),
        instance && instance.suspense
      );
    } else {
      effect2.run();
    }
    if (ssrCleanup)
      ssrCleanup.push(unwatch);
    return unwatch;
  }
  function instanceWatch(source, value, options) {
    const publicThis = this.proxy;
    const getter = isString(source) ? source.includes(".") ? createPathGetter(publicThis, source) : () => publicThis[source] : source.bind(publicThis, publicThis);
    let cb;
    if (isFunction(value)) {
      cb = value;
    } else {
      cb = value.handler;
      options = value;
    }
    const reset = setCurrentInstance(this);
    const res = doWatch(getter, cb.bind(publicThis), options);
    reset();
    return res;
  }
  function createPathGetter(ctx, path) {
    const segments = path.split(".");
    return () => {
      let cur = ctx;
      for (let i2 = 0; i2 < segments.length && cur; i2++) {
        cur = cur[segments[i2]];
      }
      return cur;
    };
  }
  function traverse(value, depth, currentDepth = 0, seen) {
    if (!isObject(value) || value["__v_skip"]) {
      return value;
    }
    if (depth && depth > 0) {
      if (currentDepth >= depth) {
        return value;
      }
      currentDepth++;
    }
    seen = seen || /* @__PURE__ */ new Set();
    if (seen.has(value)) {
      return value;
    }
    seen.add(value);
    if (isRef(value)) {
      traverse(value.value, depth, currentDepth, seen);
    } else if (isArray(value)) {
      for (let i2 = 0; i2 < value.length; i2++) {
        traverse(value[i2], depth, currentDepth, seen);
      }
    } else if (isSet(value) || isMap(value)) {
      value.forEach((v2) => {
        traverse(v2, depth, currentDepth, seen);
      });
    } else if (isPlainObject(value)) {
      for (const key in value) {
        traverse(value[key], depth, currentDepth, seen);
      }
    }
    return value;
  }
  function validateDirectiveName(name) {
    if (isBuiltInDirective(name)) {
      warn$1("Do not use built-in directive ids as custom directive id: " + name);
    }
  }
  function invokeDirectiveHook(vnode, prevVNode, instance, name) {
    const bindings = vnode.dirs;
    const oldBindings = prevVNode && prevVNode.dirs;
    for (let i2 = 0; i2 < bindings.length; i2++) {
      const binding = bindings[i2];
      if (oldBindings) {
        binding.oldValue = oldBindings[i2].value;
      }
      let hook = binding.dir[name];
      if (hook) {
        pauseTracking();
        callWithAsyncErrorHandling(hook, instance, 8, [
          vnode.el,
          binding,
          vnode,
          prevVNode
        ]);
        resetTracking();
      }
    }
  }
  /*! #__NO_SIDE_EFFECTS__ */
  // @__NO_SIDE_EFFECTS__
  function defineComponent$1(options, extraOptions) {
    return isFunction(options) ? (
      // #8326: extend call and options.name access are considered side-effects
      // by Rollup, so we have to wrap it in a pure-annotated IIFE.
      /* @__PURE__ */ (() => extend({ name: options.name }, extraOptions, { setup: options }))()
    ) : options;
  }
  const isAsyncWrapper = (i2) => !!i2.type.__asyncLoader;
  const isKeepAlive = (vnode) => vnode.type.__isKeepAlive;
  function onActivated(hook, target) {
    registerKeepAliveHook(hook, "a", target);
  }
  function onDeactivated(hook, target) {
    registerKeepAliveHook(hook, "da", target);
  }
  function registerKeepAliveHook(hook, type, target = currentInstance) {
    const wrappedHook = hook.__wdc || (hook.__wdc = () => {
      let current = target;
      while (current) {
        if (current.isDeactivated) {
          return;
        }
        current = current.parent;
      }
      return hook();
    });
    injectHook(type, wrappedHook, target);
    if (target) {
      let current = target.parent;
      while (current && current.parent) {
        if (isKeepAlive(current.parent.vnode)) {
          injectToKeepAliveRoot(wrappedHook, type, target, current);
        }
        current = current.parent;
      }
    }
  }
  function injectToKeepAliveRoot(hook, type, target, keepAliveRoot) {
    const injected = injectHook(
      type,
      hook,
      keepAliveRoot,
      true
      /* prepend */
    );
    onUnmounted(() => {
      remove(keepAliveRoot[type], injected);
    }, target);
  }
  function injectHook(type, hook, target = currentInstance, prepend = false) {
    if (target) {
      const hooks = target[type] || (target[type] = []);
      const wrappedHook = hook.__weh || (hook.__weh = (...args) => {
        if (target.isUnmounted) {
          return;
        }
        pauseTracking();
        const reset = setCurrentInstance(target);
        const res = callWithAsyncErrorHandling(hook, target, type, args);
        reset();
        resetTracking();
        return res;
      });
      if (prepend) {
        hooks.unshift(wrappedHook);
      } else {
        hooks.push(wrappedHook);
      }
      return wrappedHook;
    } else if (!!(process.env.NODE_ENV !== "production")) {
      const apiName = toHandlerKey(ErrorTypeStrings$1[type].replace(/ hook$/, ""));
      warn$1(
        `${apiName} is called when there is no active component instance to be associated with. Lifecycle injection APIs can only be used during execution of setup(). If you are using async setup(), make sure to register lifecycle hooks before the first await statement.`
      );
    }
  }
  const createHook = (lifecycle) => (hook, target = currentInstance) => (
    // post-create lifecycle registrations are noops during SSR (except for serverPrefetch)
    (!isInSSRComponentSetup || lifecycle === "sp") && injectHook(lifecycle, (...args) => hook(...args), target)
  );
  const onBeforeMount = createHook("bm");
  const onMounted = createHook("m");
  const onBeforeUpdate = createHook("bu");
  const onUpdated = createHook("u");
  const onBeforeUnmount = createHook("bum");
  const onUnmounted = createHook("um");
  const onServerPrefetch = createHook("sp");
  const onRenderTriggered = createHook(
    "rtg"
  );
  const onRenderTracked = createHook(
    "rtc"
  );
  function onErrorCaptured(hook, target = currentInstance) {
    injectHook("ec", hook, target);
  }
  const getPublicInstance = (i2) => {
    if (!i2)
      return null;
    if (isStatefulComponent(i2))
      return getExposeProxy(i2) || i2.proxy;
    return getPublicInstance(i2.parent);
  };
  const publicPropertiesMap = (
    // Move PURE marker to new line to workaround compiler discarding it
    // due to type annotation
    /* @__PURE__ */ extend(/* @__PURE__ */ Object.create(null), {
      $: (i2) => i2,
      $el: (i2) => i2.vnode.el,
      $data: (i2) => i2.data,
      $props: (i2) => !!(process.env.NODE_ENV !== "production") ? shallowReadonly(i2.props) : i2.props,
      $attrs: (i2) => !!(process.env.NODE_ENV !== "production") ? shallowReadonly(i2.attrs) : i2.attrs,
      $slots: (i2) => !!(process.env.NODE_ENV !== "production") ? shallowReadonly(i2.slots) : i2.slots,
      $refs: (i2) => !!(process.env.NODE_ENV !== "production") ? shallowReadonly(i2.refs) : i2.refs,
      $parent: (i2) => getPublicInstance(i2.parent),
      $root: (i2) => getPublicInstance(i2.root),
      $emit: (i2) => i2.emit,
      $options: (i2) => resolveMergedOptions(i2),
      $forceUpdate: (i2) => i2.f || (i2.f = () => {
        i2.effect.dirty = true;
        queueJob(i2.update);
      }),
      $nextTick: (i2) => i2.n || (i2.n = nextTick.bind(i2.proxy)),
      $watch: (i2) => instanceWatch.bind(i2)
    })
  );
  const isReservedPrefix = (key) => key === "_" || key === "$";
  const hasSetupBinding = (state, key) => state !== EMPTY_OBJ && !state.__isScriptSetup && hasOwn(state, key);
  const PublicInstanceProxyHandlers = {
    get({ _: instance }, key) {
      const { ctx, setupState, data, props, accessCache, type, appContext } = instance;
      if (!!(process.env.NODE_ENV !== "production") && key === "__isVue") {
        return true;
      }
      let normalizedProps;
      if (key[0] !== "$") {
        const n2 = accessCache[key];
        if (n2 !== void 0) {
          switch (n2) {
            case 1:
              return setupState[key];
            case 2:
              return data[key];
            case 4:
              return ctx[key];
            case 3:
              return props[key];
          }
        } else if (hasSetupBinding(setupState, key)) {
          accessCache[key] = 1;
          return setupState[key];
        } else if (data !== EMPTY_OBJ && hasOwn(data, key)) {
          accessCache[key] = 2;
          return data[key];
        } else if (
          // only cache other properties when instance has declared (thus stable)
          // props
          (normalizedProps = instance.propsOptions[0]) && hasOwn(normalizedProps, key)
        ) {
          accessCache[key] = 3;
          return props[key];
        } else if (ctx !== EMPTY_OBJ && hasOwn(ctx, key)) {
          accessCache[key] = 4;
          return ctx[key];
        } else if (shouldCacheAccess) {
          accessCache[key] = 0;
        }
      }
      const publicGetter = publicPropertiesMap[key];
      let cssModule, globalProperties;
      if (publicGetter) {
        if (key === "$attrs") {
          track(instance, "get", key);
          !!(process.env.NODE_ENV !== "production") && markAttrsAccessed();
        } else if (!!(process.env.NODE_ENV !== "production") && key === "$slots") {
          track(instance, "get", key);
        }
        return publicGetter(instance);
      } else if (
        // css module (injected by vue-loader)
        (cssModule = type.__cssModules) && (cssModule = cssModule[key])
      ) {
        return cssModule;
      } else if (ctx !== EMPTY_OBJ && hasOwn(ctx, key)) {
        accessCache[key] = 4;
        return ctx[key];
      } else if (
        // global properties
        globalProperties = appContext.config.globalProperties, hasOwn(globalProperties, key)
      ) {
        {
          return globalProperties[key];
        }
      } else if (!!(process.env.NODE_ENV !== "production") && currentRenderingInstance && (!isString(key) || // #1091 avoid internal isRef/isVNode checks on component instance leading
      // to infinite warning loop
      key.indexOf("__v") !== 0)) {
        if (data !== EMPTY_OBJ && isReservedPrefix(key[0]) && hasOwn(data, key)) {
          warn$1(
            `Property ${JSON.stringify(
              key
            )} must be accessed via $data because it starts with a reserved character ("$" or "_") and is not proxied on the render context.`
          );
        } else if (instance === currentRenderingInstance) {
          warn$1(
            `Property ${JSON.stringify(key)} was accessed during render but is not defined on instance.`
          );
        }
      }
    },
    set({ _: instance }, key, value) {
      const { data, setupState, ctx } = instance;
      if (hasSetupBinding(setupState, key)) {
        setupState[key] = value;
        return true;
      } else if (!!(process.env.NODE_ENV !== "production") && setupState.__isScriptSetup && hasOwn(setupState, key)) {
        warn$1(`Cannot mutate <script setup> binding "${key}" from Options API.`);
        return false;
      } else if (data !== EMPTY_OBJ && hasOwn(data, key)) {
        data[key] = value;
        return true;
      } else if (hasOwn(instance.props, key)) {
        !!(process.env.NODE_ENV !== "production") && warn$1(`Attempting to mutate prop "${key}". Props are readonly.`);
        return false;
      }
      if (key[0] === "$" && key.slice(1) in instance) {
        !!(process.env.NODE_ENV !== "production") && warn$1(
          `Attempting to mutate public property "${key}". Properties starting with $ are reserved and readonly.`
        );
        return false;
      } else {
        if (!!(process.env.NODE_ENV !== "production") && key in instance.appContext.config.globalProperties) {
          Object.defineProperty(ctx, key, {
            enumerable: true,
            configurable: true,
            value
          });
        } else {
          ctx[key] = value;
        }
      }
      return true;
    },
    has({
      _: { data, setupState, accessCache, ctx, appContext, propsOptions }
    }, key) {
      let normalizedProps;
      return !!accessCache[key] || data !== EMPTY_OBJ && hasOwn(data, key) || hasSetupBinding(setupState, key) || (normalizedProps = propsOptions[0]) && hasOwn(normalizedProps, key) || hasOwn(ctx, key) || hasOwn(publicPropertiesMap, key) || hasOwn(appContext.config.globalProperties, key);
    },
    defineProperty(target, key, descriptor) {
      if (descriptor.get != null) {
        target._.accessCache[key] = 0;
      } else if (hasOwn(descriptor, "value")) {
        this.set(target, key, descriptor.value, null);
      }
      return Reflect.defineProperty(target, key, descriptor);
    }
  };
  if (!!(process.env.NODE_ENV !== "production") && true) {
    PublicInstanceProxyHandlers.ownKeys = (target) => {
      warn$1(
        `Avoid app logic that relies on enumerating keys on a component instance. The keys will be empty in production mode to avoid performance overhead.`
      );
      return Reflect.ownKeys(target);
    };
  }
  function createDevRenderContext(instance) {
    const target = {};
    Object.defineProperty(target, `_`, {
      configurable: true,
      enumerable: false,
      get: () => instance
    });
    Object.keys(publicPropertiesMap).forEach((key) => {
      Object.defineProperty(target, key, {
        configurable: true,
        enumerable: false,
        get: () => publicPropertiesMap[key](instance),
        // intercepted by the proxy so no need for implementation,
        // but needed to prevent set errors
        set: NOOP
      });
    });
    return target;
  }
  function exposePropsOnRenderContext(instance) {
    const {
      ctx,
      propsOptions: [propsOptions]
    } = instance;
    if (propsOptions) {
      Object.keys(propsOptions).forEach((key) => {
        Object.defineProperty(ctx, key, {
          enumerable: true,
          configurable: true,
          get: () => instance.props[key],
          set: NOOP
        });
      });
    }
  }
  function exposeSetupStateOnRenderContext(instance) {
    const { ctx, setupState } = instance;
    Object.keys(toRaw(setupState)).forEach((key) => {
      if (!setupState.__isScriptSetup) {
        if (isReservedPrefix(key[0])) {
          warn$1(
            `setup() return property ${JSON.stringify(
              key
            )} should not start with "$" or "_" which are reserved prefixes for Vue internals.`
          );
          return;
        }
        Object.defineProperty(ctx, key, {
          enumerable: true,
          configurable: true,
          get: () => setupState[key],
          set: NOOP
        });
      }
    });
  }
  function normalizePropsOrEmits(props) {
    return isArray(props) ? props.reduce(
      (normalized, p2) => (normalized[p2] = null, normalized),
      {}
    ) : props;
  }
  function createDuplicateChecker() {
    const cache = /* @__PURE__ */ Object.create(null);
    return (type, key) => {
      if (cache[key]) {
        warn$1(`${type} property "${key}" is already defined in ${cache[key]}.`);
      } else {
        cache[key] = type;
      }
    };
  }
  let shouldCacheAccess = true;
  function applyOptions(instance) {
    const options = resolveMergedOptions(instance);
    const publicThis = instance.proxy;
    const ctx = instance.ctx;
    shouldCacheAccess = false;
    if (options.beforeCreate) {
      callHook(options.beforeCreate, instance, "bc");
    }
    const {
      // state
      data: dataOptions,
      computed: computedOptions,
      methods,
      watch: watchOptions,
      provide: provideOptions,
      inject: injectOptions,
      // lifecycle
      created,
      beforeMount,
      mounted,
      beforeUpdate,
      updated,
      activated,
      deactivated,
      beforeDestroy,
      beforeUnmount,
      destroyed,
      unmounted,
      render,
      renderTracked,
      renderTriggered,
      errorCaptured,
      serverPrefetch,
      // public API
      expose,
      inheritAttrs,
      // assets
      components,
      directives,
      filters
    } = options;
    const checkDuplicateProperties = !!(process.env.NODE_ENV !== "production") ? createDuplicateChecker() : null;
    if (!!(process.env.NODE_ENV !== "production")) {
      const [propsOptions] = instance.propsOptions;
      if (propsOptions) {
        for (const key in propsOptions) {
          checkDuplicateProperties("Props", key);
        }
      }
    }
    if (injectOptions) {
      resolveInjections(injectOptions, ctx, checkDuplicateProperties);
    }
    if (methods) {
      for (const key in methods) {
        const methodHandler = methods[key];
        if (isFunction(methodHandler)) {
          if (!!(process.env.NODE_ENV !== "production")) {
            Object.defineProperty(ctx, key, {
              value: methodHandler.bind(publicThis),
              configurable: true,
              enumerable: true,
              writable: true
            });
          } else {
            ctx[key] = methodHandler.bind(publicThis);
          }
          if (!!(process.env.NODE_ENV !== "production")) {
            checkDuplicateProperties("Methods", key);
          }
        } else if (!!(process.env.NODE_ENV !== "production")) {
          warn$1(
            `Method "${key}" has type "${typeof methodHandler}" in the component definition. Did you reference the function correctly?`
          );
        }
      }
    }
    if (dataOptions) {
      if (!!(process.env.NODE_ENV !== "production") && !isFunction(dataOptions)) {
        warn$1(
          `The data option must be a function. Plain object usage is no longer supported.`
        );
      }
      const data = dataOptions.call(publicThis, publicThis);
      if (!!(process.env.NODE_ENV !== "production") && isPromise(data)) {
        warn$1(
          `data() returned a Promise - note data() cannot be async; If you intend to perform data fetching before component renders, use async setup() + <Suspense>.`
        );
      }
      if (!isObject(data)) {
        !!(process.env.NODE_ENV !== "production") && warn$1(`data() should return an object.`);
      } else {
        instance.data = reactive(data);
        if (!!(process.env.NODE_ENV !== "production")) {
          for (const key in data) {
            checkDuplicateProperties("Data", key);
            if (!isReservedPrefix(key[0])) {
              Object.defineProperty(ctx, key, {
                configurable: true,
                enumerable: true,
                get: () => data[key],
                set: NOOP
              });
            }
          }
        }
      }
    }
    shouldCacheAccess = true;
    if (computedOptions) {
      for (const key in computedOptions) {
        const opt = computedOptions[key];
        const get2 = isFunction(opt) ? opt.bind(publicThis, publicThis) : isFunction(opt.get) ? opt.get.bind(publicThis, publicThis) : NOOP;
        if (!!(process.env.NODE_ENV !== "production") && get2 === NOOP) {
          warn$1(`Computed property "${key}" has no getter.`);
        }
        const set2 = !isFunction(opt) && isFunction(opt.set) ? opt.set.bind(publicThis) : !!(process.env.NODE_ENV !== "production") ? () => {
          warn$1(
            `Write operation failed: computed property "${key}" is readonly.`
          );
        } : NOOP;
        const c2 = computed({
          get: get2,
          set: set2
        });
        Object.defineProperty(ctx, key, {
          enumerable: true,
          configurable: true,
          get: () => c2.value,
          set: (v2) => c2.value = v2
        });
        if (!!(process.env.NODE_ENV !== "production")) {
          checkDuplicateProperties("Computed", key);
        }
      }
    }
    if (watchOptions) {
      for (const key in watchOptions) {
        createWatcher(watchOptions[key], ctx, publicThis, key);
      }
    }
    if (provideOptions) {
      const provides = isFunction(provideOptions) ? provideOptions.call(publicThis) : provideOptions;
      Reflect.ownKeys(provides).forEach((key) => {
        provide(key, provides[key]);
      });
    }
    if (created) {
      callHook(created, instance, "c");
    }
    function registerLifecycleHook(register, hook) {
      if (isArray(hook)) {
        hook.forEach((_hook) => register(_hook.bind(publicThis)));
      } else if (hook) {
        register(hook.bind(publicThis));
      }
    }
    registerLifecycleHook(onBeforeMount, beforeMount);
    registerLifecycleHook(onMounted, mounted);
    registerLifecycleHook(onBeforeUpdate, beforeUpdate);
    registerLifecycleHook(onUpdated, updated);
    registerLifecycleHook(onActivated, activated);
    registerLifecycleHook(onDeactivated, deactivated);
    registerLifecycleHook(onErrorCaptured, errorCaptured);
    registerLifecycleHook(onRenderTracked, renderTracked);
    registerLifecycleHook(onRenderTriggered, renderTriggered);
    registerLifecycleHook(onBeforeUnmount, beforeUnmount);
    registerLifecycleHook(onUnmounted, unmounted);
    registerLifecycleHook(onServerPrefetch, serverPrefetch);
    if (isArray(expose)) {
      if (expose.length) {
        const exposed = instance.exposed || (instance.exposed = {});
        expose.forEach((key) => {
          Object.defineProperty(exposed, key, {
            get: () => publicThis[key],
            set: (val) => publicThis[key] = val
          });
        });
      } else if (!instance.exposed) {
        instance.exposed = {};
      }
    }
    if (render && instance.render === NOOP) {
      instance.render = render;
    }
    if (inheritAttrs != null) {
      instance.inheritAttrs = inheritAttrs;
    }
    if (components)
      instance.components = components;
    if (directives)
      instance.directives = directives;
  }
  function resolveInjections(injectOptions, ctx, checkDuplicateProperties = NOOP) {
    if (isArray(injectOptions)) {
      injectOptions = normalizeInject(injectOptions);
    }
    for (const key in injectOptions) {
      const opt = injectOptions[key];
      let injected;
      if (isObject(opt)) {
        if ("default" in opt) {
          injected = inject(
            opt.from || key,
            opt.default,
            true
          );
        } else {
          injected = inject(opt.from || key);
        }
      } else {
        injected = inject(opt);
      }
      if (isRef(injected)) {
        Object.defineProperty(ctx, key, {
          enumerable: true,
          configurable: true,
          get: () => injected.value,
          set: (v2) => injected.value = v2
        });
      } else {
        ctx[key] = injected;
      }
      if (!!(process.env.NODE_ENV !== "production")) {
        checkDuplicateProperties("Inject", key);
      }
    }
  }
  function callHook(hook, instance, type) {
    callWithAsyncErrorHandling(
      isArray(hook) ? hook.map((h2) => h2.bind(instance.proxy)) : hook.bind(instance.proxy),
      instance,
      type
    );
  }
  function createWatcher(raw, ctx, publicThis, key) {
    const getter = key.includes(".") ? createPathGetter(publicThis, key) : () => publicThis[key];
    if (isString(raw)) {
      const handler = ctx[raw];
      if (isFunction(handler)) {
        watch(getter, handler);
      } else if (!!(process.env.NODE_ENV !== "production")) {
        warn$1(`Invalid watch handler specified by key "${raw}"`, handler);
      }
    } else if (isFunction(raw)) {
      watch(getter, raw.bind(publicThis));
    } else if (isObject(raw)) {
      if (isArray(raw)) {
        raw.forEach((r2) => createWatcher(r2, ctx, publicThis, key));
      } else {
        const handler = isFunction(raw.handler) ? raw.handler.bind(publicThis) : ctx[raw.handler];
        if (isFunction(handler)) {
          watch(getter, handler, raw);
        } else if (!!(process.env.NODE_ENV !== "production")) {
          warn$1(`Invalid watch handler specified by key "${raw.handler}"`, handler);
        }
      }
    } else if (!!(process.env.NODE_ENV !== "production")) {
      warn$1(`Invalid watch option: "${key}"`, raw);
    }
  }
  function resolveMergedOptions(instance) {
    const base = instance.type;
    const { mixins, extends: extendsOptions } = base;
    const {
      mixins: globalMixins,
      optionsCache: cache,
      config: { optionMergeStrategies }
    } = instance.appContext;
    const cached = cache.get(base);
    let resolved;
    if (cached) {
      resolved = cached;
    } else if (!globalMixins.length && !mixins && !extendsOptions) {
      {
        resolved = base;
      }
    } else {
      resolved = {};
      if (globalMixins.length) {
        globalMixins.forEach(
          (m2) => mergeOptions(resolved, m2, optionMergeStrategies, true)
        );
      }
      mergeOptions(resolved, base, optionMergeStrategies);
    }
    if (isObject(base)) {
      cache.set(base, resolved);
    }
    return resolved;
  }
  function mergeOptions(to, from, strats, asMixin = false) {
    const { mixins, extends: extendsOptions } = from;
    if (extendsOptions) {
      mergeOptions(to, extendsOptions, strats, true);
    }
    if (mixins) {
      mixins.forEach(
        (m2) => mergeOptions(to, m2, strats, true)
      );
    }
    for (const key in from) {
      if (asMixin && key === "expose") {
        !!(process.env.NODE_ENV !== "production") && warn$1(
          `"expose" option is ignored when declared in mixins or extends. It should only be declared in the base component itself.`
        );
      } else {
        const strat = internalOptionMergeStrats[key] || strats && strats[key];
        to[key] = strat ? strat(to[key], from[key]) : from[key];
      }
    }
    return to;
  }
  const internalOptionMergeStrats = {
    data: mergeDataFn,
    props: mergeEmitsOrPropsOptions,
    emits: mergeEmitsOrPropsOptions,
    // objects
    methods: mergeObjectOptions,
    computed: mergeObjectOptions,
    // lifecycle
    beforeCreate: mergeAsArray,
    created: mergeAsArray,
    beforeMount: mergeAsArray,
    mounted: mergeAsArray,
    beforeUpdate: mergeAsArray,
    updated: mergeAsArray,
    beforeDestroy: mergeAsArray,
    beforeUnmount: mergeAsArray,
    destroyed: mergeAsArray,
    unmounted: mergeAsArray,
    activated: mergeAsArray,
    deactivated: mergeAsArray,
    errorCaptured: mergeAsArray,
    serverPrefetch: mergeAsArray,
    // assets
    components: mergeObjectOptions,
    directives: mergeObjectOptions,
    // watch
    watch: mergeWatchOptions,
    // provide / inject
    provide: mergeDataFn,
    inject: mergeInject
  };
  function mergeDataFn(to, from) {
    if (!from) {
      return to;
    }
    if (!to) {
      return from;
    }
    return function mergedDataFn() {
      return extend(
        isFunction(to) ? to.call(this, this) : to,
        isFunction(from) ? from.call(this, this) : from
      );
    };
  }
  function mergeInject(to, from) {
    return mergeObjectOptions(normalizeInject(to), normalizeInject(from));
  }
  function normalizeInject(raw) {
    if (isArray(raw)) {
      const res = {};
      for (let i2 = 0; i2 < raw.length; i2++) {
        res[raw[i2]] = raw[i2];
      }
      return res;
    }
    return raw;
  }
  function mergeAsArray(to, from) {
    return to ? [...new Set([].concat(to, from))] : from;
  }
  function mergeObjectOptions(to, from) {
    return to ? extend(/* @__PURE__ */ Object.create(null), to, from) : from;
  }
  function mergeEmitsOrPropsOptions(to, from) {
    if (to) {
      if (isArray(to) && isArray(from)) {
        return [.../* @__PURE__ */ new Set([...to, ...from])];
      }
      return extend(
        /* @__PURE__ */ Object.create(null),
        normalizePropsOrEmits(to),
        normalizePropsOrEmits(from != null ? from : {})
      );
    } else {
      return from;
    }
  }
  function mergeWatchOptions(to, from) {
    if (!to)
      return from;
    if (!from)
      return to;
    const merged = extend(/* @__PURE__ */ Object.create(null), to);
    for (const key in from) {
      merged[key] = mergeAsArray(to[key], from[key]);
    }
    return merged;
  }
  function createAppContext() {
    return {
      app: null,
      config: {
        isNativeTag: NO,
        performance: false,
        globalProperties: {},
        optionMergeStrategies: {},
        errorHandler: void 0,
        warnHandler: void 0,
        compilerOptions: {}
      },
      mixins: [],
      components: {},
      directives: {},
      provides: /* @__PURE__ */ Object.create(null),
      optionsCache: /* @__PURE__ */ new WeakMap(),
      propsCache: /* @__PURE__ */ new WeakMap(),
      emitsCache: /* @__PURE__ */ new WeakMap()
    };
  }
  let uid$1 = 0;
  function createAppAPI(render, hydrate) {
    return function createApp2(rootComponent2, rootProps = null) {
      if (!isFunction(rootComponent2)) {
        rootComponent2 = extend({}, rootComponent2);
      }
      if (rootProps != null && !isObject(rootProps)) {
        !!(process.env.NODE_ENV !== "production") && warn$1(`root props passed to app.mount() must be an object.`);
        rootProps = null;
      }
      const context = createAppContext();
      const installedPlugins = /* @__PURE__ */ new WeakSet();
      let isMounted = false;
      const app = context.app = {
        _uid: uid$1++,
        _component: rootComponent2,
        _props: rootProps,
        _container: null,
        _context: context,
        _instance: null,
        version,
        get config() {
          return context.config;
        },
        set config(v2) {
          if (!!(process.env.NODE_ENV !== "production")) {
            warn$1(
              `app.config cannot be replaced. Modify individual options instead.`
            );
          }
        },
        use(plugin, ...options) {
          if (installedPlugins.has(plugin)) {
            !!(process.env.NODE_ENV !== "production") && warn$1(`Plugin has already been applied to target app.`);
          } else if (plugin && isFunction(plugin.install)) {
            installedPlugins.add(plugin);
            plugin.install(app, ...options);
          } else if (isFunction(plugin)) {
            installedPlugins.add(plugin);
            plugin(app, ...options);
          } else if (!!(process.env.NODE_ENV !== "production")) {
            warn$1(
              `A plugin must either be a function or an object with an "install" function.`
            );
          }
          return app;
        },
        mixin(mixin) {
          {
            if (!context.mixins.includes(mixin)) {
              context.mixins.push(mixin);
            } else if (!!(process.env.NODE_ENV !== "production")) {
              warn$1(
                "Mixin has already been applied to target app" + (mixin.name ? `: ${mixin.name}` : "")
              );
            }
          }
          return app;
        },
        component(name, component) {
          if (!!(process.env.NODE_ENV !== "production")) {
            validateComponentName(name, context.config);
          }
          if (!component) {
            return context.components[name];
          }
          if (!!(process.env.NODE_ENV !== "production") && context.components[name]) {
            warn$1(`Component "${name}" has already been registered in target app.`);
          }
          context.components[name] = component;
          return app;
        },
        directive(name, directive) {
          if (!!(process.env.NODE_ENV !== "production")) {
            validateDirectiveName(name);
          }
          if (!directive) {
            return context.directives[name];
          }
          if (!!(process.env.NODE_ENV !== "production") && context.directives[name]) {
            warn$1(`Directive "${name}" has already been registered in target app.`);
          }
          context.directives[name] = directive;
          return app;
        },
        mount(rootContainer, isHydrate, namespace) {
          if (!isMounted) {
            if (!!(process.env.NODE_ENV !== "production") && rootContainer.__vue_app__) {
              warn$1(
                `There is already an app instance mounted on the host container.
 If you want to mount another app on the same host container, you need to unmount the previous app by calling \`app.unmount()\` first.`
              );
            }
            const vnode = createVNode$1(rootComponent2, rootProps);
            vnode.appContext = context;
            if (namespace === true) {
              namespace = "svg";
            } else if (namespace === false) {
              namespace = void 0;
            }
            if (!!(process.env.NODE_ENV !== "production")) {
              context.reload = () => {
                render(
                  cloneVNode(vnode),
                  rootContainer,
                  namespace
                );
              };
            }
            if (isHydrate && hydrate) {
              hydrate(vnode, rootContainer);
            } else {
              render(vnode, rootContainer, namespace);
            }
            isMounted = true;
            app._container = rootContainer;
            rootContainer.__vue_app__ = app;
            if (!!(process.env.NODE_ENV !== "production") || false) {
              app._instance = vnode.component;
              devtoolsInitApp(app, version);
            }
            return getExposeProxy(vnode.component) || vnode.component.proxy;
          } else if (!!(process.env.NODE_ENV !== "production")) {
            warn$1(
              `App has already been mounted.
If you want to remount the same app, move your app creation logic into a factory function and create fresh app instances for each mount - e.g. \`const createMyApp = () => createApp(App)\``
            );
          }
        },
        unmount() {
          if (isMounted) {
            render(null, app._container);
            if (!!(process.env.NODE_ENV !== "production") || false) {
              app._instance = null;
              devtoolsUnmountApp(app);
            }
            delete app._container.__vue_app__;
          } else if (!!(process.env.NODE_ENV !== "production")) {
            warn$1(`Cannot unmount an app that is not mounted.`);
          }
        },
        provide(key, value) {
          if (!!(process.env.NODE_ENV !== "production") && key in context.provides) {
            warn$1(
              `App already provides property with key "${String(key)}". It will be overwritten with the new value.`
            );
          }
          context.provides[key] = value;
          return app;
        },
        runWithContext(fn2) {
          currentApp = app;
          try {
            return fn2();
          } finally {
            currentApp = null;
          }
        }
      };
      return app;
    };
  }
  let currentApp = null;
  function provide(key, value) {
    if (!currentInstance) {
      if (!!(process.env.NODE_ENV !== "production")) {
        warn$1(`provide() can only be used inside setup().`);
      }
    } else {
      let provides = currentInstance.provides;
      const parentProvides = currentInstance.parent && currentInstance.parent.provides;
      if (parentProvides === provides) {
        provides = currentInstance.provides = Object.create(parentProvides);
      }
      provides[key] = value;
    }
  }
  function inject(key, defaultValue, treatDefaultAsFactory = false) {
    const instance = currentInstance || currentRenderingInstance;
    if (instance || currentApp) {
      const provides = instance ? instance.parent == null ? instance.vnode.appContext && instance.vnode.appContext.provides : instance.parent.provides : currentApp._context.provides;
      if (provides && key in provides) {
        return provides[key];
      } else if (arguments.length > 1) {
        return treatDefaultAsFactory && isFunction(defaultValue) ? defaultValue.call(instance && instance.proxy) : defaultValue;
      } else if (!!(process.env.NODE_ENV !== "production")) {
        warn$1(`injection "${String(key)}" not found.`);
      }
    } else if (!!(process.env.NODE_ENV !== "production")) {
      warn$1(`inject() can only be used inside setup() or functional components.`);
    }
  }
  function initProps(instance, rawProps, isStateful, isSSR = false) {
    const props = {};
    const attrs = {};
    def(attrs, InternalObjectKey, 1);
    instance.propsDefaults = /* @__PURE__ */ Object.create(null);
    setFullProps(instance, rawProps, props, attrs);
    for (const key in instance.propsOptions[0]) {
      if (!(key in props)) {
        props[key] = void 0;
      }
    }
    if (!!(process.env.NODE_ENV !== "production")) {
      validateProps(rawProps || {}, props, instance);
    }
    if (isStateful) {
      instance.props = isSSR ? props : shallowReactive(props);
    } else {
      if (!instance.type.props) {
        instance.props = attrs;
      } else {
        instance.props = props;
      }
    }
    instance.attrs = attrs;
  }
  function isInHmrContext(instance) {
    while (instance) {
      if (instance.type.__hmrId)
        return true;
      instance = instance.parent;
    }
  }
  function updateProps(instance, rawProps, rawPrevProps, optimized) {
    const {
      props,
      attrs,
      vnode: { patchFlag }
    } = instance;
    const rawCurrentProps = toRaw(props);
    const [options] = instance.propsOptions;
    let hasAttrsChanged = false;
    if (
      // always force full diff in dev
      // - #1942 if hmr is enabled with sfc component
      // - vite#872 non-sfc component used by sfc component
      !(!!(process.env.NODE_ENV !== "production") && isInHmrContext(instance)) && (optimized || patchFlag > 0) && !(patchFlag & 16)
    ) {
      if (patchFlag & 8) {
        const propsToUpdate = instance.vnode.dynamicProps;
        for (let i2 = 0; i2 < propsToUpdate.length; i2++) {
          let key = propsToUpdate[i2];
          if (isEmitListener(instance.emitsOptions, key)) {
            continue;
          }
          const value = rawProps[key];
          if (options) {
            if (hasOwn(attrs, key)) {
              if (value !== attrs[key]) {
                attrs[key] = value;
                hasAttrsChanged = true;
              }
            } else {
              const camelizedKey = camelize(key);
              props[camelizedKey] = resolvePropValue(
                options,
                rawCurrentProps,
                camelizedKey,
                value,
                instance,
                false
              );
            }
          } else {
            if (value !== attrs[key]) {
              attrs[key] = value;
              hasAttrsChanged = true;
            }
          }
        }
      }
    } else {
      if (setFullProps(instance, rawProps, props, attrs)) {
        hasAttrsChanged = true;
      }
      let kebabKey;
      for (const key in rawCurrentProps) {
        if (!rawProps || // for camelCase
        !hasOwn(rawProps, key) && // it's possible the original props was passed in as kebab-case
        // and converted to camelCase (#955)
        ((kebabKey = hyphenate(key)) === key || !hasOwn(rawProps, kebabKey))) {
          if (options) {
            if (rawPrevProps && // for camelCase
            (rawPrevProps[key] !== void 0 || // for kebab-case
            rawPrevProps[kebabKey] !== void 0)) {
              props[key] = resolvePropValue(
                options,
                rawCurrentProps,
                key,
                void 0,
                instance,
                true
              );
            }
          } else {
            delete props[key];
          }
        }
      }
      if (attrs !== rawCurrentProps) {
        for (const key in attrs) {
          if (!rawProps || !hasOwn(rawProps, key) && true) {
            delete attrs[key];
            hasAttrsChanged = true;
          }
        }
      }
    }
    if (hasAttrsChanged) {
      trigger(instance, "set", "$attrs");
    }
    if (!!(process.env.NODE_ENV !== "production")) {
      validateProps(rawProps || {}, props, instance);
    }
  }
  function setFullProps(instance, rawProps, props, attrs) {
    const [options, needCastKeys] = instance.propsOptions;
    let hasAttrsChanged = false;
    let rawCastValues;
    if (rawProps) {
      for (let key in rawProps) {
        if (isReservedProp(key)) {
          continue;
        }
        const value = rawProps[key];
        let camelKey;
        if (options && hasOwn(options, camelKey = camelize(key))) {
          if (!needCastKeys || !needCastKeys.includes(camelKey)) {
            props[camelKey] = value;
          } else {
            (rawCastValues || (rawCastValues = {}))[camelKey] = value;
          }
        } else if (!isEmitListener(instance.emitsOptions, key)) {
          if (!(key in attrs) || value !== attrs[key]) {
            attrs[key] = value;
            hasAttrsChanged = true;
          }
        }
      }
    }
    if (needCastKeys) {
      const rawCurrentProps = toRaw(props);
      const castValues = rawCastValues || EMPTY_OBJ;
      for (let i2 = 0; i2 < needCastKeys.length; i2++) {
        const key = needCastKeys[i2];
        props[key] = resolvePropValue(
          options,
          rawCurrentProps,
          key,
          castValues[key],
          instance,
          !hasOwn(castValues, key)
        );
      }
    }
    return hasAttrsChanged;
  }
  function resolvePropValue(options, props, key, value, instance, isAbsent) {
    const opt = options[key];
    if (opt != null) {
      const hasDefault = hasOwn(opt, "default");
      if (hasDefault && value === void 0) {
        const defaultValue = opt.default;
        if (opt.type !== Function && !opt.skipFactory && isFunction(defaultValue)) {
          const { propsDefaults } = instance;
          if (key in propsDefaults) {
            value = propsDefaults[key];
          } else {
            const reset = setCurrentInstance(instance);
            value = propsDefaults[key] = defaultValue.call(
              null,
              props
            );
            reset();
          }
        } else {
          value = defaultValue;
        }
      }
      if (opt[
        0
        /* shouldCast */
      ]) {
        if (isAbsent && !hasDefault) {
          value = false;
        } else if (opt[
          1
          /* shouldCastTrue */
        ] && (value === "" || value === hyphenate(key))) {
          value = true;
        }
      }
    }
    return value;
  }
  function normalizePropsOptions(comp, appContext, asMixin = false) {
    const cache = appContext.propsCache;
    const cached = cache.get(comp);
    if (cached) {
      return cached;
    }
    const raw = comp.props;
    const normalized = {};
    const needCastKeys = [];
    let hasExtends = false;
    if (!isFunction(comp)) {
      const extendProps = (raw2) => {
        hasExtends = true;
        const [props, keys] = normalizePropsOptions(raw2, appContext, true);
        extend(normalized, props);
        if (keys)
          needCastKeys.push(...keys);
      };
      if (!asMixin && appContext.mixins.length) {
        appContext.mixins.forEach(extendProps);
      }
      if (comp.extends) {
        extendProps(comp.extends);
      }
      if (comp.mixins) {
        comp.mixins.forEach(extendProps);
      }
    }
    if (!raw && !hasExtends) {
      if (isObject(comp)) {
        cache.set(comp, EMPTY_ARR);
      }
      return EMPTY_ARR;
    }
    if (isArray(raw)) {
      for (let i2 = 0; i2 < raw.length; i2++) {
        if (!!(process.env.NODE_ENV !== "production") && !isString(raw[i2])) {
          warn$1(`props must be strings when using array syntax.`, raw[i2]);
        }
        const normalizedKey = camelize(raw[i2]);
        if (validatePropName(normalizedKey)) {
          normalized[normalizedKey] = EMPTY_OBJ;
        }
      }
    } else if (raw) {
      if (!!(process.env.NODE_ENV !== "production") && !isObject(raw)) {
        warn$1(`invalid props options`, raw);
      }
      for (const key in raw) {
        const normalizedKey = camelize(key);
        if (validatePropName(normalizedKey)) {
          const opt = raw[key];
          const prop = normalized[normalizedKey] = isArray(opt) || isFunction(opt) ? { type: opt } : extend({}, opt);
          if (prop) {
            const booleanIndex = getTypeIndex(Boolean, prop.type);
            const stringIndex = getTypeIndex(String, prop.type);
            prop[
              0
              /* shouldCast */
            ] = booleanIndex > -1;
            prop[
              1
              /* shouldCastTrue */
            ] = stringIndex < 0 || booleanIndex < stringIndex;
            if (booleanIndex > -1 || hasOwn(prop, "default")) {
              needCastKeys.push(normalizedKey);
            }
          }
        }
      }
    }
    const res = [normalized, needCastKeys];
    if (isObject(comp)) {
      cache.set(comp, res);
    }
    return res;
  }
  function validatePropName(key) {
    if (key[0] !== "$") {
      return true;
    } else if (!!(process.env.NODE_ENV !== "production")) {
      warn$1(`Invalid prop name: "${key}" is a reserved property.`);
    }
    return false;
  }
  function getType(ctor) {
    const match = ctor && ctor.toString().match(/^\s*(function|class) (\w+)/);
    return match ? match[2] : ctor === null ? "null" : "";
  }
  function isSameType(a2, b2) {
    return getType(a2) === getType(b2);
  }
  function getTypeIndex(type, expectedTypes) {
    if (isArray(expectedTypes)) {
      return expectedTypes.findIndex((t2) => isSameType(t2, type));
    } else if (isFunction(expectedTypes)) {
      return isSameType(expectedTypes, type) ? 0 : -1;
    }
    return -1;
  }
  function validateProps(rawProps, props, instance) {
    const resolvedValues = toRaw(props);
    const options = instance.propsOptions[0];
    for (const key in options) {
      let opt = options[key];
      if (opt == null)
        continue;
      validateProp(
        key,
        resolvedValues[key],
        opt,
        !!(process.env.NODE_ENV !== "production") ? shallowReadonly(resolvedValues) : resolvedValues,
        !hasOwn(rawProps, key) && !hasOwn(rawProps, hyphenate(key))
      );
    }
  }
  function validateProp(name, value, prop, props, isAbsent) {
    const { type, required, validator, skipCheck } = prop;
    if (required && isAbsent) {
      warn$1('Missing required prop: "' + name + '"');
      return;
    }
    if (value == null && !required) {
      return;
    }
    if (type != null && type !== true && !skipCheck) {
      let isValid = false;
      const types = isArray(type) ? type : [type];
      const expectedTypes = [];
      for (let i2 = 0; i2 < types.length && !isValid; i2++) {
        const { valid, expectedType } = assertType(value, types[i2]);
        expectedTypes.push(expectedType || "");
        isValid = valid;
      }
      if (!isValid) {
        warn$1(getInvalidTypeMessage(name, value, expectedTypes));
        return;
      }
    }
    if (validator && !validator(value, props)) {
      warn$1('Invalid prop: custom validator check failed for prop "' + name + '".');
    }
  }
  const isSimpleType = /* @__PURE__ */ makeMap(
    "String,Number,Boolean,Function,Symbol,BigInt"
  );
  function assertType(value, type) {
    let valid;
    const expectedType = getType(type);
    if (isSimpleType(expectedType)) {
      const t2 = typeof value;
      valid = t2 === expectedType.toLowerCase();
      if (!valid && t2 === "object") {
        valid = value instanceof type;
      }
    } else if (expectedType === "Object") {
      valid = isObject(value);
    } else if (expectedType === "Array") {
      valid = isArray(value);
    } else if (expectedType === "null") {
      valid = value === null;
    } else {
      valid = value instanceof type;
    }
    return {
      valid,
      expectedType
    };
  }
  function getInvalidTypeMessage(name, value, expectedTypes) {
    if (expectedTypes.length === 0) {
      return `Prop type [] for prop "${name}" won't match anything. Did you mean to use type Array instead?`;
    }
    let message = `Invalid prop: type check failed for prop "${name}". Expected ${expectedTypes.map(capitalize).join(" | ")}`;
    const expectedType = expectedTypes[0];
    const receivedType = toRawType(value);
    const expectedValue = styleValue(value, expectedType);
    const receivedValue = styleValue(value, receivedType);
    if (expectedTypes.length === 1 && isExplicable(expectedType) && !isBoolean(expectedType, receivedType)) {
      message += ` with value ${expectedValue}`;
    }
    message += `, got ${receivedType} `;
    if (isExplicable(receivedType)) {
      message += `with value ${receivedValue}.`;
    }
    return message;
  }
  function styleValue(value, type) {
    if (type === "String") {
      return `"${value}"`;
    } else if (type === "Number") {
      return `${Number(value)}`;
    } else {
      return `${value}`;
    }
  }
  function isExplicable(type) {
    const explicitTypes = ["string", "number", "boolean"];
    return explicitTypes.some((elem) => type.toLowerCase() === elem);
  }
  function isBoolean(...args) {
    return args.some((elem) => elem.toLowerCase() === "boolean");
  }
  const isInternalKey = (key) => key[0] === "_" || key === "$stable";
  const normalizeSlotValue = (value) => isArray(value) ? value.map(normalizeVNode) : [normalizeVNode(value)];
  const normalizeSlot = (key, rawSlot, ctx) => {
    if (rawSlot._n) {
      return rawSlot;
    }
    const normalized = withCtx((...args) => {
      if (!!(process.env.NODE_ENV !== "production") && currentInstance && (!ctx || ctx.root === currentInstance.root)) {
        warn$1(
          `Slot "${key}" invoked outside of the render function: this will not track dependencies used in the slot. Invoke the slot function inside the render function instead.`
        );
      }
      return normalizeSlotValue(rawSlot(...args));
    }, ctx);
    normalized._c = false;
    return normalized;
  };
  const normalizeObjectSlots = (rawSlots, slots, instance) => {
    const ctx = rawSlots._ctx;
    for (const key in rawSlots) {
      if (isInternalKey(key))
        continue;
      const value = rawSlots[key];
      if (isFunction(value)) {
        slots[key] = normalizeSlot(key, value, ctx);
      } else if (value != null) {
        if (!!(process.env.NODE_ENV !== "production") && true) {
          warn$1(
            `Non-function value encountered for slot "${key}". Prefer function slots for better performance.`
          );
        }
        const normalized = normalizeSlotValue(value);
        slots[key] = () => normalized;
      }
    }
  };
  const normalizeVNodeSlots = (instance, children) => {
    if (!!(process.env.NODE_ENV !== "production") && !isKeepAlive(instance.vnode) && true) {
      warn$1(
        `Non-function value encountered for default slot. Prefer function slots for better performance.`
      );
    }
    const normalized = normalizeSlotValue(children);
    instance.slots.default = () => normalized;
  };
  const initSlots = (instance, children) => {
    if (instance.vnode.shapeFlag & 32) {
      const type = children._;
      if (type) {
        instance.slots = toRaw(children);
        def(children, "_", type);
      } else {
        normalizeObjectSlots(
          children,
          instance.slots = {}
        );
      }
    } else {
      instance.slots = {};
      if (children) {
        normalizeVNodeSlots(instance, children);
      }
    }
    def(instance.slots, InternalObjectKey, 1);
  };
  const updateSlots = (instance, children, optimized) => {
    const { vnode, slots } = instance;
    let needDeletionCheck = true;
    let deletionComparisonTarget = EMPTY_OBJ;
    if (vnode.shapeFlag & 32) {
      const type = children._;
      if (type) {
        if (!!(process.env.NODE_ENV !== "production") && isHmrUpdating) {
          extend(slots, children);
          trigger(instance, "set", "$slots");
        } else if (optimized && type === 1) {
          needDeletionCheck = false;
        } else {
          extend(slots, children);
          if (!optimized && type === 1) {
            delete slots._;
          }
        }
      } else {
        needDeletionCheck = !children.$stable;
        normalizeObjectSlots(children, slots);
      }
      deletionComparisonTarget = children;
    } else if (children) {
      normalizeVNodeSlots(instance, children);
      deletionComparisonTarget = { default: 1 };
    }
    if (needDeletionCheck) {
      for (const key in slots) {
        if (!isInternalKey(key) && deletionComparisonTarget[key] == null) {
          delete slots[key];
        }
      }
    }
  };
  function setRef(rawRef, oldRawRef, parentSuspense, vnode, isUnmount = false) {
    if (isArray(rawRef)) {
      rawRef.forEach(
        (r2, i2) => setRef(
          r2,
          oldRawRef && (isArray(oldRawRef) ? oldRawRef[i2] : oldRawRef),
          parentSuspense,
          vnode,
          isUnmount
        )
      );
      return;
    }
    if (isAsyncWrapper(vnode) && !isUnmount) {
      return;
    }
    const refValue = vnode.shapeFlag & 4 ? getExposeProxy(vnode.component) || vnode.component.proxy : vnode.el;
    const value = isUnmount ? null : refValue;
    const { i: owner, r: ref3 } = rawRef;
    if (!!(process.env.NODE_ENV !== "production") && !owner) {
      warn$1(
        `Missing ref owner context. ref cannot be used on hoisted vnodes. A vnode with ref must be created inside the render function.`
      );
      return;
    }
    const oldRef = oldRawRef && oldRawRef.r;
    const refs = owner.refs === EMPTY_OBJ ? owner.refs = {} : owner.refs;
    const setupState = owner.setupState;
    if (oldRef != null && oldRef !== ref3) {
      if (isString(oldRef)) {
        refs[oldRef] = null;
        if (hasOwn(setupState, oldRef)) {
          setupState[oldRef] = null;
        }
      } else if (isRef(oldRef)) {
        oldRef.value = null;
      }
    }
    if (isFunction(ref3)) {
      callWithErrorHandling(ref3, owner, 12, [value, refs]);
    } else {
      const _isString = isString(ref3);
      const _isRef = isRef(ref3);
      const isVFor = rawRef.f;
      if (_isString || _isRef) {
        const doSet = () => {
          if (isVFor) {
            const existing = _isString ? hasOwn(setupState, ref3) ? setupState[ref3] : refs[ref3] : ref3.value;
            if (isUnmount) {
              isArray(existing) && remove(existing, refValue);
            } else {
              if (!isArray(existing)) {
                if (_isString) {
                  refs[ref3] = [refValue];
                  if (hasOwn(setupState, ref3)) {
                    setupState[ref3] = refs[ref3];
                  }
                } else {
                  ref3.value = [refValue];
                  if (rawRef.k)
                    refs[rawRef.k] = ref3.value;
                }
              } else if (!existing.includes(refValue)) {
                existing.push(refValue);
              }
            }
          } else if (_isString) {
            refs[ref3] = value;
            if (hasOwn(setupState, ref3)) {
              setupState[ref3] = value;
            }
          } else if (_isRef) {
            ref3.value = value;
            if (rawRef.k)
              refs[rawRef.k] = value;
          } else if (!!(process.env.NODE_ENV !== "production")) {
            warn$1("Invalid template ref type:", ref3, `(${typeof ref3})`);
          }
        };
        if (isUnmount || isVFor) {
          doSet();
        } else {
          doSet.id = -1;
          queuePostRenderEffect(doSet, parentSuspense);
        }
      } else if (!!(process.env.NODE_ENV !== "production")) {
        warn$1("Invalid template ref type:", ref3, `(${typeof ref3})`);
      }
    }
  }
  let supported;
  let perf;
  function startMeasure(instance, type) {
    if (instance.appContext.config.performance && isSupported()) {
      perf.mark(`vue-${type}-${instance.uid}`);
    }
    if (!!(process.env.NODE_ENV !== "production") || false) {
      devtoolsPerfStart(instance, type, isSupported() ? perf.now() : Date.now());
    }
  }
  function endMeasure(instance, type) {
    if (instance.appContext.config.performance && isSupported()) {
      const startTag = `vue-${type}-${instance.uid}`;
      const endTag = startTag + `:end`;
      perf.mark(endTag);
      perf.measure(
        `<${formatComponentName(instance, instance.type)}> ${type}`,
        startTag,
        endTag
      );
      perf.clearMarks(startTag);
      perf.clearMarks(endTag);
    }
    if (!!(process.env.NODE_ENV !== "production") || false) {
      devtoolsPerfEnd(instance, type, isSupported() ? perf.now() : Date.now());
    }
  }
  function isSupported() {
    if (supported !== void 0) {
      return supported;
    }
    if (typeof window !== "undefined" && window.performance) {
      supported = true;
      perf = window.performance;
    } else {
      supported = false;
    }
    return supported;
  }
  function initFeatureFlags() {
    const needWarn = [];
    if (!!(process.env.NODE_ENV !== "production") && needWarn.length) {
      const multi = needWarn.length > 1;
      console.warn(
        `Feature flag${multi ? `s` : ``} ${needWarn.join(", ")} ${multi ? `are` : `is`} not explicitly defined. You are running the esm-bundler build of Vue, which expects these compile-time feature flags to be globally injected via the bundler config in order to get better tree-shaking in the production bundle.

For more details, see https://link.vuejs.org/feature-flags.`
      );
    }
  }
  const queuePostRenderEffect = queueEffectWithSuspense;
  function createRenderer(options) {
    return baseCreateRenderer(options);
  }
  function baseCreateRenderer(options, createHydrationFns) {
    {
      initFeatureFlags();
    }
    const target = getGlobalThis();
    target.__VUE__ = true;
    if (!!(process.env.NODE_ENV !== "production") || false) {
      setDevtoolsHook$1(target.__VUE_DEVTOOLS_GLOBAL_HOOK__, target);
    }
    const {
      insert: hostInsert,
      remove: hostRemove,
      patchProp: hostPatchProp,
      createElement: hostCreateElement,
      createText: hostCreateText,
      createComment: hostCreateComment,
      setText: hostSetText,
      setElementText: hostSetElementText,
      parentNode: hostParentNode,
      nextSibling: hostNextSibling,
      setScopeId: hostSetScopeId = NOOP,
      insertStaticContent: hostInsertStaticContent
    } = options;
    const patch = (n1, n2, container, anchor = null, parentComponent = null, parentSuspense = null, namespace = void 0, slotScopeIds = null, optimized = !!(process.env.NODE_ENV !== "production") && isHmrUpdating ? false : !!n2.dynamicChildren) => {
      if (n1 === n2) {
        return;
      }
      if (n1 && !isSameVNodeType(n1, n2)) {
        anchor = getNextHostNode(n1);
        unmount(n1, parentComponent, parentSuspense, true);
        n1 = null;
      }
      if (n2.patchFlag === -2) {
        optimized = false;
        n2.dynamicChildren = null;
      }
      const { type, ref: ref3, shapeFlag } = n2;
      switch (type) {
        case Text$1:
          processText(n1, n2, container, anchor);
          break;
        case Comment:
          processCommentNode(n1, n2, container, anchor);
          break;
        case Static:
          if (n1 == null) {
            mountStaticNode(n2, container, anchor, namespace);
          } else if (!!(process.env.NODE_ENV !== "production")) {
            patchStaticNode(n1, n2, container, namespace);
          }
          break;
        case Fragment:
          processFragment(
            n1,
            n2,
            container,
            anchor,
            parentComponent,
            parentSuspense,
            namespace,
            slotScopeIds,
            optimized
          );
          break;
        default:
          if (shapeFlag & 1) {
            processElement(
              n1,
              n2,
              container,
              anchor,
              parentComponent,
              parentSuspense,
              namespace,
              slotScopeIds,
              optimized
            );
          } else if (shapeFlag & 6) {
            processComponent(
              n1,
              n2,
              container,
              anchor,
              parentComponent,
              parentSuspense,
              namespace,
              slotScopeIds,
              optimized
            );
          } else if (shapeFlag & 64) {
            type.process(
              n1,
              n2,
              container,
              anchor,
              parentComponent,
              parentSuspense,
              namespace,
              slotScopeIds,
              optimized,
              internals
            );
          } else if (shapeFlag & 128) {
            type.process(
              n1,
              n2,
              container,
              anchor,
              parentComponent,
              parentSuspense,
              namespace,
              slotScopeIds,
              optimized,
              internals
            );
          } else if (!!(process.env.NODE_ENV !== "production")) {
            warn$1("Invalid VNode type:", type, `(${typeof type})`);
          }
      }
      if (ref3 != null && parentComponent) {
        setRef(ref3, n1 && n1.ref, parentSuspense, n2 || n1, !n2);
      }
    };
    const processText = (n1, n2, container, anchor) => {
      if (n1 == null) {
        hostInsert(
          n2.el = hostCreateText(n2.children),
          container,
          anchor
        );
      } else {
        const el = n2.el = n1.el;
        if (n2.children !== n1.children) {
          hostSetText(el, n2.children);
        }
      }
    };
    const processCommentNode = (n1, n2, container, anchor) => {
      if (n1 == null) {
        hostInsert(
          n2.el = hostCreateComment(n2.children || ""),
          container,
          anchor
        );
      } else {
        n2.el = n1.el;
      }
    };
    const mountStaticNode = (n2, container, anchor, namespace) => {
      [n2.el, n2.anchor] = hostInsertStaticContent(
        n2.children,
        container,
        anchor,
        namespace,
        n2.el,
        n2.anchor
      );
    };
    const patchStaticNode = (n1, n2, container, namespace) => {
      if (n2.children !== n1.children) {
        const anchor = hostNextSibling(n1.anchor);
        removeStaticNode(n1);
        [n2.el, n2.anchor] = hostInsertStaticContent(
          n2.children,
          container,
          anchor,
          namespace
        );
      } else {
        n2.el = n1.el;
        n2.anchor = n1.anchor;
      }
    };
    const moveStaticNode = ({ el, anchor }, container, nextSibling) => {
      let next;
      while (el && el !== anchor) {
        next = hostNextSibling(el);
        hostInsert(el, container, nextSibling);
        el = next;
      }
      hostInsert(anchor, container, nextSibling);
    };
    const removeStaticNode = ({ el, anchor }) => {
      let next;
      while (el && el !== anchor) {
        next = hostNextSibling(el);
        hostRemove(el);
        el = next;
      }
      hostRemove(anchor);
    };
    const processElement = (n1, n2, container, anchor, parentComponent, parentSuspense, namespace, slotScopeIds, optimized) => {
      if (n2.type === "svg") {
        namespace = "svg";
      } else if (n2.type === "math") {
        namespace = "mathml";
      }
      if (n1 == null) {
        mountElement(
          n2,
          container,
          anchor,
          parentComponent,
          parentSuspense,
          namespace,
          slotScopeIds,
          optimized
        );
      } else {
        patchElement(
          n1,
          n2,
          parentComponent,
          parentSuspense,
          namespace,
          slotScopeIds,
          optimized
        );
      }
    };
    const mountElement = (vnode, container, anchor, parentComponent, parentSuspense, namespace, slotScopeIds, optimized) => {
      let el;
      let vnodeHook;
      const { props, shapeFlag, transition, dirs } = vnode;
      el = vnode.el = hostCreateElement(
        vnode.type,
        namespace,
        props && props.is,
        props
      );
      if (shapeFlag & 8) {
        hostSetElementText(el, vnode.children);
      } else if (shapeFlag & 16) {
        mountChildren(
          vnode.children,
          el,
          null,
          parentComponent,
          parentSuspense,
          resolveChildrenNamespace(vnode, namespace),
          slotScopeIds,
          optimized
        );
      }
      if (dirs) {
        invokeDirectiveHook(vnode, null, parentComponent, "created");
      }
      setScopeId(el, vnode, vnode.scopeId, slotScopeIds, parentComponent);
      if (props) {
        for (const key in props) {
          if (key !== "value" && !isReservedProp(key)) {
            hostPatchProp(
              el,
              key,
              null,
              props[key],
              namespace,
              vnode.children,
              parentComponent,
              parentSuspense,
              unmountChildren
            );
          }
        }
        if ("value" in props) {
          hostPatchProp(el, "value", null, props.value, namespace);
        }
        if (vnodeHook = props.onVnodeBeforeMount) {
          invokeVNodeHook(vnodeHook, parentComponent, vnode);
        }
      }
      if (!!(process.env.NODE_ENV !== "production") || false) {
        Object.defineProperty(el, "__vnode", {
          value: vnode,
          enumerable: false
        });
        Object.defineProperty(el, "__vueParentComponent", {
          value: parentComponent,
          enumerable: false
        });
      }
      if (dirs) {
        invokeDirectiveHook(vnode, null, parentComponent, "beforeMount");
      }
      const needCallTransitionHooks = needTransition(parentSuspense, transition);
      if (needCallTransitionHooks) {
        transition.beforeEnter(el);
      }
      hostInsert(el, container, anchor);
      if ((vnodeHook = props && props.onVnodeMounted) || needCallTransitionHooks || dirs) {
        queuePostRenderEffect(() => {
          vnodeHook && invokeVNodeHook(vnodeHook, parentComponent, vnode);
          needCallTransitionHooks && transition.enter(el);
          dirs && invokeDirectiveHook(vnode, null, parentComponent, "mounted");
        }, parentSuspense);
      }
    };
    const setScopeId = (el, vnode, scopeId, slotScopeIds, parentComponent) => {
      if (scopeId) {
        hostSetScopeId(el, scopeId);
      }
      if (slotScopeIds) {
        for (let i2 = 0; i2 < slotScopeIds.length; i2++) {
          hostSetScopeId(el, slotScopeIds[i2]);
        }
      }
      if (parentComponent) {
        let subTree = parentComponent.subTree;
        if (!!(process.env.NODE_ENV !== "production") && subTree.patchFlag > 0 && subTree.patchFlag & 2048) {
          subTree = filterSingleRoot(subTree.children) || subTree;
        }
        if (vnode === subTree) {
          const parentVNode = parentComponent.vnode;
          setScopeId(
            el,
            parentVNode,
            parentVNode.scopeId,
            parentVNode.slotScopeIds,
            parentComponent.parent
          );
        }
      }
    };
    const mountChildren = (children, container, anchor, parentComponent, parentSuspense, namespace, slotScopeIds, optimized, start = 0) => {
      for (let i2 = start; i2 < children.length; i2++) {
        const child = children[i2] = optimized ? cloneIfMounted(children[i2]) : normalizeVNode(children[i2]);
        patch(
          null,
          child,
          container,
          anchor,
          parentComponent,
          parentSuspense,
          namespace,
          slotScopeIds,
          optimized
        );
      }
    };
    const patchElement = (n1, n2, parentComponent, parentSuspense, namespace, slotScopeIds, optimized) => {
      const el = n2.el = n1.el;
      let { patchFlag, dynamicChildren, dirs } = n2;
      patchFlag |= n1.patchFlag & 16;
      const oldProps = n1.props || EMPTY_OBJ;
      const newProps = n2.props || EMPTY_OBJ;
      let vnodeHook;
      parentComponent && toggleRecurse(parentComponent, false);
      if (vnodeHook = newProps.onVnodeBeforeUpdate) {
        invokeVNodeHook(vnodeHook, parentComponent, n2, n1);
      }
      if (dirs) {
        invokeDirectiveHook(n2, n1, parentComponent, "beforeUpdate");
      }
      parentComponent && toggleRecurse(parentComponent, true);
      if (!!(process.env.NODE_ENV !== "production") && isHmrUpdating) {
        patchFlag = 0;
        optimized = false;
        dynamicChildren = null;
      }
      if (dynamicChildren) {
        patchBlockChildren(
          n1.dynamicChildren,
          dynamicChildren,
          el,
          parentComponent,
          parentSuspense,
          resolveChildrenNamespace(n2, namespace),
          slotScopeIds
        );
        if (!!(process.env.NODE_ENV !== "production")) {
          traverseStaticChildren(n1, n2);
        }
      } else if (!optimized) {
        patchChildren(
          n1,
          n2,
          el,
          null,
          parentComponent,
          parentSuspense,
          resolveChildrenNamespace(n2, namespace),
          slotScopeIds,
          false
        );
      }
      if (patchFlag > 0) {
        if (patchFlag & 16) {
          patchProps(
            el,
            n2,
            oldProps,
            newProps,
            parentComponent,
            parentSuspense,
            namespace
          );
        } else {
          if (patchFlag & 2) {
            if (oldProps.class !== newProps.class) {
              hostPatchProp(el, "class", null, newProps.class, namespace);
            }
          }
          if (patchFlag & 4) {
            hostPatchProp(el, "style", oldProps.style, newProps.style, namespace);
          }
          if (patchFlag & 8) {
            const propsToUpdate = n2.dynamicProps;
            for (let i2 = 0; i2 < propsToUpdate.length; i2++) {
              const key = propsToUpdate[i2];
              const prev = oldProps[key];
              const next = newProps[key];
              if (next !== prev || key === "value") {
                hostPatchProp(
                  el,
                  key,
                  prev,
                  next,
                  namespace,
                  n1.children,
                  parentComponent,
                  parentSuspense,
                  unmountChildren
                );
              }
            }
          }
        }
        if (patchFlag & 1) {
          if (n1.children !== n2.children) {
            hostSetElementText(el, n2.children);
          }
        }
      } else if (!optimized && dynamicChildren == null) {
        patchProps(
          el,
          n2,
          oldProps,
          newProps,
          parentComponent,
          parentSuspense,
          namespace
        );
      }
      if ((vnodeHook = newProps.onVnodeUpdated) || dirs) {
        queuePostRenderEffect(() => {
          vnodeHook && invokeVNodeHook(vnodeHook, parentComponent, n2, n1);
          dirs && invokeDirectiveHook(n2, n1, parentComponent, "updated");
        }, parentSuspense);
      }
    };
    const patchBlockChildren = (oldChildren, newChildren, fallbackContainer, parentComponent, parentSuspense, namespace, slotScopeIds) => {
      for (let i2 = 0; i2 < newChildren.length; i2++) {
        const oldVNode = oldChildren[i2];
        const newVNode = newChildren[i2];
        const container = (
          // oldVNode may be an errored async setup() component inside Suspense
          // which will not have a mounted element
          oldVNode.el && // - In the case of a Fragment, we need to provide the actual parent
          // of the Fragment itself so it can move its children.
          (oldVNode.type === Fragment || // - In the case of different nodes, there is going to be a replacement
          // which also requires the correct parent container
          !isSameVNodeType(oldVNode, newVNode) || // - In the case of a component, it could contain anything.
          oldVNode.shapeFlag & (6 | 64)) ? hostParentNode(oldVNode.el) : (
            // In other cases, the parent container is not actually used so we
            // just pass the block element here to avoid a DOM parentNode call.
            fallbackContainer
          )
        );
        patch(
          oldVNode,
          newVNode,
          container,
          null,
          parentComponent,
          parentSuspense,
          namespace,
          slotScopeIds,
          true
        );
      }
    };
    const patchProps = (el, vnode, oldProps, newProps, parentComponent, parentSuspense, namespace) => {
      if (oldProps !== newProps) {
        if (oldProps !== EMPTY_OBJ) {
          for (const key in oldProps) {
            if (!isReservedProp(key) && !(key in newProps)) {
              hostPatchProp(
                el,
                key,
                oldProps[key],
                null,
                namespace,
                vnode.children,
                parentComponent,
                parentSuspense,
                unmountChildren
              );
            }
          }
        }
        for (const key in newProps) {
          if (isReservedProp(key))
            continue;
          const next = newProps[key];
          const prev = oldProps[key];
          if (next !== prev && key !== "value") {
            hostPatchProp(
              el,
              key,
              prev,
              next,
              namespace,
              vnode.children,
              parentComponent,
              parentSuspense,
              unmountChildren
            );
          }
        }
        if ("value" in newProps) {
          hostPatchProp(el, "value", oldProps.value, newProps.value, namespace);
        }
      }
    };
    const processFragment = (n1, n2, container, anchor, parentComponent, parentSuspense, namespace, slotScopeIds, optimized) => {
      const fragmentStartAnchor = n2.el = n1 ? n1.el : hostCreateText("");
      const fragmentEndAnchor = n2.anchor = n1 ? n1.anchor : hostCreateText("");
      let { patchFlag, dynamicChildren, slotScopeIds: fragmentSlotScopeIds } = n2;
      if (!!(process.env.NODE_ENV !== "production") && // #5523 dev root fragment may inherit directives
      (isHmrUpdating || patchFlag & 2048)) {
        patchFlag = 0;
        optimized = false;
        dynamicChildren = null;
      }
      if (fragmentSlotScopeIds) {
        slotScopeIds = slotScopeIds ? slotScopeIds.concat(fragmentSlotScopeIds) : fragmentSlotScopeIds;
      }
      if (n1 == null) {
        hostInsert(fragmentStartAnchor, container, anchor);
        hostInsert(fragmentEndAnchor, container, anchor);
        mountChildren(
          // #10007
          // such fragment like `<></>` will be compiled into
          // a fragment which doesn't have a children.
          // In this case fallback to an empty array
          n2.children || [],
          container,
          fragmentEndAnchor,
          parentComponent,
          parentSuspense,
          namespace,
          slotScopeIds,
          optimized
        );
      } else {
        if (patchFlag > 0 && patchFlag & 64 && dynamicChildren && // #2715 the previous fragment could've been a BAILed one as a result
        // of renderSlot() with no valid children
        n1.dynamicChildren) {
          patchBlockChildren(
            n1.dynamicChildren,
            dynamicChildren,
            container,
            parentComponent,
            parentSuspense,
            namespace,
            slotScopeIds
          );
          if (!!(process.env.NODE_ENV !== "production")) {
            traverseStaticChildren(n1, n2);
          } else if (
            // #2080 if the stable fragment has a key, it's a <template v-for> that may
            //  get moved around. Make sure all root level vnodes inherit el.
            // #2134 or if it's a component root, it may also get moved around
            // as the component is being moved.
            n2.key != null || parentComponent && n2 === parentComponent.subTree
          ) {
            traverseStaticChildren(
              n1,
              n2,
              true
              /* shallow */
            );
          }
        } else {
          patchChildren(
            n1,
            n2,
            container,
            fragmentEndAnchor,
            parentComponent,
            parentSuspense,
            namespace,
            slotScopeIds,
            optimized
          );
        }
      }
    };
    const processComponent = (n1, n2, container, anchor, parentComponent, parentSuspense, namespace, slotScopeIds, optimized) => {
      n2.slotScopeIds = slotScopeIds;
      if (n1 == null) {
        if (n2.shapeFlag & 512) {
          parentComponent.ctx.activate(
            n2,
            container,
            anchor,
            namespace,
            optimized
          );
        } else {
          mountComponent(
            n2,
            container,
            anchor,
            parentComponent,
            parentSuspense,
            namespace,
            optimized
          );
        }
      } else {
        updateComponent(n1, n2, optimized);
      }
    };
    const mountComponent = (initialVNode, container, anchor, parentComponent, parentSuspense, namespace, optimized) => {
      const instance = initialVNode.component = createComponentInstance(
        initialVNode,
        parentComponent,
        parentSuspense
      );
      if (!!(process.env.NODE_ENV !== "production") && instance.type.__hmrId) {
        registerHMR(instance);
      }
      if (!!(process.env.NODE_ENV !== "production")) {
        pushWarningContext(initialVNode);
        startMeasure(instance, `mount`);
      }
      if (isKeepAlive(initialVNode)) {
        instance.ctx.renderer = internals;
      }
      {
        if (!!(process.env.NODE_ENV !== "production")) {
          startMeasure(instance, `init`);
        }
        setupComponent(instance);
        if (!!(process.env.NODE_ENV !== "production")) {
          endMeasure(instance, `init`);
        }
      }
      if (instance.asyncDep) {
        parentSuspense && parentSuspense.registerDep(instance, setupRenderEffect);
        if (!initialVNode.el) {
          const placeholder = instance.subTree = createVNode$1(Comment);
          processCommentNode(null, placeholder, container, anchor);
        }
      } else {
        setupRenderEffect(
          instance,
          initialVNode,
          container,
          anchor,
          parentSuspense,
          namespace,
          optimized
        );
      }
      if (!!(process.env.NODE_ENV !== "production")) {
        popWarningContext();
        endMeasure(instance, `mount`);
      }
    };
    const updateComponent = (n1, n2, optimized) => {
      const instance = n2.component = n1.component;
      if (shouldUpdateComponent(n1, n2, optimized)) {
        if (instance.asyncDep && !instance.asyncResolved) {
          if (!!(process.env.NODE_ENV !== "production")) {
            pushWarningContext(n2);
          }
          updateComponentPreRender(instance, n2, optimized);
          if (!!(process.env.NODE_ENV !== "production")) {
            popWarningContext();
          }
          return;
        } else {
          instance.next = n2;
          invalidateJob(instance.update);
          instance.effect.dirty = true;
          instance.update();
        }
      } else {
        n2.el = n1.el;
        instance.vnode = n2;
      }
    };
    const setupRenderEffect = (instance, initialVNode, container, anchor, parentSuspense, namespace, optimized) => {
      const componentUpdateFn = () => {
        if (!instance.isMounted) {
          let vnodeHook;
          const { el, props } = initialVNode;
          const { bm, m: m2, parent } = instance;
          const isAsyncWrapperVNode = isAsyncWrapper(initialVNode);
          toggleRecurse(instance, false);
          if (bm) {
            invokeArrayFns(bm);
          }
          if (!isAsyncWrapperVNode && (vnodeHook = props && props.onVnodeBeforeMount)) {
            invokeVNodeHook(vnodeHook, parent, initialVNode);
          }
          toggleRecurse(instance, true);
          if (el && hydrateNode) {
            const hydrateSubTree = () => {
              if (!!(process.env.NODE_ENV !== "production")) {
                startMeasure(instance, `render`);
              }
              instance.subTree = renderComponentRoot(instance);
              if (!!(process.env.NODE_ENV !== "production")) {
                endMeasure(instance, `render`);
              }
              if (!!(process.env.NODE_ENV !== "production")) {
                startMeasure(instance, `hydrate`);
              }
              hydrateNode(
                el,
                instance.subTree,
                instance,
                parentSuspense,
                null
              );
              if (!!(process.env.NODE_ENV !== "production")) {
                endMeasure(instance, `hydrate`);
              }
            };
            if (isAsyncWrapperVNode) {
              initialVNode.type.__asyncLoader().then(
                // note: we are moving the render call into an async callback,
                // which means it won't track dependencies - but it's ok because
                // a server-rendered async wrapper is already in resolved state
                // and it will never need to change.
                () => !instance.isUnmounted && hydrateSubTree()
              );
            } else {
              hydrateSubTree();
            }
          } else {
            if (!!(process.env.NODE_ENV !== "production")) {
              startMeasure(instance, `render`);
            }
            const subTree = instance.subTree = renderComponentRoot(instance);
            if (!!(process.env.NODE_ENV !== "production")) {
              endMeasure(instance, `render`);
            }
            if (!!(process.env.NODE_ENV !== "production")) {
              startMeasure(instance, `patch`);
            }
            patch(
              null,
              subTree,
              container,
              anchor,
              instance,
              parentSuspense,
              namespace
            );
            if (!!(process.env.NODE_ENV !== "production")) {
              endMeasure(instance, `patch`);
            }
            initialVNode.el = subTree.el;
          }
          if (m2) {
            queuePostRenderEffect(m2, parentSuspense);
          }
          if (!isAsyncWrapperVNode && (vnodeHook = props && props.onVnodeMounted)) {
            const scopedInitialVNode = initialVNode;
            queuePostRenderEffect(
              () => invokeVNodeHook(vnodeHook, parent, scopedInitialVNode),
              parentSuspense
            );
          }
          if (initialVNode.shapeFlag & 256 || parent && isAsyncWrapper(parent.vnode) && parent.vnode.shapeFlag & 256) {
            instance.a && queuePostRenderEffect(instance.a, parentSuspense);
          }
          instance.isMounted = true;
          if (!!(process.env.NODE_ENV !== "production") || false) {
            devtoolsComponentAdded(instance);
          }
          initialVNode = container = anchor = null;
        } else {
          let { next, bu, u: u2, parent, vnode } = instance;
          {
            const nonHydratedAsyncRoot = locateNonHydratedAsyncRoot(instance);
            if (nonHydratedAsyncRoot) {
              if (next) {
                next.el = vnode.el;
                updateComponentPreRender(instance, next, optimized);
              }
              nonHydratedAsyncRoot.asyncDep.then(() => {
                if (!instance.isUnmounted) {
                  componentUpdateFn();
                }
              });
              return;
            }
          }
          let originNext = next;
          let vnodeHook;
          if (!!(process.env.NODE_ENV !== "production")) {
            pushWarningContext(next || instance.vnode);
          }
          toggleRecurse(instance, false);
          if (next) {
            next.el = vnode.el;
            updateComponentPreRender(instance, next, optimized);
          } else {
            next = vnode;
          }
          if (bu) {
            invokeArrayFns(bu);
          }
          if (vnodeHook = next.props && next.props.onVnodeBeforeUpdate) {
            invokeVNodeHook(vnodeHook, parent, next, vnode);
          }
          toggleRecurse(instance, true);
          if (!!(process.env.NODE_ENV !== "production")) {
            startMeasure(instance, `render`);
          }
          const nextTree = renderComponentRoot(instance);
          if (!!(process.env.NODE_ENV !== "production")) {
            endMeasure(instance, `render`);
          }
          const prevTree = instance.subTree;
          instance.subTree = nextTree;
          if (!!(process.env.NODE_ENV !== "production")) {
            startMeasure(instance, `patch`);
          }
          patch(
            prevTree,
            nextTree,
            // parent may have changed if it's in a teleport
            hostParentNode(prevTree.el),
            // anchor may have changed if it's in a fragment
            getNextHostNode(prevTree),
            instance,
            parentSuspense,
            namespace
          );
          if (!!(process.env.NODE_ENV !== "production")) {
            endMeasure(instance, `patch`);
          }
          next.el = nextTree.el;
          if (originNext === null) {
            updateHOCHostEl(instance, nextTree.el);
          }
          if (u2) {
            queuePostRenderEffect(u2, parentSuspense);
          }
          if (vnodeHook = next.props && next.props.onVnodeUpdated) {
            queuePostRenderEffect(
              () => invokeVNodeHook(vnodeHook, parent, next, vnode),
              parentSuspense
            );
          }
          if (!!(process.env.NODE_ENV !== "production") || false) {
            devtoolsComponentUpdated(instance);
          }
          if (!!(process.env.NODE_ENV !== "production")) {
            popWarningContext();
          }
        }
      };
      const effect2 = instance.effect = new ReactiveEffect(
        componentUpdateFn,
        NOOP,
        () => queueJob(update),
        instance.scope
        // track it in component's effect scope
      );
      const update = instance.update = () => {
        if (effect2.dirty) {
          effect2.run();
        }
      };
      update.id = instance.uid;
      toggleRecurse(instance, true);
      if (!!(process.env.NODE_ENV !== "production")) {
        effect2.onTrack = instance.rtc ? (e) => invokeArrayFns(instance.rtc, e) : void 0;
        effect2.onTrigger = instance.rtg ? (e) => invokeArrayFns(instance.rtg, e) : void 0;
        update.ownerInstance = instance;
      }
      update();
    };
    const updateComponentPreRender = (instance, nextVNode, optimized) => {
      nextVNode.component = instance;
      const prevProps = instance.vnode.props;
      instance.vnode = nextVNode;
      instance.next = null;
      updateProps(instance, nextVNode.props, prevProps, optimized);
      updateSlots(instance, nextVNode.children, optimized);
      pauseTracking();
      flushPreFlushCbs(instance);
      resetTracking();
    };
    const patchChildren = (n1, n2, container, anchor, parentComponent, parentSuspense, namespace, slotScopeIds, optimized = false) => {
      const c1 = n1 && n1.children;
      const prevShapeFlag = n1 ? n1.shapeFlag : 0;
      const c2 = n2.children;
      const { patchFlag, shapeFlag } = n2;
      if (patchFlag > 0) {
        if (patchFlag & 128) {
          patchKeyedChildren(
            c1,
            c2,
            container,
            anchor,
            parentComponent,
            parentSuspense,
            namespace,
            slotScopeIds,
            optimized
          );
          return;
        } else if (patchFlag & 256) {
          patchUnkeyedChildren(
            c1,
            c2,
            container,
            anchor,
            parentComponent,
            parentSuspense,
            namespace,
            slotScopeIds,
            optimized
          );
          return;
        }
      }
      if (shapeFlag & 8) {
        if (prevShapeFlag & 16) {
          unmountChildren(c1, parentComponent, parentSuspense);
        }
        if (c2 !== c1) {
          hostSetElementText(container, c2);
        }
      } else {
        if (prevShapeFlag & 16) {
          if (shapeFlag & 16) {
            patchKeyedChildren(
              c1,
              c2,
              container,
              anchor,
              parentComponent,
              parentSuspense,
              namespace,
              slotScopeIds,
              optimized
            );
          } else {
            unmountChildren(c1, parentComponent, parentSuspense, true);
          }
        } else {
          if (prevShapeFlag & 8) {
            hostSetElementText(container, "");
          }
          if (shapeFlag & 16) {
            mountChildren(
              c2,
              container,
              anchor,
              parentComponent,
              parentSuspense,
              namespace,
              slotScopeIds,
              optimized
            );
          }
        }
      }
    };
    const patchUnkeyedChildren = (c1, c2, container, anchor, parentComponent, parentSuspense, namespace, slotScopeIds, optimized) => {
      c1 = c1 || EMPTY_ARR;
      c2 = c2 || EMPTY_ARR;
      const oldLength = c1.length;
      const newLength = c2.length;
      const commonLength = Math.min(oldLength, newLength);
      let i2;
      for (i2 = 0; i2 < commonLength; i2++) {
        const nextChild = c2[i2] = optimized ? cloneIfMounted(c2[i2]) : normalizeVNode(c2[i2]);
        patch(
          c1[i2],
          nextChild,
          container,
          null,
          parentComponent,
          parentSuspense,
          namespace,
          slotScopeIds,
          optimized
        );
      }
      if (oldLength > newLength) {
        unmountChildren(
          c1,
          parentComponent,
          parentSuspense,
          true,
          false,
          commonLength
        );
      } else {
        mountChildren(
          c2,
          container,
          anchor,
          parentComponent,
          parentSuspense,
          namespace,
          slotScopeIds,
          optimized,
          commonLength
        );
      }
    };
    const patchKeyedChildren = (c1, c2, container, parentAnchor, parentComponent, parentSuspense, namespace, slotScopeIds, optimized) => {
      let i2 = 0;
      const l2 = c2.length;
      let e1 = c1.length - 1;
      let e2 = l2 - 1;
      while (i2 <= e1 && i2 <= e2) {
        const n1 = c1[i2];
        const n2 = c2[i2] = optimized ? cloneIfMounted(c2[i2]) : normalizeVNode(c2[i2]);
        if (isSameVNodeType(n1, n2)) {
          patch(
            n1,
            n2,
            container,
            null,
            parentComponent,
            parentSuspense,
            namespace,
            slotScopeIds,
            optimized
          );
        } else {
          break;
        }
        i2++;
      }
      while (i2 <= e1 && i2 <= e2) {
        const n1 = c1[e1];
        const n2 = c2[e2] = optimized ? cloneIfMounted(c2[e2]) : normalizeVNode(c2[e2]);
        if (isSameVNodeType(n1, n2)) {
          patch(
            n1,
            n2,
            container,
            null,
            parentComponent,
            parentSuspense,
            namespace,
            slotScopeIds,
            optimized
          );
        } else {
          break;
        }
        e1--;
        e2--;
      }
      if (i2 > e1) {
        if (i2 <= e2) {
          const nextPos = e2 + 1;
          const anchor = nextPos < l2 ? c2[nextPos].el : parentAnchor;
          while (i2 <= e2) {
            patch(
              null,
              c2[i2] = optimized ? cloneIfMounted(c2[i2]) : normalizeVNode(c2[i2]),
              container,
              anchor,
              parentComponent,
              parentSuspense,
              namespace,
              slotScopeIds,
              optimized
            );
            i2++;
          }
        }
      } else if (i2 > e2) {
        while (i2 <= e1) {
          unmount(c1[i2], parentComponent, parentSuspense, true);
          i2++;
        }
      } else {
        const s1 = i2;
        const s2 = i2;
        const keyToNewIndexMap = /* @__PURE__ */ new Map();
        for (i2 = s2; i2 <= e2; i2++) {
          const nextChild = c2[i2] = optimized ? cloneIfMounted(c2[i2]) : normalizeVNode(c2[i2]);
          if (nextChild.key != null) {
            if (!!(process.env.NODE_ENV !== "production") && keyToNewIndexMap.has(nextChild.key)) {
              warn$1(
                `Duplicate keys found during update:`,
                JSON.stringify(nextChild.key),
                `Make sure keys are unique.`
              );
            }
            keyToNewIndexMap.set(nextChild.key, i2);
          }
        }
        let j2;
        let patched = 0;
        const toBePatched = e2 - s2 + 1;
        let moved = false;
        let maxNewIndexSoFar = 0;
        const newIndexToOldIndexMap = new Array(toBePatched);
        for (i2 = 0; i2 < toBePatched; i2++)
          newIndexToOldIndexMap[i2] = 0;
        for (i2 = s1; i2 <= e1; i2++) {
          const prevChild = c1[i2];
          if (patched >= toBePatched) {
            unmount(prevChild, parentComponent, parentSuspense, true);
            continue;
          }
          let newIndex;
          if (prevChild.key != null) {
            newIndex = keyToNewIndexMap.get(prevChild.key);
          } else {
            for (j2 = s2; j2 <= e2; j2++) {
              if (newIndexToOldIndexMap[j2 - s2] === 0 && isSameVNodeType(prevChild, c2[j2])) {
                newIndex = j2;
                break;
              }
            }
          }
          if (newIndex === void 0) {
            unmount(prevChild, parentComponent, parentSuspense, true);
          } else {
            newIndexToOldIndexMap[newIndex - s2] = i2 + 1;
            if (newIndex >= maxNewIndexSoFar) {
              maxNewIndexSoFar = newIndex;
            } else {
              moved = true;
            }
            patch(
              prevChild,
              c2[newIndex],
              container,
              null,
              parentComponent,
              parentSuspense,
              namespace,
              slotScopeIds,
              optimized
            );
            patched++;
          }
        }
        const increasingNewIndexSequence = moved ? getSequence(newIndexToOldIndexMap) : EMPTY_ARR;
        j2 = increasingNewIndexSequence.length - 1;
        for (i2 = toBePatched - 1; i2 >= 0; i2--) {
          const nextIndex = s2 + i2;
          const nextChild = c2[nextIndex];
          const anchor = nextIndex + 1 < l2 ? c2[nextIndex + 1].el : parentAnchor;
          if (newIndexToOldIndexMap[i2] === 0) {
            patch(
              null,
              nextChild,
              container,
              anchor,
              parentComponent,
              parentSuspense,
              namespace,
              slotScopeIds,
              optimized
            );
          } else if (moved) {
            if (j2 < 0 || i2 !== increasingNewIndexSequence[j2]) {
              move(nextChild, container, anchor, 2);
            } else {
              j2--;
            }
          }
        }
      }
    };
    const move = (vnode, container, anchor, moveType, parentSuspense = null) => {
      const { el, type, transition, children, shapeFlag } = vnode;
      if (shapeFlag & 6) {
        move(vnode.component.subTree, container, anchor, moveType);
        return;
      }
      if (shapeFlag & 128) {
        vnode.suspense.move(container, anchor, moveType);
        return;
      }
      if (shapeFlag & 64) {
        type.move(vnode, container, anchor, internals);
        return;
      }
      if (type === Fragment) {
        hostInsert(el, container, anchor);
        for (let i2 = 0; i2 < children.length; i2++) {
          move(children[i2], container, anchor, moveType);
        }
        hostInsert(vnode.anchor, container, anchor);
        return;
      }
      if (type === Static) {
        moveStaticNode(vnode, container, anchor);
        return;
      }
      const needTransition2 = moveType !== 2 && shapeFlag & 1 && transition;
      if (needTransition2) {
        if (moveType === 0) {
          transition.beforeEnter(el);
          hostInsert(el, container, anchor);
          queuePostRenderEffect(() => transition.enter(el), parentSuspense);
        } else {
          const { leave, delayLeave, afterLeave } = transition;
          const remove22 = () => hostInsert(el, container, anchor);
          const performLeave = () => {
            leave(el, () => {
              remove22();
              afterLeave && afterLeave();
            });
          };
          if (delayLeave) {
            delayLeave(el, remove22, performLeave);
          } else {
            performLeave();
          }
        }
      } else {
        hostInsert(el, container, anchor);
      }
    };
    const unmount = (vnode, parentComponent, parentSuspense, doRemove = false, optimized = false) => {
      const {
        type,
        props,
        ref: ref3,
        children,
        dynamicChildren,
        shapeFlag,
        patchFlag,
        dirs
      } = vnode;
      if (ref3 != null) {
        setRef(ref3, null, parentSuspense, vnode, true);
      }
      if (shapeFlag & 256) {
        parentComponent.ctx.deactivate(vnode);
        return;
      }
      const shouldInvokeDirs = shapeFlag & 1 && dirs;
      const shouldInvokeVnodeHook = !isAsyncWrapper(vnode);
      let vnodeHook;
      if (shouldInvokeVnodeHook && (vnodeHook = props && props.onVnodeBeforeUnmount)) {
        invokeVNodeHook(vnodeHook, parentComponent, vnode);
      }
      if (shapeFlag & 6) {
        unmountComponent(vnode.component, parentSuspense, doRemove);
      } else {
        if (shapeFlag & 128) {
          vnode.suspense.unmount(parentSuspense, doRemove);
          return;
        }
        if (shouldInvokeDirs) {
          invokeDirectiveHook(vnode, null, parentComponent, "beforeUnmount");
        }
        if (shapeFlag & 64) {
          vnode.type.remove(
            vnode,
            parentComponent,
            parentSuspense,
            optimized,
            internals,
            doRemove
          );
        } else if (dynamicChildren && // #1153: fast path should not be taken for non-stable (v-for) fragments
        (type !== Fragment || patchFlag > 0 && patchFlag & 64)) {
          unmountChildren(
            dynamicChildren,
            parentComponent,
            parentSuspense,
            false,
            true
          );
        } else if (type === Fragment && patchFlag & (128 | 256) || !optimized && shapeFlag & 16) {
          unmountChildren(children, parentComponent, parentSuspense);
        }
        if (doRemove) {
          remove2(vnode);
        }
      }
      if (shouldInvokeVnodeHook && (vnodeHook = props && props.onVnodeUnmounted) || shouldInvokeDirs) {
        queuePostRenderEffect(() => {
          vnodeHook && invokeVNodeHook(vnodeHook, parentComponent, vnode);
          shouldInvokeDirs && invokeDirectiveHook(vnode, null, parentComponent, "unmounted");
        }, parentSuspense);
      }
    };
    const remove2 = (vnode) => {
      const { type, el, anchor, transition } = vnode;
      if (type === Fragment) {
        if (!!(process.env.NODE_ENV !== "production") && vnode.patchFlag > 0 && vnode.patchFlag & 2048 && transition && !transition.persisted) {
          vnode.children.forEach((child) => {
            if (child.type === Comment) {
              hostRemove(child.el);
            } else {
              remove2(child);
            }
          });
        } else {
          removeFragment(el, anchor);
        }
        return;
      }
      if (type === Static) {
        removeStaticNode(vnode);
        return;
      }
      const performRemove = () => {
        hostRemove(el);
        if (transition && !transition.persisted && transition.afterLeave) {
          transition.afterLeave();
        }
      };
      if (vnode.shapeFlag & 1 && transition && !transition.persisted) {
        const { leave, delayLeave } = transition;
        const performLeave = () => leave(el, performRemove);
        if (delayLeave) {
          delayLeave(vnode.el, performRemove, performLeave);
        } else {
          performLeave();
        }
      } else {
        performRemove();
      }
    };
    const removeFragment = (cur, end) => {
      let next;
      while (cur !== end) {
        next = hostNextSibling(cur);
        hostRemove(cur);
        cur = next;
      }
      hostRemove(end);
    };
    const unmountComponent = (instance, parentSuspense, doRemove) => {
      if (!!(process.env.NODE_ENV !== "production") && instance.type.__hmrId) {
        unregisterHMR(instance);
      }
      const { bum, scope, update, subTree, um } = instance;
      if (bum) {
        invokeArrayFns(bum);
      }
      scope.stop();
      if (update) {
        update.active = false;
        unmount(subTree, instance, parentSuspense, doRemove);
      }
      if (um) {
        queuePostRenderEffect(um, parentSuspense);
      }
      queuePostRenderEffect(() => {
        instance.isUnmounted = true;
      }, parentSuspense);
      if (parentSuspense && parentSuspense.pendingBranch && !parentSuspense.isUnmounted && instance.asyncDep && !instance.asyncResolved && instance.suspenseId === parentSuspense.pendingId) {
        parentSuspense.deps--;
        if (parentSuspense.deps === 0) {
          parentSuspense.resolve();
        }
      }
      if (!!(process.env.NODE_ENV !== "production") || false) {
        devtoolsComponentRemoved(instance);
      }
    };
    const unmountChildren = (children, parentComponent, parentSuspense, doRemove = false, optimized = false, start = 0) => {
      for (let i2 = start; i2 < children.length; i2++) {
        unmount(children[i2], parentComponent, parentSuspense, doRemove, optimized);
      }
    };
    const getNextHostNode = (vnode) => {
      if (vnode.shapeFlag & 6) {
        return getNextHostNode(vnode.component.subTree);
      }
      if (vnode.shapeFlag & 128) {
        return vnode.suspense.next();
      }
      return hostNextSibling(vnode.anchor || vnode.el);
    };
    let isFlushing2 = false;
    const render = (vnode, container, namespace) => {
      if (vnode == null) {
        if (container._vnode) {
          unmount(container._vnode, null, null, true);
        }
      } else {
        patch(
          container._vnode || null,
          vnode,
          container,
          null,
          null,
          null,
          namespace
        );
      }
      if (!isFlushing2) {
        isFlushing2 = true;
        flushPreFlushCbs();
        flushPostFlushCbs();
        isFlushing2 = false;
      }
      container._vnode = vnode;
    };
    const internals = {
      p: patch,
      um: unmount,
      m: move,
      r: remove2,
      mt: mountComponent,
      mc: mountChildren,
      pc: patchChildren,
      pbc: patchBlockChildren,
      n: getNextHostNode,
      o: options
    };
    let hydrate;
    let hydrateNode;
    if (createHydrationFns) {
      [hydrate, hydrateNode] = createHydrationFns(
        internals
      );
    }
    return {
      render,
      hydrate,
      createApp: createAppAPI(render, hydrate)
    };
  }
  function resolveChildrenNamespace({ type, props }, currentNamespace) {
    return currentNamespace === "svg" && type === "foreignObject" || currentNamespace === "mathml" && type === "annotation-xml" && props && props.encoding && props.encoding.includes("html") ? void 0 : currentNamespace;
  }
  function toggleRecurse({ effect: effect2, update }, allowed) {
    effect2.allowRecurse = update.allowRecurse = allowed;
  }
  function needTransition(parentSuspense, transition) {
    return (!parentSuspense || parentSuspense && !parentSuspense.pendingBranch) && transition && !transition.persisted;
  }
  function traverseStaticChildren(n1, n2, shallow = false) {
    const ch1 = n1.children;
    const ch2 = n2.children;
    if (isArray(ch1) && isArray(ch2)) {
      for (let i2 = 0; i2 < ch1.length; i2++) {
        const c1 = ch1[i2];
        let c2 = ch2[i2];
        if (c2.shapeFlag & 1 && !c2.dynamicChildren) {
          if (c2.patchFlag <= 0 || c2.patchFlag === 32) {
            c2 = ch2[i2] = cloneIfMounted(ch2[i2]);
            c2.el = c1.el;
          }
          if (!shallow)
            traverseStaticChildren(c1, c2);
        }
        if (c2.type === Text$1) {
          c2.el = c1.el;
        }
        if (!!(process.env.NODE_ENV !== "production") && c2.type === Comment && !c2.el) {
          c2.el = c1.el;
        }
      }
    }
  }
  function getSequence(arr) {
    const p2 = arr.slice();
    const result = [0];
    let i2, j2, u2, v2, c2;
    const len = arr.length;
    for (i2 = 0; i2 < len; i2++) {
      const arrI = arr[i2];
      if (arrI !== 0) {
        j2 = result[result.length - 1];
        if (arr[j2] < arrI) {
          p2[i2] = j2;
          result.push(i2);
          continue;
        }
        u2 = 0;
        v2 = result.length - 1;
        while (u2 < v2) {
          c2 = u2 + v2 >> 1;
          if (arr[result[c2]] < arrI) {
            u2 = c2 + 1;
          } else {
            v2 = c2;
          }
        }
        if (arrI < arr[result[u2]]) {
          if (u2 > 0) {
            p2[i2] = result[u2 - 1];
          }
          result[u2] = i2;
        }
      }
    }
    u2 = result.length;
    v2 = result[u2 - 1];
    while (u2-- > 0) {
      result[u2] = v2;
      v2 = p2[v2];
    }
    return result;
  }
  function locateNonHydratedAsyncRoot(instance) {
    const subComponent = instance.subTree.component;
    if (subComponent) {
      if (subComponent.asyncDep && !subComponent.asyncResolved) {
        return subComponent;
      } else {
        return locateNonHydratedAsyncRoot(subComponent);
      }
    }
  }
  const isTeleport = (type) => type.__isTeleport;
  const Fragment = Symbol.for("v-fgt");
  const Text$1 = Symbol.for("v-txt");
  const Comment = Symbol.for("v-cmt");
  const Static = Symbol.for("v-stc");
  const blockStack = [];
  let currentBlock = null;
  function openBlock(disableTracking = false) {
    blockStack.push(currentBlock = disableTracking ? null : []);
  }
  function closeBlock() {
    blockStack.pop();
    currentBlock = blockStack[blockStack.length - 1] || null;
  }
  let isBlockTreeEnabled = 1;
  function setBlockTracking(value) {
    isBlockTreeEnabled += value;
  }
  function setupBlock(vnode) {
    vnode.dynamicChildren = isBlockTreeEnabled > 0 ? currentBlock || EMPTY_ARR : null;
    closeBlock();
    if (isBlockTreeEnabled > 0 && currentBlock) {
      currentBlock.push(vnode);
    }
    return vnode;
  }
  function createBlock(type, props, children, patchFlag, dynamicProps) {
    return setupBlock(
      createVNode$1(
        type,
        props,
        children,
        patchFlag,
        dynamicProps,
        true
      )
    );
  }
  function isVNode(value) {
    return value ? value.__v_isVNode === true : false;
  }
  function isSameVNodeType(n1, n2) {
    if (!!(process.env.NODE_ENV !== "production") && n2.shapeFlag & 6 && hmrDirtyComponents.has(n2.type)) {
      n1.shapeFlag &= ~256;
      n2.shapeFlag &= ~512;
      return false;
    }
    return n1.type === n2.type && n1.key === n2.key;
  }
  const createVNodeWithArgsTransform = (...args) => {
    return _createVNode(
      ...args
    );
  };
  const InternalObjectKey = `__vInternal`;
  const normalizeKey = ({ key }) => key != null ? key : null;
  const normalizeRef = ({
    ref: ref3,
    ref_key,
    ref_for
  }) => {
    if (typeof ref3 === "number") {
      ref3 = "" + ref3;
    }
    return ref3 != null ? isString(ref3) || isRef(ref3) || isFunction(ref3) ? { i: currentRenderingInstance, r: ref3, k: ref_key, f: !!ref_for } : ref3 : null;
  };
  function createBaseVNode(type, props = null, children = null, patchFlag = 0, dynamicProps = null, shapeFlag = type === Fragment ? 0 : 1, isBlockNode = false, needFullChildrenNormalization = false) {
    const vnode = {
      __v_isVNode: true,
      __v_skip: true,
      type,
      props,
      key: props && normalizeKey(props),
      ref: props && normalizeRef(props),
      scopeId: currentScopeId,
      slotScopeIds: null,
      children,
      component: null,
      suspense: null,
      ssContent: null,
      ssFallback: null,
      dirs: null,
      transition: null,
      el: null,
      anchor: null,
      target: null,
      targetAnchor: null,
      staticCount: 0,
      shapeFlag,
      patchFlag,
      dynamicProps,
      dynamicChildren: null,
      appContext: null,
      ctx: currentRenderingInstance
    };
    if (needFullChildrenNormalization) {
      normalizeChildren(vnode, children);
      if (shapeFlag & 128) {
        type.normalize(vnode);
      }
    } else if (children) {
      vnode.shapeFlag |= isString(children) ? 8 : 16;
    }
    if (!!(process.env.NODE_ENV !== "production") && vnode.key !== vnode.key) {
      warn$1(`VNode created with invalid key (NaN). VNode type:`, vnode.type);
    }
    if (isBlockTreeEnabled > 0 && // avoid a block node from tracking itself
    !isBlockNode && // has current parent block
    currentBlock && // presence of a patch flag indicates this node needs patching on updates.
    // component nodes also should always be patched, because even if the
    // component doesn't need to update, it needs to persist the instance on to
    // the next vnode so that it can be properly unmounted later.
    (vnode.patchFlag > 0 || shapeFlag & 6) && // the EVENTS flag is only for hydration and if it is the only flag, the
    // vnode should not be considered dynamic due to handler caching.
    vnode.patchFlag !== 32) {
      currentBlock.push(vnode);
    }
    return vnode;
  }
  const createVNode$1 = !!(process.env.NODE_ENV !== "production") ? createVNodeWithArgsTransform : _createVNode;
  function _createVNode(type, props = null, children = null, patchFlag = 0, dynamicProps = null, isBlockNode = false) {
    if (!type || type === NULL_DYNAMIC_COMPONENT) {
      if (!!(process.env.NODE_ENV !== "production") && !type) {
        warn$1(`Invalid vnode type when creating vnode: ${type}.`);
      }
      type = Comment;
    }
    if (isVNode(type)) {
      const cloned = cloneVNode(
        type,
        props,
        true
        /* mergeRef: true */
      );
      if (children) {
        normalizeChildren(cloned, children);
      }
      if (isBlockTreeEnabled > 0 && !isBlockNode && currentBlock) {
        if (cloned.shapeFlag & 6) {
          currentBlock[currentBlock.indexOf(type)] = cloned;
        } else {
          currentBlock.push(cloned);
        }
      }
      cloned.patchFlag |= -2;
      return cloned;
    }
    if (isClassComponent(type)) {
      type = type.__vccOpts;
    }
    if (props) {
      props = guardReactiveProps(props);
      let { class: klass, style } = props;
      if (klass && !isString(klass)) {
        props.class = normalizeClass(klass);
      }
      if (isObject(style)) {
        if (isProxy(style) && !isArray(style)) {
          style = extend({}, style);
        }
        props.style = normalizeStyle(style);
      }
    }
    const shapeFlag = isString(type) ? 1 : isSuspense(type) ? 128 : isTeleport(type) ? 64 : isObject(type) ? 4 : isFunction(type) ? 2 : 0;
    if (!!(process.env.NODE_ENV !== "production") && shapeFlag & 4 && isProxy(type)) {
      type = toRaw(type);
      warn$1(
        `Vue received a Component that was made a reactive object. This can lead to unnecessary performance overhead and should be avoided by marking the component with \`markRaw\` or using \`shallowRef\` instead of \`ref\`.`,
        `
Component that was made reactive: `,
        type
      );
    }
    return createBaseVNode(
      type,
      props,
      children,
      patchFlag,
      dynamicProps,
      shapeFlag,
      isBlockNode,
      true
    );
  }
  function guardReactiveProps(props) {
    if (!props)
      return null;
    return isProxy(props) || InternalObjectKey in props ? extend({}, props) : props;
  }
  function cloneVNode(vnode, extraProps, mergeRef = false) {
    const { props, ref: ref3, patchFlag, children } = vnode;
    const mergedProps = extraProps ? mergeProps(props || {}, extraProps) : props;
    const cloned = {
      __v_isVNode: true,
      __v_skip: true,
      type: vnode.type,
      props: mergedProps,
      key: mergedProps && normalizeKey(mergedProps),
      ref: extraProps && extraProps.ref ? (
        // #2078 in the case of <component :is="vnode" ref="extra"/>
        // if the vnode itself already has a ref, cloneVNode will need to merge
        // the refs so the single vnode can be set on multiple refs
        mergeRef && ref3 ? isArray(ref3) ? ref3.concat(normalizeRef(extraProps)) : [ref3, normalizeRef(extraProps)] : normalizeRef(extraProps)
      ) : ref3,
      scopeId: vnode.scopeId,
      slotScopeIds: vnode.slotScopeIds,
      children: !!(process.env.NODE_ENV !== "production") && patchFlag === -1 && isArray(children) ? children.map(deepCloneVNode) : children,
      target: vnode.target,
      targetAnchor: vnode.targetAnchor,
      staticCount: vnode.staticCount,
      shapeFlag: vnode.shapeFlag,
      // if the vnode is cloned with extra props, we can no longer assume its
      // existing patch flag to be reliable and need to add the FULL_PROPS flag.
      // note: preserve flag for fragments since they use the flag for children
      // fast paths only.
      patchFlag: extraProps && vnode.type !== Fragment ? patchFlag === -1 ? 16 : patchFlag | 16 : patchFlag,
      dynamicProps: vnode.dynamicProps,
      dynamicChildren: vnode.dynamicChildren,
      appContext: vnode.appContext,
      dirs: vnode.dirs,
      transition: vnode.transition,
      // These should technically only be non-null on mounted VNodes. However,
      // they *should* be copied for kept-alive vnodes. So we just always copy
      // them since them being non-null during a mount doesn't affect the logic as
      // they will simply be overwritten.
      component: vnode.component,
      suspense: vnode.suspense,
      ssContent: vnode.ssContent && cloneVNode(vnode.ssContent),
      ssFallback: vnode.ssFallback && cloneVNode(vnode.ssFallback),
      el: vnode.el,
      anchor: vnode.anchor,
      ctx: vnode.ctx,
      ce: vnode.ce
    };
    return cloned;
  }
  function deepCloneVNode(vnode) {
    const cloned = cloneVNode(vnode);
    if (isArray(vnode.children)) {
      cloned.children = vnode.children.map(deepCloneVNode);
    }
    return cloned;
  }
  function createTextVNode(text = " ", flag = 0) {
    return createVNode$1(Text$1, null, text, flag);
  }
  function normalizeVNode(child) {
    if (child == null || typeof child === "boolean") {
      return createVNode$1(Comment);
    } else if (isArray(child)) {
      return createVNode$1(
        Fragment,
        null,
        // #3666, avoid reference pollution when reusing vnode
        child.slice()
      );
    } else if (typeof child === "object") {
      return cloneIfMounted(child);
    } else {
      return createVNode$1(Text$1, null, String(child));
    }
  }
  function cloneIfMounted(child) {
    return child.el === null && child.patchFlag !== -1 || child.memo ? child : cloneVNode(child);
  }
  function normalizeChildren(vnode, children) {
    let type = 0;
    const { shapeFlag } = vnode;
    if (children == null) {
      children = null;
    } else if (isArray(children)) {
      type = 16;
    } else if (typeof children === "object") {
      if (shapeFlag & (1 | 64)) {
        const slot = children.default;
        if (slot) {
          slot._c && (slot._d = false);
          normalizeChildren(vnode, slot());
          slot._c && (slot._d = true);
        }
        return;
      } else {
        type = 32;
        const slotFlag = children._;
        if (!slotFlag && !(InternalObjectKey in children)) {
          children._ctx = currentRenderingInstance;
        } else if (slotFlag === 3 && currentRenderingInstance) {
          if (currentRenderingInstance.slots._ === 1) {
            children._ = 1;
          } else {
            children._ = 2;
            vnode.patchFlag |= 1024;
          }
        }
      }
    } else if (isFunction(children)) {
      children = { default: children, _ctx: currentRenderingInstance };
      type = 32;
    } else {
      children = String(children);
      if (shapeFlag & 64) {
        type = 16;
        children = [createTextVNode(children)];
      } else {
        type = 8;
      }
    }
    vnode.children = children;
    vnode.shapeFlag |= type;
  }
  function mergeProps(...args) {
    const ret = {};
    for (let i2 = 0; i2 < args.length; i2++) {
      const toMerge = args[i2];
      for (const key in toMerge) {
        if (key === "class") {
          if (ret.class !== toMerge.class) {
            ret.class = normalizeClass([ret.class, toMerge.class]);
          }
        } else if (key === "style") {
          ret.style = normalizeStyle([ret.style, toMerge.style]);
        } else if (isOn(key)) {
          const existing = ret[key];
          const incoming = toMerge[key];
          if (incoming && existing !== incoming && !(isArray(existing) && existing.includes(incoming))) {
            ret[key] = existing ? [].concat(existing, incoming) : incoming;
          }
        } else if (key !== "") {
          ret[key] = toMerge[key];
        }
      }
    }
    return ret;
  }
  function invokeVNodeHook(hook, instance, vnode, prevVNode = null) {
    callWithAsyncErrorHandling(hook, instance, 7, [
      vnode,
      prevVNode
    ]);
  }
  const emptyAppContext = createAppContext();
  let uid = 0;
  function createComponentInstance(vnode, parent, suspense) {
    const type = vnode.type;
    const appContext = (parent ? parent.appContext : vnode.appContext) || emptyAppContext;
    const instance = {
      uid: uid++,
      vnode,
      type,
      parent,
      appContext,
      root: null,
      // to be immediately set
      next: null,
      subTree: null,
      // will be set synchronously right after creation
      effect: null,
      update: null,
      // will be set synchronously right after creation
      scope: new EffectScope(
        true
        /* detached */
      ),
      render: null,
      proxy: null,
      exposed: null,
      exposeProxy: null,
      withProxy: null,
      provides: parent ? parent.provides : Object.create(appContext.provides),
      accessCache: null,
      renderCache: [],
      // local resolved assets
      components: null,
      directives: null,
      // resolved props and emits options
      propsOptions: normalizePropsOptions(type, appContext),
      emitsOptions: normalizeEmitsOptions(type, appContext),
      // emit
      emit: null,
      // to be set immediately
      emitted: null,
      // props default value
      propsDefaults: EMPTY_OBJ,
      // inheritAttrs
      inheritAttrs: type.inheritAttrs,
      // state
      ctx: EMPTY_OBJ,
      data: EMPTY_OBJ,
      props: EMPTY_OBJ,
      attrs: EMPTY_OBJ,
      slots: EMPTY_OBJ,
      refs: EMPTY_OBJ,
      setupState: EMPTY_OBJ,
      setupContext: null,
      attrsProxy: null,
      slotsProxy: null,
      // suspense related
      suspense,
      suspenseId: suspense ? suspense.pendingId : 0,
      asyncDep: null,
      asyncResolved: false,
      // lifecycle hooks
      // not using enums here because it results in computed properties
      isMounted: false,
      isUnmounted: false,
      isDeactivated: false,
      bc: null,
      c: null,
      bm: null,
      m: null,
      bu: null,
      u: null,
      um: null,
      bum: null,
      da: null,
      a: null,
      rtg: null,
      rtc: null,
      ec: null,
      sp: null
    };
    if (!!(process.env.NODE_ENV !== "production")) {
      instance.ctx = createDevRenderContext(instance);
    } else {
      instance.ctx = { _: instance };
    }
    instance.root = parent ? parent.root : instance;
    instance.emit = emit.bind(null, instance);
    if (vnode.ce) {
      vnode.ce(instance);
    }
    return instance;
  }
  let currentInstance = null;
  const getCurrentInstance = () => currentInstance || currentRenderingInstance;
  let internalSetCurrentInstance;
  let setInSSRSetupState;
  {
    const g2 = getGlobalThis();
    const registerGlobalSetter = (key, setter) => {
      let setters;
      if (!(setters = g2[key]))
        setters = g2[key] = [];
      setters.push(setter);
      return (v2) => {
        if (setters.length > 1)
          setters.forEach((set2) => set2(v2));
        else
          setters[0](v2);
      };
    };
    internalSetCurrentInstance = registerGlobalSetter(
      `__VUE_INSTANCE_SETTERS__`,
      (v2) => currentInstance = v2
    );
    setInSSRSetupState = registerGlobalSetter(
      `__VUE_SSR_SETTERS__`,
      (v2) => isInSSRComponentSetup = v2
    );
  }
  const setCurrentInstance = (instance) => {
    const prev = currentInstance;
    internalSetCurrentInstance(instance);
    instance.scope.on();
    return () => {
      instance.scope.off();
      internalSetCurrentInstance(prev);
    };
  };
  const unsetCurrentInstance = () => {
    currentInstance && currentInstance.scope.off();
    internalSetCurrentInstance(null);
  };
  const isBuiltInTag = /* @__PURE__ */ makeMap("slot,component");
  function validateComponentName(name, config) {
    const appIsNativeTag = config.isNativeTag || NO;
    if (isBuiltInTag(name) || appIsNativeTag(name)) {
      warn$1(
        "Do not use built-in or reserved HTML elements as component id: " + name
      );
    }
  }
  function isStatefulComponent(instance) {
    return instance.vnode.shapeFlag & 4;
  }
  let isInSSRComponentSetup = false;
  function setupComponent(instance, isSSR = false) {
    isSSR && setInSSRSetupState(isSSR);
    const { props, children } = instance.vnode;
    const isStateful = isStatefulComponent(instance);
    initProps(instance, props, isStateful, isSSR);
    initSlots(instance, children);
    const setupResult = isStateful ? setupStatefulComponent(instance, isSSR) : void 0;
    isSSR && setInSSRSetupState(false);
    return setupResult;
  }
  function setupStatefulComponent(instance, isSSR) {
    var _a;
    const Component2 = instance.type;
    if (!!(process.env.NODE_ENV !== "production")) {
      if (Component2.name) {
        validateComponentName(Component2.name, instance.appContext.config);
      }
      if (Component2.components) {
        const names = Object.keys(Component2.components);
        for (let i2 = 0; i2 < names.length; i2++) {
          validateComponentName(names[i2], instance.appContext.config);
        }
      }
      if (Component2.directives) {
        const names = Object.keys(Component2.directives);
        for (let i2 = 0; i2 < names.length; i2++) {
          validateDirectiveName(names[i2]);
        }
      }
      if (Component2.compilerOptions && isRuntimeOnly()) {
        warn$1(
          `"compilerOptions" is only supported when using a build of Vue that includes the runtime compiler. Since you are using a runtime-only build, the options should be passed via your build tool config instead.`
        );
      }
    }
    instance.accessCache = /* @__PURE__ */ Object.create(null);
    instance.proxy = markRaw(new Proxy(instance.ctx, PublicInstanceProxyHandlers));
    if (!!(process.env.NODE_ENV !== "production")) {
      exposePropsOnRenderContext(instance);
    }
    const { setup } = Component2;
    if (setup) {
      const setupContext = instance.setupContext = setup.length > 1 ? createSetupContext(instance) : null;
      const reset = setCurrentInstance(instance);
      pauseTracking();
      const setupResult = callWithErrorHandling(
        setup,
        instance,
        0,
        [
          !!(process.env.NODE_ENV !== "production") ? shallowReadonly(instance.props) : instance.props,
          setupContext
        ]
      );
      resetTracking();
      reset();
      if (isPromise(setupResult)) {
        setupResult.then(unsetCurrentInstance, unsetCurrentInstance);
        if (isSSR) {
          return setupResult.then((resolvedResult) => {
            handleSetupResult(instance, resolvedResult, isSSR);
          }).catch((e) => {
            handleError(e, instance, 0);
          });
        } else {
          instance.asyncDep = setupResult;
          if (!!(process.env.NODE_ENV !== "production") && !instance.suspense) {
            const name = (_a = Component2.name) != null ? _a : "Anonymous";
            warn$1(
              `Component <${name}>: setup function returned a promise, but no <Suspense> boundary was found in the parent component tree. A component with async setup() must be nested in a <Suspense> in order to be rendered.`
            );
          }
        }
      } else {
        handleSetupResult(instance, setupResult, isSSR);
      }
    } else {
      finishComponentSetup(instance, isSSR);
    }
  }
  function handleSetupResult(instance, setupResult, isSSR) {
    if (isFunction(setupResult)) {
      if (instance.type.__ssrInlineRender) {
        instance.ssrRender = setupResult;
      } else {
        instance.render = setupResult;
      }
    } else if (isObject(setupResult)) {
      if (!!(process.env.NODE_ENV !== "production") && isVNode(setupResult)) {
        warn$1(
          `setup() should not return VNodes directly - return a render function instead.`
        );
      }
      if (!!(process.env.NODE_ENV !== "production") || false) {
        instance.devtoolsRawSetupState = setupResult;
      }
      instance.setupState = proxyRefs(setupResult);
      if (!!(process.env.NODE_ENV !== "production")) {
        exposeSetupStateOnRenderContext(instance);
      }
    } else if (!!(process.env.NODE_ENV !== "production") && setupResult !== void 0) {
      warn$1(
        `setup() should return an object. Received: ${setupResult === null ? "null" : typeof setupResult}`
      );
    }
    finishComponentSetup(instance, isSSR);
  }
  let compile;
  const isRuntimeOnly = () => !compile;
  function finishComponentSetup(instance, isSSR, skipOptions) {
    const Component2 = instance.type;
    if (!instance.render) {
      if (!isSSR && compile && !Component2.render) {
        const template = Component2.template || resolveMergedOptions(instance).template;
        if (template) {
          if (!!(process.env.NODE_ENV !== "production")) {
            startMeasure(instance, `compile`);
          }
          const { isCustomElement, compilerOptions } = instance.appContext.config;
          const { delimiters, compilerOptions: componentCompilerOptions } = Component2;
          const finalCompilerOptions = extend(
            extend(
              {
                isCustomElement,
                delimiters
              },
              compilerOptions
            ),
            componentCompilerOptions
          );
          Component2.render = compile(template, finalCompilerOptions);
          if (!!(process.env.NODE_ENV !== "production")) {
            endMeasure(instance, `compile`);
          }
        }
      }
      instance.render = Component2.render || NOOP;
    }
    {
      const reset = setCurrentInstance(instance);
      pauseTracking();
      try {
        applyOptions(instance);
      } finally {
        resetTracking();
        reset();
      }
    }
    if (!!(process.env.NODE_ENV !== "production") && !Component2.render && instance.render === NOOP && !isSSR) {
      if (Component2.template) {
        warn$1(
          `Component provided template option but runtime compilation is not supported in this build of Vue. Configure your bundler to alias "vue" to "vue/dist/vue.esm-bundler.js".`
        );
      } else {
        warn$1(`Component is missing template or render function.`);
      }
    }
  }
  function getAttrsProxy(instance) {
    return instance.attrsProxy || (instance.attrsProxy = new Proxy(
      instance.attrs,
      !!(process.env.NODE_ENV !== "production") ? {
        get(target, key) {
          markAttrsAccessed();
          track(instance, "get", "$attrs");
          return target[key];
        },
        set() {
          warn$1(`setupContext.attrs is readonly.`);
          return false;
        },
        deleteProperty() {
          warn$1(`setupContext.attrs is readonly.`);
          return false;
        }
      } : {
        get(target, key) {
          track(instance, "get", "$attrs");
          return target[key];
        }
      }
    ));
  }
  function getSlotsProxy(instance) {
    return instance.slotsProxy || (instance.slotsProxy = new Proxy(instance.slots, {
      get(target, key) {
        track(instance, "get", "$slots");
        return target[key];
      }
    }));
  }
  function createSetupContext(instance) {
    const expose = (exposed) => {
      if (!!(process.env.NODE_ENV !== "production")) {
        if (instance.exposed) {
          warn$1(`expose() should be called only once per setup().`);
        }
        if (exposed != null) {
          let exposedType = typeof exposed;
          if (exposedType === "object") {
            if (isArray(exposed)) {
              exposedType = "array";
            } else if (isRef(exposed)) {
              exposedType = "ref";
            }
          }
          if (exposedType !== "object") {
            warn$1(
              `expose() should be passed a plain object, received ${exposedType}.`
            );
          }
        }
      }
      instance.exposed = exposed || {};
    };
    if (!!(process.env.NODE_ENV !== "production")) {
      return Object.freeze({
        get attrs() {
          return getAttrsProxy(instance);
        },
        get slots() {
          return getSlotsProxy(instance);
        },
        get emit() {
          return (event, ...args) => instance.emit(event, ...args);
        },
        expose
      });
    } else {
      return {
        get attrs() {
          return getAttrsProxy(instance);
        },
        slots: instance.slots,
        emit: instance.emit,
        expose
      };
    }
  }
  function getExposeProxy(instance) {
    if (instance.exposed) {
      return instance.exposeProxy || (instance.exposeProxy = new Proxy(proxyRefs(markRaw(instance.exposed)), {
        get(target, key) {
          if (key in target) {
            return target[key];
          } else if (key in publicPropertiesMap) {
            return publicPropertiesMap[key](instance);
          }
        },
        has(target, key) {
          return key in target || key in publicPropertiesMap;
        }
      }));
    }
  }
  const classifyRE = /(?:^|[-_])(\w)/g;
  const classify = (str) => str.replace(classifyRE, (c2) => c2.toUpperCase()).replace(/[-_]/g, "");
  function getComponentName(Component2, includeInferred = true) {
    return isFunction(Component2) ? Component2.displayName || Component2.name : Component2.name || includeInferred && Component2.__name;
  }
  function formatComponentName(instance, Component2, isRoot = false) {
    let name = getComponentName(Component2);
    if (!name && Component2.__file) {
      const match = Component2.__file.match(/([^/\\]+)\.\w+$/);
      if (match) {
        name = match[1];
      }
    }
    if (!name && instance && instance.parent) {
      const inferFromRegistry = (registry) => {
        for (const key in registry) {
          if (registry[key] === Component2) {
            return key;
          }
        }
      };
      name = inferFromRegistry(
        instance.components || instance.parent.type.components
      ) || inferFromRegistry(instance.appContext.components);
    }
    return name ? classify(name) : isRoot ? `App` : `Anonymous`;
  }
  function isClassComponent(value) {
    return isFunction(value) && "__vccOpts" in value;
  }
  const computed = (getterOrOptions, debugOptions) => {
    return computed$1(getterOrOptions, debugOptions, isInSSRComponentSetup);
  };
  function h$1(type, propsOrChildren, children) {
    const l2 = arguments.length;
    if (l2 === 2) {
      if (isObject(propsOrChildren) && !isArray(propsOrChildren)) {
        if (isVNode(propsOrChildren)) {
          return createVNode$1(type, null, [propsOrChildren]);
        }
        return createVNode$1(type, propsOrChildren);
      } else {
        return createVNode$1(type, null, propsOrChildren);
      }
    } else {
      if (l2 > 3) {
        children = Array.prototype.slice.call(arguments, 2);
      } else if (l2 === 3 && isVNode(children)) {
        children = [children];
      }
      return createVNode$1(type, propsOrChildren, children);
    }
  }
  function isShallow2(value) {
    return !!(value && value["__v_isShallow"]);
  }
  function initCustomFormatter() {
    if (!!!(process.env.NODE_ENV !== "production") || typeof window === "undefined") {
      return;
    }
    const vueStyle = { style: "color:#3ba776" };
    const numberStyle = { style: "color:#1677ff" };
    const stringStyle = { style: "color:#f5222d" };
    const keywordStyle = { style: "color:#eb2f96" };
    const formatter = {
      header(obj) {
        if (!isObject(obj)) {
          return null;
        }
        if (obj.__isVue) {
          return ["div", vueStyle, `VueInstance`];
        } else if (isRef(obj)) {
          return [
            "div",
            {},
            ["span", vueStyle, genRefFlag(obj)],
            "<",
            formatValue(obj.value),
            `>`
          ];
        } else if (isReactive(obj)) {
          return [
            "div",
            {},
            ["span", vueStyle, isShallow2(obj) ? "ShallowReactive" : "Reactive"],
            "<",
            formatValue(obj),
            `>${isReadonly(obj) ? ` (readonly)` : ``}`
          ];
        } else if (isReadonly(obj)) {
          return [
            "div",
            {},
            ["span", vueStyle, isShallow2(obj) ? "ShallowReadonly" : "Readonly"],
            "<",
            formatValue(obj),
            ">"
          ];
        }
        return null;
      },
      hasBody(obj) {
        return obj && obj.__isVue;
      },
      body(obj) {
        if (obj && obj.__isVue) {
          return [
            "div",
            {},
            ...formatInstance(obj.$)
          ];
        }
      }
    };
    function formatInstance(instance) {
      const blocks = [];
      if (instance.type.props && instance.props) {
        blocks.push(createInstanceBlock("props", toRaw(instance.props)));
      }
      if (instance.setupState !== EMPTY_OBJ) {
        blocks.push(createInstanceBlock("setup", instance.setupState));
      }
      if (instance.data !== EMPTY_OBJ) {
        blocks.push(createInstanceBlock("data", toRaw(instance.data)));
      }
      const computed2 = extractKeys(instance, "computed");
      if (computed2) {
        blocks.push(createInstanceBlock("computed", computed2));
      }
      const injected = extractKeys(instance, "inject");
      if (injected) {
        blocks.push(createInstanceBlock("injected", injected));
      }
      blocks.push([
        "div",
        {},
        [
          "span",
          {
            style: keywordStyle.style + ";opacity:0.66"
          },
          "$ (internal): "
        ],
        ["object", { object: instance }]
      ]);
      return blocks;
    }
    function createInstanceBlock(type, target) {
      target = extend({}, target);
      if (!Object.keys(target).length) {
        return ["span", {}];
      }
      return [
        "div",
        { style: "line-height:1.25em;margin-bottom:0.6em" },
        [
          "div",
          {
            style: "color:#476582"
          },
          type
        ],
        [
          "div",
          {
            style: "padding-left:1.25em"
          },
          ...Object.keys(target).map((key) => {
            return [
              "div",
              {},
              ["span", keywordStyle, key + ": "],
              formatValue(target[key], false)
            ];
          })
        ]
      ];
    }
    function formatValue(v2, asRaw = true) {
      if (typeof v2 === "number") {
        return ["span", numberStyle, v2];
      } else if (typeof v2 === "string") {
        return ["span", stringStyle, JSON.stringify(v2)];
      } else if (typeof v2 === "boolean") {
        return ["span", keywordStyle, v2];
      } else if (isObject(v2)) {
        return ["object", { object: asRaw ? toRaw(v2) : v2 }];
      } else {
        return ["span", stringStyle, String(v2)];
      }
    }
    function extractKeys(instance, type) {
      const Comp = instance.type;
      if (isFunction(Comp)) {
        return;
      }
      const extracted = {};
      for (const key in instance.ctx) {
        if (isKeyOfType(Comp, key, type)) {
          extracted[key] = instance.ctx[key];
        }
      }
      return extracted;
    }
    function isKeyOfType(Comp, key, type) {
      const opts = Comp[type];
      if (isArray(opts) && opts.includes(key) || isObject(opts) && key in opts) {
        return true;
      }
      if (Comp.extends && isKeyOfType(Comp.extends, key, type)) {
        return true;
      }
      if (Comp.mixins && Comp.mixins.some((m2) => isKeyOfType(m2, key, type))) {
        return true;
      }
    }
    function genRefFlag(v2) {
      if (isShallow2(v2)) {
        return `ShallowRef`;
      }
      if (v2.effect) {
        return `ComputedRef`;
      }
      return `Ref`;
    }
    if (window.devtoolsFormatters) {
      window.devtoolsFormatters.push(formatter);
    } else {
      window.devtoolsFormatters = [formatter];
    }
  }
  const version = "3.4.15";
  const warn = !!(process.env.NODE_ENV !== "production") ? warn$1 : NOOP;
  !!(process.env.NODE_ENV !== "production") || true ? devtools$1 : void 0;
  !!(process.env.NODE_ENV !== "production") || true ? setDevtoolsHook$1 : NOOP;
  /**
  * @vue/runtime-dom v3.4.15
  * (c) 2018-present Yuxi (Evan) You and Vue contributors
  * @license MIT
  **/
  const svgNS = "http://www.w3.org/2000/svg";
  const mathmlNS = "http://www.w3.org/1998/Math/MathML";
  const doc = typeof document !== "undefined" ? document : null;
  const templateContainer = doc && /* @__PURE__ */ doc.createElement("template");
  const nodeOps = {
    insert: (child, parent, anchor) => {
      parent.insertBefore(child, anchor || null);
    },
    remove: (child) => {
      const parent = child.parentNode;
      if (parent) {
        parent.removeChild(child);
      }
    },
    createElement: (tag, namespace, is, props) => {
      const el = namespace === "svg" ? doc.createElementNS(svgNS, tag) : namespace === "mathml" ? doc.createElementNS(mathmlNS, tag) : doc.createElement(tag, is ? { is } : void 0);
      if (tag === "select" && props && props.multiple != null) {
        el.setAttribute("multiple", props.multiple);
      }
      return el;
    },
    createText: (text) => doc.createTextNode(text),
    createComment: (text) => doc.createComment(text),
    setText: (node, text) => {
      node.nodeValue = text;
    },
    setElementText: (el, text) => {
      el.textContent = text;
    },
    parentNode: (node) => node.parentNode,
    nextSibling: (node) => node.nextSibling,
    querySelector: (selector) => doc.querySelector(selector),
    setScopeId(el, id) {
      el.setAttribute(id, "");
    },
    // __UNSAFE__
    // Reason: innerHTML.
    // Static content here can only come from compiled templates.
    // As long as the user only uses trusted templates, this is safe.
    insertStaticContent(content, parent, anchor, namespace, start, end) {
      const before = anchor ? anchor.previousSibling : parent.lastChild;
      if (start && (start === end || start.nextSibling)) {
        while (true) {
          parent.insertBefore(start.cloneNode(true), anchor);
          if (start === end || !(start = start.nextSibling))
            break;
        }
      } else {
        templateContainer.innerHTML = namespace === "svg" ? `<svg>${content}</svg>` : namespace === "mathml" ? `<math>${content}</math>` : content;
        const template = templateContainer.content;
        if (namespace === "svg" || namespace === "mathml") {
          const wrapper = template.firstChild;
          while (wrapper.firstChild) {
            template.appendChild(wrapper.firstChild);
          }
          template.removeChild(wrapper);
        }
        parent.insertBefore(template, anchor);
      }
      return [
        // first
        before ? before.nextSibling : parent.firstChild,
        // last
        anchor ? anchor.previousSibling : parent.lastChild
      ];
    }
  };
  const vtcKey = Symbol("_vtc");
  function patchClass(el, value, isSVG) {
    const transitionClasses = el[vtcKey];
    if (transitionClasses) {
      value = (value ? [value, ...transitionClasses] : [...transitionClasses]).join(" ");
    }
    if (value == null) {
      el.removeAttribute("class");
    } else if (isSVG) {
      el.setAttribute("class", value);
    } else {
      el.className = value;
    }
  }
  const vShowOldKey = Symbol("_vod");
  if (!!(process.env.NODE_ENV !== "production"))
    ;
  const CSS_VAR_TEXT = Symbol(!!(process.env.NODE_ENV !== "production") ? "CSS_VAR_TEXT" : "");
  function patchStyle(el, prev, next) {
    const style = el.style;
    const currentDisplay = style.display;
    const isCssString = isString(next);
    if (next && !isCssString) {
      if (prev && !isString(prev)) {
        for (const key in prev) {
          if (next[key] == null) {
            setStyle(style, key, "");
          }
        }
      }
      for (const key in next) {
        setStyle(style, key, next[key]);
      }
    } else {
      if (isCssString) {
        if (prev !== next) {
          const cssVarText = style[CSS_VAR_TEXT];
          if (cssVarText) {
            next += ";" + cssVarText;
          }
          style.cssText = next;
        }
      } else if (prev) {
        el.removeAttribute("style");
      }
    }
    if (vShowOldKey in el) {
      style.display = currentDisplay;
    }
  }
  const semicolonRE = /[^\\];\s*$/;
  const importantRE = /\s*!important$/;
  function setStyle(style, name, val) {
    if (isArray(val)) {
      val.forEach((v2) => setStyle(style, name, v2));
    } else {
      if (val == null)
        val = "";
      if (!!(process.env.NODE_ENV !== "production")) {
        if (semicolonRE.test(val)) {
          warn(
            `Unexpected semicolon at the end of '${name}' style value: '${val}'`
          );
        }
      }
      if (name.startsWith("--")) {
        style.setProperty(name, val);
      } else {
        const prefixed = autoPrefix(style, name);
        if (importantRE.test(val)) {
          style.setProperty(
            hyphenate(prefixed),
            val.replace(importantRE, ""),
            "important"
          );
        } else {
          style[prefixed] = val;
        }
      }
    }
  }
  const prefixes = ["Webkit", "Moz", "ms"];
  const prefixCache = {};
  function autoPrefix(style, rawName) {
    const cached = prefixCache[rawName];
    if (cached) {
      return cached;
    }
    let name = camelize(rawName);
    if (name !== "filter" && name in style) {
      return prefixCache[rawName] = name;
    }
    name = capitalize(name);
    for (let i2 = 0; i2 < prefixes.length; i2++) {
      const prefixed = prefixes[i2] + name;
      if (prefixed in style) {
        return prefixCache[rawName] = prefixed;
      }
    }
    return rawName;
  }
  const xlinkNS = "http://www.w3.org/1999/xlink";
  function patchAttr(el, key, value, isSVG, instance) {
    if (isSVG && key.startsWith("xlink:")) {
      if (value == null) {
        el.removeAttributeNS(xlinkNS, key.slice(6, key.length));
      } else {
        el.setAttributeNS(xlinkNS, key, value);
      }
    } else {
      const isBoolean2 = isSpecialBooleanAttr(key);
      if (value == null || isBoolean2 && !includeBooleanAttr(value)) {
        el.removeAttribute(key);
      } else {
        el.setAttribute(key, isBoolean2 ? "" : value);
      }
    }
  }
  function patchDOMProp(el, key, value, prevChildren, parentComponent, parentSuspense, unmountChildren) {
    if (key === "innerHTML" || key === "textContent") {
      if (prevChildren) {
        unmountChildren(prevChildren, parentComponent, parentSuspense);
      }
      el[key] = value == null ? "" : value;
      return;
    }
    const tag = el.tagName;
    if (key === "value" && tag !== "PROGRESS" && // custom elements may use _value internally
    !tag.includes("-")) {
      el._value = value;
      const oldValue = tag === "OPTION" ? el.getAttribute("value") : el.value;
      const newValue = value == null ? "" : value;
      if (oldValue !== newValue) {
        el.value = newValue;
      }
      if (value == null) {
        el.removeAttribute(key);
      }
      return;
    }
    let needRemove = false;
    if (value === "" || value == null) {
      const type = typeof el[key];
      if (type === "boolean") {
        value = includeBooleanAttr(value);
      } else if (value == null && type === "string") {
        value = "";
        needRemove = true;
      } else if (type === "number") {
        value = 0;
        needRemove = true;
      }
    }
    try {
      el[key] = value;
    } catch (e) {
      if (!!(process.env.NODE_ENV !== "production") && !needRemove) {
        warn(
          `Failed setting prop "${key}" on <${tag.toLowerCase()}>: value ${value} is invalid.`,
          e
        );
      }
    }
    needRemove && el.removeAttribute(key);
  }
  function addEventListener(el, event, handler, options) {
    el.addEventListener(event, handler, options);
  }
  function removeEventListener(el, event, handler, options) {
    el.removeEventListener(event, handler, options);
  }
  const veiKey = Symbol("_vei");
  function patchEvent(el, rawName, prevValue, nextValue, instance = null) {
    const invokers = el[veiKey] || (el[veiKey] = {});
    const existingInvoker = invokers[rawName];
    if (nextValue && existingInvoker) {
      existingInvoker.value = nextValue;
    } else {
      const [name, options] = parseName(rawName);
      if (nextValue) {
        const invoker = invokers[rawName] = createInvoker(nextValue, instance);
        addEventListener(el, name, invoker, options);
      } else if (existingInvoker) {
        removeEventListener(el, name, existingInvoker, options);
        invokers[rawName] = void 0;
      }
    }
  }
  const optionsModifierRE = /(?:Once|Passive|Capture)$/;
  function parseName(name) {
    let options;
    if (optionsModifierRE.test(name)) {
      options = {};
      let m2;
      while (m2 = name.match(optionsModifierRE)) {
        name = name.slice(0, name.length - m2[0].length);
        options[m2[0].toLowerCase()] = true;
      }
    }
    const event = name[2] === ":" ? name.slice(3) : hyphenate(name.slice(2));
    return [event, options];
  }
  let cachedNow = 0;
  const p$1 = /* @__PURE__ */ Promise.resolve();
  const getNow = () => cachedNow || (p$1.then(() => cachedNow = 0), cachedNow = Date.now());
  function createInvoker(initialValue, instance) {
    const invoker = (e) => {
      if (!e._vts) {
        e._vts = Date.now();
      } else if (e._vts <= invoker.attached) {
        return;
      }
      callWithAsyncErrorHandling(
        patchStopImmediatePropagation(e, invoker.value),
        instance,
        5,
        [e]
      );
    };
    invoker.value = initialValue;
    invoker.attached = getNow();
    return invoker;
  }
  function patchStopImmediatePropagation(e, value) {
    if (isArray(value)) {
      const originalStop = e.stopImmediatePropagation;
      e.stopImmediatePropagation = () => {
        originalStop.call(e);
        e._stopped = true;
      };
      return value.map((fn2) => (e2) => !e2._stopped && fn2 && fn2(e2));
    } else {
      return value;
    }
  }
  const isNativeOn = (key) => key.charCodeAt(0) === 111 && key.charCodeAt(1) === 110 && // lowercase letter
  key.charCodeAt(2) > 96 && key.charCodeAt(2) < 123;
  const patchProp = (el, key, prevValue, nextValue, namespace, prevChildren, parentComponent, parentSuspense, unmountChildren) => {
    const isSVG = namespace === "svg";
    if (key === "class") {
      patchClass(el, nextValue, isSVG);
    } else if (key === "style") {
      patchStyle(el, prevValue, nextValue);
    } else if (isOn(key)) {
      if (!isModelListener(key)) {
        patchEvent(el, key, prevValue, nextValue, parentComponent);
      }
    } else if (key[0] === "." ? (key = key.slice(1), true) : key[0] === "^" ? (key = key.slice(1), false) : shouldSetAsProp(el, key, nextValue, isSVG)) {
      patchDOMProp(
        el,
        key,
        nextValue,
        prevChildren,
        parentComponent,
        parentSuspense,
        unmountChildren
      );
    } else {
      if (key === "true-value") {
        el._trueValue = nextValue;
      } else if (key === "false-value") {
        el._falseValue = nextValue;
      }
      patchAttr(el, key, nextValue, isSVG);
    }
  };
  function shouldSetAsProp(el, key, value, isSVG) {
    if (isSVG) {
      if (key === "innerHTML" || key === "textContent") {
        return true;
      }
      if (key in el && isNativeOn(key) && isFunction(value)) {
        return true;
      }
      return false;
    }
    if (key === "spellcheck" || key === "draggable" || key === "translate") {
      return false;
    }
    if (key === "form") {
      return false;
    }
    if (key === "list" && el.tagName === "INPUT") {
      return false;
    }
    if (key === "type" && el.tagName === "TEXTAREA") {
      return false;
    }
    if (key === "width" || key === "height") {
      const tag = el.tagName;
      if (tag === "IMG" || tag === "VIDEO" || tag === "CANVAS" || tag === "SOURCE") {
        return false;
      }
    }
    if (isNativeOn(key) && isString(value)) {
      return false;
    }
    return key in el;
  }
  const rendererOptions = /* @__PURE__ */ extend({ patchProp }, nodeOps);
  let renderer;
  function ensureRenderer() {
    return renderer || (renderer = createRenderer(rendererOptions));
  }
  const createApp = (...args) => {
    const app = ensureRenderer().createApp(...args);
    if (!!(process.env.NODE_ENV !== "production")) {
      injectNativeTagCheck(app);
      injectCompilerOptionsCheck(app);
    }
    const { mount } = app;
    app.mount = (containerOrSelector) => {
      const container = normalizeContainer(containerOrSelector);
      if (!container)
        return;
      const component = app._component;
      if (!isFunction(component) && !component.render && !component.template) {
        component.template = container.innerHTML;
      }
      container.innerHTML = "";
      const proxy = mount(container, false, resolveRootNamespace(container));
      if (container instanceof Element) {
        container.removeAttribute("v-cloak");
        container.setAttribute("data-v-app", "");
      }
      return proxy;
    };
    return app;
  };
  function resolveRootNamespace(container) {
    if (container instanceof SVGElement) {
      return "svg";
    }
    if (typeof MathMLElement === "function" && container instanceof MathMLElement) {
      return "mathml";
    }
  }
  function injectNativeTagCheck(app) {
    Object.defineProperty(app.config, "isNativeTag", {
      value: (tag) => isHTMLTag(tag) || isSVGTag(tag) || isMathMLTag(tag),
      writable: false
    });
  }
  function injectCompilerOptionsCheck(app) {
    {
      const isCustomElement = app.config.isCustomElement;
      Object.defineProperty(app.config, "isCustomElement", {
        get() {
          return isCustomElement;
        },
        set() {
          warn(
            `The \`isCustomElement\` config option is deprecated. Use \`compilerOptions.isCustomElement\` instead.`
          );
        }
      });
      const compilerOptions = app.config.compilerOptions;
      const msg = `The \`compilerOptions\` config option is only respected when using a build of Vue.js that includes the runtime compiler (aka "full build"). Since you are using the runtime-only build, \`compilerOptions\` must be passed to \`@vue/compiler-dom\` in the build setup instead.
- For vue-loader: pass it via vue-loader's \`compilerOptions\` loader option.
- For vue-cli: see https://cli.vuejs.org/guide/webpack.html#modifying-options-of-a-loader
- For vite: pass it via @vitejs/plugin-vue options. See https://github.com/vitejs/vite-plugin-vue/tree/main/packages/plugin-vue#example-for-passing-options-to-vuecompiler-sfc`;
      Object.defineProperty(app.config, "compilerOptions", {
        get() {
          warn(msg);
          return compilerOptions;
        },
        set() {
          warn(msg);
        }
      });
    }
  }
  function normalizeContainer(container) {
    if (isString(container)) {
      const res = document.querySelector(container);
      if (!!(process.env.NODE_ENV !== "production") && !res) {
        warn(
          `Failed to mount app: mount target selector "${container}" returned null.`
        );
      }
      return res;
    }
    if (!!(process.env.NODE_ENV !== "production") && window.ShadowRoot && container instanceof window.ShadowRoot && container.mode === "closed") {
      warn(
        `mounting on a ShadowRoot with \`{mode: "closed"}\` may lead to unpredictable bugs`
      );
    }
    return container;
  }
  /**
  * vue v3.4.15
  * (c) 2018-present Yuxi (Evan) You and Vue contributors
  * @license MIT
  **/
  function initDev() {
    {
      initCustomFormatter();
    }
  }
  if (!!(process.env.NODE_ENV !== "production")) {
    initDev();
  }
  class Subscriber {
    constructor(destinationOrNext) {
      Object.defineProperty(this, "closed", {
        enumerable: true,
        configurable: true,
        writable: true,
        value: false
      });
      Object.defineProperty(this, "syncErrorThrowable", {
        enumerable: true,
        configurable: true,
        writable: true,
        value: true
      });
      Object.defineProperty(this, "destinationOrNext", {
        enumerable: true,
        configurable: true,
        writable: true,
        value: void 0
      });
      if (typeof destinationOrNext === "function") {
        this.destinationOrNext = {
          next: destinationOrNext
        };
      } else {
        this.destinationOrNext = destinationOrNext;
      }
    }
    next(value) {
      if (this.closed) {
        return;
      }
      if (this.destinationOrNext.next) {
        this.syncErrorThrowable = false;
        this.destinationOrNext.next(value);
        this.syncErrorThrowable = true;
      }
    }
    error(err) {
      if (this.closed) {
        return;
      }
      this.closed = true;
      if (this.destinationOrNext.error) {
        this.syncErrorThrowable = false;
        this.destinationOrNext.error(err);
        this.syncErrorThrowable = true;
        this.destinationOrNext = null;
        return;
      }
      this.syncErrorThrowable = false;
      this.destinationOrNext = null;
      throw err;
    }
    complete() {
      if (this.closed) {
        return;
      }
      this.closed = true;
      if (this.destinationOrNext.complete) {
        this.syncErrorThrowable = false;
        this.destinationOrNext.complete();
        this.syncErrorThrowable = true;
      }
      this.destinationOrNext = null;
    }
  }
  function noop() {
  }
  class Subscription {
    constructor(unsubscribeCallback) {
      Object.defineProperty(this, "unsubscribeCallback", {
        enumerable: true,
        configurable: true,
        writable: true,
        value: unsubscribeCallback
      });
      Object.defineProperty(this, "subs", {
        enumerable: true,
        configurable: true,
        writable: true,
        value: []
      });
      Object.defineProperty(this, "isStopped", {
        enumerable: true,
        configurable: true,
        writable: true,
        value: false
      });
    }
    add(...subscriptions) {
      if (this.isStopped) {
        return this;
      }
      this.subs.push(...subscriptions);
      return this;
    }
    unsubscribe() {
      this.isStopped = true;
      if (this.unsubscribeCallback) {
        this.unsubscribeCallback();
        this.unsubscribeCallback = noop;
      }
      this.subs.forEach((i2) => i2.unsubscribe());
      this.subs = [];
    }
  }
  class Observable {
    constructor(source = (observer) => {
      observer.complete();
    }) {
      Object.defineProperty(this, "source", {
        enumerable: true,
        configurable: true,
        writable: true,
        value: source
      });
    }
    pipe(...operators) {
      if (operators.length === 0) {
        return this;
      }
      return operators.reduce((stream, nextOperator) => {
        return nextOperator(new Observable((subscriber) => {
          return stream.subscribe(subscriber);
        }));
      }, this);
    }
    subscribe(observer = noop) {
      const subscriber = this.toSubscriber(observer);
      return this.trySubscribe(subscriber);
    }
    toPromise() {
      return new Promise((resolve2, reject) => {
        this.subscribe({
          next(value) {
            resolve2(value);
          },
          error(err) {
            reject(err);
          }
        });
      });
    }
    toSubscriber(observer) {
      if (typeof observer === "function") {
        return new Subscriber({
          next: observer
        });
      }
      return new Subscriber(observer);
    }
    trySubscribe(subscriber) {
      let s2;
      try {
        s2 = this.source(subscriber);
      } catch (e) {
        if (subscriber.syncErrorThrowable) {
          subscriber.error(e);
        } else {
          throw e;
        }
      }
      if (typeof s2 === "function") {
        return new Subscription(function() {
          subscriber.closed = true;
          s2();
        });
      } else if (s2 instanceof Subscription) {
        return new Subscription(function() {
          subscriber.closed = true;
          s2.unsubscribe();
        });
      }
      return new Subscription(function() {
        subscriber.closed = true;
      });
    }
  }
  class Subject extends Observable {
    constructor() {
      super((subscriber) => {
        this.subscribers.push(subscriber);
      });
      Object.defineProperty(this, "subscribers", {
        enumerable: true,
        configurable: true,
        writable: true,
        value: []
      });
    }
    asObservable() {
      return new Observable((subscriber) => {
        this.subscribe(subscriber);
      });
    }
    next(newValue) {
      [...this.subscribers].forEach((subscriber) => {
        try {
          subscriber.next(newValue);
        } catch (e) {
          if (subscriber.syncErrorThrowable) {
            subscriber.error(e);
          } else {
            throw e;
          }
        }
      });
    }
    error(err) {
      [...this.subscribers].forEach((observer) => {
        observer.error(err);
      });
    }
    complete() {
      [...this.subscribers].forEach((observer) => {
        observer.complete();
      });
    }
  }
  function fromEvent(source, type, capture = false) {
    return new Observable((subscriber) => {
      function listenFn(event) {
        return subscriber.next(event);
      }
      source.addEventListener(type, listenFn, capture);
      return function() {
        source.removeEventListener(type, listenFn);
      };
    });
  }
  function merge(...inputs) {
    return new Observable((subscriber) => {
      if (inputs.length === 0) {
        subscriber.complete();
      }
      const marks = inputs.map((i2) => {
        return {
          source: i2,
          isComplete: false
        };
      });
      const subs = marks.map((s2) => {
        return s2.source.subscribe({
          next(value) {
            subscriber.next(value);
          },
          error(err) {
            subscriber.error(err);
          },
          complete() {
            s2.isComplete = true;
            if (marks.every((i2) => i2.isComplete)) {
              subscriber.complete();
            }
          }
        });
      });
      return function() {
        subs.forEach((i2) => i2.unsubscribe());
      };
    });
  }
  function distinctUntilChanged(comparator2) {
    return function(source) {
      return new Observable((subscriber) => {
        let lastValue = {};
        let isFirst = true;
        return source.subscribe({
          next(value) {
            if (isFirst) {
              isFirst = false;
              lastValue = value;
              subscriber.next(value);
              return;
            }
            if (comparator2) {
              const b2 = comparator2(lastValue, value);
              lastValue = value;
              if (b2) {
                subscriber.next(value);
              }
            } else if (value !== lastValue) {
              lastValue = value;
              subscriber.next(value);
            }
          },
          error(err) {
            subscriber.error(err);
          },
          complete() {
            subscriber.complete();
          }
        });
      });
    };
  }
  function filter(handle) {
    return function(source) {
      return new Observable((subscriber) => {
        return source.subscribe({
          next(value) {
            if (handle(value)) {
              subscriber.next(value);
            }
          },
          error(err) {
            subscriber.error(err);
          },
          complete() {
            subscriber.complete();
          }
        });
      });
    };
  }
  function map(handle) {
    return function(source) {
      return new Observable((subscriber) => {
        return source.subscribe({
          next(value) {
            subscriber.next(handle(value));
          },
          error(err) {
            subscriber.error(err);
          },
          complete() {
            subscriber.complete();
          }
        });
      });
    };
  }
  function microTask() {
    return function(source) {
      return new Observable((subscriber) => {
        let values = [];
        let task = null;
        let isComplete = false;
        return source.subscribe({
          next(v2) {
            values.push(v2);
            if (!task) {
              task = Promise.resolve().then(() => {
                const nextValues = values;
                values = [];
                task = null;
                subscriber.next(nextValues);
                if (isComplete) {
                  subscriber.complete();
                }
              });
            }
          },
          error(err) {
            subscriber.error(err);
          },
          complete() {
            if (task === null) {
              subscriber.complete();
            } else {
              isComplete = true;
            }
          }
        });
      });
    };
  }
  function share() {
    return function(source) {
      const subject = new Subject();
      source.subscribe({
        next(value) {
          subject.next(value);
        },
        error(err) {
          subject.error(err);
        },
        complete() {
          subject.complete();
        }
      });
      return subject;
    };
  }
  function take(count) {
    return function(source) {
      return new Observable((subscriber) => {
        let i2 = 0;
        const subscription = new Subscription();
        let isComplete = false;
        const obs = {
          next(value) {
            if (i2 < count) {
              subscriber.next(value);
              i2++;
              if (i2 === count) {
                isComplete = true;
                subscription.unsubscribe();
                subscriber.complete();
              }
              return;
            }
            isComplete = true;
            subscriber.complete();
          },
          error(err) {
            subscriber.error(err);
          },
          complete() {
            subscriber.complete();
          }
        };
        subscription.add(source.subscribe(obs));
        if (isComplete) {
          subscription.unsubscribe();
        }
        return subscription;
      });
    };
  }
  var commonjsGlobal = typeof globalThis !== "undefined" ? globalThis : typeof window !== "undefined" ? window : typeof global !== "undefined" ? global : typeof self !== "undefined" ? self : {};
  /*! *****************************************************************************
    Copyright (C) Microsoft. All rights reserved.
    Licensed under the Apache License, Version 2.0 (the "License"); you may not use
    this file except in compliance with the License. You may obtain a copy of the
    License at http://www.apache.org/licenses/LICENSE-2.0
  
    THIS CODE IS PROVIDED ON AN *AS IS* BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY
    KIND, EITHER EXPRESS OR IMPLIED, INCLUDING WITHOUT LIMITATION ANY IMPLIED
    WARRANTIES OR CONDITIONS OF TITLE, FITNESS FOR A PARTICULAR PURPOSE,
    MERCHANTABLITY OR NON-INFRINGEMENT.
  
    See the Apache Version 2.0 License for specific language governing permissions
    and limitations under the License.
    ***************************************************************************** */
  var Reflect$1;
  (function(Reflect2) {
    (function(factory) {
      var root = typeof commonjsGlobal === "object" ? commonjsGlobal : typeof self === "object" ? self : typeof this === "object" ? this : Function("return this;")();
      var exporter = makeExporter(Reflect2);
      if (typeof root.Reflect === "undefined") {
        root.Reflect = Reflect2;
      } else {
        exporter = makeExporter(root.Reflect, exporter);
      }
      factory(exporter);
      function makeExporter(target, previous) {
        return function(key, value) {
          if (typeof target[key] !== "function") {
            Object.defineProperty(target, key, { configurable: true, writable: true, value });
          }
          if (previous)
            previous(key, value);
        };
      }
    })(function(exporter) {
      var hasOwn2 = Object.prototype.hasOwnProperty;
      var supportsSymbol = typeof Symbol === "function";
      var toPrimitiveSymbol = supportsSymbol && typeof Symbol.toPrimitive !== "undefined" ? Symbol.toPrimitive : "@@toPrimitive";
      var iteratorSymbol = supportsSymbol && typeof Symbol.iterator !== "undefined" ? Symbol.iterator : "@@iterator";
      var supportsCreate = typeof Object.create === "function";
      var supportsProto = { __proto__: [] } instanceof Array;
      var downLevel = !supportsCreate && !supportsProto;
      var HashMap = {
        // create an object in dictionary mode (a.k.a. "slow" mode in v8)
        create: supportsCreate ? function() {
          return MakeDictionary(/* @__PURE__ */ Object.create(null));
        } : supportsProto ? function() {
          return MakeDictionary({ __proto__: null });
        } : function() {
          return MakeDictionary({});
        },
        has: downLevel ? function(map2, key) {
          return hasOwn2.call(map2, key);
        } : function(map2, key) {
          return key in map2;
        },
        get: downLevel ? function(map2, key) {
          return hasOwn2.call(map2, key) ? map2[key] : void 0;
        } : function(map2, key) {
          return map2[key];
        }
      };
      var functionPrototype = Object.getPrototypeOf(Function);
      var usePolyfill = typeof process === "object" && process["env"] && process["env"]["REFLECT_METADATA_USE_MAP_POLYFILL"] === "true";
      var _Map = !usePolyfill && typeof Map === "function" && typeof Map.prototype.entries === "function" ? Map : CreateMapPolyfill();
      var _Set = !usePolyfill && typeof Set === "function" && typeof Set.prototype.entries === "function" ? Set : CreateSetPolyfill();
      var _WeakMap = !usePolyfill && typeof WeakMap === "function" ? WeakMap : CreateWeakMapPolyfill();
      var Metadata = new _WeakMap();
      function decorate(decorators, target, propertyKey, attributes) {
        if (!IsUndefined(propertyKey)) {
          if (!IsArray(decorators))
            throw new TypeError();
          if (!IsObject(target))
            throw new TypeError();
          if (!IsObject(attributes) && !IsUndefined(attributes) && !IsNull(attributes))
            throw new TypeError();
          if (IsNull(attributes))
            attributes = void 0;
          propertyKey = ToPropertyKey(propertyKey);
          return DecorateProperty(decorators, target, propertyKey, attributes);
        } else {
          if (!IsArray(decorators))
            throw new TypeError();
          if (!IsConstructor(target))
            throw new TypeError();
          return DecorateConstructor(decorators, target);
        }
      }
      exporter("decorate", decorate);
      function metadata(metadataKey, metadataValue) {
        function decorator(target, propertyKey) {
          if (!IsObject(target))
            throw new TypeError();
          if (!IsUndefined(propertyKey) && !IsPropertyKey(propertyKey))
            throw new TypeError();
          OrdinaryDefineOwnMetadata(metadataKey, metadataValue, target, propertyKey);
        }
        return decorator;
      }
      exporter("metadata", metadata);
      function defineMetadata(metadataKey, metadataValue, target, propertyKey) {
        if (!IsObject(target))
          throw new TypeError();
        if (!IsUndefined(propertyKey))
          propertyKey = ToPropertyKey(propertyKey);
        return OrdinaryDefineOwnMetadata(metadataKey, metadataValue, target, propertyKey);
      }
      exporter("defineMetadata", defineMetadata);
      function hasMetadata(metadataKey, target, propertyKey) {
        if (!IsObject(target))
          throw new TypeError();
        if (!IsUndefined(propertyKey))
          propertyKey = ToPropertyKey(propertyKey);
        return OrdinaryHasMetadata(metadataKey, target, propertyKey);
      }
      exporter("hasMetadata", hasMetadata);
      function hasOwnMetadata(metadataKey, target, propertyKey) {
        if (!IsObject(target))
          throw new TypeError();
        if (!IsUndefined(propertyKey))
          propertyKey = ToPropertyKey(propertyKey);
        return OrdinaryHasOwnMetadata(metadataKey, target, propertyKey);
      }
      exporter("hasOwnMetadata", hasOwnMetadata);
      function getMetadata(metadataKey, target, propertyKey) {
        if (!IsObject(target))
          throw new TypeError();
        if (!IsUndefined(propertyKey))
          propertyKey = ToPropertyKey(propertyKey);
        return OrdinaryGetMetadata(metadataKey, target, propertyKey);
      }
      exporter("getMetadata", getMetadata);
      function getOwnMetadata(metadataKey, target, propertyKey) {
        if (!IsObject(target))
          throw new TypeError();
        if (!IsUndefined(propertyKey))
          propertyKey = ToPropertyKey(propertyKey);
        return OrdinaryGetOwnMetadata(metadataKey, target, propertyKey);
      }
      exporter("getOwnMetadata", getOwnMetadata);
      function getMetadataKeys(target, propertyKey) {
        if (!IsObject(target))
          throw new TypeError();
        if (!IsUndefined(propertyKey))
          propertyKey = ToPropertyKey(propertyKey);
        return OrdinaryMetadataKeys(target, propertyKey);
      }
      exporter("getMetadataKeys", getMetadataKeys);
      function getOwnMetadataKeys(target, propertyKey) {
        if (!IsObject(target))
          throw new TypeError();
        if (!IsUndefined(propertyKey))
          propertyKey = ToPropertyKey(propertyKey);
        return OrdinaryOwnMetadataKeys(target, propertyKey);
      }
      exporter("getOwnMetadataKeys", getOwnMetadataKeys);
      function deleteMetadata(metadataKey, target, propertyKey) {
        if (!IsObject(target))
          throw new TypeError();
        if (!IsUndefined(propertyKey))
          propertyKey = ToPropertyKey(propertyKey);
        var metadataMap = GetOrCreateMetadataMap(
          target,
          propertyKey,
          /*Create*/
          false
        );
        if (IsUndefined(metadataMap))
          return false;
        if (!metadataMap.delete(metadataKey))
          return false;
        if (metadataMap.size > 0)
          return true;
        var targetMetadata = Metadata.get(target);
        targetMetadata.delete(propertyKey);
        if (targetMetadata.size > 0)
          return true;
        Metadata.delete(target);
        return true;
      }
      exporter("deleteMetadata", deleteMetadata);
      function DecorateConstructor(decorators, target) {
        for (var i2 = decorators.length - 1; i2 >= 0; --i2) {
          var decorator = decorators[i2];
          var decorated = decorator(target);
          if (!IsUndefined(decorated) && !IsNull(decorated)) {
            if (!IsConstructor(decorated))
              throw new TypeError();
            target = decorated;
          }
        }
        return target;
      }
      function DecorateProperty(decorators, target, propertyKey, descriptor) {
        for (var i2 = decorators.length - 1; i2 >= 0; --i2) {
          var decorator = decorators[i2];
          var decorated = decorator(target, propertyKey, descriptor);
          if (!IsUndefined(decorated) && !IsNull(decorated)) {
            if (!IsObject(decorated))
              throw new TypeError();
            descriptor = decorated;
          }
        }
        return descriptor;
      }
      function GetOrCreateMetadataMap(O2, P2, Create) {
        var targetMetadata = Metadata.get(O2);
        if (IsUndefined(targetMetadata)) {
          if (!Create)
            return void 0;
          targetMetadata = new _Map();
          Metadata.set(O2, targetMetadata);
        }
        var metadataMap = targetMetadata.get(P2);
        if (IsUndefined(metadataMap)) {
          if (!Create)
            return void 0;
          metadataMap = new _Map();
          targetMetadata.set(P2, metadataMap);
        }
        return metadataMap;
      }
      function OrdinaryHasMetadata(MetadataKey, O2, P2) {
        var hasOwn3 = OrdinaryHasOwnMetadata(MetadataKey, O2, P2);
        if (hasOwn3)
          return true;
        var parent = OrdinaryGetPrototypeOf(O2);
        if (!IsNull(parent))
          return OrdinaryHasMetadata(MetadataKey, parent, P2);
        return false;
      }
      function OrdinaryHasOwnMetadata(MetadataKey, O2, P2) {
        var metadataMap = GetOrCreateMetadataMap(
          O2,
          P2,
          /*Create*/
          false
        );
        if (IsUndefined(metadataMap))
          return false;
        return ToBoolean(metadataMap.has(MetadataKey));
      }
      function OrdinaryGetMetadata(MetadataKey, O2, P2) {
        var hasOwn3 = OrdinaryHasOwnMetadata(MetadataKey, O2, P2);
        if (hasOwn3)
          return OrdinaryGetOwnMetadata(MetadataKey, O2, P2);
        var parent = OrdinaryGetPrototypeOf(O2);
        if (!IsNull(parent))
          return OrdinaryGetMetadata(MetadataKey, parent, P2);
        return void 0;
      }
      function OrdinaryGetOwnMetadata(MetadataKey, O2, P2) {
        var metadataMap = GetOrCreateMetadataMap(
          O2,
          P2,
          /*Create*/
          false
        );
        if (IsUndefined(metadataMap))
          return void 0;
        return metadataMap.get(MetadataKey);
      }
      function OrdinaryDefineOwnMetadata(MetadataKey, MetadataValue, O2, P2) {
        var metadataMap = GetOrCreateMetadataMap(
          O2,
          P2,
          /*Create*/
          true
        );
        metadataMap.set(MetadataKey, MetadataValue);
      }
      function OrdinaryMetadataKeys(O2, P2) {
        var ownKeys = OrdinaryOwnMetadataKeys(O2, P2);
        var parent = OrdinaryGetPrototypeOf(O2);
        if (parent === null)
          return ownKeys;
        var parentKeys = OrdinaryMetadataKeys(parent, P2);
        if (parentKeys.length <= 0)
          return ownKeys;
        if (ownKeys.length <= 0)
          return parentKeys;
        var set2 = new _Set();
        var keys = [];
        for (var _i = 0, ownKeys_1 = ownKeys; _i < ownKeys_1.length; _i++) {
          var key = ownKeys_1[_i];
          var hasKey = set2.has(key);
          if (!hasKey) {
            set2.add(key);
            keys.push(key);
          }
        }
        for (var _a = 0, parentKeys_1 = parentKeys; _a < parentKeys_1.length; _a++) {
          var key = parentKeys_1[_a];
          var hasKey = set2.has(key);
          if (!hasKey) {
            set2.add(key);
            keys.push(key);
          }
        }
        return keys;
      }
      function OrdinaryOwnMetadataKeys(O2, P2) {
        var keys = [];
        var metadataMap = GetOrCreateMetadataMap(
          O2,
          P2,
          /*Create*/
          false
        );
        if (IsUndefined(metadataMap))
          return keys;
        var keysObj = metadataMap.keys();
        var iterator = GetIterator(keysObj);
        var k2 = 0;
        while (true) {
          var next = IteratorStep(iterator);
          if (!next) {
            keys.length = k2;
            return keys;
          }
          var nextValue = IteratorValue(next);
          try {
            keys[k2] = nextValue;
          } catch (e) {
            try {
              IteratorClose(iterator);
            } finally {
              throw e;
            }
          }
          k2++;
        }
      }
      function Type(x2) {
        if (x2 === null)
          return 1;
        switch (typeof x2) {
          case "undefined":
            return 0;
          case "boolean":
            return 2;
          case "string":
            return 3;
          case "symbol":
            return 4;
          case "number":
            return 5;
          case "object":
            return x2 === null ? 1 : 6;
          default:
            return 6;
        }
      }
      function IsUndefined(x2) {
        return x2 === void 0;
      }
      function IsNull(x2) {
        return x2 === null;
      }
      function IsSymbol(x2) {
        return typeof x2 === "symbol";
      }
      function IsObject(x2) {
        return typeof x2 === "object" ? x2 !== null : typeof x2 === "function";
      }
      function ToPrimitive(input, PreferredType) {
        switch (Type(input)) {
          case 0:
            return input;
          case 1:
            return input;
          case 2:
            return input;
          case 3:
            return input;
          case 4:
            return input;
          case 5:
            return input;
        }
        var hint = PreferredType === 3 ? "string" : PreferredType === 5 ? "number" : "default";
        var exoticToPrim = GetMethod(input, toPrimitiveSymbol);
        if (exoticToPrim !== void 0) {
          var result = exoticToPrim.call(input, hint);
          if (IsObject(result))
            throw new TypeError();
          return result;
        }
        return OrdinaryToPrimitive(input, hint === "default" ? "number" : hint);
      }
      function OrdinaryToPrimitive(O2, hint) {
        if (hint === "string") {
          var toString_1 = O2.toString;
          if (IsCallable(toString_1)) {
            var result = toString_1.call(O2);
            if (!IsObject(result))
              return result;
          }
          var valueOf = O2.valueOf;
          if (IsCallable(valueOf)) {
            var result = valueOf.call(O2);
            if (!IsObject(result))
              return result;
          }
        } else {
          var valueOf = O2.valueOf;
          if (IsCallable(valueOf)) {
            var result = valueOf.call(O2);
            if (!IsObject(result))
              return result;
          }
          var toString_2 = O2.toString;
          if (IsCallable(toString_2)) {
            var result = toString_2.call(O2);
            if (!IsObject(result))
              return result;
          }
        }
        throw new TypeError();
      }
      function ToBoolean(argument) {
        return !!argument;
      }
      function ToString(argument) {
        return "" + argument;
      }
      function ToPropertyKey(argument) {
        var key = ToPrimitive(
          argument,
          3
          /* String */
        );
        if (IsSymbol(key))
          return key;
        return ToString(key);
      }
      function IsArray(argument) {
        return Array.isArray ? Array.isArray(argument) : argument instanceof Object ? argument instanceof Array : Object.prototype.toString.call(argument) === "[object Array]";
      }
      function IsCallable(argument) {
        return typeof argument === "function";
      }
      function IsConstructor(argument) {
        return typeof argument === "function";
      }
      function IsPropertyKey(argument) {
        switch (Type(argument)) {
          case 3:
            return true;
          case 4:
            return true;
          default:
            return false;
        }
      }
      function GetMethod(V, P2) {
        var func = V[P2];
        if (func === void 0 || func === null)
          return void 0;
        if (!IsCallable(func))
          throw new TypeError();
        return func;
      }
      function GetIterator(obj) {
        var method = GetMethod(obj, iteratorSymbol);
        if (!IsCallable(method))
          throw new TypeError();
        var iterator = method.call(obj);
        if (!IsObject(iterator))
          throw new TypeError();
        return iterator;
      }
      function IteratorValue(iterResult) {
        return iterResult.value;
      }
      function IteratorStep(iterator) {
        var result = iterator.next();
        return result.done ? false : result;
      }
      function IteratorClose(iterator) {
        var f2 = iterator["return"];
        if (f2)
          f2.call(iterator);
      }
      function OrdinaryGetPrototypeOf(O2) {
        var proto = Object.getPrototypeOf(O2);
        if (typeof O2 !== "function" || O2 === functionPrototype)
          return proto;
        if (proto !== functionPrototype)
          return proto;
        var prototype = O2.prototype;
        var prototypeProto = prototype && Object.getPrototypeOf(prototype);
        if (prototypeProto == null || prototypeProto === Object.prototype)
          return proto;
        var constructor = prototypeProto.constructor;
        if (typeof constructor !== "function")
          return proto;
        if (constructor === O2)
          return proto;
        return constructor;
      }
      function CreateMapPolyfill() {
        var cacheSentinel = {};
        var arraySentinel = [];
        var MapIterator = (
          /** @class */
          function() {
            function MapIterator2(keys, values, selector) {
              this._index = 0;
              this._keys = keys;
              this._values = values;
              this._selector = selector;
            }
            MapIterator2.prototype["@@iterator"] = function() {
              return this;
            };
            MapIterator2.prototype[iteratorSymbol] = function() {
              return this;
            };
            MapIterator2.prototype.next = function() {
              var index = this._index;
              if (index >= 0 && index < this._keys.length) {
                var result = this._selector(this._keys[index], this._values[index]);
                if (index + 1 >= this._keys.length) {
                  this._index = -1;
                  this._keys = arraySentinel;
                  this._values = arraySentinel;
                } else {
                  this._index++;
                }
                return { value: result, done: false };
              }
              return { value: void 0, done: true };
            };
            MapIterator2.prototype.throw = function(error) {
              if (this._index >= 0) {
                this._index = -1;
                this._keys = arraySentinel;
                this._values = arraySentinel;
              }
              throw error;
            };
            MapIterator2.prototype.return = function(value) {
              if (this._index >= 0) {
                this._index = -1;
                this._keys = arraySentinel;
                this._values = arraySentinel;
              }
              return { value, done: true };
            };
            return MapIterator2;
          }()
        );
        return (
          /** @class */
          function() {
            function Map2() {
              this._keys = [];
              this._values = [];
              this._cacheKey = cacheSentinel;
              this._cacheIndex = -2;
            }
            Object.defineProperty(Map2.prototype, "size", {
              get: function() {
                return this._keys.length;
              },
              enumerable: true,
              configurable: true
            });
            Map2.prototype.has = function(key) {
              return this._find(
                key,
                /*insert*/
                false
              ) >= 0;
            };
            Map2.prototype.get = function(key) {
              var index = this._find(
                key,
                /*insert*/
                false
              );
              return index >= 0 ? this._values[index] : void 0;
            };
            Map2.prototype.set = function(key, value) {
              var index = this._find(
                key,
                /*insert*/
                true
              );
              this._values[index] = value;
              return this;
            };
            Map2.prototype.delete = function(key) {
              var index = this._find(
                key,
                /*insert*/
                false
              );
              if (index >= 0) {
                var size2 = this._keys.length;
                for (var i2 = index + 1; i2 < size2; i2++) {
                  this._keys[i2 - 1] = this._keys[i2];
                  this._values[i2 - 1] = this._values[i2];
                }
                this._keys.length--;
                this._values.length--;
                if (key === this._cacheKey) {
                  this._cacheKey = cacheSentinel;
                  this._cacheIndex = -2;
                }
                return true;
              }
              return false;
            };
            Map2.prototype.clear = function() {
              this._keys.length = 0;
              this._values.length = 0;
              this._cacheKey = cacheSentinel;
              this._cacheIndex = -2;
            };
            Map2.prototype.keys = function() {
              return new MapIterator(this._keys, this._values, getKey);
            };
            Map2.prototype.values = function() {
              return new MapIterator(this._keys, this._values, getValue);
            };
            Map2.prototype.entries = function() {
              return new MapIterator(this._keys, this._values, getEntry);
            };
            Map2.prototype["@@iterator"] = function() {
              return this.entries();
            };
            Map2.prototype[iteratorSymbol] = function() {
              return this.entries();
            };
            Map2.prototype._find = function(key, insert) {
              if (this._cacheKey !== key) {
                this._cacheIndex = this._keys.indexOf(this._cacheKey = key);
              }
              if (this._cacheIndex < 0 && insert) {
                this._cacheIndex = this._keys.length;
                this._keys.push(key);
                this._values.push(void 0);
              }
              return this._cacheIndex;
            };
            return Map2;
          }()
        );
        function getKey(key, _2) {
          return key;
        }
        function getValue(_2, value) {
          return value;
        }
        function getEntry(key, value) {
          return [key, value];
        }
      }
      function CreateSetPolyfill() {
        return (
          /** @class */
          function() {
            function Set2() {
              this._map = new _Map();
            }
            Object.defineProperty(Set2.prototype, "size", {
              get: function() {
                return this._map.size;
              },
              enumerable: true,
              configurable: true
            });
            Set2.prototype.has = function(value) {
              return this._map.has(value);
            };
            Set2.prototype.add = function(value) {
              return this._map.set(value, value), this;
            };
            Set2.prototype.delete = function(value) {
              return this._map.delete(value);
            };
            Set2.prototype.clear = function() {
              this._map.clear();
            };
            Set2.prototype.keys = function() {
              return this._map.keys();
            };
            Set2.prototype.values = function() {
              return this._map.values();
            };
            Set2.prototype.entries = function() {
              return this._map.entries();
            };
            Set2.prototype["@@iterator"] = function() {
              return this.keys();
            };
            Set2.prototype[iteratorSymbol] = function() {
              return this.keys();
            };
            return Set2;
          }()
        );
      }
      function CreateWeakMapPolyfill() {
        var UUID_SIZE = 16;
        var keys = HashMap.create();
        var rootKey = CreateUniqueKey();
        return (
          /** @class */
          function() {
            function WeakMap2() {
              this._key = CreateUniqueKey();
            }
            WeakMap2.prototype.has = function(target) {
              var table = GetOrCreateWeakMapTable(
                target,
                /*create*/
                false
              );
              return table !== void 0 ? HashMap.has(table, this._key) : false;
            };
            WeakMap2.prototype.get = function(target) {
              var table = GetOrCreateWeakMapTable(
                target,
                /*create*/
                false
              );
              return table !== void 0 ? HashMap.get(table, this._key) : void 0;
            };
            WeakMap2.prototype.set = function(target, value) {
              var table = GetOrCreateWeakMapTable(
                target,
                /*create*/
                true
              );
              table[this._key] = value;
              return this;
            };
            WeakMap2.prototype.delete = function(target) {
              var table = GetOrCreateWeakMapTable(
                target,
                /*create*/
                false
              );
              return table !== void 0 ? delete table[this._key] : false;
            };
            WeakMap2.prototype.clear = function() {
              this._key = CreateUniqueKey();
            };
            return WeakMap2;
          }()
        );
        function CreateUniqueKey() {
          var key;
          do
            key = "@@WeakMap@@" + CreateUUID();
          while (HashMap.has(keys, key));
          keys[key] = true;
          return key;
        }
        function GetOrCreateWeakMapTable(target, create) {
          if (!hasOwn2.call(target, rootKey)) {
            if (!create)
              return void 0;
            Object.defineProperty(target, rootKey, { value: HashMap.create() });
          }
          return target[rootKey];
        }
        function FillRandomBytes(buffer2, size2) {
          for (var i2 = 0; i2 < size2; ++i2)
            buffer2[i2] = Math.random() * 255 | 0;
          return buffer2;
        }
        function GenRandomBytes(size2) {
          if (typeof Uint8Array === "function") {
            if (typeof crypto !== "undefined")
              return crypto.getRandomValues(new Uint8Array(size2));
            if (typeof msCrypto !== "undefined")
              return msCrypto.getRandomValues(new Uint8Array(size2));
            return FillRandomBytes(new Uint8Array(size2), size2);
          }
          return FillRandomBytes(new Array(size2), size2);
        }
        function CreateUUID() {
          var data = GenRandomBytes(UUID_SIZE);
          data[6] = data[6] & 79 | 64;
          data[8] = data[8] & 191 | 128;
          var result = "";
          for (var offset = 0; offset < UUID_SIZE; ++offset) {
            var byte = data[offset];
            if (offset === 4 || offset === 6 || offset === 8)
              result += "-";
            if (byte < 16)
              result += "0";
            result += byte.toString(16).toLowerCase();
          }
          return result;
        }
      }
      function MakeDictionary(obj) {
        obj.__ = void 0;
        delete obj.__;
        return obj;
      }
    });
  })(Reflect$1 || (Reflect$1 = {}));
  class ForwardRef {
    constructor(forwardRefFn) {
      this.forwardRefFn = forwardRefFn;
    }
    getRef() {
      return this.forwardRefFn();
    }
  }
  class Annotations {
    constructor() {
      this.classes = /* @__PURE__ */ new Map();
      this.props = /* @__PURE__ */ new Map();
      this.params = /* @__PURE__ */ new Map();
    }
    setClassMetadata(token, params) {
      this.classes.set(token, params);
    }
    getClassMetadata(token) {
      return this.classes.get(token);
    }
    pushParamMetadata(token, params) {
      if (this.params.has(token)) {
        this.params.get(token).push(params);
      } else {
        this.params.set(token, [params]);
      }
    }
    getParamMetadata(token) {
      return this.params.get(token);
    }
    getPropMetadataKeys() {
      return Array.from(this.props.keys());
    }
    pushPropMetadata(token, params) {
      if (this.props.has(token)) {
        this.props.get(token).push(params);
      } else {
        this.props.set(token, [params]);
      }
    }
    getPropMetadata(token) {
      return this.props.get(token);
    }
  }
  function makeParamDecorator(token, metadata) {
    return function(target, propertyKey, parameterIndex) {
      const annotations = getAnnotations(target);
      annotations.pushParamMetadata(token, {
        propertyKey,
        parameterIndex,
        metadata
      });
    };
  }
  function makePropertyDecorator(token, injectToken, contextCallback) {
    return function(target, propertyKey) {
      const annotations = getAnnotations(target.constructor);
      annotations.pushPropMetadata(token, {
        injectToken: injectToken || Reflect.getMetadata("design:type", target, propertyKey),
        propertyKey,
        contextCallback
      });
    };
  }
  function makeClassDecorator(token, metadata) {
    return function(target) {
      const annotations = getAnnotations(target);
      annotations.setClassMetadata(token, {
        paramTypes: Reflect.getMetadata("design:paramtypes", target),
        metadata
      });
    };
  }
  function getAnnotations(target) {
    const key = "__annotations__";
    if (!target.hasOwnProperty(key)) {
      target[key] = new Annotations();
    }
    return target[key];
  }
  class Scope {
    constructor(name) {
      this.name = name;
    }
    toString() {
      return this.name || "[anonymous provide scope]";
    }
  }
  const Injectable = function InjectableDecorator(options) {
    if (this instanceof InjectableDecorator) {
      this.provideIn = (options === null || options === void 0 ? void 0 : options.provideIn) || null;
    } else {
      return makeClassDecorator(Injectable, new Injectable(options));
    }
  };
  class InjectionToken {
    constructor(description) {
      this.description = description;
    }
    toString() {
      return this.description || "[anonymous injection token]";
    }
  }
  var InjectFlags;
  (function(InjectFlags2) {
    InjectFlags2["Default"] = "Default";
    InjectFlags2["Self"] = "Self";
    InjectFlags2["SkipSelf"] = "SkipSelf";
    InjectFlags2["Optional"] = "Optional";
  })(InjectFlags || (InjectFlags = {}));
  class Injector {
  }
  function stringify(token) {
    if (typeof token === "string") {
      return token;
    }
    if (Array.isArray(token)) {
      return "[" + token.map(stringify).join(", ") + "]";
    }
    if (token == null) {
      return "" + token;
    }
    if (token.name) {
      return `${token.name}`;
    }
    if (token.token) {
      return `${token.token}`;
    }
    const res = token.toString();
    if (res == null) {
      return "" + res;
    }
    const newLineIndex = res.indexOf("\n");
    return newLineIndex === -1 ? res : res.substring(0, newLineIndex);
  }
  function makeError$1(name) {
    return function viewflyError(message) {
      const error = new Error(message);
      error.name = `[ViewflyError: ${name}]`;
      error.stack = error.stack.replace(/\n.*?(?=\n)/, "");
      return error;
    };
  }
  const THROW_IF_NOT_FOUND = {
    __debug_value__: "THROW_IF_NOT_FOUND"
  };
  const nullInjectorErrorFn = (token) => {
    return makeError$1("NullInjector")(`No provide for \`${stringify(token)}\`!`);
  };
  class NullInjector extends Injector {
    constructor() {
      super(...arguments);
      this.parentInjector = null;
    }
    get(token, notFoundValue = THROW_IF_NOT_FOUND) {
      if (notFoundValue === THROW_IF_NOT_FOUND) {
        throw nullInjectorErrorFn(token);
      }
      return notFoundValue;
    }
  }
  const Inject = function InjectDecorator(token) {
    if (this instanceof Inject) {
      this.token = token;
    } else {
      return makeParamDecorator(Inject, new Inject(token));
    }
  };
  const Self = function SelfDecorator() {
    if (!(this instanceof Self)) {
      return makeParamDecorator(Self, new Self());
    }
  };
  const SkipSelf = function SkipSelfDecorator() {
    if (!(this instanceof SkipSelf)) {
      return makeParamDecorator(SkipSelf, new SkipSelf());
    }
  };
  const Optional = function OptionalDecorator() {
    if (!(this instanceof Optional)) {
      return makeParamDecorator(Optional, new Optional());
    }
  };
  const Prop = function PropDecorator(token, notFoundValue = THROW_IF_NOT_FOUND, flags) {
    if (!(this instanceof Prop)) {
      return makePropertyDecorator(Prop, token, function(instance, propertyName, token2, injector) {
        instance[propertyName] = injector.get(token2 instanceof ForwardRef ? token2.getRef() : token2, notFoundValue, flags);
      });
    }
  };
  function normalizeProvider(provider) {
    if (provider.useValue) {
      return normalizeValueProviderFactory(provider);
    }
    if (provider.useClass) {
      return normalizeClassProviderFactory(provider);
    }
    if (provider.useExisting) {
      return normalizeExistingProviderFactory(provider);
    }
    if (provider.useFactory) {
      return normalizeFactoryProviderFactory(provider);
    }
    if (provider.provide) {
      if (provider.provide instanceof InjectionToken) {
        return normalizeValueProviderFactory(provider);
      }
      return normalizeConstructorProviderFactory(provider);
    }
    return normalizeTypeProviderFactory(provider);
  }
  function normalizeValueProviderFactory(provider) {
    return {
      provide: provider.provide,
      scope: null,
      generateFactory() {
        return function() {
          return provider.useValue;
        };
      },
      deps: []
    };
  }
  function normalizeClassProviderFactory(provider) {
    let deps;
    let provideIn = null;
    if (provider.deps) {
      deps = normalizeDeps(provider.provide, provider.deps);
    } else {
      const resolvedClass = resolveClassParams(provider.useClass);
      provideIn = resolvedClass.scope;
      deps = normalizeDeps(provider.provide, resolvedClass.deps);
    }
    return {
      provide: provider.provide,
      scope: provideIn,
      deps,
      generateFactory(injector, cacheFn) {
        return function(...args) {
          const instance = new provider.useClass(...args);
          cacheFn(provider.provide, instance);
          const propMetadataKeys = getAnnotations(provider.useClass).getPropMetadataKeys();
          propMetadataKeys.forEach((key) => {
            const propsMetadata = getAnnotations(provider.useClass).getPropMetadata(key);
            propsMetadata.forEach((item) => {
              item.contextCallback(instance, item.propertyKey, item.injectToken, injector);
            });
          });
          return instance;
        };
      }
    };
  }
  function normalizeExistingProviderFactory(provider) {
    return {
      provide: provider.provide,
      scope: null,
      generateFactory(injector) {
        return function() {
          return injector.get(provider.useExisting);
        };
      },
      deps: []
    };
  }
  function normalizeFactoryProviderFactory(provider) {
    return {
      provide: provider.provide,
      scope: null,
      generateFactory() {
        return function(...args) {
          return provider.useFactory(...args);
        };
      },
      deps: normalizeDeps(provider.provide, provider.deps || [])
    };
  }
  function normalizeConstructorProviderFactory(provider) {
    return normalizeClassProviderFactory(Object.assign(Object.assign({}, provider), { useClass: provider.provide }));
  }
  function normalizeTypeProviderFactory(provider) {
    return normalizeClassProviderFactory({
      provide: provider,
      useClass: provider
    });
  }
  function resolveClassParams(construct) {
    const annotations = getAnnotations(construct);
    const metadata = annotations.getClassMetadata(Injectable);
    if (typeof metadata === "undefined") {
      throw new Error(`Class \`${stringify(construct)}\` is not injectable!`);
    }
    const deps = (metadata.paramTypes || []).map((i2) => [i2]);
    const metadataKeys = [Inject, Self, SkipSelf, Optional];
    metadataKeys.forEach((key) => {
      (annotations.getParamMetadata(key) || []).forEach((item) => {
        deps[item.parameterIndex].push(item.metadata);
      });
    });
    return {
      scope: metadata.metadata.provideIn,
      deps
    };
  }
  function normalizeDeps(provide2, deps) {
    return deps.map((dep, index) => {
      const r2 = {
        injectKey: null,
        optional: false,
        visibility: null
      };
      if (!Array.isArray(dep)) {
        r2.injectKey = dep;
      } else {
        for (let i2 = 0; i2 < dep.length; i2++) {
          const item = dep[i2];
          if (item instanceof Inject) {
            r2.injectKey = item.token;
          } else if (item instanceof Self || item instanceof SkipSelf) {
            r2.visibility = item;
          } else if (item instanceof Optional) {
            r2.optional = true;
          } else {
            r2.injectKey = item;
          }
        }
      }
      if (typeof r2.injectKey === "undefined") {
        throw new Error(`The ${index} th dependent parameter type of \`${stringify(provide2)}\` was not obtained, if the dependency is declared later, you can refer to it using \`constructor(@Inject(forwardRef(() => [Type|InjectionToken])) paramName: [Type]) {}\``);
      }
      return r2;
    });
  }
  const reflectiveInjectorErrorFn = (token) => {
    return makeError$1("ReflectiveInjector")(`No provide for \`${stringify(token)}\`!`);
  };
  const provideScopeError = (token) => {
    return makeError$1("ProvideScope")(`Can not found provide scope \`${stringify(token)}\`!`);
  };
  class ReflectiveInjector extends Injector {
    constructor(parentInjector, staticProviders, scope) {
      super();
      this.parentInjector = parentInjector;
      this.staticProviders = staticProviders;
      this.scope = scope;
      this.recordValues = /* @__PURE__ */ new Map();
      this.normalizedProviders = staticProviders.map((provide2) => {
        return normalizeProvider(provide2);
      });
    }
    /**
     * 用于获取当前注入器上下文内的实例、对象或数据
     * @param token 访问 token
     * @param notFoundValue 如未查找到的返回值
     * @param flags 查询规则
     */
    get(token, notFoundValue = THROW_IF_NOT_FOUND, flags) {
      var _a;
      flags = flags || InjectFlags.Default;
      if (flags === InjectFlags.SkipSelf) {
        if (this.parentInjector) {
          return this.parentInjector.get(token, notFoundValue);
        }
        if (notFoundValue !== THROW_IF_NOT_FOUND) {
          return notFoundValue;
        }
        throw reflectiveInjectorErrorFn(token);
      }
      if (this.recordValues.has(token)) {
        return this.recordValues.get(token);
      }
      for (let i2 = 0; i2 < this.normalizedProviders.length; i2++) {
        const normalizedProvider = this.normalizedProviders[i2];
        if (normalizedProvider.provide === token) {
          return this.getValue(token, normalizedProvider);
        }
      }
      if (!(token instanceof InjectionToken)) {
        const scope = (_a = getAnnotations(token).getClassMetadata(Injectable)) === null || _a === void 0 ? void 0 : _a.metadata.provideIn;
        if (scope) {
          const normalizedProvider = normalizeProvider(token);
          if (this.scope === scope) {
            this.normalizedProviders.push(normalizedProvider);
            return this.getValue(token, normalizedProvider);
          }
          const parentInjector = this.parentInjector;
          if (!parentInjector || parentInjector instanceof NullInjector) {
            if (normalizedProvider.scope === "root") {
              this.normalizedProviders.push(normalizedProvider);
              return this.getValue(token, normalizedProvider);
            }
            if (notFoundValue !== THROW_IF_NOT_FOUND) {
              return notFoundValue;
            }
            throw provideScopeError(normalizedProvider.scope);
          }
        }
      }
      if (flags === InjectFlags.Self) {
        if (notFoundValue === THROW_IF_NOT_FOUND) {
          throw reflectiveInjectorErrorFn(token);
        }
        return notFoundValue;
      }
      if (this.parentInjector) {
        return this.parentInjector.get(token, notFoundValue, flags === InjectFlags.Optional ? InjectFlags.Optional : InjectFlags.Default);
      }
      if (notFoundValue === THROW_IF_NOT_FOUND) {
        throw reflectiveInjectorErrorFn(token);
      }
      return notFoundValue;
    }
    getValue(token, normalizedProvider) {
      const { generateFactory, deps } = normalizedProvider;
      const params = this.resolveDeps(deps);
      let value = this.recordValues.get(token);
      if (value) {
        return value;
      }
      const factory = generateFactory(this, (token2, value2) => {
        this.recordValues.set(token2, value2);
      });
      value = factory(...params);
      this.recordValues.set(token, value);
      return value;
    }
    /**
     * 解决并获取依赖参数
     * @param deps 依赖规则
     * @private
     */
    resolveDeps(deps) {
      return deps.map((dep) => {
        let reflectiveValue;
        const tryValue = {};
        const injectToken = dep.injectKey instanceof ForwardRef ? dep.injectKey.getRef() : dep.injectKey;
        if (dep.visibility instanceof Self) {
          reflectiveValue = this.get(injectToken, tryValue, InjectFlags.Self);
        } else if (dep.visibility instanceof SkipSelf) {
          if (this.parentInjector) {
            reflectiveValue = this.parentInjector.get(injectToken, tryValue);
          } else {
            if (dep.optional) {
              return null;
            }
            throw reflectiveInjectorErrorFn(injectToken);
          }
        } else {
          reflectiveValue = this.get(injectToken, tryValue);
        }
        if (reflectiveValue === tryValue) {
          if (dep.optional) {
            return null;
          }
          throw reflectiveInjectorErrorFn(injectToken);
        }
        return reflectiveValue;
      });
    }
  }
  function n(n2) {
    for (var r2 = arguments.length, t2 = Array(r2 > 1 ? r2 - 1 : 0), e = 1; e < r2; e++)
      t2[e - 1] = arguments[e];
    if ("production" !== process.env.NODE_ENV) {
      var i2 = Y[n2], o2 = i2 ? "function" == typeof i2 ? i2.apply(null, t2) : i2 : "unknown error nr: " + n2;
      throw Error("[Immer] " + o2);
    }
    throw Error("[Immer] minified error nr: " + n2 + (t2.length ? " " + t2.map(function(n3) {
      return "'" + n3 + "'";
    }).join(",") : "") + ". Find the full error at: https://bit.ly/3cXEKWf");
  }
  function r(n2) {
    return !!n2 && !!n2[Q];
  }
  function t(n2) {
    var r2;
    return !!n2 && (function(n3) {
      if (!n3 || "object" != typeof n3)
        return false;
      var r3 = Object.getPrototypeOf(n3);
      if (null === r3)
        return true;
      var t2 = Object.hasOwnProperty.call(r3, "constructor") && r3.constructor;
      return t2 === Object || "function" == typeof t2 && Function.toString.call(t2) === Z;
    }(n2) || Array.isArray(n2) || !!n2[L] || !!(null === (r2 = n2.constructor) || void 0 === r2 ? void 0 : r2[L]) || s(n2) || v(n2));
  }
  function i(n2, r2, t2) {
    void 0 === t2 && (t2 = false), 0 === o(n2) ? (t2 ? Object.keys : nn)(n2).forEach(function(e) {
      t2 && "symbol" == typeof e || r2(e, n2[e], n2);
    }) : n2.forEach(function(t3, e) {
      return r2(e, t3, n2);
    });
  }
  function o(n2) {
    var r2 = n2[Q];
    return r2 ? r2.i > 3 ? r2.i - 4 : r2.i : Array.isArray(n2) ? 1 : s(n2) ? 2 : v(n2) ? 3 : 0;
  }
  function u(n2, r2) {
    return 2 === o(n2) ? n2.has(r2) : Object.prototype.hasOwnProperty.call(n2, r2);
  }
  function a(n2, r2) {
    return 2 === o(n2) ? n2.get(r2) : n2[r2];
  }
  function f(n2, r2, t2) {
    var e = o(n2);
    2 === e ? n2.set(r2, t2) : 3 === e ? n2.add(t2) : n2[r2] = t2;
  }
  function c(n2, r2) {
    return n2 === r2 ? 0 !== n2 || 1 / n2 == 1 / r2 : n2 != n2 && r2 != r2;
  }
  function s(n2) {
    return X && n2 instanceof Map;
  }
  function v(n2) {
    return q && n2 instanceof Set;
  }
  function p(n2) {
    return n2.o || n2.t;
  }
  function l(n2) {
    if (Array.isArray(n2))
      return Array.prototype.slice.call(n2);
    var r2 = rn(n2);
    delete r2[Q];
    for (var t2 = nn(r2), e = 0; e < t2.length; e++) {
      var i2 = t2[e], o2 = r2[i2];
      false === o2.writable && (o2.writable = true, o2.configurable = true), (o2.get || o2.set) && (r2[i2] = { configurable: true, writable: true, enumerable: o2.enumerable, value: n2[i2] });
    }
    return Object.create(Object.getPrototypeOf(n2), r2);
  }
  function d(n2, e) {
    return void 0 === e && (e = false), y(n2) || r(n2) || !t(n2) || (o(n2) > 1 && (n2.set = n2.add = n2.clear = n2.delete = h), Object.freeze(n2), e && i(n2, function(n3, r2) {
      return d(r2, true);
    }, true)), n2;
  }
  function h() {
    n(2);
  }
  function y(n2) {
    return null == n2 || "object" != typeof n2 || Object.isFrozen(n2);
  }
  function b(r2) {
    var t2 = tn[r2];
    return t2 || n(18, r2), t2;
  }
  function m(n2, r2) {
    tn[n2] || (tn[n2] = r2);
  }
  function _() {
    return "production" === process.env.NODE_ENV || U || n(0), U;
  }
  function j(n2, r2) {
    r2 && (b("Patches"), n2.u = [], n2.s = [], n2.v = r2);
  }
  function g(n2) {
    O(n2), n2.p.forEach(S), n2.p = null;
  }
  function O(n2) {
    n2 === U && (U = n2.l);
  }
  function w(n2) {
    return U = { p: [], l: U, h: n2, m: true, _: 0 };
  }
  function S(n2) {
    var r2 = n2[Q];
    0 === r2.i || 1 === r2.i ? r2.j() : r2.g = true;
  }
  function P(r2, e) {
    e._ = e.p.length;
    var i2 = e.p[0], o2 = void 0 !== r2 && r2 !== i2;
    return e.h.O || b("ES5").S(e, r2, o2), o2 ? (i2[Q].P && (g(e), n(4)), t(r2) && (r2 = M(e, r2), e.l || x(e, r2)), e.u && b("Patches").M(i2[Q].t, r2, e.u, e.s)) : r2 = M(e, i2, []), g(e), e.u && e.v(e.u, e.s), r2 !== H ? r2 : void 0;
  }
  function M(n2, r2, t2) {
    if (y(r2))
      return r2;
    var e = r2[Q];
    if (!e)
      return i(r2, function(i2, o3) {
        return A(n2, e, r2, i2, o3, t2);
      }, true), r2;
    if (e.A !== n2)
      return r2;
    if (!e.P)
      return x(n2, e.t, true), e.t;
    if (!e.I) {
      e.I = true, e.A._--;
      var o2 = 4 === e.i || 5 === e.i ? e.o = l(e.k) : e.o, u2 = o2, a2 = false;
      3 === e.i && (u2 = new Set(o2), o2.clear(), a2 = true), i(u2, function(r3, i2) {
        return A(n2, e, o2, r3, i2, t2, a2);
      }), x(n2, o2, false), t2 && n2.u && b("Patches").N(e, t2, n2.u, n2.s);
    }
    return e.o;
  }
  function A(e, i2, o2, a2, c2, s2, v2) {
    if ("production" !== process.env.NODE_ENV && c2 === o2 && n(5), r(c2)) {
      var p2 = M(e, c2, s2 && i2 && 3 !== i2.i && !u(i2.R, a2) ? s2.concat(a2) : void 0);
      if (f(o2, a2, p2), !r(p2))
        return;
      e.m = false;
    } else
      v2 && o2.add(c2);
    if (t(c2) && !y(c2)) {
      if (!e.h.D && e._ < 1)
        return;
      M(e, c2), i2 && i2.A.l || x(e, c2);
    }
  }
  function x(n2, r2, t2) {
    void 0 === t2 && (t2 = false), !n2.l && n2.h.D && n2.m && d(r2, t2);
  }
  function z(n2, r2) {
    var t2 = n2[Q];
    return (t2 ? p(t2) : n2)[r2];
  }
  function I(n2, r2) {
    if (r2 in n2)
      for (var t2 = Object.getPrototypeOf(n2); t2; ) {
        var e = Object.getOwnPropertyDescriptor(t2, r2);
        if (e)
          return e;
        t2 = Object.getPrototypeOf(t2);
      }
  }
  function k(n2) {
    n2.P || (n2.P = true, n2.l && k(n2.l));
  }
  function E(n2) {
    n2.o || (n2.o = l(n2.t));
  }
  function N(n2, r2, t2) {
    var e = s(r2) ? b("MapSet").F(r2, t2) : v(r2) ? b("MapSet").T(r2, t2) : n2.O ? function(n3, r3) {
      var t3 = Array.isArray(n3), e2 = { i: t3 ? 1 : 0, A: r3 ? r3.A : _(), P: false, I: false, R: {}, l: r3, t: n3, k: null, o: null, j: null, C: false }, i2 = e2, o2 = en;
      t3 && (i2 = [e2], o2 = on);
      var u2 = Proxy.revocable(i2, o2), a2 = u2.revoke, f2 = u2.proxy;
      return e2.k = f2, e2.j = a2, f2;
    }(r2, t2) : b("ES5").J(r2, t2);
    return (t2 ? t2.A : _()).p.push(e), e;
  }
  function R(e) {
    return r(e) || n(22, e), function n2(r2) {
      if (!t(r2))
        return r2;
      var e2, u2 = r2[Q], c2 = o(r2);
      if (u2) {
        if (!u2.P && (u2.i < 4 || !b("ES5").K(u2)))
          return u2.t;
        u2.I = true, e2 = D(r2, c2), u2.I = false;
      } else
        e2 = D(r2, c2);
      return i(e2, function(r3, t2) {
        u2 && a(u2.t, r3) === t2 || f(e2, r3, n2(t2));
      }), 3 === c2 ? new Set(e2) : e2;
    }(e);
  }
  function D(n2, r2) {
    switch (r2) {
      case 2:
        return new Map(n2);
      case 3:
        return Array.from(n2);
    }
    return l(n2);
  }
  function T() {
    function e(n2) {
      if (!t(n2))
        return n2;
      if (Array.isArray(n2))
        return n2.map(e);
      if (s(n2))
        return new Map(Array.from(n2.entries()).map(function(n3) {
          return [n3[0], e(n3[1])];
        }));
      if (v(n2))
        return new Set(Array.from(n2).map(e));
      var r2 = Object.create(Object.getPrototypeOf(n2));
      for (var i2 in n2)
        r2[i2] = e(n2[i2]);
      return u(n2, L) && (r2[L] = n2[L]), r2;
    }
    function f2(n2) {
      return r(n2) ? e(n2) : n2;
    }
    var c2 = "add";
    m("Patches", { $: function(r2, t2) {
      return t2.forEach(function(t3) {
        for (var i2 = t3.path, u2 = t3.op, f3 = r2, s2 = 0; s2 < i2.length - 1; s2++) {
          var v2 = o(f3), p2 = i2[s2];
          "string" != typeof p2 && "number" != typeof p2 && (p2 = "" + p2), 0 !== v2 && 1 !== v2 || "__proto__" !== p2 && "constructor" !== p2 || n(24), "function" == typeof f3 && "prototype" === p2 && n(24), "object" != typeof (f3 = a(f3, p2)) && n(15, i2.join("/"));
        }
        var l2 = o(f3), d2 = e(t3.value), h2 = i2[i2.length - 1];
        switch (u2) {
          case "replace":
            switch (l2) {
              case 2:
                return f3.set(h2, d2);
              case 3:
                n(16);
              default:
                return f3[h2] = d2;
            }
          case c2:
            switch (l2) {
              case 1:
                return "-" === h2 ? f3.push(d2) : f3.splice(h2, 0, d2);
              case 2:
                return f3.set(h2, d2);
              case 3:
                return f3.add(d2);
              default:
                return f3[h2] = d2;
            }
          case "remove":
            switch (l2) {
              case 1:
                return f3.splice(h2, 1);
              case 2:
                return f3.delete(h2);
              case 3:
                return f3.delete(t3.value);
              default:
                return delete f3[h2];
            }
          default:
            n(17, u2);
        }
      }), r2;
    }, N: function(n2, r2, t2, e2) {
      switch (n2.i) {
        case 0:
        case 4:
        case 2:
          return function(n3, r3, t3, e3) {
            var o2 = n3.t, s2 = n3.o;
            i(n3.R, function(n4, i2) {
              var v2 = a(o2, n4), p2 = a(s2, n4), l2 = i2 ? u(o2, n4) ? "replace" : c2 : "remove";
              if (v2 !== p2 || "replace" !== l2) {
                var d2 = r3.concat(n4);
                t3.push("remove" === l2 ? { op: l2, path: d2 } : { op: l2, path: d2, value: p2 }), e3.push(l2 === c2 ? { op: "remove", path: d2 } : "remove" === l2 ? { op: c2, path: d2, value: f2(v2) } : { op: "replace", path: d2, value: f2(v2) });
              }
            });
          }(n2, r2, t2, e2);
        case 5:
        case 1:
          return function(n3, r3, t3, e3) {
            var i2 = n3.t, o2 = n3.R, u2 = n3.o;
            if (u2.length < i2.length) {
              var a2 = [u2, i2];
              i2 = a2[0], u2 = a2[1];
              var s2 = [e3, t3];
              t3 = s2[0], e3 = s2[1];
            }
            for (var v2 = 0; v2 < i2.length; v2++)
              if (o2[v2] && u2[v2] !== i2[v2]) {
                var p2 = r3.concat([v2]);
                t3.push({ op: "replace", path: p2, value: f2(u2[v2]) }), e3.push({ op: "replace", path: p2, value: f2(i2[v2]) });
              }
            for (var l2 = i2.length; l2 < u2.length; l2++) {
              var d2 = r3.concat([l2]);
              t3.push({ op: c2, path: d2, value: f2(u2[l2]) });
            }
            i2.length < u2.length && e3.push({ op: "replace", path: r3.concat(["length"]), value: i2.length });
          }(n2, r2, t2, e2);
        case 3:
          return function(n3, r3, t3, e3) {
            var i2 = n3.t, o2 = n3.o, u2 = 0;
            i2.forEach(function(n4) {
              if (!o2.has(n4)) {
                var i3 = r3.concat([u2]);
                t3.push({ op: "remove", path: i3, value: n4 }), e3.unshift({ op: c2, path: i3, value: n4 });
              }
              u2++;
            }), u2 = 0, o2.forEach(function(n4) {
              if (!i2.has(n4)) {
                var o3 = r3.concat([u2]);
                t3.push({ op: c2, path: o3, value: n4 }), e3.unshift({ op: "remove", path: o3, value: n4 });
              }
              u2++;
            });
          }(n2, r2, t2, e2);
      }
    }, M: function(n2, r2, t2, e2) {
      t2.push({ op: "replace", path: [], value: r2 === H ? void 0 : r2 }), e2.push({ op: "replace", path: [], value: n2 });
    } });
  }
  var G, U, W = "undefined" != typeof Symbol && "symbol" == typeof Symbol("x"), X = "undefined" != typeof Map, q = "undefined" != typeof Set, B = "undefined" != typeof Proxy && void 0 !== Proxy.revocable && "undefined" != typeof Reflect, H = W ? Symbol.for("immer-nothing") : ((G = {})["immer-nothing"] = true, G), L = W ? Symbol.for("immer-draftable") : "__$immer_draftable", Q = W ? Symbol.for("immer-state") : "__$immer_state", Y = { 0: "Illegal state", 1: "Immer drafts cannot have computed properties", 2: "This object has been frozen and should not be mutated", 3: function(n2) {
    return "Cannot use a proxy that has been revoked. Did you pass an object from inside an immer function to an async process? " + n2;
  }, 4: "An immer producer returned a new value *and* modified its draft. Either return a new value *or* modify the draft.", 5: "Immer forbids circular references", 6: "The first or second argument to `produce` must be a function", 7: "The third argument to `produce` must be a function or undefined", 8: "First argument to `createDraft` must be a plain object, an array, or an immerable object", 9: "First argument to `finishDraft` must be a draft returned by `createDraft`", 10: "The given draft is already finalized", 11: "Object.defineProperty() cannot be used on an Immer draft", 12: "Object.setPrototypeOf() cannot be used on an Immer draft", 13: "Immer only supports deleting array indices", 14: "Immer only supports setting array indices and the 'length' property", 15: function(n2) {
    return "Cannot apply patch, path doesn't resolve: " + n2;
  }, 16: 'Sets cannot have "replace" patches.', 17: function(n2) {
    return "Unsupported patch operation: " + n2;
  }, 18: function(n2) {
    return "The plugin for '" + n2 + "' has not been loaded into Immer. To enable the plugin, import and call `enable" + n2 + "()` when initializing your application.";
  }, 20: "Cannot use proxies if Proxy, Proxy.revocable or Reflect are not available", 21: function(n2) {
    return "produce can only be called on things that are draftable: plain objects, arrays, Map, Set or classes that are marked with '[immerable]: true'. Got '" + n2 + "'";
  }, 22: function(n2) {
    return "'current' expects a draft, got: " + n2;
  }, 23: function(n2) {
    return "'original' expects a draft, got: " + n2;
  }, 24: "Patching reserved attributes like __proto__, prototype and constructor is not allowed" }, Z = "" + Object.prototype.constructor, nn = "undefined" != typeof Reflect && Reflect.ownKeys ? Reflect.ownKeys : void 0 !== Object.getOwnPropertySymbols ? function(n2) {
    return Object.getOwnPropertyNames(n2).concat(Object.getOwnPropertySymbols(n2));
  } : Object.getOwnPropertyNames, rn = Object.getOwnPropertyDescriptors || function(n2) {
    var r2 = {};
    return nn(n2).forEach(function(t2) {
      r2[t2] = Object.getOwnPropertyDescriptor(n2, t2);
    }), r2;
  }, tn = {}, en = { get: function(n2, r2) {
    if (r2 === Q)
      return n2;
    var e = p(n2);
    if (!u(e, r2))
      return function(n3, r3, t2) {
        var e2, i3 = I(r3, t2);
        return i3 ? "value" in i3 ? i3.value : null === (e2 = i3.get) || void 0 === e2 ? void 0 : e2.call(n3.k) : void 0;
      }(n2, e, r2);
    var i2 = e[r2];
    return n2.I || !t(i2) ? i2 : i2 === z(n2.t, r2) ? (E(n2), n2.o[r2] = N(n2.A.h, i2, n2)) : i2;
  }, has: function(n2, r2) {
    return r2 in p(n2);
  }, ownKeys: function(n2) {
    return Reflect.ownKeys(p(n2));
  }, set: function(n2, r2, t2) {
    var e = I(p(n2), r2);
    if (null == e ? void 0 : e.set)
      return e.set.call(n2.k, t2), true;
    if (!n2.P) {
      var i2 = z(p(n2), r2), o2 = null == i2 ? void 0 : i2[Q];
      if (o2 && o2.t === t2)
        return n2.o[r2] = t2, n2.R[r2] = false, true;
      if (c(t2, i2) && (void 0 !== t2 || u(n2.t, r2)))
        return true;
      E(n2), k(n2);
    }
    return n2.o[r2] === t2 && (void 0 !== t2 || r2 in n2.o) || Number.isNaN(t2) && Number.isNaN(n2.o[r2]) || (n2.o[r2] = t2, n2.R[r2] = true), true;
  }, deleteProperty: function(n2, r2) {
    return void 0 !== z(n2.t, r2) || r2 in n2.t ? (n2.R[r2] = false, E(n2), k(n2)) : delete n2.R[r2], n2.o && delete n2.o[r2], true;
  }, getOwnPropertyDescriptor: function(n2, r2) {
    var t2 = p(n2), e = Reflect.getOwnPropertyDescriptor(t2, r2);
    return e ? { writable: true, configurable: 1 !== n2.i || "length" !== r2, enumerable: e.enumerable, value: t2[r2] } : e;
  }, defineProperty: function() {
    n(11);
  }, getPrototypeOf: function(n2) {
    return Object.getPrototypeOf(n2.t);
  }, setPrototypeOf: function() {
    n(12);
  } }, on = {};
  i(en, function(n2, r2) {
    on[n2] = function() {
      return arguments[0] = arguments[0][0], r2.apply(this, arguments);
    };
  }), on.deleteProperty = function(r2, t2) {
    return "production" !== process.env.NODE_ENV && isNaN(parseInt(t2)) && n(13), on.set.call(this, r2, t2, void 0);
  }, on.set = function(r2, t2, e) {
    return "production" !== process.env.NODE_ENV && "length" !== t2 && isNaN(parseInt(t2)) && n(14), en.set.call(this, r2[0], t2, e, r2[0]);
  };
  var un = function() {
    function e(r2) {
      var e2 = this;
      this.O = B, this.D = true, this.produce = function(r3, i3, o2) {
        if ("function" == typeof r3 && "function" != typeof i3) {
          var u2 = i3;
          i3 = r3;
          var a2 = e2;
          return function(n2) {
            var r4 = this;
            void 0 === n2 && (n2 = u2);
            for (var t2 = arguments.length, e3 = Array(t2 > 1 ? t2 - 1 : 0), o3 = 1; o3 < t2; o3++)
              e3[o3 - 1] = arguments[o3];
            return a2.produce(n2, function(n3) {
              var t3;
              return (t3 = i3).call.apply(t3, [r4, n3].concat(e3));
            });
          };
        }
        var f2;
        if ("function" != typeof i3 && n(6), void 0 !== o2 && "function" != typeof o2 && n(7), t(r3)) {
          var c2 = w(e2), s2 = N(e2, r3, void 0), v2 = true;
          try {
            f2 = i3(s2), v2 = false;
          } finally {
            v2 ? g(c2) : O(c2);
          }
          return "undefined" != typeof Promise && f2 instanceof Promise ? f2.then(function(n2) {
            return j(c2, o2), P(n2, c2);
          }, function(n2) {
            throw g(c2), n2;
          }) : (j(c2, o2), P(f2, c2));
        }
        if (!r3 || "object" != typeof r3) {
          if (void 0 === (f2 = i3(r3)) && (f2 = r3), f2 === H && (f2 = void 0), e2.D && d(f2, true), o2) {
            var p2 = [], l2 = [];
            b("Patches").M(r3, f2, p2, l2), o2(p2, l2);
          }
          return f2;
        }
        n(21, r3);
      }, this.produceWithPatches = function(n2, r3) {
        if ("function" == typeof n2)
          return function(r4) {
            for (var t3 = arguments.length, i4 = Array(t3 > 1 ? t3 - 1 : 0), o3 = 1; o3 < t3; o3++)
              i4[o3 - 1] = arguments[o3];
            return e2.produceWithPatches(r4, function(r5) {
              return n2.apply(void 0, [r5].concat(i4));
            });
          };
        var t2, i3, o2 = e2.produce(n2, r3, function(n3, r4) {
          t2 = n3, i3 = r4;
        });
        return "undefined" != typeof Promise && o2 instanceof Promise ? o2.then(function(n3) {
          return [n3, t2, i3];
        }) : [o2, t2, i3];
      }, "boolean" == typeof (null == r2 ? void 0 : r2.useProxies) && this.setUseProxies(r2.useProxies), "boolean" == typeof (null == r2 ? void 0 : r2.autoFreeze) && this.setAutoFreeze(r2.autoFreeze);
    }
    var i2 = e.prototype;
    return i2.createDraft = function(e2) {
      t(e2) || n(8), r(e2) && (e2 = R(e2));
      var i3 = w(this), o2 = N(this, e2, void 0);
      return o2[Q].C = true, O(i3), o2;
    }, i2.finishDraft = function(r2, t2) {
      var e2 = r2 && r2[Q];
      "production" !== process.env.NODE_ENV && (e2 && e2.C || n(9), e2.I && n(10));
      var i3 = e2.A;
      return j(i3, t2), P(void 0, i3);
    }, i2.setAutoFreeze = function(n2) {
      this.D = n2;
    }, i2.setUseProxies = function(r2) {
      r2 && !B && n(20), this.O = r2;
    }, i2.applyPatches = function(n2, t2) {
      var e2;
      for (e2 = t2.length - 1; e2 >= 0; e2--) {
        var i3 = t2[e2];
        if (0 === i3.path.length && "replace" === i3.op) {
          n2 = i3.value;
          break;
        }
      }
      e2 > -1 && (t2 = t2.slice(e2 + 1));
      var o2 = b("Patches").$;
      return r(n2) ? o2(n2, t2) : this.produce(n2, function(n3) {
        return o2(n3, t2);
      });
    }, e;
  }(), an = new un(), fn = an.produce;
  an.produceWithPatches.bind(an);
  an.setAutoFreeze.bind(an);
  an.setUseProxies.bind(an);
  var pn = an.applyPatches.bind(an);
  an.createDraft.bind(an);
  an.finishDraft.bind(an);
  function makeError(name) {
    return function textbusError2(message) {
      const error = new Error(message);
      error.name = `[TextbusError: ${name}]`;
      error.stack = error.stack.replace(/\n.*?(?=\n)/, "");
      return error;
    };
  }
  function replaceEmpty(s2) {
    const empty = " ";
    return s2.replace(/\s\s+/g, (str) => {
      return " " + Array.from({
        length: str.length - 1
      }).fill(empty).join("");
    }).replace(/^\s|\s$/g, empty);
  }
  function createBidirectionalMapping(isA) {
    const a2b = /* @__PURE__ */ new WeakMap();
    const b2a = /* @__PURE__ */ new WeakMap();
    function set2(key, value) {
      if (get2(key)) {
        remove2(key);
      }
      if (get2(value)) {
        remove2(value);
      }
      if (isA(key)) {
        a2b.set(key, value);
        b2a.set(value, key);
      } else {
        a2b.set(value, key);
        b2a.set(key, value);
      }
    }
    function get2(key) {
      if (isA(key)) {
        return a2b.get(key);
      }
      return b2a.get(key);
    }
    function remove2(key) {
      if (isA(key)) {
        const v2 = a2b.get(key);
        a2b.delete(key);
        b2a.delete(v2);
      } else {
        const v2 = b2a.get(key);
        b2a.delete(key);
        a2b.delete(v2);
      }
    }
    return {
      set: set2,
      get: get2,
      remove: remove2
    };
  }
  class RootComponentRef {
  }
  class ViewAdapter {
  }
  const COMPONENT_LIST = new InjectionToken("COMPONENT_LIST");
  const FORMATTER_LIST = new InjectionToken("FORMATTER_LIST");
  const ATTRIBUTE_LIST = new InjectionToken("ATTRIBUTE_LIST");
  const ZEN_CODING_DETECT = new InjectionToken("ZEN_CODING_DETECT");
  const HISTORY_STACK_SIZE = new InjectionToken("HISTORY_STACK_SIZE");
  const READONLY = new InjectionToken("READONLY");
  class FocusManager {
  }
  function __decorate$1(decorators, target, key, desc) {
    var c2 = arguments.length, r2 = c2 < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d2;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function")
      r2 = Reflect.decorate(decorators, target, key, desc);
    else
      for (var i2 = decorators.length - 1; i2 >= 0; i2--)
        if (d2 = decorators[i2])
          r2 = (c2 < 3 ? d2(r2) : c2 > 3 ? d2(target, key, r2) : d2(target, key)) || r2;
    return c2 > 3 && r2 && Object.defineProperty(target, key, r2), r2;
  }
  function __param$1(paramIndex, decorator) {
    return function(target, key) {
      decorator(target, key, paramIndex);
    };
  }
  function __metadata$1(metadataKey, metadataValue) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function")
      return Reflect.metadata(metadataKey, metadataValue);
  }
  function __awaiter(thisArg, _arguments, P2, generator) {
    function adopt(value) {
      return value instanceof P2 ? value : new P2(function(resolve2) {
        resolve2(value);
      });
    }
    return new (P2 || (P2 = Promise))(function(resolve2, reject) {
      function fulfilled(value) {
        try {
          step(generator.next(value));
        } catch (e) {
          reject(e);
        }
      }
      function rejected(value) {
        try {
          step(generator["throw"](value));
        } catch (e) {
          reject(e);
        }
      }
      function step(result) {
        result.done ? resolve2(result.value) : adopt(result.value).then(fulfilled, rejected);
      }
      step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
  }
  typeof SuppressedError === "function" ? SuppressedError : function(error, suppressed, message) {
    var e = new Error(message);
    return e.name = "SuppressedError", e.error = error, e.suppressed = suppressed, e;
  };
  class ChangeMarker {
    get dirty() {
      return this._dirty;
    }
    get changed() {
      return this._changed;
    }
    constructor() {
      this._dirty = true;
      this._changed = true;
      this.changeEvent = new Subject();
      this.childComponentRemovedEvent = new Subject();
      this.onChange = this.changeEvent.asObservable();
      this.onChildComponentRemoved = this.childComponentRemovedEvent.asObservable();
    }
    markAsDirtied(operation) {
      this._dirty = true;
      this.markAsChanged(operation);
    }
    markAsChanged(operation) {
      this._changed = true;
      this.changeEvent.next(operation);
    }
    rendered() {
      this._dirty = this._changed = false;
    }
    reset() {
      this._changed = this._dirty = true;
    }
    recordComponentRemoved(instance) {
      this.childComponentRemovedEvent.next(instance);
    }
  }
  class Content {
    constructor() {
      this.segmenter = new Intl.Segmenter();
      this.data = [];
    }
    /**
     * 内容的长度
     */
    get length() {
      return this.data.reduce((p2, n2) => p2 + n2.length, 0);
    }
    /**
     * 修复 index，由于 emoji 长度不固定，当 index 在 emoji 中时，操作数据会产生意外的数据
     * @param index 当前的 index
     * @param toEnd 当需要变更 index 时，是向后还是向前移动
     */
    correctIndex(index, toEnd) {
      if (index === 0 || index === this.length) {
        return index;
      }
      let i2 = 0;
      for (const item of this.data) {
        const itemLength = item.length;
        if (typeof item === "string") {
          if (index > i2 && index < i2 + itemLength) {
            const offsetIndex = index - i2;
            const startIndex = Math.max(0, offsetIndex - 15);
            const endIndex = Math.min(startIndex + 30, item.length);
            const fragment = item.slice(startIndex, endIndex);
            const segments = this.segmenter.segment(fragment);
            let offset = startIndex;
            for (const p2 of segments) {
              const segmentLength = p2.segment.length;
              if (index > i2 + offset && index < i2 + offset + segmentLength) {
                return toEnd ? i2 + offset + segmentLength : i2 + offset;
              }
              offset += segmentLength;
              if (i2 + offset >= index) {
                break;
              }
            }
            return index;
          }
        }
        i2 += itemLength;
        if (i2 >= index) {
          break;
        }
      }
      return index;
    }
    /**
     * 在指定下标位置插入内容
     * @param index
     * @param content
     */
    insert(index, content) {
      if (index >= this.length) {
        this.append(content);
      } else {
        let i2 = 0;
        let ii = 0;
        for (const el of this.data) {
          if (index >= i2) {
            if (typeof el === "string") {
              if (index >= i2 && index < i2 + el.length) {
                const cc = [el.slice(0, index - i2), content, el.slice(index - i2)].filter((i3) => i3);
                if (typeof content === "string") {
                  this.data.splice(ii, 1, cc.join(""));
                } else {
                  this.data.splice(ii, 1, ...cc);
                }
                break;
              }
            } else if (index === i2) {
              const prev = this.data[ii - 1];
              if (typeof prev === "string" && typeof content === "string") {
                this.data[ii - 1] = prev + content;
              } else if (i2 === 0) {
                this.data.unshift(content);
              } else {
                this.data.splice(ii, 0, content);
              }
              break;
            }
          }
          ii++;
          i2 += el.length;
        }
      }
    }
    /**
     * 把内容添加到最后
     * @param content
     */
    append(content) {
      const lastChildIndex = this.data.length - 1;
      const lastChild = this.data[lastChildIndex];
      if (typeof lastChild === "string" && typeof content === "string") {
        this.data[lastChildIndex] = lastChild + content;
      } else {
        this.data.push(content);
      }
    }
    cut(startIndex = 0, endIndex = this.length) {
      if (endIndex <= startIndex) {
        return [];
      }
      const discardedContents = this.slice(startIndex, endIndex);
      const elements = this.slice(0, startIndex).concat(this.slice(endIndex, this.length));
      this.data = [];
      elements.forEach((item) => this.append(item));
      return discardedContents;
    }
    slice(startIndex = 0, endIndex = this.length) {
      if (startIndex >= endIndex) {
        return [];
      }
      startIndex = this.correctIndex(startIndex, false);
      endIndex = this.correctIndex(endIndex, true);
      let index = 0;
      const result = [];
      for (const el of this.data) {
        const fragmentStartIndex = index;
        const len = el.length;
        const fragmentEndIndex = index + len;
        index += len;
        if (startIndex < fragmentEndIndex && endIndex > fragmentStartIndex) {
          if (typeof el === "string") {
            const min = Math.max(0, startIndex - fragmentStartIndex);
            const max = Math.min(fragmentEndIndex, endIndex) - fragmentStartIndex;
            result.push(el.slice(min, max));
          } else {
            result.push(el);
          }
        }
      }
      return result;
    }
    toJSON() {
      return this.data.map((i2) => {
        if (typeof i2 === "string") {
          return i2;
        }
        return i2.toJSON();
      });
    }
    indexOf(element) {
      let index = 0;
      for (const item of this.data) {
        if (item === element) {
          return index;
        }
        index += item.length;
      }
      return -1;
    }
    getContentAtIndex(index) {
      return this.slice(index, index + 1)[0];
    }
    toGrid() {
      const splitPoints = [0];
      let index = 0;
      this.data.forEach((i2) => {
        index += i2.length;
        splitPoints.push(index);
      });
      return [...splitPoints];
    }
    toString() {
      return this.data.map((i2) => {
        if (typeof i2 === "string") {
          return i2;
        }
        return i2.toString();
      }).join("");
    }
  }
  class Slots {
    /** 子插槽的个数 */
    get length() {
      return this.slots.length;
    }
    /** 最后一个子插槽 */
    get last() {
      return this.slots[this.length - 1] || null;
    }
    /** 第一个子插槽 */
    get first() {
      return this.slots[0] || null;
    }
    get index() {
      return this._index;
    }
    constructor(host, slots = []) {
      this.host = host;
      this.slots = [];
      this._index = 0;
      this.changeEvent = new Subject();
      this.childSlotChangeEvent = new Subject();
      this.childSlotRemoveEvent = new Subject();
      this.changeListeners = /* @__PURE__ */ new WeakMap();
      this.onChange = this.changeEvent.asObservable();
      this.onChildSlotChange = this.childSlotChangeEvent.asObservable();
      this.onChildSlotRemove = this.childSlotRemoveEvent.asObservable();
      this.insert(...Array.from(new Set(slots)));
    }
    /**
     * 获取子插槽的下标位置
     * @param slot
     */
    indexOf(slot) {
      return this.slots.indexOf(slot);
    }
    /**
     * 删除指定插槽
     * @param slot
     */
    remove(slot) {
      const index = this.slots.indexOf(slot);
      if (index > -1) {
        this.retain(index);
        this.delete(1);
        return true;
      }
      return false;
    }
    /**
     * 把新插槽插入到指定插槽的后面
     * @param slots
     * @param ref
     */
    insertAfter(slots, ref2) {
      const index = this.slots.indexOf(ref2);
      if (index > -1) {
        this.insertByIndex(slots, index + 1);
      }
    }
    /**
     * 把新插槽插入到指定插槽的前面
     * @param slots
     * @param ref
     */
    insertBefore(slots, ref2) {
      const index = this.slots.indexOf(ref2);
      if (index > -1) {
        this.insertByIndex(slots, index);
      }
    }
    /**
     * 把新插槽插入到指定下标位置
     * @param slots
     * @param index
     */
    insertByIndex(slots, index) {
      if (index < 0) {
        index = 0;
      }
      if (index > this.slots.length) {
        index = this.slots.length;
      }
      this.retain(index);
      const s2 = Array.isArray(slots) ? slots : [slots];
      this.insert(...s2);
    }
    /**
     * 把新插槽添加到最后
     * @param slots
     */
    push(...slots) {
      this.retain(this.length);
      this.insert(...slots);
    }
    /**
     * 删除最后一个插槽并返回
     */
    pop() {
      if (this.length > 0) {
        const last = this.last;
        this.retain(this.length - 1);
        this.delete(1);
        return last;
      }
      return null;
    }
    /**
     * 删除第一个插槽并返回
     */
    shift() {
      if (this.length > 0) {
        const first = this.first;
        this.retain(0);
        this.delete(1);
        return first;
      }
      return null;
    }
    /**
     * 把新插槽添加到最前
     * @param slots
     */
    unshift(...slots) {
      this.retain(0);
      this.insert(...slots);
    }
    /**
     * 获取指定下标位置的插槽
     * @param index
     */
    get(index) {
      return this.slots[index] || null;
    }
    /**
     * 替换插槽
     * @param oldSlot 被替换的插槽
     * @param newSlot 新的插槽
     */
    replace(oldSlot, newSlot) {
      const index = this.indexOf(oldSlot);
      if (index > 0) {
        this.retain(index);
        this.delete(1);
        this.insert(newSlot);
      }
    }
    /**
     * 把所有子插槽转换为 JSON
     */
    toJSON() {
      return this.slots.map((i2) => i2.toJSON());
    }
    /**
     * 把当前插槽集合转换为数组
     */
    toArray() {
      return [...this.slots];
    }
    /**
     * 清空子插槽
     */
    clean() {
      this.retain(0);
      this.delete(this.length);
    }
    /**
     * 插入新的子插槽
     * @param slots
     */
    insert(...slots) {
      if (slots.length === 0) {
        return;
      }
      const index = this._index;
      this.slots.splice(index, 0, ...slots);
      slots.forEach((i2) => {
        if (i2.parent) {
          i2.parent.slots.remove(i2);
        }
        i2.changeMarker.reset();
        i2.parent = this.host;
        const sub = i2.changeMarker.onChange.subscribe((operation) => {
          operation.path.unshift(this.indexOf(i2));
          if (i2.changeMarker.dirty) {
            this.host.changeMarker.markAsDirtied(operation);
          } else {
            this.host.changeMarker.markAsChanged(operation);
          }
          this.childSlotChangeEvent.next(i2);
        });
        sub.add(i2.changeMarker.onChildComponentRemoved.subscribe((instance) => {
          this.host.changeMarker.recordComponentRemoved(instance);
        }));
        this.changeListeners.set(i2, sub);
      });
      this._index += slots.length;
      this.changeEvent.next({
        path: [],
        apply: [{
          type: "retain",
          offset: index
        }, ...slots.map((i2) => {
          return {
            type: "insertSlot",
            slot: i2.toJSON(),
            ref: i2
          };
        })],
        unApply: [{
          type: "retain",
          offset: index
        }, {
          type: "delete",
          count: slots.length
        }]
      });
    }
    /**
     * 设置新的下标
     * @param index
     */
    retain(index) {
      if (index < 0) {
        this._index = 0;
      } else if (index > this.length) {
        this._index = this.length;
      } else {
        this._index = index;
      }
    }
    /**
     * 从下标位置向后删除指定数量的子插槽
     * @param count
     */
    delete(count) {
      const startIndex = this._index;
      const deletedSlots = this.slots.splice(startIndex, count);
      deletedSlots.forEach((i2) => {
        var _a;
        i2.sliceContent().forEach((content) => {
          if (typeof content !== "string") {
            this.host.changeMarker.recordComponentRemoved(content);
          }
        });
        (_a = this.changeListeners.get(i2)) === null || _a === void 0 ? void 0 : _a.unsubscribe();
        this.changeListeners.delete(i2);
      });
      this.changeEvent.next({
        path: [],
        apply: [{
          type: "retain",
          offset: startIndex
        }, {
          type: "delete",
          count
        }],
        unApply: deletedSlots.map((slot, i2) => {
          slot.parent = null;
          return [{
            type: "retain",
            offset: startIndex + i2
          }, {
            type: "insertSlot",
            slot: slot.toJSON(),
            ref: slot
          }];
        }).flat()
      });
      this.childSlotRemoveEvent.next(deletedSlots);
    }
    /**
     * 剪切子插槽
     * @param startIndex
     * @param endIndex
     */
    cut(startIndex = 0, endIndex = this.length) {
      if (startIndex >= endIndex) {
        return [];
      }
      const deletedSlots = this.slots.slice(startIndex, endIndex);
      this.retain(startIndex);
      this.delete(endIndex - startIndex);
      return deletedSlots;
    }
    /**
     * 根据范围切分出一组子插槽
     * @param startIndex
     * @param endIndex
     */
    slice(startIndex, endIndex) {
      return this.slots.slice(startIndex, endIndex);
    }
    /**
     * 当前集合是否包含指定插槽
     * @param slot
     */
    has(slot) {
      return this.indexOf(slot) > -1;
    }
    toString() {
      return this.slots.map((i2) => {
        return i2.toString();
      }).join("");
    }
  }
  const textbusError = makeError("Textbus");
  class Textbus extends ReflectiveInjector {
    get readonly() {
      return this.controller.readonly;
    }
    set readonly(b2) {
      this.controller.readonly = b2;
    }
    get isFocus() {
      return this._isFocus;
    }
    constructor(config) {
      var _a;
      super(new NullInjector(), [], Textbus.diScope);
      this.config = config;
      this.destroyed = false;
      this.isReady = false;
      this._isFocus = false;
      this.beforeDestroyCallbacks = [];
      this.isDestroyed = false;
      this.changeEvent = new Subject();
      this.focusEvent = new Subject();
      this.blurEvent = new Subject();
      this.saveEvent = new Subject();
      this.readyEvent = new Subject();
      const { plugins, providers } = this.mergeModules(config);
      this.plugins = plugins;
      this.staticProviders = providers;
      this.normalizedProviders = this.staticProviders.map((i2) => normalizeProvider(i2));
      this.onChange = this.changeEvent.asObservable();
      this.onFocus = this.focusEvent.asObservable();
      this.onBlur = this.blurEvent.asObservable();
      this.onSave = this.saveEvent.asObservable();
      this.onReady = this.readyEvent.asObservable();
      this.controller = this.get(Controller);
      (_a = config.imports) === null || _a === void 0 ? void 0 : _a.forEach((module2) => {
        if (typeof module2.beforeEach === "function") {
          module2.beforeEach(this);
        }
      });
    }
    /**
     * 启动一个 Textbus 实例，并将根组件渲染到原生节点
     * @param rootComponent 根组件
     */
    render(rootComponent2) {
      var _a, _b, _c;
      return __awaiter(this, void 0, void 0, function* () {
        if (this.isDestroyed) {
          throw textbusError("Textbus instance is destroyed!");
        }
        const rootComponentRef = this.get(RootComponentRef);
        rootComponentRef.component = rootComponent2;
        const callbacks = [];
        (_a = this.config.imports) === null || _a === void 0 ? void 0 : _a.forEach((i2) => {
          if (typeof i2.setup === "function") {
            const callback = i2.setup(this);
            callbacks.push(callback || null);
          }
        });
        callbacks.push(((_c = (_b = this.config).setup) === null || _c === void 0 ? void 0 : _c.call(_b, this)) || null);
        const fns = yield Promise.all(callbacks);
        fns.forEach((i2) => {
          if (i2) {
            this.beforeDestroyCallbacks.push(i2);
          }
        });
        const scheduler = this.get(Scheduler);
        const history = this.get(History);
        const adapter = this.get(ViewAdapter);
        const formatters = this.get(FORMATTER_LIST);
        const attributes = this.get(ATTRIBUTE_LIST);
        this.initDefaultShortcut();
        history.listen();
        scheduler.run();
        const subscription = scheduler.onDocChanged.subscribe(() => {
          this.changeEvent.next();
        });
        this.beforeDestroyCallbacks.push(() => {
          subscription.unsubscribe();
        });
        const focusManager = this.get(FocusManager, null);
        if (focusManager) {
          subscription.add(focusManager.onFocus.subscribe(() => {
            this.focusEvent.next();
          }), focusManager.onBlur.subscribe(() => {
            this.blurEvent.next();
          }));
        }
        const destroyView = adapter.render(rootComponent2, this);
        if (typeof destroyView === "function") {
          this.beforeDestroyCallbacks.push(destroyView);
        }
        formatters.forEach((f2) => {
          f2.setup(this);
        });
        attributes.forEach((a2) => {
          a2.setup(this);
        });
        this.plugins.forEach((i2) => i2.setup(this));
        this.isReady = true;
        this.readyEvent.next();
        this.readyEvent.complete();
        return this;
      });
    }
    /**
     * 获取焦点
     */
    focus() {
      this.guardReady();
      const selection = this.get(Selection);
      const rootComponentRef = this.get(RootComponentRef);
      if (selection.commonAncestorSlot) {
        selection.restore();
        return;
      }
      const location = selection.findFirstPosition(rootComponentRef.component.slots.get(0));
      selection.setPosition(location.slot, location.offset);
      selection.restore();
    }
    /**
     * 取消编辑器焦点
     */
    blur() {
      if (this.isReady) {
        const selection = this.get(Selection);
        selection.unSelect();
        selection.restore();
      }
    }
    /**
     * 获取 JSON 格式的内容
     */
    getJSON() {
      this.guardReady();
      const rootComponentRef = this.get(RootComponentRef);
      return rootComponentRef.component.toJSON();
    }
    /**
     * 销毁 Textbus 实例
     */
    destroy() {
      this.isDestroyed = true;
      this.plugins.forEach((i2) => {
        var _a;
        return (_a = i2.onDestroy) === null || _a === void 0 ? void 0 : _a.call(i2);
      });
      this.beforeDestroyCallbacks.forEach((i2) => {
        i2();
      });
      const formatters = this.get(FORMATTER_LIST);
      const attributes = this.get(ATTRIBUTE_LIST);
      [this.get(History), this.get(Selection), this.get(Scheduler), ...formatters, ...attributes].forEach((i2) => {
        i2.destroy();
      });
    }
    guardReady() {
      if (this.destroyed) {
        throw textbusError("the editor instance is destroyed!");
      }
      if (!this.isReady) {
        throw textbusError("please wait for the editor to initialize before getting the content!");
      }
    }
    mergeModules(config) {
      var _a;
      const customProviders = [
        ...config.providers || []
      ];
      const components = [
        ...config.components || []
      ];
      const attributes = this.bindContext(config.attributes);
      const formatters = this.bindContext(config.formatters);
      const plugins = [
        ...config.plugins || []
      ];
      (_a = config.imports) === null || _a === void 0 ? void 0 : _a.forEach((module2) => {
        customProviders.push(...module2.providers || []);
        components.push(...module2.components || []);
        attributes.push(...this.bindContext(module2.attributes));
        formatters.push(...this.bindContext(module2.formatters));
        plugins.push(...module2.plugins || []);
      });
      const providers = [
        ...customProviders,
        {
          provide: READONLY,
          useValue: !!config.readonly
        },
        {
          provide: HISTORY_STACK_SIZE,
          useValue: typeof config.historyStackSize === "number" ? config.historyStackSize : 500
        },
        {
          provide: COMPONENT_LIST,
          useValue: components
        },
        {
          provide: ATTRIBUTE_LIST,
          useValue: attributes
        },
        {
          provide: FORMATTER_LIST,
          useValue: formatters
        },
        {
          provide: ZEN_CODING_DETECT,
          useValue: config.zenCoding
        },
        {
          provide: RootComponentRef,
          useValue: {}
        },
        {
          provide: History,
          useClass: LocalHistory
        },
        Controller,
        Scheduler,
        Commander,
        Keyboard,
        Query,
        Selection,
        Registry,
        {
          provide: Textbus,
          useFactory: () => this
        },
        {
          provide: Injector,
          useFactory: () => {
            return this;
          }
        },
        {
          provide: NativeSelectionBridge,
          useFactory() {
            throw textbusError("You must implement the `NativeSelectionBridge` interface to start Textbus!");
          }
        },
        {
          provide: ViewAdapter,
          useFactory() {
            throw textbusError("You must implement the `ViewAdapter` interface to start Textbus!");
          }
        }
      ];
      return {
        providers,
        plugins
      };
    }
    bindContext(list = []) {
      return list.map((item) => {
        if (typeof item === "function") {
          return item(this);
        }
        return item;
      });
    }
    initDefaultShortcut() {
      const selection = this.get(Selection);
      const keyboard = this.get(Keyboard);
      const history = this.get(History);
      const commander = this.get(Commander);
      keyboard.addShortcut({
        keymap: {
          key: "s",
          ctrlKey: true
        },
        action: () => {
          this.saveEvent.next();
        }
      });
      keyboard.addShortcut({
        keymap: {
          key: "Enter"
        },
        action: () => {
          commander.break();
        }
      });
      keyboard.addShortcut({
        keymap: {
          key: ["Delete", "Backspace"]
        },
        action: (key) => {
          commander.delete(key === "Backspace");
        }
      });
      keyboard.addShortcut({
        keymap: {
          key: ["ArrowLeft", "ArrowRight", "ArrowUp", "ArrowDown"]
        },
        action: (key) => {
          switch (key) {
            case "ArrowLeft":
              selection.toPrevious();
              break;
            case "ArrowRight":
              selection.toNext();
              break;
            case "ArrowUp":
              selection.toPreviousLine();
              break;
            case "ArrowDown":
              selection.toNextLine();
              break;
          }
        }
      });
      keyboard.addShortcut({
        keymap: {
          key: ["ArrowLeft", "ArrowRight", "ArrowUp", "ArrowDown"],
          shiftKey: true
        },
        action: (key) => {
          switch (key) {
            case "ArrowLeft":
              selection.wrapToBefore();
              break;
            case "ArrowRight":
              selection.wrapToAfter();
              break;
            case "ArrowUp":
              selection.wrapToPreviousLine();
              break;
            case "ArrowDown":
              selection.wrapToNextLine();
              break;
          }
        }
      });
      keyboard.addShortcut({
        keymap: {
          key: "Tab"
        },
        action: () => {
          commander.insert("    ");
        }
      });
      keyboard.addShortcut({
        keymap: {
          key: "a",
          ctrlKey: true
        },
        action: () => {
          selection.selectAll();
        }
      });
      keyboard.addShortcut({
        keymap: {
          key: "c",
          ctrlKey: true
        },
        action: () => {
          commander.copy();
        }
      });
      keyboard.addShortcut({
        keymap: {
          key: "x",
          ctrlKey: true
        },
        action: () => {
          commander.cut();
        }
      });
      keyboard.addShortcut({
        keymap: {
          key: "z",
          ctrlKey: true
        },
        action: () => {
          history.back();
        }
      });
      keyboard.addShortcut({
        keymap: {
          key: "z",
          ctrlKey: true,
          shiftKey: true
        },
        action: () => {
          history.forward();
        }
      });
    }
  }
  Textbus.diScope = new Scope("Textbus");
  T();
  const componentErrorFn = makeError("DefineComponent");
  class ComponentInstance {
    /**
     * 父组件
     */
    get parentComponent() {
      var _a;
      return ((_a = this.parent) === null || _a === void 0 ? void 0 : _a.parent) || null;
    }
    /**
     * @param textbus 当前容器上下文
     * @param options 组件配置项
     * @param initData 初始数据
     */
    constructor(textbus, options, initData) {
      this.id = Math.random();
      this.parent = null;
      this.changeMarker = new ChangeMarker();
      this.length = 1;
      this.shortcutList = [];
      this.stateChangeEvent = new Subject();
      this.onStateChange = this.stateChangeEvent.asObservable();
      this.name = options.name;
      this.type = options.type;
      this.separable = !!options.separable;
      if (typeof options.validate === "function") {
        initData = options.validate(textbus, initData);
      }
      this.state = (initData === null || initData === void 0 ? void 0 : initData.state) || null;
      this.slots = new Slots(this, (initData === null || initData === void 0 ? void 0 : initData.slots) || []);
      const changeController = {
        update: (fn2, record = true) => {
          return this.updateState(fn2, record);
        },
        onChange: this.onStateChange.pipe(map((i2) => i2.newState))
      };
      const context = {
        textbus,
        changeController,
        componentInstance: this,
        eventCache: new EventCache()
      };
      contextStack.push(context);
      if (typeof options.setup === "function") {
        this.extends = options.setup();
      }
      onDestroy(() => {
        eventCacheMap.delete(this);
        subscriptions.forEach((i2) => i2.unsubscribe());
      });
      eventCacheMap.set(this, context.eventCache);
      contextStack.pop();
      const subscriptions = [
        this.slots.onChange.subscribe((ops) => {
          this.changeMarker.markAsDirtied(ops);
        })
      ];
    }
    /**
     * 更新组件状态的方法
     * @param fn
     * @param record
     */
    updateState(fn$1, record) {
      let changes;
      let inverseChanges;
      const oldState = this.state;
      const newState = fn(oldState, fn$1, (p2, ip) => {
        changes = p2;
        inverseChanges = ip;
      });
      if (changes.length === 0 && inverseChanges.length === 0) {
        return oldState;
      }
      this.state = newState;
      this.changeMarker.markAsDirtied({
        path: [],
        apply: [{
          type: "apply",
          patches: changes,
          value: newState,
          record: !!record
        }],
        unApply: [{
          type: "apply",
          patches: inverseChanges,
          value: oldState,
          record: !!record
        }]
      });
      this.stateChangeEvent.next({
        oldState,
        newState,
        record: !!record
      });
      return newState;
    }
    /**
     * 组件转为 JSON 数据的方法
     */
    toJSON() {
      var _a;
      return {
        name: this.name,
        state: (_a = this.state) !== null && _a !== void 0 ? _a : null,
        slots: this.slots.toJSON()
      };
    }
    /**
     * 将组件转换为 string
     */
    toString() {
      return this.slots.toString();
    }
  }
  class Component {
    constructor(options) {
      this.options = options;
      this.name = options.name;
      this.instanceType = options.type;
      this.separable = !!options.separable;
      this.zenCoding = options.zenCoding || [];
    }
    /**
     * 组件创建实例的方法
     * @param textbus
     * @param data
     */
    createInstance(textbus, data) {
      return new ComponentInstance(textbus, this.options, data);
    }
  }
  class EventCache {
    constructor() {
      this.listeners = /* @__PURE__ */ new Map();
    }
    add(eventType, callback) {
      let callbacks = this.listeners.get(eventType);
      if (!callbacks) {
        callbacks = [];
        this.listeners.set(eventType, callbacks);
      }
      callbacks.push(callback);
    }
    get(eventType) {
      return this.listeners.get(eventType) || [];
    }
    clean(eventType) {
      this.listeners.delete(eventType);
    }
  }
  const eventCacheMap = /* @__PURE__ */ new WeakMap();
  const contextStack = [];
  function getCurrentContext() {
    const current = contextStack[contextStack.length - 1];
    if (!current) {
      throw componentErrorFn("cannot be called outside the component!");
    }
    return current;
  }
  function defineComponent(options) {
    return new Component(options);
  }
  function useContext(token = Textbus, noFoundValue, flags) {
    const context = getCurrentContext();
    return context.textbus.get(token, noFoundValue, flags);
  }
  function useSelf() {
    const context = getCurrentContext();
    return context.componentInstance;
  }
  class Event {
    get isPrevented() {
      return this._isPrevented;
    }
    constructor(target, data) {
      this.target = target;
      this.data = data;
      this._isPrevented = false;
    }
    preventDefault() {
      this._isPrevented = true;
    }
  }
  class GetRangesEvent extends Event {
    constructor(target, getRanges) {
      super(target, null);
      this.getRanges = getRanges;
    }
    useRanges(ranges) {
      this.getRanges(ranges);
    }
  }
  function invokeListener(target, eventType, event) {
    if (typeof target !== "object" || target === null) {
      return;
    }
    const cache = eventCacheMap.get(target);
    if (cache) {
      const callbacks = cache.get(eventType);
      callbacks.forEach((fn2) => {
        return fn2(event);
      });
      if (eventType === "onDestroy") {
        eventCacheMap.delete(target);
      }
    }
  }
  function makeEventHook(type) {
    return function(listener) {
      const context = getCurrentContext();
      if (context) {
        context.eventCache.add(type, listener);
      }
    };
  }
  const onContentDelete = makeEventHook("onContentDelete");
  const onContentDeleted = makeEventHook("onContentDeleted");
  const onBreak = makeEventHook("onBreak");
  const onContentInsert = makeEventHook("onContentInsert");
  const onContentInserted = makeEventHook("onContentInserted");
  const onDestroy = makeEventHook("onDestroy");
  class VTextNode {
    constructor(textContent = "") {
      this.textContent = textContent;
      this.location = null;
    }
  }
  function append(children, node) {
    if (node instanceof VElement || node instanceof ComponentInstance) {
      children.push(node);
    } else if (node instanceof VTextNode) {
      if (node.textContent) {
        children.push(node);
      }
    } else if (typeof node === "string" && node.length > 0) {
      children.push(new VTextNode(node));
    } else if (Array.isArray(node)) {
      for (const item of node.flat()) {
        append(children, item);
      }
    } else if (node !== false && node !== true && node !== null && typeof node !== "undefined") {
      children.push(new VTextNode(String(node)));
    }
  }
  function createVNode(tagName, attrs, children) {
    return new VElement(tagName, attrs, children);
  }
  class VElement {
    constructor(tagName, attrs, children) {
      this.tagName = tagName;
      this.children = [];
      this.location = null;
      this.attrs = /* @__PURE__ */ new Map();
      this.styles = /* @__PURE__ */ new Map();
      this.classes = /* @__PURE__ */ new Set();
      this.listeners = {};
      if (attrs) {
        Object.keys(attrs).forEach((key) => {
          if (key === "class") {
            const className = (attrs.class || "").trim();
            this.classes = new Set(className ? className.split(/\s+/g) : []);
          } else if (key === "style") {
            const style = attrs.style || "";
            if (typeof style === "string") {
              style.split(";").map((s2) => s2.split(":")).forEach((v2) => {
                if (!v2[0] || !v2[1]) {
                  return;
                }
                this.styles.set(v2[0].trim(), v2[1].trim());
              });
            } else if (typeof style === "object") {
              Object.keys(style).forEach((key2) => {
                this.styles.set(key2, style[key2]);
              });
            }
          } else {
            this.attrs.set(key, attrs[key]);
          }
        });
      }
      if (children) {
        children.flat(2).forEach((i2) => {
          append(this.children, i2);
        });
      }
    }
    /**
     * 在最后位置添加一个子节点。
     * @param newNodes
     */
    appendChild(...newNodes) {
      this.children.push(...newNodes);
    }
  }
  function isVoid(data) {
    return data === null || typeof data === "undefined";
  }
  class Format {
    constructor(slot) {
      this.slot = slot;
      this.map = /* @__PURE__ */ new Map();
    }
    /**
     * 将新样式合并到现有样式中
     * @param formatter
     * @param value
     * @param background
     */
    merge(formatter, value, background = false) {
      let ranges = this.map.get(formatter);
      if (!ranges) {
        const v2 = value.value;
        if (isVoid(v2)) {
          return this;
        }
        ranges = [value];
        this.map.set(formatter, ranges);
        return this;
      }
      const newRanges = this.normalizeFormatRange(background, ranges, value);
      if (newRanges.length) {
        this.map.set(formatter, newRanges);
      } else {
        this.map.delete(formatter);
      }
      return this;
    }
    /**
     * 将 index 后的样式起始和结束位置均增加 count 大小
     * @param index
     * @param count
     */
    stretch(index, count) {
      this.map.forEach((values) => {
        values.forEach((range) => {
          if (range.endIndex < index) {
            return;
          }
          range.endIndex += count;
          if (range.startIndex >= index) {
            range.startIndex += count;
          }
        });
      });
      return this;
    }
    /**
     * 将指定 index 位置后的样式向后平移 distance 长度
     * @param index
     * @param distance
     */
    split(index, distance) {
      const expandedValues = Array.from({ length: distance });
      Array.from(this.map).forEach(([key, formatRanges]) => {
        const values = this.tileRanges(formatRanges);
        values.splice(index, 0, ...expandedValues);
        const newRanges = Format.toRanges(values);
        this.map.set(key, newRanges);
      });
      return this;
    }
    /**
     * 从指定 index 位置的样式删除 count
     * @param startIndex
     * @param count
     */
    shrink(startIndex, count) {
      this.map.forEach((values) => {
        values.forEach((range) => {
          if (range.endIndex <= startIndex) {
            return;
          }
          range.endIndex = Math.max(startIndex, range.endIndex - count);
          if (range.startIndex > startIndex) {
            range.startIndex = Math.max(startIndex, range.startIndex - count);
          }
        });
      });
      Array.from(this.map.keys()).forEach((key) => {
        const oldRanges = this.map.get(key);
        const newRanges = this.normalizeFormatRange(false, oldRanges);
        if (newRanges.length) {
          this.map.set(key, newRanges);
        } else {
          this.map.delete(key);
        }
      });
      return this;
    }
    /**
     * 提取指定范围内的样式
     * @param startIndex
     * @param endIndex
     */
    extract(startIndex, endIndex) {
      const format = new Format(this.slot);
      this.map.forEach((ranges, key) => {
        const extractRanges = this.extractFormatRangesByFormatter(startIndex, endIndex, key);
        if (extractRanges.length) {
          format.map.set(key, extractRanges);
        }
      });
      return format;
    }
    /**
     * 生成一个重置位置的 format
     * @param slot
     * @param startIndex
     * @param endIndex
     */
    createFormatByRange(slot, startIndex, endIndex) {
      const format = new Format(slot);
      this.map.forEach((ranges, key) => {
        const extractRanges = this.extractFormatRangesByFormatter(startIndex, endIndex, key);
        if (extractRanges.length) {
          format.map.set(key, extractRanges.map((i2) => {
            i2.startIndex -= startIndex;
            i2.endIndex -= startIndex;
            return i2;
          }));
        }
      });
      return format;
    }
    /**
     * 通过 formatter 提取指定范围内的样式数据
     * @param startIndex
     * @param endIndex
     * @param formatter
     */
    extractFormatRangesByFormatter(startIndex, endIndex, formatter) {
      const extractRanges = [];
      const ranges = this.map.get(formatter) || [];
      ranges.forEach((range) => {
        if (range.startIndex > endIndex || range.endIndex < startIndex) {
          return;
        }
        const s2 = Math.max(range.startIndex, startIndex);
        const n2 = Math.min(range.endIndex, endIndex);
        if (s2 < n2) {
          extractRanges.push({
            startIndex: s2,
            endIndex: n2,
            value: range.value
          });
        }
      });
      return extractRanges;
    }
    /**
     * 丢弃指定范围内的样式
     * @param formatter
     * @param startIndex
     * @param endIndex
     */
    discard(formatter, startIndex, endIndex) {
      const oldRanges = this.map.get(formatter);
      if (oldRanges) {
        this.normalizeFormatRange(false, oldRanges, {
          startIndex,
          endIndex,
          value: null
        });
      }
      return this;
    }
    extractFormatsByIndex(index) {
      const formats = [];
      if (index === 0) {
        this.map.forEach((ranges, formatter) => {
          ranges.forEach((i2) => {
            if (i2.startIndex === 0) {
              formats.push([
                formatter,
                i2.value
              ]);
            }
          });
        });
      } else {
        this.map.forEach((ranges, formatter) => {
          ranges.forEach((i2) => {
            if (i2.startIndex < index && i2.endIndex >= index) {
              formats.push([
                formatter,
                i2.value
              ]);
            }
          });
        });
      }
      return formats;
    }
    toGrid() {
      const splitPoints = /* @__PURE__ */ new Set();
      splitPoints.add(0);
      splitPoints.add(this.slot.length);
      this.map.forEach((ranges) => {
        ranges.forEach((item) => {
          splitPoints.add(item.startIndex);
          splitPoints.add(item.endIndex);
        });
      });
      return [...splitPoints].sort((a2, b2) => a2 - b2);
    }
    toJSON() {
      const json = {};
      this.map.forEach((value, formatter) => {
        json[formatter.name] = value.map((i2) => Object.assign({}, i2));
      });
      return json;
    }
    toTree(startIndex, endIndex) {
      const copyFormat = this.extract(startIndex, endIndex);
      const tree = {
        startIndex,
        endIndex
      };
      let nextStartIndex = endIndex;
      let nextEndIndex = startIndex;
      const formats = [];
      const columnedFormats = [];
      Array.from(copyFormat.map.keys()).forEach((formatter) => {
        const ranges = copyFormat.map.get(formatter);
        ranges.forEach((range) => {
          if (range.startIndex === startIndex && range.endIndex === endIndex) {
            if (formatter.columned) {
              columnedFormats.push(Object.assign({ formatter }, range));
            } else {
              formats.push(Object.assign({ formatter }, range));
              copyFormat.map.delete(formatter);
            }
          } else if (range.startIndex < nextStartIndex) {
            nextStartIndex = range.startIndex;
            nextEndIndex = range.endIndex;
          } else if (range.startIndex === nextStartIndex) {
            nextEndIndex = Math.max(nextEndIndex, range.endIndex);
          }
        });
      });
      const hasChildren = copyFormat.map.size > columnedFormats.length;
      if (hasChildren) {
        tree.children = [];
        if (startIndex < nextStartIndex) {
          if (columnedFormats.length) {
            const childTree = copyFormat.extract(startIndex, nextStartIndex).toTree(startIndex, nextStartIndex);
            tree.children.push(childTree);
          } else {
            tree.children.push({
              startIndex,
              endIndex: nextStartIndex
            });
          }
        }
        const push = function(tree2, childTree) {
          if (childTree.formats) {
            tree2.children.push(childTree);
          } else if (childTree.children) {
            tree2.children.push(...childTree.children);
          } else {
            tree2.children.push(childTree);
          }
        };
        const nextTree = copyFormat.toTree(nextStartIndex, nextEndIndex);
        push(tree, nextTree);
        if (nextEndIndex < endIndex) {
          const afterFormat = copyFormat.extract(nextEndIndex, endIndex);
          const afterTree = afterFormat.toTree(nextEndIndex, endIndex);
          push(tree, afterTree);
        }
      } else {
        formats.push(...columnedFormats);
      }
      if (formats.length) {
        tree.formats = formats.sort((a2, b2) => {
          return a2.formatter.priority - b2.formatter.priority;
        });
      }
      return tree;
    }
    toArray() {
      const list = [];
      Array.from(this.map).forEach((i2) => {
        const formatter = i2[0];
        i2[1].forEach((range) => {
          list.push(Object.assign(Object.assign({}, range), { formatter }));
        });
      });
      return list;
    }
    normalizeFormatRange(background, oldRanges, newRange) {
      if (newRange) {
        oldRanges = background ? [newRange, ...oldRanges] : [...oldRanges, newRange];
      }
      const formatValues = this.tileRanges(oldRanges);
      return Format.toRanges(formatValues);
    }
    tileRanges(ranges) {
      const formatValues = [];
      ranges.forEach((range) => {
        formatValues.length = Math.max(formatValues.length, range.endIndex);
        formatValues.fill(range.value, range.startIndex, range.endIndex);
      });
      formatValues.length = Math.min(formatValues.length, this.slot.length);
      return formatValues;
    }
    static toRanges(values) {
      const newRanges = [];
      let range = null;
      for (let i2 = 0; i2 < values.length; i2++) {
        const item = values[i2];
        if (isVoid(item)) {
          range = null;
          continue;
        }
        if (Format.equal(range === null || range === void 0 ? void 0 : range.value, item)) {
          range.endIndex = i2 + 1;
          continue;
        }
        range = {
          startIndex: i2,
          endIndex: i2 + 1,
          value: item
        };
        newRanges.push(range);
      }
      return newRanges;
    }
    static equal(left, right) {
      if (left === right) {
        return true;
      }
      if (typeof left === "object" && typeof right === "object") {
        const leftKeys = Object.keys(left);
        const rightKeys = Object.keys(right);
        if (leftKeys.length === rightKeys.length) {
          return leftKeys.every((key) => {
            return rightKeys.includes(key) && right[key] === left[key];
          });
        }
      }
      return false;
    }
  }
  class Formatter {
    /**
     * 构造函数
     * @param name 格式的名字，在同一个编辑器实例内不可重复
     * @param config 格式配置
     */
    constructor(name, config) {
      this.name = name;
      this.config = config;
      this.priority = 0;
      this.columned = false;
      this.inheritable = true;
      const { priority = 0, inheritable = true, columned = false } = config;
      this.priority = priority;
      this.inheritable = inheritable;
      this.columned = columned;
    }
    setup(textbus) {
      var _a, _b;
      (_b = (_a = this.config).setup) === null || _b === void 0 ? void 0 : _b.call(_a, textbus);
    }
    destroy() {
      var _a, _b;
      (_b = (_a = this.config).onDestroy) === null || _b === void 0 ? void 0 : _b.call(_a);
    }
    render(children, formatValue, renderEnv) {
      return this.config.render(children, formatValue, renderEnv);
    }
  }
  const slotError = makeError("Slot");
  var ContentType;
  (function(ContentType2) {
    ContentType2[ContentType2["Text"] = 1] = "Text";
    ContentType2[ContentType2["InlineComponent"] = 2] = "InlineComponent";
    ContentType2[ContentType2["BlockComponent"] = 3] = "BlockComponent";
  })(ContentType || (ContentType = {}));
  class DeltaLite extends Array {
    constructor() {
      super(...arguments);
      this.attributes = /* @__PURE__ */ new Map();
    }
  }
  class Slot {
    static get emptyPlaceholder() {
      return "\n";
    }
    get parentSlot() {
      var _a;
      return ((_a = this.parent) === null || _a === void 0 ? void 0 : _a.parent) || null;
    }
    /** 插槽内容长度 */
    get length() {
      return this.content.length;
    }
    /** 插槽内容是否为空 */
    get isEmpty() {
      return this.length === 1 && this.getContentAtIndex(0) === Slot.emptyPlaceholder;
    }
    /** 插槽当前下标位置 */
    get index() {
      return this.isEmpty ? 0 : this._index;
    }
    constructor(schema, state) {
      this.state = state;
      this.parent = null;
      this.changeMarker = new ChangeMarker();
      this.componentChangeListeners = /* @__PURE__ */ new WeakMap();
      this.childComponentRemoveEvent = new Subject();
      this.id = Math.random();
      this._index = 0;
      this.content = new Content();
      this.format = new Format(this);
      this.attributes = /* @__PURE__ */ new Map();
      this.contentChangeEvent = new Subject();
      this.stateChangeEvent = new Subject();
      this.applyFormatCoverChild = false;
      this.schema = schema.sort();
      this.onContentChange = this.contentChangeEvent.asObservable();
      this.onStateChange = this.stateChangeEvent.asObservable();
      this.onChildComponentRemove = this.childComponentRemoveEvent.asObservable();
      this.content.append(Slot.emptyPlaceholder);
      this._index = 0;
    }
    /**
     * 设置属性
     * @param attribute
     * @param value
     */
    setAttribute(attribute, value) {
      const has2 = this.attributes.has(attribute);
      const v2 = this.attributes.get(attribute);
      this.attributes.set(attribute, value);
      const applyActions = [{
        type: "attrSet",
        name: attribute.name,
        value
      }];
      this.sliceContent().forEach((item) => {
        if (typeof item !== "string") {
          item.slots.toArray().forEach((slot) => {
            slot.setAttribute(attribute, value);
          });
        }
      });
      this.changeMarker.markAsDirtied({
        path: [],
        apply: applyActions,
        unApply: [has2 ? {
          type: "attrSet",
          name: attribute.name,
          value: v2
        } : {
          type: "attrRemove",
          name: attribute.name
        }]
      });
      this.contentChangeEvent.next(applyActions);
    }
    /**
     * 获取属性
     * @param attribute
     */
    getAttribute(attribute) {
      var _a;
      return (_a = this.attributes.get(attribute)) !== null && _a !== void 0 ? _a : null;
    }
    /**
     * 获取所有属性
     */
    getAttributes() {
      return Array.from(this.attributes.entries());
    }
    /**
     * 删除属性
     * @param attribute
     */
    removeAttribute(attribute) {
      this.sliceContent().forEach((item) => {
        if (typeof item !== "string") {
          item.slots.toArray().forEach((slot) => {
            slot.removeAttribute(attribute);
          });
        }
      });
      const has2 = this.attributes.has(attribute);
      if (!has2) {
        return;
      }
      const v2 = this.attributes.get(attribute);
      this.attributes.delete(attribute);
      const applyActions = [{
        type: "attrRemove",
        name: attribute.name
      }];
      this.changeMarker.markAsDirtied({
        path: [],
        apply: applyActions,
        unApply: [{
          type: "attrSet",
          name: attribute.name,
          value: v2
        }]
      });
      this.contentChangeEvent.next(applyActions);
    }
    /**
     * 根据是否包含指定 Attribute
     * @param attribute
     */
    hasAttribute(attribute) {
      return this.attributes.has(attribute);
    }
    /**
     * 更新插槽状态的方法
     * @param fn
     * @param record
     */
    updateState(fn$1, record = true) {
      let changes;
      let inverseChanges;
      const oldState = this.state;
      const newState = fn(oldState, fn$1, (p2, ip) => {
        changes = p2;
        inverseChanges = ip;
      });
      if (changes.length === 0 && inverseChanges.length === 0) {
        return oldState;
      }
      this.state = newState;
      const applyAction = {
        type: "apply",
        patches: changes,
        value: newState,
        record
      };
      this.changeMarker.markAsDirtied({
        path: [],
        apply: [applyAction],
        unApply: [{
          type: "apply",
          patches: inverseChanges,
          value: oldState,
          record
        }]
      });
      this.stateChangeEvent.next({
        newState,
        oldState,
        record
      });
      return newState;
    }
    write(content, formatter, value) {
      const index = this.index;
      const expandFormat = this.isEmpty || index === 0 ? this.format.extract(0, 1) : this.format.extract(index - 1, index);
      const formats = expandFormat.toArray().map((i2) => {
        return [
          i2.formatter,
          i2.value
        ];
      });
      if (formatter) {
        if (Array.isArray(formatter)) {
          formats.push(...formatter);
        } else {
          formats.push([formatter, value]);
        }
      }
      return this.insert(content, formats);
    }
    insert(content, formatter, value) {
      const contentType = typeof content === "string" ? ContentType.Text : content.type;
      if (!this.schema.includes(contentType)) {
        return false;
      }
      const prevContent = this.getContentAtIndex(this.index - 1);
      if (prevContent === Slot.placeholder) {
        this.retain(this.index - 1);
        this.delete(1);
      }
      const isEmpty = this.isEmpty;
      let actionData;
      let length;
      const startIndex = this.index;
      if (typeof content === "string") {
        if (content.length === 0) {
          return true;
        }
        actionData = content;
        length = content.length;
      } else {
        length = 1;
        actionData = content.toJSON();
        if (content.parent) {
          content.parent.removeComponent(content);
        }
        content.parent = this;
        const sub = content.changeMarker.onChange.subscribe((ops) => {
          ops.path.unshift(this.indexOf(content));
          this.changeMarker.markAsChanged(ops);
        });
        sub.add(content.changeMarker.onChildComponentRemoved.subscribe((instance) => {
          this.changeMarker.recordComponentRemoved(instance);
        }));
        this.componentChangeListeners.set(content, sub);
      }
      let formats = [];
      if (formatter) {
        if (Array.isArray(formatter)) {
          formats = formatter;
        } else {
          formats.push([formatter, value]);
        }
      }
      this.format.split(startIndex, length);
      this.content.insert(startIndex, content);
      this.applyFormats(formats, startIndex, length, false);
      if (isEmpty) {
        const len = this.length - 1;
        this.content.cut(len);
        this.format.shrink(len, 1);
      }
      this._index = startIndex + length;
      const applyActions = [{
        type: "retain",
        offset: startIndex
      }, formats.length ? {
        type: "insert",
        content: actionData,
        ref: content,
        formats: formats.reduce((opt, next) => {
          opt[next[0].name] = next[1];
          return opt;
        }, {})
      } : {
        type: "insert",
        content: actionData,
        ref: content
      }];
      this.changeMarker.markAsDirtied({
        path: [],
        apply: applyActions,
        unApply: [{
          type: "retain",
          offset: startIndex
        }, {
          type: "delete",
          count: length
        }]
      });
      this.contentChangeEvent.next(applyActions);
      return true;
    }
    retain(offset, formatter, value) {
      let formats = [];
      if (formatter) {
        if (Array.isArray(formatter)) {
          if (formatter.length === 0) {
            return true;
          }
          formats = formatter;
        } else {
          formats.push([formatter, value]);
        }
      }
      const len = this.length;
      if (formats.length === 0) {
        if (offset < 0) {
          offset = 0;
        }
        if (offset > len) {
          offset = len;
        }
        this._index = this.content.correctIndex(offset, false);
        return true;
      }
      const startIndex = this._index;
      let endIndex = this.content.correctIndex(startIndex + offset, true);
      if (endIndex > len) {
        endIndex = len;
      }
      let index = startIndex;
      const applyActions = [];
      const unApplyActions = [];
      const formatsObj = formats.reduce((opt, next) => {
        opt[next[0].name] = next[1];
        return opt;
      }, {});
      const resetFormatObj = formats.reduce((opt, next) => {
        opt[next[0].name] = null;
        return opt;
      }, {});
      this.content.slice(startIndex, endIndex).forEach((content) => {
        const offset2 = content.length;
        if (typeof content === "string" || content.type !== ContentType.BlockComponent) {
          const deletedFormat = this.format.extract(index, index + offset2);
          this.applyFormats(formats, index, offset2, this.applyFormatCoverChild);
          applyActions.push({
            type: "retain",
            offset: index
          }, {
            type: "retain",
            offset: offset2,
            formats: Object.assign({}, formatsObj)
          });
          unApplyActions.push({
            type: "retain",
            offset: index
          }, {
            type: "retain",
            offset: offset2,
            formats: resetFormatObj
          }, ...Slot.createActionByFormat(deletedFormat));
        } else {
          content.slots.toArray().forEach((slot) => {
            if (this.applyFormatCoverChild) {
              slot.background(() => {
                slot.retain(0);
                slot.retain(slot.length, formats);
              });
            } else {
              slot.retain(0);
              slot.retain(slot.length, formats);
            }
          });
        }
        index += offset2;
      });
      if (applyActions.length || unApplyActions.length) {
        this.changeMarker.markAsDirtied({
          path: [],
          apply: applyActions,
          unApply: unApplyActions
        });
        if (applyActions.length) {
          this.contentChangeEvent.next(applyActions);
        }
      }
      return true;
    }
    /**
     * 从当前位置向后删除指定长度的内容
     * @param count
     */
    delete(count) {
      if (count <= 0) {
        return false;
      }
      const startIndex = this._index;
      let endIndex = this.content.correctIndex(this._index + count, true);
      count = endIndex - startIndex;
      if (endIndex > this.length) {
        endIndex = this.length;
      }
      const deletedData = this.content.cut(startIndex, endIndex);
      const deletedFormat = this.format.extract(startIndex, endIndex);
      this.format.shrink(startIndex, count);
      if (this.length === 0) {
        this.content.append(Slot.emptyPlaceholder);
        this.format = deletedFormat.extract(0, 1);
      }
      const applyActions = [{
        type: "retain",
        offset: startIndex
      }, {
        type: "delete",
        count
      }];
      const deletedComponents = [];
      this.changeMarker.markAsDirtied({
        path: [],
        apply: applyActions,
        unApply: [{
          type: "retain",
          offset: startIndex
        }, ...deletedData.map((item) => {
          var _a;
          if (typeof item === "string") {
            return {
              type: "insert",
              content: item,
              ref: item
            };
          }
          deletedComponents.push(item);
          this.changeMarker.recordComponentRemoved(item);
          (_a = this.componentChangeListeners.get(item)) === null || _a === void 0 ? void 0 : _a.unsubscribe();
          this.componentChangeListeners.delete(item);
          item.parent = null;
          return {
            type: "insert",
            content: item.toJSON(),
            ref: item
          };
        }), ...Slot.createActionByFormat(deletedFormat)]
      });
      this.contentChangeEvent.next(applyActions);
      if (deletedComponents.length) {
        this.childComponentRemoveEvent.next(deletedComponents);
      }
      return true;
    }
    /**
     * 给插槽应用新的格式，如果为块级样式，则应用到整个插槽，否则根据参数配置的范围应用
     * @param formatter
     * @param data
     */
    applyFormat(formatter, data) {
      this.retain(data.startIndex);
      this.retain(data.endIndex - data.startIndex, formatter, data.value);
    }
    /**
     * 在当前插槽内删除指定的组件
     * @param component
     */
    removeComponent(component) {
      const index = this.indexOf(component);
      if (index > -1) {
        this.retain(index);
        return this.delete(1);
      }
      return false;
    }
    /**
     * 剪切插槽内指定范围的内容
     * @param startIndex
     * @param endIndex
     */
    cut(startIndex = 0, endIndex = this.length) {
      return this.cutTo(new Slot([...this.schema], this.state), startIndex, endIndex);
    }
    /**
     * 把当前插槽内指定范围的内容剪切到新插槽
     * @param slot 新插槽
     * @param startIndex
     * @param endIndex
     */
    cutTo(slot, startIndex = 0, endIndex = this.length) {
      if (startIndex < 0) {
        startIndex = 0;
      }
      const length = this.length;
      if (endIndex > length) {
        endIndex = length;
      }
      if (startIndex > endIndex) {
        return slot;
      }
      if (slot.isEmpty) {
        this.attributes.forEach((value, key) => {
          slot.setAttribute(key, value);
        });
      }
      startIndex = this.content.correctIndex(startIndex, false);
      endIndex = this.content.correctIndex(endIndex, true);
      if (this.isEmpty) {
        slot.format = this.format.createFormatByRange(slot, 0, 1);
        this.retain(startIndex);
        this.delete(endIndex - startIndex);
        return slot;
      }
      if (startIndex === length || startIndex === length - 1 && this.content.getContentAtIndex(length - 1) === "\n") {
        slot.format = this.format.createFormatByRange(slot, startIndex - 1, startIndex);
        this.retain(startIndex);
        this.delete(endIndex - startIndex);
        return slot;
      }
      this.retain(startIndex);
      const deletedData = this.content.slice(this.index, endIndex);
      const deletedFormat = this.format.createFormatByRange(slot, this.index, endIndex);
      this.delete(endIndex - this.index);
      const temporarySlot = new Slot([
        ...slot.schema
      ]);
      deletedData.forEach((i2) => {
        temporarySlot.insert(i2);
      });
      temporarySlot.format = deletedFormat.createFormatByRange(temporarySlot, 0, temporarySlot.length);
      temporarySlot.toDelta().forEach((item) => {
        slot.insert(item.insert, item.formats);
      });
      return slot;
    }
    /**
     * 查找组件在插槽内的索引
     * @param component
     */
    indexOf(component) {
      return this.content.indexOf(component);
    }
    /**
     * 查找指定下标位置的内容
     * @param index
     */
    getContentAtIndex(index) {
      return this.content.getContentAtIndex(index);
    }
    /**
     * 切分出插槽内指定范围的内容
     * @param startIndex
     * @param endIndex
     */
    sliceContent(startIndex = 0, endIndex = this.length) {
      return this.content.slice(startIndex, endIndex);
    }
    /**
     * 获取传入格式在插槽指定内范围的集合
     * @param formatter 指定的格式
     * @param startIndex
     * @param endIndex
     */
    getFormatRangesByFormatter(formatter, startIndex, endIndex) {
      return this.format.extractFormatRangesByFormatter(startIndex, endIndex, formatter);
    }
    /**
     * 获取插槽格式的数组集合
     */
    getFormats() {
      return this.format.toArray();
    }
    /**
     * 提取 index 下标位置的格式
     * @param index
     */
    extractFormatsByIndex(index) {
      return this.format.extractFormatsByIndex(index);
    }
    /**
     * 把插槽内容转换为 JSON
     */
    toJSON() {
      var _a;
      const attrs = {};
      this.attributes.forEach((value, key) => {
        attrs[key.name] = value;
      });
      return {
        schema: this.schema,
        content: this.content.toJSON(),
        attributes: attrs,
        formats: this.format.toJSON(),
        state: (_a = this.state) !== null && _a !== void 0 ? _a : null
      };
    }
    toString() {
      return this.content.toString();
    }
    /**
     * 将插槽数据转换为 delta 表示
     */
    toDelta() {
      const deltaList = new DeltaLite();
      if (this.length === 0) {
        return deltaList;
      }
      const formatGrid = this.format.toGrid();
      const contentGrid = this.content.toGrid();
      const gridSet = /* @__PURE__ */ new Set([...formatGrid, ...contentGrid]);
      const grid = [...gridSet].sort((a2, b2) => a2 - b2);
      this.attributes.forEach((value, key) => {
        deltaList.attributes.set(key, value);
      });
      let startIndex = grid.shift();
      while (grid.length) {
        const endIndex = grid.shift();
        deltaList.push({
          insert: this.content.slice(startIndex, endIndex)[0],
          formats: this.format.extract(startIndex, endIndex).toArray().map((i2) => {
            return [i2.formatter, i2.value];
          })
        });
        startIndex = endIndex;
      }
      return deltaList;
    }
    /**
     * 根据 delta 插入内容
     * @param delta
     */
    insertDelta(delta) {
      delta.attributes.forEach((value, key) => {
        this.setAttribute(key, value);
      });
      while (delta.length) {
        const first = delta[0];
        const is = this.insert(first.insert, first.formats);
        if (is) {
          delta.shift();
        } else {
          break;
        }
      }
      return delta;
    }
    /**
     * 清除插槽格式
     * @param excludeFormats 要排除的格式
     * @param startIndex 开始位置
     * @param endIndex 结束位置
     */
    cleanFormats(excludeFormats = [], startIndex = 0, endIndex = this.length) {
      const formats = this.getFormats();
      if (formats.length) {
        formats.forEach((item) => {
          if (typeof excludeFormats === "function" ? excludeFormats(item.formatter) : excludeFormats.includes(item.formatter)) {
            return;
          }
          this.retain(startIndex);
          this.retain(endIndex - startIndex, item.formatter, null);
        });
      } else {
        this.sliceContent(startIndex, endIndex).forEach((item) => {
          if (typeof item !== "string") {
            item.slots.toArray().forEach((slot) => {
              slot.cleanFormats(excludeFormats);
            });
          }
        });
      }
    }
    /**
     * 当在回调函数中应用样式时，将把应用的样式作为子插槽的最低优化级合并
     * @param fn
     */
    background(fn2) {
      this.applyFormatCoverChild = true;
      fn2();
      this.applyFormatCoverChild = false;
    }
    /**
     * 清除插槽属性
     * @param excludeAttributes 要排除的属性
     */
    cleanAttributes(excludeAttributes = []) {
      Array.from(this.attributes.keys()).forEach((item) => {
        if (typeof excludeAttributes === "function" ? excludeAttributes(item) : excludeAttributes.includes(item)) {
          return;
        }
        this.removeAttribute(item);
      });
      this.sliceContent().forEach((item) => {
        if (typeof item !== "string") {
          item.slots.toArray().forEach((slot) => {
            slot.cleanAttributes(excludeAttributes);
          });
        }
      });
    }
    applyFormats(formats, startIndex, offset, background) {
      formats.forEach((keyValue) => {
        const key = keyValue[0];
        const value = keyValue[1];
        this.format.merge(key, {
          startIndex,
          endIndex: startIndex + offset,
          value
        }, background);
      });
    }
    /**
     * 根据插槽的格式数据，生成格式树
     */
    toTree(slotRenderFactory, renderEnv) {
      const formatTree = this.format.toTree(0, this.length);
      let children = formatTree.children ? this.createVDomByFormatTree(this, formatTree.children, renderEnv) : this.createVDomByContent(this, formatTree.startIndex, formatTree.endIndex);
      if (formatTree.formats) {
        children = [this.createVDomByOverlapFormats(formatTree.formats, children, renderEnv)];
      }
      const root = slotRenderFactory(children);
      for (const [attribute, value] of this.getAttributes()) {
        attribute.render(root, value, renderEnv);
      }
      root.location = {
        slot: this,
        startIndex: 0,
        endIndex: this.length
      };
      return root;
    }
    createVDomByFormatTree(slot, formats, renderEnv) {
      var _a;
      const nodes = [];
      for (const child of formats) {
        if ((_a = child.formats) === null || _a === void 0 ? void 0 : _a.length) {
          const children = child.children ? this.createVDomByFormatTree(slot, child.children, renderEnv) : this.createVDomByContent(slot, child.startIndex, child.endIndex);
          const nextChildren = this.createVDomByOverlapFormats(child.formats, children, renderEnv);
          nodes.push(nextChildren);
        } else {
          nodes.push(...this.createVDomByContent(slot, child.startIndex, child.endIndex));
        }
      }
      return nodes;
    }
    createVDomByOverlapFormats(formats, children, renderEnv) {
      const hostBindings = [];
      let host = null;
      for (let i2 = formats.length - 1; i2 > -1; i2--) {
        const item = formats[i2];
        const next = item.formatter.render(children, item.value, renderEnv);
        if (!next) {
          throw slotError(`Formatter \`${item.formatter.name}\` must return an VElement!`);
        }
        if (!(next instanceof VElement)) {
          hostBindings.push({
            item,
            render: next
          });
          continue;
        }
        next.location = {
          slot: this,
          startIndex: item.startIndex,
          endIndex: item.endIndex
        };
        host = next;
        children = [next];
      }
      for (const binding of hostBindings) {
        const { render, item } = binding;
        if (!host) {
          host = new VElement(render.fallbackTagName);
          host.location = {
            slot: this,
            startIndex: item.startIndex,
            endIndex: item.endIndex
          };
          host.appendChild(...children);
        }
        render.attach(host);
      }
      return host;
    }
    createVDomByContent(slot, startIndex, endIndex) {
      const elements = slot.sliceContent(startIndex, endIndex).map((i2) => {
        if (typeof i2 === "string") {
          return i2.match(/\n|[^\n]+/g);
        }
        return i2;
      }).flat();
      return elements.map((item) => {
        let vNode;
        let length;
        if (typeof item === "string") {
          if (item === "\n") {
            vNode = new VElement("br");
            vNode.location = {
              slot: this,
              startIndex,
              endIndex: startIndex + 1
            };
            length = 1;
          } else {
            vNode = new VTextNode(item);
            length = item.length;
            vNode.location = {
              slot,
              startIndex,
              endIndex: startIndex + length
            };
          }
        } else {
          length = 1;
          vNode = item;
        }
        startIndex += length;
        return vNode;
      });
    }
    static createActionByFormat(format) {
      return format.toArray().map((item) => {
        return [{
          type: "retain",
          offset: item.startIndex
        }, {
          type: "retain",
          offset: item.endIndex - item.startIndex,
          formats: {
            [item.formatter.name]: item.value
          }
        }];
      }).flat();
    }
  }
  Slot.placeholder = "​";
  let Controller = class Controller {
    /** 是否只读 */
    get readonly() {
      return this._readonly;
    }
    set readonly(b2) {
      this._readonly = b2;
      this.readonlyStateChangeEvent.next(b2);
    }
    constructor(readonly2) {
      this._readonly = false;
      this.readonlyStateChangeEvent = new Subject();
      this.onReadonlyStateChange = this.readonlyStateChangeEvent.asObservable().pipe(distinctUntilChanged());
      this._readonly = readonly2;
    }
  };
  Controller = __decorate$1([
    Injectable(),
    __param$1(0, Inject(READONLY)),
    __metadata$1("design:paramtypes", [Boolean])
  ], Controller);
  var Selection_1;
  class NativeSelectionBridge {
  }
  let Selection = Selection_1 = class Selection {
    /** 当前是否有选区 */
    get isSelected() {
      return ![this.startSlot, this.startOffset, this.endSlot, this.endOffset].includes(null);
    }
    /** 当前选区是否闭合 */
    get isCollapsed() {
      var _a;
      if ((_a = this.customRanges) === null || _a === void 0 ? void 0 : _a.length) {
        return false;
      }
      return this.isSelected && this.startSlot === this.endSlot && this.startOffset === this.endOffset;
    }
    /** 选区开始插槽 */
    get startSlot() {
      return this._startSlot;
    }
    /** 选区开始位置在开始插槽中的索引 */
    get startOffset() {
      return this._startOffset;
    }
    /** 选区结束插槽 */
    get endSlot() {
      return this._endSlot;
    }
    /** 选区结束位置在线束插槽中的索引 */
    get endOffset() {
      return this._endOffset;
    }
    /** 锚点插槽 */
    get anchorSlot() {
      return this._anchorSlot;
    }
    /** 锚点插槽偏移量 */
    get anchorOffset() {
      return this._anchorOffset;
    }
    /** 焦点插槽 */
    get focusSlot() {
      return this._focusSlot;
    }
    /** 焦点插槽偏移量 */
    get focusOffset() {
      return this._focusOffset;
    }
    /**
     * 选区的公共父插槽
     */
    get commonAncestorSlot() {
      return this._commonAncestorSlot;
    }
    /**
     * 选区的公共父组件
     */
    get commonAncestorComponent() {
      return this._commonAncestorComponent;
    }
    /**
     * 是否代理原生选区
     */
    get nativeSelectionDelegate() {
      return this._nativeSelectionDelegate;
    }
    set nativeSelectionDelegate(v2) {
      if (v2 === this._nativeSelectionDelegate) {
        return;
      }
      this._nativeSelectionDelegate = v2;
      if (this.controller.readonly) {
        return;
      }
      if (v2) {
        this.bridge.connect(this.connector);
      } else {
        this.bridge.disConnect();
      }
    }
    constructor(root, controller) {
      this.root = root;
      this.controller = controller;
      this.connector = {
        setSelection: (range) => {
          if (range === null) {
            if (null === this.startSlot && null === this.endSlot && null === this.startOffset && null === this.endOffset) {
              return;
            }
            this.unSelect();
            return;
          }
          const { focusOffset, focusSlot, anchorOffset, anchorSlot } = range;
          if (focusSlot === this.focusSlot && anchorSlot === this.anchorSlot && focusOffset === this.focusOffset && anchorOffset === this.anchorOffset) {
            return;
          }
          this.setBaseAndExtent(anchorSlot, anchorOffset, focusSlot, focusOffset);
        }
      };
      this._commonAncestorSlot = null;
      this._commonAncestorComponent = null;
      this._startSlot = null;
      this._endSlot = null;
      this._startOffset = null;
      this._endOffset = null;
      this._anchorSlot = null;
      this._anchorOffset = null;
      this._focusSlot = null;
      this._focusOffset = null;
      this.changeEvent = new Subject();
      this._nativeSelectionDelegate = false;
      this.subscriptions = [];
      this.customRanges = null;
      this.changeFromUpdateCustomRanges = false;
      let prevFocusComponent;
      this.onChange = this.changeEvent.asObservable().pipe(distinctUntilChanged((previous, current) => {
        if (previous && current) {
          return !(previous.focusOffset === current.focusOffset && previous.anchorOffset === current.anchorOffset && previous.focusSlot === current.focusSlot && previous.anchorSlot === current.anchorSlot);
        }
        return previous !== current;
      }), share());
      let selectedComponent = null;
      const focusInComponents = [];
      this.subscriptions.push(controller.onReadonlyStateChange.subscribe((b2) => {
        if (b2) {
          this.bridge.disConnect();
        } else {
          this.bridge.connect(this.connector);
        }
      }), this.onChange.pipe(map(() => {
        return this.commonAncestorComponent;
      }), distinctUntilChanged()).subscribe((component) => {
        while (focusInComponents.length) {
          const focusOutComponent = focusInComponents.shift();
          let parentComponent = focusOutComponent;
          while (parentComponent) {
            if (parentComponent === root.component) {
              invokeListener(focusOutComponent, "onFocusOut");
            }
            parentComponent = parentComponent.parentComponent;
          }
        }
        while (component) {
          focusInComponents.push(component);
          invokeListener(component, "onFocusIn");
          component = component.parentComponent;
        }
      }), this.onChange.pipe(map(() => {
        return this.commonAncestorComponent;
      })).subscribe((commonAncestorComponent) => {
        let ranges = null;
        if (commonAncestorComponent) {
          invokeListener(commonAncestorComponent, "onGetRanges", new GetRangesEvent(commonAncestorComponent, (rgs) => {
            ranges = rgs;
          }));
        }
        if (!this.changeFromUpdateCustomRanges) {
          this.customRanges = ranges;
        }
      }), this.onChange.pipe(map(() => {
        var _a, _b, _c;
        if (((_a = this.startSlot) === null || _a === void 0 ? void 0 : _a.parent) === ((_b = this.endSlot) === null || _b === void 0 ? void 0 : _b.parent)) {
          return ((_c = this.startSlot) === null || _c === void 0 ? void 0 : _c.parent) || null;
        }
        return null;
      }), distinctUntilChanged()).subscribe((component) => {
        if (prevFocusComponent) {
          let parentComponent = prevFocusComponent;
          while (parentComponent) {
            if (parentComponent === root.component) {
              invokeListener(prevFocusComponent, "onBlur");
            }
            parentComponent = parentComponent.parentComponent;
          }
        }
        if (component) {
          invokeListener(component, "onFocus");
        }
        prevFocusComponent = component;
      }), this.onChange.pipe(map(() => {
        if (selectedComponent) {
          let p2 = selectedComponent.parentComponent;
          while (p2) {
            if (p2 === root.component) {
              invokeListener(selectedComponent, "onUnselect");
            }
            p2 = p2.parentComponent;
          }
          selectedComponent = null;
        }
        if (!this.isSelected) {
          return null;
        }
        if (this.startSlot === this.endSlot && this.endOffset - this.startOffset === 1) {
          const content = this.startSlot.getContentAtIndex(this.startOffset);
          if (typeof content !== "string") {
            return content;
          }
        }
        return null;
      }), distinctUntilChanged()).subscribe((component) => {
        if (component) {
          invokeListener(component, "onSelected");
          selectedComponent = component;
        }
      }));
      Promise.resolve().then(() => this.nativeSelectionDelegate = true);
    }
    /**
     * 创建选区快照，并可在需要时恢复选区，前提是缓存的插槽和位置还在文档中存在
     */
    createSnapshot() {
      const { anchorSlot, anchorOffset, focusSlot, focusOffset } = this;
      return {
        restore: (syncNative) => {
          this._anchorSlot = anchorSlot;
          this._anchorOffset = anchorOffset;
          this._focusSlot = focusSlot;
          this._focusOffset = focusOffset;
          this.resetStartAndEndPosition();
          if (syncNative) {
            this.restore(true);
          }
        }
      };
    }
    /**
     * 销毁选区
     */
    destroy() {
      this.subscriptions.forEach((i2) => i2.unsubscribe());
      this.subscriptions = [];
    }
    /**
     * 设置自定义选中的区间
     * @param ranges
     */
    setSelectedRanges(ranges) {
      if (ranges.length === 0) {
        this.unSelect();
        return;
      }
      this.changeFromUpdateCustomRanges = true;
      this.customRanges = ranges;
      const start = ranges[0];
      const end = ranges[ranges.length - 1];
      this.setBaseAndExtent(start.slot, start.startIndex, end.slot, end.endIndex);
      this.changeFromUpdateCustomRanges = false;
    }
    /**
     * 设置锚点和焦点的位置
     * @param anchorSlot 锚点插槽
     * @param anchorOffset 锚点偏移量
     * @param focusSlot 焦点插槽
     * @param focusOffset 焦点偏移量
     */
    setBaseAndExtent(anchorSlot, anchorOffset, focusSlot, focusOffset) {
      if (this.controller.readonly) {
        return;
      }
      this._anchorSlot = anchorSlot;
      anchorSlot.retain(anchorOffset);
      this._anchorOffset = anchorSlot.index;
      this._focusSlot = focusSlot;
      focusSlot.retain(focusOffset);
      this._focusOffset = focusSlot.index;
      this.resetStartAndEndPosition();
    }
    /**
     * 获取选区内的选择范围，一般情况下为一个。组件可以 onGetRanges 勾子函数中定制范围个数，如表格中可能为多个
     */
    getRanges() {
      if (this.customRanges) {
        return this.customRanges.map((i2) => {
          return {
            startOffset: i2.startIndex,
            endOffset: i2.endIndex,
            startSlot: i2.slot,
            endSlot: i2.slot
          };
        });
      }
      return this.isSelected ? [{
        startSlot: this.startSlot,
        endSlot: this.endSlot,
        startOffset: this.startOffset,
        endOffset: this.endOffset
      }] : [];
    }
    /**
     * 设置选区的锚点位置
     * @param slot 锚点位置的插槽
     * @param offset 锚点位置索引
     */
    setAnchor(slot, offset) {
      if (this.controller.readonly) {
        return;
      }
      this._anchorSlot = slot;
      slot.retain(offset);
      this._anchorOffset = slot.index;
      this.resetStartAndEndPosition();
    }
    /**
     * 设置选区焦点位置
     * @param slot 焦点位置的插槽
     * @param offset 焦点位置的索引
     */
    setFocus(slot, offset) {
      if (this.controller.readonly) {
        return;
      }
      this._focusSlot = slot;
      slot.retain(offset);
      this._focusOffset = slot.index;
      this.resetStartAndEndPosition();
    }
    /**
     * 设置选区位置
     * @param slot 选区所以插槽
     * @param offset 选区位置索引
     */
    setPosition(slot, offset) {
      if (this.controller.readonly) {
        return;
      }
      this._focusSlot = this._anchorSlot = slot;
      slot.retain(offset);
      this._focusOffset = this._anchorOffset = slot.index;
      this.resetStartAndEndPosition();
    }
    /**
     * 设置选区选择插槽的全部内容
     * @param slot
     */
    selectSlot(slot) {
      this.setBaseAndExtent(slot, 0, slot, slot.length);
    }
    /**
     * 设置选区为组件的第一个位置
     * @param componentInstance
     * @param isRestore
     */
    selectFirstPosition(componentInstance, isRestore = false) {
      const slots = componentInstance.slots;
      if (slots.length) {
        const first = slots.first;
        const { slot, offset } = this.findFirstPosition(first, false);
        this.setBaseAndExtent(slot, offset, slot, offset);
      } else {
        this.selectComponentFront(componentInstance);
      }
      if (isRestore) {
        this.restore();
      }
    }
    /**
     * 设置选区为组件的最后一个位置
     * @param componentInstance
     * @param isRestore
     */
    selectLastPosition(componentInstance, isRestore = false) {
      const slots = componentInstance.slots;
      if (slots.length) {
        const last = slots.last;
        const { slot, offset } = this.findLastPosition(last, false);
        this.setBaseAndExtent(slot, offset, slot, offset);
      } else {
        this.selectComponentEnd(componentInstance);
      }
      if (isRestore) {
        this.restore();
      }
    }
    /**
     * 把选区设置在组件之前
     * @param componentInstance
     * @param isRestore
     */
    selectComponentFront(componentInstance, isRestore = false) {
      const parent = componentInstance.parent;
      if (parent) {
        const index = parent.indexOf(componentInstance);
        this.setBaseAndExtent(parent, index, parent, index);
      } else {
        this.unSelect();
      }
      if (isRestore) {
        this.restore();
      }
    }
    /**
     * 把选区设置在组件之后
     * @param componentInstance
     * @param isRestore
     */
    selectComponentEnd(componentInstance, isRestore = false) {
      const parent = componentInstance.parent;
      if (parent) {
        const index = parent.indexOf(componentInstance);
        this.setBaseAndExtent(parent, index + 1, parent, index + 1);
      } else {
        this.unSelect();
      }
      if (isRestore) {
        this.restore();
      }
    }
    /**
     * 选中组件所有的子插槽
     * @param componentInstance
     * @param isRestore
     */
    selectChildSlots(componentInstance, isRestore = false) {
      const slots = componentInstance.slots;
      if (slots.length) {
        const firstPosition = this.findFirstPosition(slots.first, false);
        const lastPosition = this.findLastPosition(slots.last, false);
        this.setBaseAndExtent(firstPosition.slot, firstPosition.offset, lastPosition.slot, lastPosition.offset);
      } else {
        this.selectComponent(componentInstance, false);
      }
      if (isRestore) {
        this.restore();
      }
    }
    /**
     * 设置选区选择一个组件
     * @param componentInstance 要选择的组件
     * @param isRestore 是否同步触发原生选区，默认为 `false`
     */
    selectComponent(componentInstance, isRestore = false) {
      const parent = componentInstance.parent;
      if (parent) {
        const index = parent.indexOf(componentInstance);
        this.setBaseAndExtent(parent, index, parent, index + 1);
        if (isRestore) {
          this.restore();
        }
      }
    }
    /**
     * 获取选区所选择的块的集合
     * @param decompose 是否按块分解已选中的区域
     */
    getSelectedScopes(decompose = false) {
      if (!this.isSelected) {
        return [];
      }
      if (this.isCollapsed) {
        return [{
          slot: this.startSlot,
          startIndex: this.startOffset,
          endIndex: this.startOffset
        }];
      }
      const scopes = this.getScopes(this.startSlot, this.startOffset, this.endSlot, this.endOffset, true);
      if (decompose) {
        const ranges = [];
        scopes.forEach((i2) => {
          ranges.push(...this.decomposeSlotRange(i2.slot, i2.startIndex, i2.endIndex));
        });
        return ranges;
      }
      return scopes;
    }
    /**
     * 把光标移动到前一个位置
     */
    toPrevious() {
      var _a, _b;
      if (!this.isCollapsed) {
        this.collapse(true);
        this.restore();
        return;
      }
      const { startSlot, startOffset } = this;
      const position = this.getPreviousPosition();
      if (position) {
        this.setPosition(position.slot, position.offset);
        let content = null;
        if (startSlot === this.startSlot) {
          if (startOffset === this.startOffset) {
            const first = this.root.component.slots.first;
            this.setPosition(first, 0);
          } else if (startOffset - this.startOffset === 1) {
            content = startSlot.getContentAtIndex(this.startOffset);
          }
        } else if ((startSlot === null || startSlot === void 0 ? void 0 : startSlot.parent) !== ((_a = this.startSlot) === null || _a === void 0 ? void 0 : _a.parent)) {
          content = ((_b = this.endSlot) === null || _b === void 0 ? void 0 : _b.parent) || null;
        }
        if (content && typeof content !== "string") {
          const event = new Event(content, null);
          invokeListener(content, "onSelectionFromEnd", event);
          if (!event.isPrevented) {
            if (content.slots.length === 0) {
              this.selectComponent(content);
            }
          } else {
            this.setPosition(startSlot, startOffset);
          }
        }
        this.restore();
      }
    }
    /**
     * 把光标移动到后一个位置
     */
    toNext() {
      var _a, _b;
      if (!this.isCollapsed) {
        this.collapse();
        this.restore();
        return;
      }
      const { endSlot, endOffset } = this;
      const position = this.getNextPosition();
      if (position) {
        let offset = position.offset;
        const slot = position.slot;
        while (offset <= slot.length) {
          this.setPosition(slot, offset);
          if (slot.index < offset) {
            offset++;
          } else {
            break;
          }
        }
        let content = null;
        if (endSlot === this.endSlot) {
          if (endOffset === this.endOffset) {
            const last = this.root.component.slots.last;
            this.setPosition(last, last.length);
          } else if (this.endOffset - endOffset === 1) {
            content = endSlot.getContentAtIndex(endOffset);
          }
        } else if ((endSlot === null || endSlot === void 0 ? void 0 : endSlot.parent) !== ((_a = this.endSlot) === null || _a === void 0 ? void 0 : _a.parent)) {
          content = ((_b = this.endSlot) === null || _b === void 0 ? void 0 : _b.parent) || null;
        }
        if (content && typeof content !== "string") {
          const event = new Event(content, null);
          invokeListener(content, "onSelectionFromFront", event);
          if (!event.isPrevented) {
            if (content.slots.length === 0) {
              this.selectComponent(content);
            }
          } else {
            this.setPosition(endSlot, endOffset);
          }
        }
        this.restore();
      }
    }
    /**
     * 把光标移动到上一行
     */
    toPreviousLine() {
      const previousLinePosition = this.bridge.getPreviousLinePositionByCurrent({
        slot: this.focusSlot,
        offset: this.focusOffset
      });
      if (previousLinePosition) {
        this.setPosition(previousLinePosition.slot, previousLinePosition.offset);
        this.restore();
      }
    }
    /**
     * 把光标移动到下一行
     */
    toNextLine() {
      const nextLinePosition = this.bridge.getNextLinePositionByCurrent({
        slot: this.focusSlot,
        offset: this.focusOffset
      });
      if (nextLinePosition) {
        this.setPosition(nextLinePosition.slot, nextLinePosition.offset);
        this.restore();
      }
    }
    /**
     * 向右框选
     */
    wrapToAfter() {
      this.wrapTo(false);
    }
    /**
     * 向左框选
     */
    wrapToBefore() {
      this.wrapTo(true);
    }
    /**
     * 向上一行框选
     */
    wrapToPreviousLine() {
      const previousLinePosition = this.bridge.getPreviousLinePositionByCurrent({
        slot: this.focusSlot,
        offset: this.focusOffset
      });
      if (previousLinePosition) {
        this.setFocus(previousLinePosition.slot, previousLinePosition.offset);
        this.restore();
      }
    }
    /**
     * 向下一行框选
     */
    wrapToNextLine() {
      const nextLinePosition = this.bridge.getNextLinePositionByCurrent({
        slot: this.focusSlot,
        offset: this.focusOffset
      });
      if (nextLinePosition) {
        this.setFocus(nextLinePosition.slot, nextLinePosition.offset);
        this.restore();
      }
    }
    /**
     * 闭合选区
     * @param toStart 是否闭合到结束位置
     */
    collapse(toStart = false) {
      if (toStart) {
        this.setPosition(this.startSlot, this.startOffset);
      } else {
        this.setPosition(this.endSlot, this.endOffset);
      }
    }
    /**
     * 立即同步 Textbus 选区到原生选区
     */
    restore(fromLocal = true) {
      if (this.nativeSelectionDelegate) {
        const focusSlot = this.focusSlot;
        const focusOffset = this.focusOffset;
        const anchorSlot = this.anchorSlot;
        const anchorOffset = this.anchorOffset;
        if (focusSlot && anchorSlot) {
          focusSlot.retain(focusOffset);
          anchorSlot.retain(anchorOffset);
          this.bridge.restore({
            focusOffset,
            focusSlot,
            anchorOffset,
            anchorSlot
          }, fromLocal);
        } else {
          this.bridge.restore(null, fromLocal);
        }
      }
    }
    /**
     * 获取当前选区在文档中的路径
     */
    getPaths() {
      if (!this.isSelected) {
        return {
          anchor: [],
          focus: []
        };
      }
      const anchor = this.getPathsBySlot(this.anchorSlot) || [];
      anchor.push(this.anchorOffset);
      const focus = this.getPathsBySlot(this.focusSlot) || [];
      focus.push(this.focusOffset);
      return {
        anchor,
        focus
      };
    }
    /**
     * 把选区设置为指定的路径
     * @param paths
     */
    usePaths(paths) {
      const anchorPosition = this.findPositionByPath(paths.anchor);
      const focusPosition = this.findPositionByPath(paths.focus);
      if (anchorPosition && focusPosition) {
        this.setBaseAndExtent(anchorPosition.slot, anchorPosition.offset, focusPosition.slot, focusPosition.offset);
      }
    }
    /**
     * 取消选区
     */
    unSelect() {
      this._anchorSlot = this._focusSlot = this._anchorOffset = this._focusOffset = null;
      this.resetStartAndEndPosition();
      this.restore();
    }
    /**
     * 选择整个文档
     */
    selectAll() {
      const { first, last } = this.root.component.slots;
      if (first && last) {
        this.setBaseAndExtent(first, 0, last, last.length);
        this.restore();
      }
    }
    /**
     * 获取下一个选区位置。
     */
    getNextPosition() {
      if (!this.isSelected) {
        return null;
      }
      return this.getNextPositionByPosition(this.focusSlot, this.focusOffset);
    }
    /**
     * 获取上一个选区位置。
     */
    getPreviousPosition() {
      if (!this.isSelected) {
        return null;
      }
      return this.getPreviousPositionByPosition(this.focusSlot, this.focusOffset);
    }
    /**
     * 根据路径获取对应的插槽
     * @param paths
     */
    findSlotByPaths(paths) {
      const result = Selection_1.findTreeNode(paths, this.root.component);
      if (result instanceof Slot) {
        return result;
      }
      return null;
    }
    /**
     * 根据路径获取对应的组件
     * @param paths
     */
    findComponentByPaths(paths) {
      if (paths.length === 0) {
        return this.root.component;
      }
      const result = Selection_1.findTreeNode(paths, this.root.component);
      if (result instanceof Slot) {
        return null;
      }
      return result;
    }
    /**
     * 获取选区内所有的块集合
     */
    getBlocks() {
      const blocks = [];
      if (!this.isSelected) {
        return blocks;
      }
      const scopes = this.getGreedyRanges();
      scopes.forEach((i2) => {
        blocks.push(...this.decomposeSlotRange(i2.slot, i2.startIndex, i2.endIndex));
      });
      return blocks;
    }
    /**
     * 获取开始插槽和结束插槽在公共组件内的下标范围
     */
    getSlotRangeInCommonAncestorComponent() {
      const ancestorComponent = this.commonAncestorComponent;
      if (!ancestorComponent) {
        return null;
      }
      let startSlot = this.startSlot;
      let endSlot = this.endSlot;
      let startOffset;
      let endOffset;
      while (true) {
        const parent = startSlot.parent;
        if (parent === ancestorComponent) {
          startOffset = parent.slots.indexOf(startSlot);
          break;
        }
        if (parent === null || parent === void 0 ? void 0 : parent.parent) {
          startSlot = parent.parent;
        } else {
          return null;
        }
      }
      while (true) {
        const parent = endSlot.parent;
        if (parent === ancestorComponent) {
          endOffset = parent.slots.indexOf(endSlot) + 1;
          break;
        }
        if (parent === null || parent === void 0 ? void 0 : parent.parent) {
          endSlot = parent.parent;
        } else {
          return null;
        }
      }
      if (startOffset >= 0 && endOffset >= 1) {
        return {
          startOffset,
          endOffset,
          component: ancestorComponent
        };
      }
      return null;
    }
    /**
     * 获取当前选区在开始和结束位置均扩展到最大行内内容位置是的块
     */
    getGreedyRanges() {
      if (!this.isSelected) {
        return [];
      }
      return this.getScopes(this.startSlot, Selection_1.getInlineContentStartIndex(this.startSlot, this.startOffset), this.endSlot, Selection_1.getInlineContentEndIndex(this.endSlot, this.endOffset));
    }
    /**
     * 查找插槽内最深的第一个光标位置
     * @param slot
     * @param toChild
     */
    findFirstPosition(slot, toChild = true) {
      const first = slot.getContentAtIndex(0);
      if (toChild && first && typeof first !== "string") {
        const firstChildSlot = first.slots.first;
        if (firstChildSlot) {
          return this.findFirstPosition(firstChildSlot);
        }
      }
      return {
        offset: 0,
        slot
      };
    }
    /**
     * 查的插槽内最深的最后一个光标位置
     * @param slot
     * @param toChild
     */
    findLastPosition(slot, toChild = true) {
      const last = slot.getContentAtIndex(slot.length - 1);
      if (toChild && last && typeof last !== "string") {
        const lastChildSlot = last.slots.last;
        if (lastChildSlot) {
          return this.findLastPosition(lastChildSlot);
        }
      }
      return {
        offset: last === "\n" ? slot.length - 1 : slot.length,
        slot
      };
    }
    /**
     * 获取当前选区在公共插槽的位置
     */
    getCommonAncestorSlotScope() {
      if (!this.isSelected) {
        return null;
      }
      let startSlot = this.startSlot;
      let endSlot = this.endSlot;
      let startChildSlot = this.startSlot;
      let endChildSlot = this.endSlot;
      let startOffset = this.startOffset;
      let endOffset = this.endOffset;
      const commonAncestorSlot = this.commonAncestorSlot;
      const commonAncestorComponent = this.commonAncestorComponent;
      let startChildComponent = null;
      let endChildComponent = null;
      while (startSlot !== commonAncestorSlot) {
        startChildComponent = startSlot.parent;
        if (startChildComponent === commonAncestorComponent) {
          startChildSlot = startSlot;
        }
        startSlot = startChildComponent.parent;
        startOffset = startSlot.indexOf(startChildComponent);
      }
      while (endSlot !== commonAncestorSlot) {
        endChildComponent = endSlot.parent;
        if (endChildComponent === commonAncestorComponent) {
          endChildSlot = endSlot;
        }
        endSlot = endChildComponent.parent;
        endOffset = endSlot.indexOf(endChildComponent);
      }
      return {
        startOffset,
        startSlot,
        startChildComponent,
        endOffset: endOffset + 1,
        endSlot,
        endChildComponent,
        startChildSlot,
        endChildSlot
      };
    }
    /**
     * 获取插槽在文档中的绝对路径
     * @param slot
     */
    getPathsBySlot(slot) {
      const paths = [];
      while (true) {
        const parentComponent = slot.parent;
        if (!parentComponent) {
          return null;
        }
        const slotIndex = parentComponent.slots.indexOf(slot);
        paths.push(slotIndex);
        const parentSlot = parentComponent.parent;
        if (!parentSlot) {
          if (parentComponent !== this.root.component) {
            return null;
          }
          break;
        }
        const componentIndex = parentSlot.indexOf(parentComponent);
        paths.push(componentIndex);
        slot = parentSlot;
      }
      return paths.length ? paths.reverse() : null;
    }
    /**
     * 根据当前位置获取下一个光标位置
     * @param slot
     * @param offset
     */
    getNextPositionByPosition(slot, offset) {
      if (offset === slot.length - 1) {
        const current = slot.getContentAtIndex(offset);
        if (current === "\n") {
          offset++;
        }
      }
      if (offset < slot.length) {
        const current = slot.getContentAtIndex(offset);
        if (typeof current !== "string") {
          const firstChildSlot = current.slots.get(0);
          if (firstChildSlot) {
            return this.findFirstPosition(firstChildSlot);
          }
        }
        return {
          slot,
          offset: offset + current.length
        };
      }
      const cacheSlot = slot;
      while (slot) {
        const parentComponent = slot.parent;
        const slotIndex = parentComponent.slots.indexOf(slot);
        if (slotIndex < parentComponent.slots.length - 1) {
          return this.findFirstPosition(parentComponent.slots.get(slotIndex + 1));
        }
        const parentSlot = parentComponent.parent;
        if (!parentSlot) {
          const len = cacheSlot.length;
          const last = cacheSlot.getContentAtIndex(len - 1);
          return {
            slot: cacheSlot,
            offset: last === "\n" ? len - 1 : len
          };
        }
        const componentIndex = parentSlot.indexOf(parentComponent);
        if (componentIndex < parentSlot.length) {
          if (parentComponent.type !== ContentType.BlockComponent) {
            return {
              slot: parentSlot,
              offset: componentIndex + 1
            };
          }
          const nextContent = parentSlot.getContentAtIndex(componentIndex + 1);
          if (nextContent) {
            if (typeof nextContent !== "string") {
              const nextFirstSlot = nextContent.slots.first;
              if (nextFirstSlot) {
                return this.findFirstPosition(nextFirstSlot);
              }
            }
            return {
              slot: parentSlot,
              offset: componentIndex + 1
            };
          }
        }
        slot = parentSlot;
      }
      return {
        slot: cacheSlot,
        offset: this.endOffset
      };
    }
    /**
     * 根据当前位置，获取下一个光标位置
     * @param slot
     * @param offset
     */
    getPreviousPositionByPosition(slot, offset) {
      if (offset > 0) {
        const prev = slot.getContentAtIndex(offset - 1);
        if (prev && typeof prev !== "string") {
          const lastChildSlot = prev.slots.last;
          if (lastChildSlot) {
            return this.findLastPosition(lastChildSlot);
          }
        }
        return {
          slot,
          offset: offset - prev.length
        };
      }
      let cacheSlot = slot;
      while (slot) {
        const parentComponent = slot.parent;
        const slots = parentComponent.slots;
        const slotIndex = slots.indexOf(slot);
        if (slotIndex > 0) {
          return this.findLastPosition(slots.get(slotIndex - 1));
        }
        const parentSlot = parentComponent.parent;
        if (!parentSlot) {
          return {
            slot: cacheSlot,
            offset: 0
          };
        }
        const componentIndex = parentSlot.indexOf(parentComponent);
        if (componentIndex > 0) {
          const prevContent = parentSlot.getContentAtIndex(componentIndex - 1);
          if (prevContent && typeof prevContent !== "string") {
            const lastChildSlot = prevContent.slots.last;
            if (lastChildSlot) {
              return this.findLastPosition(lastChildSlot);
            }
          }
          return {
            slot: parentSlot,
            offset: prevContent === "\n" ? componentIndex - 1 : componentIndex
          };
        }
        slot = parentSlot;
        cacheSlot = slot;
      }
      return {
        slot: cacheSlot,
        offset: 0
      };
    }
    /**
     * 根据指定的开始位置和结束位置，获取选区中片段
     * @param startSlot
     * @param startIndex
     * @param endSlot
     * @param endIndex
     * @param discardEmptyScope
     */
    getScopes(startSlot, startIndex, endSlot, endIndex, discardEmptyScope = false) {
      const commonAncestorSlot = Selection_1.getCommonAncestorSlot(startSlot, endSlot);
      const commonAncestorComponent = Selection_1.getCommonAncestorComponent(startSlot, endSlot);
      return this.getScopesByRange(startSlot, startIndex, endSlot, endIndex, commonAncestorSlot, commonAncestorComponent, discardEmptyScope);
    }
    /**
     * 根据开始插槽和结束插槽获取最近的公共父组件
     * @param startSlot
     * @param endSlot
     */
    static getCommonAncestorComponent(startSlot, endSlot) {
      let startComponent = startSlot === null || startSlot === void 0 ? void 0 : startSlot.parent;
      let endComponent = endSlot === null || endSlot === void 0 ? void 0 : endSlot.parent;
      if (startComponent === endComponent) {
        return startComponent || null;
      }
      const startPaths = [];
      const endPaths = [];
      while (startComponent) {
        startPaths.push(startComponent);
        const parentSlot = startComponent.parent;
        if (!parentSlot) {
          break;
        }
        startComponent = parentSlot.parent;
      }
      while (endComponent) {
        endPaths.push(endComponent);
        const parentSlot = endComponent.parent;
        if (!parentSlot) {
          break;
        }
        endComponent = parentSlot.parent;
      }
      let f2 = null;
      while (startPaths.length && endPaths.length) {
        const s2 = startPaths.pop();
        const e = endPaths.pop();
        if (s2 === e) {
          f2 = s2;
        } else {
          break;
        }
      }
      return f2;
    }
    /**
     * 根据开始插槽和结束插槽获取最近的公共父插槽
     * @param startSlot
     * @param endSlot
     */
    static getCommonAncestorSlot(startSlot, endSlot) {
      if (startSlot === endSlot) {
        return startSlot;
      }
      const startPaths = [];
      const endPaths = [];
      while (startSlot) {
        startPaths.push(startSlot);
        const parentComponent = startSlot.parent;
        if (!parentComponent) {
          break;
        }
        startSlot = parentComponent.parent;
      }
      while (endSlot) {
        endPaths.push(endSlot);
        const parentComponent = endSlot.parent;
        if (!parentComponent) {
          break;
        }
        endSlot = parentComponent.parent;
      }
      let f2 = null;
      while (startPaths.length && endPaths.length) {
        const s2 = startPaths.pop();
        const e = endPaths.pop();
        if (s2 === e) {
          f2 = s2;
        } else {
          break;
        }
      }
      return f2;
    }
    /**
     * 比较两个绝对路径的前后，当 minPaths 小于 maxPaths 时，返回 true，否则返回 false
     * @param minPaths 假定的小路径
     * @param maxPaths 假定的大路径
     * @param canEqual minPaths 和 maxPaths 是否可以相等
     */
    static compareSelectionPaths(minPaths, maxPaths, canEqual = true) {
      let minIsStart = true;
      let i2 = 0;
      while (true) {
        if (i2 < maxPaths.length) {
          if (i2 < minPaths.length) {
            const min = minPaths[i2];
            const max = maxPaths[i2];
            if (min === max) {
              if (i2 === maxPaths.length - 1 && i2 === minPaths.length - 1) {
                return canEqual;
              }
              i2++;
              continue;
            }
            minIsStart = min < max;
            break;
          } else {
            minIsStart = true;
            break;
          }
        } else {
          minIsStart = false;
          break;
        }
      }
      return minIsStart;
    }
    /**
     * 获取插槽指定位置之前的非 BlockComponent 内容
     * @param slot
     * @param index
     */
    static getInlineContentStartIndex(slot, index) {
      const contents = slot.sliceContent(0, index);
      const len = contents.length;
      for (let i2 = len - 1; i2 >= 0; i2--) {
        const item = contents[i2];
        if (typeof item !== "string" && item.type === ContentType.BlockComponent) {
          break;
        }
        index -= item.length;
      }
      return index;
    }
    /**
     * 获取插槽指定位置之后的非 BlockComponent 内容
     * @param slot
     * @param index
     */
    static getInlineContentEndIndex(slot, index) {
      const contents = slot.sliceContent(index);
      for (let i2 = 0; i2 < contents.length; i2++) {
        const item = contents[i2];
        if (typeof item !== "string" && item.type === ContentType.BlockComponent) {
          break;
        }
        index += item.length;
      }
      return index;
    }
    decomposeSlotRange(slot, startIndex, endIndex) {
      const scopes = [];
      if (startIndex >= endIndex) {
        return scopes;
      }
      let newScope = null;
      let i2 = 0;
      const contents = slot.sliceContent(startIndex, endIndex);
      contents.forEach((c2) => {
        if (typeof c2 !== "string" && c2.type === ContentType.BlockComponent && c2.slots.length !== 0) {
          newScope = null;
          c2.slots.toArray().forEach((s2) => {
            scopes.push(...this.decomposeSlotRange(s2, 0, s2.length));
          });
        } else if (!newScope) {
          newScope = {
            startIndex: startIndex + i2,
            endIndex: startIndex + i2 + c2.length,
            slot
          };
          scopes.push(newScope);
        } else {
          newScope.endIndex = startIndex + i2 + c2.length;
        }
        i2 += c2.length;
      });
      return scopes;
    }
    resetStartAndEndPosition() {
      let focusPaths = [];
      let anchorPaths = [];
      if (this.focusSlot) {
        const _focusPaths = this.getPathsBySlot(this.focusSlot);
        if (_focusPaths) {
          focusPaths = _focusPaths;
          focusPaths.push(this.focusOffset);
        } else {
          this._focusSlot = this._focusOffset = null;
        }
      }
      if (this.anchorSlot) {
        const _anchorPaths = this.getPathsBySlot(this.anchorSlot);
        if (_anchorPaths) {
          anchorPaths = _anchorPaths;
          anchorPaths.push(this.anchorOffset);
        } else {
          this._anchorSlot = this._anchorOffset = null;
        }
      }
      const anchorSlotIsStart = Selection_1.compareSelectionPaths(anchorPaths, focusPaths);
      if (anchorSlotIsStart) {
        this._startSlot = this.anchorSlot;
        this._startOffset = this.anchorOffset;
        this._endSlot = this.focusSlot;
        this._endOffset = this.focusOffset;
      } else {
        this._endSlot = this.anchorSlot;
        this._endOffset = this.anchorOffset;
        this._startSlot = this.focusSlot;
        this._startOffset = this.focusOffset;
      }
      this._commonAncestorSlot = Selection_1.getCommonAncestorSlot(this.startSlot, this.endSlot);
      this._commonAncestorComponent = Selection_1.getCommonAncestorComponent(this.startSlot, this.endSlot);
      this.broadcastChanged();
    }
    wrapTo(toLeft) {
      if (!this.isSelected) {
        return;
      }
      const position = toLeft ? this.getPreviousPositionByPosition(this.focusSlot, this.focusOffset) : this.getNextPositionByPosition(this.focusSlot, this.focusOffset);
      this.setBaseAndExtent(this.anchorSlot, this.anchorOffset, position.slot, position.offset);
      this.restore();
    }
    findPositionByPath(paths) {
      const startPaths = [...paths];
      const offset = startPaths.pop();
      const slot = this.findSlotByPaths(startPaths);
      if (slot) {
        return {
          slot,
          offset
        };
      }
      return null;
    }
    broadcastChanged() {
      this.changeEvent.next(this.isSelected ? {
        focusSlot: this.focusSlot,
        anchorSlot: this.anchorSlot,
        focusOffset: this.focusOffset,
        anchorOffset: this.anchorOffset
      } : null);
    }
    getScopesByRange(startSlot, startIndex, endSlot, endIndex, commonAncestorSlot, commonAncestorComponent, discardEmptyScope = false) {
      const start = [];
      const end = [];
      let startParentComponent = null;
      let endParentComponent = null;
      let startSlotRefIndex = null;
      let endSlotRefIndex = null;
      if (this.customRanges) {
        return this.customRanges;
      }
      while (startSlot !== commonAncestorSlot) {
        start.push({
          startIndex,
          endIndex: startSlot.length,
          slot: startSlot
        });
        startParentComponent = startSlot.parent;
        const childSlots = startParentComponent.slots;
        const end2 = childSlots.indexOf(endSlot);
        startSlotRefIndex = childSlots.indexOf(startSlot);
        if (startParentComponent !== commonAncestorComponent && end2 === -1) {
          start.push(...childSlots.slice(startSlotRefIndex + 1, childSlots.length).map((slot) => {
            return {
              startIndex: 0,
              endIndex: slot.length,
              slot
            };
          }));
        }
        if (!startParentComponent.parent) {
          break;
        }
        startSlot = startParentComponent.parent;
        startIndex = startSlot.indexOf(startParentComponent) + 1;
      }
      while (endSlot !== commonAncestorSlot) {
        end.push({
          startIndex: 0,
          endIndex,
          slot: endSlot
        });
        endParentComponent = endSlot.parent;
        if (!endParentComponent) {
          break;
        }
        const childSlots = endParentComponent.slots;
        const index = childSlots.indexOf(startSlot);
        endSlotRefIndex = childSlots.indexOf(endSlot);
        if (endParentComponent !== commonAncestorComponent && index === -1) {
          end.push(...childSlots.slice(0, endSlotRefIndex).map((slot) => {
            return {
              startIndex: 0,
              endIndex: slot.length,
              slot
            };
          }).reverse());
        }
        if (!endParentComponent.parent) {
          break;
        }
        endSlot = endParentComponent.parent;
        endIndex = endSlot.indexOf(endParentComponent);
      }
      const result = [...start];
      if (startParentComponent && startParentComponent === endParentComponent) {
        const slots = startParentComponent.slots.slice(startSlotRefIndex + 1, endSlotRefIndex);
        result.push(...slots.map((slot) => {
          return {
            startIndex: 0,
            endIndex: slot.length,
            slot
          };
        }));
      } else {
        result.push({
          startIndex,
          endIndex,
          slot: commonAncestorSlot
        });
      }
      result.push(...end.reverse());
      if (discardEmptyScope) {
        return result.filter((item) => {
          return item.slot && item.startIndex < item.endIndex;
        });
      }
      return result;
    }
    static findTreeNode(paths, component) {
      if (typeof component !== "object") {
        return null;
      }
      const firstSlotRefIndex = paths.shift();
      const slot = component.slots.get(firstSlotRefIndex);
      if (paths.length === 0 || !slot) {
        return slot || null;
      }
      const position = paths.shift();
      component = slot.getContentAtIndex(position);
      if (paths.length === 0 || !component) {
        return component || null;
      }
      return Selection_1.findTreeNode(paths, component);
    }
  };
  __decorate$1([
    Prop(),
    __metadata$1(
      "design:type",
      NativeSelectionBridge
      /** 当选区变化时触发 */
    )
  ], Selection.prototype, "bridge", void 0);
  Selection = Selection_1 = __decorate$1([
    Injectable(),
    __metadata$1("design:paramtypes", [
      RootComponentRef,
      Controller
    ])
  ], Selection);
  let Registry = class Registry {
    constructor(textbus, components, attributes, formatters) {
      this.textbus = textbus;
      this.componentMap = /* @__PURE__ */ new Map();
      this.formatMap = /* @__PURE__ */ new Map();
      this.attributeMap = /* @__PURE__ */ new Map();
      components.reverse().forEach((f2) => {
        this.componentMap.set(f2.name, f2);
      });
      attributes.reverse().forEach((f2) => {
        this.attributeMap.set(f2.name, f2);
      });
      formatters.reverse().forEach((f2) => {
        this.formatMap.set(f2.name, f2);
      });
    }
    /**
     * 根据组件名获取组件
     * @param name 组件名
     */
    getComponent(name) {
      return this.componentMap.get(name) || null;
    }
    /**
     * 根据格式名获取格式
     * @param name 格式名
     */
    getFormatter(name) {
      return this.formatMap.get(name) || null;
    }
    /**
     * 根据名字获取 Attribute 实例
     * @param name
     */
    getAttribute(name) {
      return this.attributeMap.get(name) || null;
    }
    /**
     * 根据组件名和数据创建组件
     * @param name
     * @param data
     */
    createComponentByData(name, data) {
      const factory = this.getComponent(name);
      if (factory) {
        return factory.createInstance(this.textbus, data);
      }
      return null;
    }
    /**
     * 根据插槽数据生成插槽实例
     * @param slotLiteral
     * @param customComponentCreator
     */
    createSlot(slotLiteral, customComponentCreator) {
      const slot = new Slot(slotLiteral.schema, slotLiteral.state);
      return this.loadSlot(slot, slotLiteral, customComponentCreator);
    }
    /**
     * 根据组件数据生成组件实例
     * @param componentLiteral
     * @param customSlotCreator
     */
    createComponent(componentLiteral, customSlotCreator) {
      const factory = this.getComponent(componentLiteral.name);
      if (factory) {
        return this.createComponentByFactory(componentLiteral, factory, customSlotCreator);
      }
      return null;
    }
    /**
     * 指定组件创建实例
     * @param componentLiteral
     * @param factory
     * @param customSlotCreator
     */
    createComponentByFactory(componentLiteral, factory, customSlotCreator) {
      const slots = componentLiteral.slots.map(customSlotCreator || ((i2) => this.createSlot(i2)));
      return factory.createInstance(this.textbus, {
        state: componentLiteral.state,
        slots
      });
    }
    /**
     * 将插槽数据填充到指定的插槽
     * @param source
     * @param target
     */
    fillSlot(source, target) {
      return this.loadSlot(target, source);
    }
    loadSlot(slot, slotLiteral, customComponentCreator) {
      slotLiteral.content.forEach((item, index) => {
        if (typeof item !== "string") {
          const component = customComponentCreator ? customComponentCreator(item, index) : this.createComponent(item);
          if (component) {
            slot.insert(component);
          }
          return;
        }
        slot.insert(item);
      });
      Object.keys(slotLiteral.formats).forEach((key) => {
        const formatter = this.getFormatter(key);
        if (formatter) {
          slotLiteral.formats[key].forEach((i2) => {
            slot.retain(i2.startIndex);
            slot.retain(i2.endIndex - i2.startIndex, formatter, i2.value);
          });
        }
      });
      if (slotLiteral.attributes !== null && typeof slotLiteral.attributes === "object") {
        Object.keys(slotLiteral.attributes).forEach((key) => {
          const attribute = this.attributeMap.get(key);
          if (attribute) {
            slot.setAttribute(attribute, slotLiteral.attributes[key]);
          }
        });
      }
      return slot;
    }
  };
  Registry = __decorate$1([
    Injectable(),
    __param$1(1, Inject(COMPONENT_LIST)),
    __param$1(2, Inject(ATTRIBUTE_LIST)),
    __param$1(3, Inject(FORMATTER_LIST)),
    __metadata$1("design:paramtypes", [Textbus, Array, Array, Array])
  ], Registry);
  function getInsertPosition(slot, offset, content, excludeSlots = []) {
    if (canInsert(content, slot)) {
      return {
        slot,
        offset
      };
    }
    excludeSlots.push(slot);
    return getNextInsertPosition(slot, content, excludeSlots);
  }
  function canInsert(content, target) {
    const insertType = typeof content === "string" ? ContentType.Text : content.type;
    return target.schema.includes(insertType);
  }
  function getNextInsertPosition(currentSlot, content, excludeSlots) {
    const parentComponent = currentSlot.parent;
    const slotIndex = parentComponent.slots.indexOf(currentSlot);
    if (currentSlot !== parentComponent.slots.last) {
      return getInsertPosition(parentComponent.slots.get(slotIndex + 1), 0, content, excludeSlots);
    }
    const parentSlot = parentComponent.parent;
    if (!parentSlot) {
      return null;
    }
    if (excludeSlots.includes(parentSlot)) {
      return getNextInsertPosition(parentSlot, content, excludeSlots);
    }
    const index = parentSlot.indexOf(parentComponent);
    const position = getInsertPosition(parentSlot, index + 1, content, excludeSlots);
    if (position) {
      return position;
    }
    excludeSlots.push(parentSlot);
    const afterContent = parentSlot.sliceContent(index + 1);
    const firstComponent = afterContent.filter((i2) => {
      return typeof i2 !== "string";
    }).shift();
    if (firstComponent && firstComponent.slots.length) {
      return getInsertPosition(firstComponent.slots.get(0), 0, content, excludeSlots);
    }
    return getNextInsertPosition(parentSlot, content, excludeSlots);
  }
  function deleteUpBySlot(selection, slot, offset, rootComponent2, deleteBefore) {
    const parentComponent = slot.parent;
    if (!parentComponent) {
      return {
        slot,
        offset
      };
    }
    const parentSlot = parentComponent.parent;
    if (!parentSlot) {
      return {
        slot,
        offset
      };
    }
    const index = parentSlot.indexOf(parentComponent);
    if (parentComponent.slots.length === 1) {
      if (parentComponent === rootComponent2) {
        return {
          slot,
          offset
        };
      }
      const event2 = new Event(parentSlot, {
        index,
        count: 1,
        toEnd: !deleteBefore,
        actionType: "delete"
      });
      invokeListener(parentSlot.parent, "onContentDelete", event2);
      if (event2.isPrevented) {
        return {
          slot,
          offset
        };
      }
      parentSlot.retain(index);
      parentSlot.delete(1);
      invokeListener(parentSlot.parent, "onContentDeleted", new Event(parentSlot, null));
      if (parentSlot.isEmpty) {
        return deleteUpBySlot(selection, parentSlot, index, rootComponent2, deleteBefore);
      }
      return {
        slot: parentSlot,
        offset: parentSlot.index
      };
    }
    const slotIndex = parentComponent.slots.indexOf(slot);
    const position = slotIndex === 0 ? {
      slot: parentSlot,
      offset: index
    } : selection.findLastPosition(parentComponent.slots.get(slotIndex - 1), true);
    const event = new Event(parentComponent, {
      index: slotIndex,
      count: 1,
      toEnd: !deleteBefore,
      actionType: "delete"
    });
    invokeListener(parentComponent, "onSlotRemove", event);
    if (!event.isPrevented) {
      const isSuccess = parentComponent.slots.remove(slot);
      if (isSuccess) {
        invokeListener(parentComponent, "onSlotRemoved", new Event(parentComponent, null));
      }
      return position;
    }
    return {
      slot,
      offset
    };
  }
  function deltaToSlots(selection, source, delta, rule, abstractSelection, offset) {
    const parentComponent = source.parent;
    const context = {
      slotState: source.state,
      parentComponentName: parentComponent.name,
      parentComponentState: parentComponent.state
    };
    let newSlot = rule.slotFactory(context);
    delta.attributes.forEach((value, key) => {
      newSlot.setAttribute(key, value);
    });
    const newSlots = [newSlot];
    let index = 0;
    while (delta.length) {
      const { insert, formats } = delta.shift();
      const b2 = canInsert(insert, newSlot);
      const oldIndex = index;
      index += insert.length;
      if (b2) {
        newSlot.insert(insert, formats);
        if (source === abstractSelection.anchorSlot && abstractSelection.anchorOffset - offset >= oldIndex && abstractSelection.anchorOffset - offset <= index) {
          abstractSelection.anchorSlot = newSlot;
          abstractSelection.anchorOffset -= offset;
        }
        if (source === abstractSelection.focusSlot && abstractSelection.focusOffset - offset >= oldIndex && abstractSelection.focusOffset - offset <= index) {
          abstractSelection.focusSlot = newSlot;
          abstractSelection.focusOffset -= offset;
        }
        continue;
      }
      if (abstractSelection.anchorOffset > index) {
        abstractSelection.anchorOffset -= index;
      }
      if (abstractSelection.focusOffset > index) {
        abstractSelection.focusOffset -= index;
      }
      if (typeof insert !== "string") {
        const slots = insert.slots.toArray().map((childSlot) => {
          return deltaToSlots(selection, source, childSlot.toDelta(), rule, abstractSelection, offset);
        }).flat();
        newSlots.push(...slots);
      }
      newSlot = rule.slotFactory(context);
      delta.attributes.forEach((value, key) => {
        newSlot.setAttribute(key, value);
      });
    }
    return newSlots;
  }
  function slotsToComponents(textbus, slots, rule) {
    var _a;
    const componentInstances = [];
    if (!slots.length) {
      return componentInstances;
    }
    if (rule.multipleSlot) {
      componentInstances.push(rule.target.createInstance(textbus, {
        state: (_a = rule.stateFactory) === null || _a === void 0 ? void 0 : _a.call(rule),
        slots
      }));
    } else {
      slots.forEach((childSlot) => {
        var _a2;
        componentInstances.push(rule.target.createInstance(textbus, {
          state: (_a2 = rule.stateFactory) === null || _a2 === void 0 ? void 0 : _a2.call(rule),
          slots: [childSlot]
        }));
      });
    }
    return componentInstances;
  }
  function getBlockRangeToBegin(slot, offset) {
    let startIndex = offset;
    const content = slot.sliceContent(0, offset);
    while (content.length) {
      const item = content.pop();
      if (typeof item !== "string" && item.type === ContentType.BlockComponent) {
        break;
      }
      startIndex -= item.length;
    }
    return {
      slot,
      startIndex,
      endIndex: offset
    };
  }
  let Commander = class Commander {
    constructor(selection, platform, textbus, registry, rootComponentRef) {
      this.selection = selection;
      this.platform = platform;
      this.textbus = textbus;
      this.registry = registry;
      this.rootComponentRef = rootComponentRef;
    }
    /**
     * 将选区内容转换为指定组件
     * @param rule
     */
    transform(rule) {
      const selection = this.selection;
      if (!selection.isSelected) {
        return false;
      }
      const abstractSelection = {
        anchorSlot: selection.anchorSlot,
        anchorOffset: selection.anchorOffset,
        focusSlot: selection.focusSlot,
        focusOffset: selection.focusOffset
      };
      const ranges = selection.getRanges();
      for (let i2 = 0; i2 < ranges.length; i2++) {
        const range = ranges[i2];
        const isTransformed = this.transformByRange(rule, abstractSelection, range);
        if (!isTransformed) {
          break;
        }
      }
      selection.setBaseAndExtent(abstractSelection.anchorSlot, abstractSelection.anchorOffset, abstractSelection.focusSlot, abstractSelection.focusOffset);
      return true;
    }
    write(content, formatter, value) {
      const selection = this.selection;
      const canInsert2 = selection.isCollapsed ? true : this.delete();
      if (!canInsert2) {
        return false;
      }
      const position = getInsertPosition(selection.startSlot, selection.startOffset, content);
      if (!position) {
        return false;
      }
      const nextFormats = position.slot.extractFormatsByIndex(position.offset + 1);
      let formats = position.slot.extractFormatsByIndex(position.offset).filter((i2) => {
        return i2[0].inheritable || nextFormats.some((value2) => {
          return value2[0] === i2[0] && value2[1] === i2[1];
        });
      });
      if (formatter) {
        if (Array.isArray(formatter)) {
          formats = [
            ...formats,
            ...formatter
          ];
        } else {
          formats.push([formatter, value]);
        }
      }
      return this.insert(content, formats);
    }
    insert(content, formatter, value) {
      const selection = this.selection;
      const canInsert2 = selection.isCollapsed ? true : this.delete();
      if (!canInsert2) {
        return false;
      }
      let formats = [];
      if (formatter) {
        if (Array.isArray(formatter)) {
          formats = formatter;
        } else {
          formats.push([formatter, value]);
        }
      }
      const position = getInsertPosition(selection.startSlot, selection.startOffset, content);
      if (!position) {
        return false;
      }
      const { slot, offset } = position;
      const event = new Event(slot, {
        index: offset,
        content,
        formats
      });
      invokeListener(slot.parent, "onContentInsert", event);
      if (!event.isPrevented) {
        slot.retain(offset);
        slot.insert(content, formats);
        const insertedEvent = new Event(slot, {
          index: offset,
          content,
          formats
        });
        invokeListener(slot.parent, "onContentInserted", insertedEvent);
        if (!insertedEvent.isPrevented) {
          selection.setBaseAndExtent(slot, slot.index, slot, slot.index);
        }
      }
      return !event.isPrevented;
    }
    delete(receiver, deleteBefore = true) {
      if (typeof receiver === "boolean") {
        deleteBefore = receiver;
        receiver = function() {
        };
      } else if (typeof receiver !== "function") {
        receiver = function() {
        };
      }
      const selection = this.selection;
      if (!selection.isSelected) {
        return false;
      }
      let endSlot = selection.endSlot;
      let endOffset = selection.endOffset;
      let startSlot = selection.startSlot;
      let startOffset = selection.startOffset;
      let isDeleteRanges = true;
      if (selection.isCollapsed) {
        if (deleteBefore) {
          if (startOffset === 0) {
            isDeleteRanges = false;
          }
          const prevPosition = selection.getPreviousPosition();
          startSlot = prevPosition.slot;
          startOffset = prevPosition.offset;
        } else {
          const nextPosition = selection.getNextPosition();
          endSlot = nextPosition.slot;
          endOffset = nextPosition.offset;
        }
      }
      if (startSlot === endSlot && startOffset === endOffset) {
        if (startSlot.isEmpty) {
          receiver(startSlot.cut());
          const position = deleteUpBySlot(selection, startSlot, startOffset, this.rootComponentRef.component, deleteBefore);
          selection.setBaseAndExtent(position.slot, position.offset, position.slot, position.offset);
          return position.slot !== startSlot || position.offset !== startOffset;
        }
        return false;
      }
      const scopes = selection.getScopes(startSlot, startOffset, endSlot, endOffset, true);
      let endCutIndex = endOffset;
      while (isDeleteRanges && scopes.length) {
        const lastScope = scopes.pop();
        const { slot, startIndex } = lastScope;
        const endIndex = lastScope.endIndex;
        const isFocusEnd = selection.focusSlot === slot && selection.focusOffset === endIndex;
        const event = new Event(slot, {
          index: startIndex,
          count: endIndex - startIndex,
          toEnd: !deleteBefore,
          actionType: "delete"
        });
        invokeListener(slot.parent, "onContentDelete", event);
        if (event.isPrevented) {
          return false;
        }
        const deletedSlot = slot.cut(startIndex, endIndex);
        receiver(deletedSlot);
        const deletedEvent = new Event(slot, null);
        invokeListener(slot.parent, "onContentDeleted", deletedEvent);
        if (deletedEvent.isPrevented) {
          if (isFocusEnd) {
            selection.setFocus(slot, endIndex);
          } else {
            selection.setAnchor(slot, endIndex);
          }
          return false;
        }
        if (slot === endSlot) {
          endCutIndex = startIndex;
        }
        if (slot !== startSlot && slot !== endSlot && slot.isEmpty) {
          const position = deleteUpBySlot(selection, slot, startIndex, this.rootComponentRef.component, deleteBefore);
          if (position.slot === endSlot) {
            endCutIndex = position.offset;
          }
        }
      }
      if (startSlot !== endSlot) {
        const event = new Event(endSlot, {
          index: endCutIndex,
          count: endSlot.length,
          toEnd: !deleteBefore,
          actionType: "move"
        });
        invokeListener(endSlot.parent, "onContentDelete", event);
        if (event.isPrevented) {
          return false;
        }
        const deletedSlot = endSlot.cut(endCutIndex);
        receiver(deletedSlot);
        const deletedEvent = new Event(endSlot, null);
        invokeListener(endSlot.parent, "onContentDeleted", deletedEvent);
        if (!deletedEvent.isPrevented) {
          if (endSlot.isEmpty) {
            deleteUpBySlot(selection, endSlot, 0, this.rootComponentRef.component, deleteBefore);
          }
        }
        if (!deletedSlot.isEmpty) {
          const deletedDelta = deletedSlot.toDelta();
          selection.setPosition(startSlot, startOffset);
          deletedDelta.forEach((item) => {
            this.insert(item.insert, item.formats);
          });
        }
        if (deletedEvent.isPrevented) {
          return false;
        }
      }
      selection.setBaseAndExtent(startSlot, startOffset, startSlot, startOffset);
      return true;
    }
    /**
     * 在当前选区内触发换行操作，如果选区未闭合，则先删除选区内容，再触发回车操作
     */
    break() {
      const selection = this.selection;
      if (!selection.isSelected) {
        return false;
      }
      if (!selection.isCollapsed) {
        const isCollapsed = this.delete(false);
        if (!isCollapsed) {
          return false;
        }
      }
      const startSlot = this.selection.startSlot;
      const event = new Event(startSlot, {
        index: this.selection.startOffset
      });
      invokeListener(startSlot.parent, "onBreak", event);
      if (!event.isPrevented) {
        const startOffset = this.selection.startOffset;
        const isToEnd = startOffset === startSlot.length || startSlot.isEmpty;
        const content = isToEnd ? "\n\n" : "\n";
        const isInserted = this.write(content);
        if (isInserted && isToEnd) {
          this.selection.setPosition(startSlot, startOffset + 1);
        }
      }
      return !event.isPrevented;
    }
    /**
     * 在指定组件前插入新的组件
     * @param newChild 要插入的组件
     * @param ref 新组件插入组件位置的引用
     */
    insertBefore(newChild, ref2) {
      const parentSlot = ref2 === null || ref2 === void 0 ? void 0 : ref2.parent;
      if (parentSlot) {
        const index = parentSlot.indexOf(ref2);
        this.selection.setBaseAndExtent(parentSlot, index, parentSlot, index);
        return this.insert(newChild);
      }
      return false;
    }
    /**
     * 在指定组件后插入新的组件
     * @param newChild 要插入的组件
     * @param ref 新组件插入组件位置的引用
     */
    insertAfter(newChild, ref2) {
      const parentSlot = ref2 === null || ref2 === void 0 ? void 0 : ref2.parent;
      if (parentSlot) {
        const index = parentSlot.indexOf(ref2) + 1;
        this.selection.setBaseAndExtent(parentSlot, index, parentSlot, index);
        return this.insert(newChild);
      }
      return false;
    }
    /**
     * 用新组件替换旧组件
     * @param oldComponent 要删除的组件
     * @param newComponent 新插入的组件
     */
    replaceComponent(oldComponent, newComponent) {
      const b2 = this.removeComponent(oldComponent);
      if (b2) {
        return this.insert(newComponent);
      }
      return false;
    }
    /**
     * 复制当前选区内容
     */
    copy() {
      this.platform.copy();
    }
    /**
     * 剪切当前选区内容
     */
    cut() {
      this.copy();
      if (this.selection.isCollapsed) {
        return false;
      }
      return this.delete();
    }
    /**
     * 在当前选区粘贴新内容，当选区未闭合时，会先删除选区内容，再粘贴新内容
     * @param pasteSlot 要粘贴的数据
     * @param text 要粘贴的文本
     */
    paste(pasteSlot, text) {
      if (pasteSlot.isEmpty) {
        return false;
      }
      const selection = this.selection;
      if (!selection.isSelected) {
        return false;
      }
      if (!selection.isCollapsed) {
        this.delete();
      }
      const component = selection.commonAncestorComponent;
      const slot = selection.commonAncestorSlot;
      const event = new Event(slot, {
        index: selection.startOffset,
        data: pasteSlot,
        text
      });
      invokeListener(component, "onPaste", event);
      if (!event.isPrevented) {
        const delta = pasteSlot.toDelta();
        const afterDelta = new DeltaLite();
        while (delta.length) {
          const { insert, formats } = delta.shift();
          const commonAncestorSlot = selection.commonAncestorSlot;
          if (canInsert(insert, commonAncestorSlot)) {
            this.insert(insert, formats);
            continue;
          }
          afterDelta.push(...commonAncestorSlot.cut(selection.startOffset).toDelta());
          const parentComponent = commonAncestorSlot.parent;
          if (commonAncestorSlot === parentComponent.slots.last) {
            this.insert(insert, formats);
            continue;
          }
          if (parentComponent.separable) {
            const index = parentComponent.slots.indexOf(commonAncestorSlot);
            const nextSlots = parentComponent.slots.cut(index + 1);
            const nextComponent = this.registry.createComponentByData(parentComponent.name, {
              state: typeof parentComponent.state === "object" && parentComponent.state !== null ? JSON.parse(JSON.stringify(parentComponent.state)) : parentComponent.state,
              slots: nextSlots
            });
            afterDelta.push({
              insert: nextComponent,
              formats: []
            });
            this.insert(insert, formats);
            continue;
          }
          if (typeof insert === "string") {
            this.insert(insert, formats);
            continue;
          }
          for (const childSlot of insert.slots.toArray()) {
            delta.unshift(...childSlot.toDelta());
          }
        }
        const snapshot = this.selection.createSnapshot();
        while (afterDelta.length) {
          const { insert, formats } = afterDelta.shift();
          this.insert(insert, formats);
        }
        snapshot.restore();
        const currentContent = selection.startSlot.getContentAtIndex(selection.startOffset);
        if (currentContent && typeof currentContent !== "string" && currentContent.type === ContentType.BlockComponent && currentContent.slots.length > 0) {
          selection.toNext();
        }
      }
      return !event.isPrevented;
    }
    /**
     * 清除当前选区的所有格式
     * @param excludeFormatters 在清除格式时，排除的格式
     */
    cleanFormats(excludeFormatters = []) {
      this.selection.getSelectedScopes().forEach((scope) => {
        const slot = scope.slot;
        if (scope.startIndex === 0) {
          if (scope.endIndex === slot.length - 1) {
            const lastContent = slot.getContentAtIndex(slot.length - 1);
            if (lastContent === "\n") {
              scope.endIndex++;
            }
          }
        }
        slot.cleanFormats(excludeFormatters, scope.startIndex, scope.endIndex);
      });
    }
    /**
     * 给当前选区应用新的格式
     * @param formatter 要应用的格式
     * @param value 当前格式要应用的值
     */
    applyFormat(formatter, value) {
      if (this.selection.isCollapsed) {
        const slot = this.selection.commonAncestorSlot;
        if (slot.isEmpty) {
          slot.retain(0);
          slot.retain(slot.length, formatter, value);
        } else {
          this.write(Slot.placeholder);
          const startOffset = this.selection.startOffset;
          slot.retain(startOffset - 1);
          slot.retain(1, formatter, value);
        }
        return;
      }
      this.selection.getSelectedScopes().forEach((i2) => {
        i2.slot.retain(i2.startIndex);
        i2.slot.retain(i2.endIndex - i2.startIndex, formatter, value);
      });
    }
    /**
     * 清除当前选区特定的格式
     * @param formatter 要清除的格式
     */
    unApplyFormat(formatter) {
      if (this.selection.isCollapsed) {
        const slot = this.selection.commonAncestorSlot;
        if (slot.isEmpty) {
          slot.retain(0);
          slot.retain(slot.length, formatter, null);
        } else {
          const startOffset = this.selection.startOffset;
          const prevContent = slot.getContentAtIndex(startOffset - 1);
          if (prevContent === Slot.placeholder) {
            slot.retain(startOffset - 1);
            slot.retain(1, formatter, null);
          } else {
            this.write(Slot.placeholder);
            slot.retain(startOffset);
            slot.retain(1, formatter, null);
          }
        }
        return;
      }
      this.selection.getSelectedScopes().forEach((i2) => {
        i2.slot.retain(i2.startIndex);
        i2.slot.retain(i2.endIndex - i2.startIndex, formatter, null);
      });
    }
    /**
     * 根据选区应用插槽属性
     * @param attribute
     * @param value
     */
    applyAttribute(attribute, value) {
      if (this.selection.isCollapsed) {
        const slot = this.selection.commonAncestorSlot;
        slot.setAttribute(attribute, value);
        return;
      }
      this.selection.getSelectedScopes().forEach((i2) => {
        const contents = i2.slot.sliceContent(i2.startIndex, i2.endIndex);
        const childComponents = [];
        let hasInlineContent = false;
        contents.forEach((item) => {
          if (typeof item === "string" || item.type === ContentType.InlineComponent) {
            hasInlineContent = true;
          } else {
            childComponents.push(item);
          }
        });
        if (hasInlineContent) {
          i2.slot.setAttribute(attribute, value);
        } else {
          childComponents.forEach((i3) => {
            i3.slots.toArray().forEach((slot) => {
              slot.setAttribute(attribute, value);
            });
          });
        }
      });
    }
    /**
     * 根据选区清除插槽属性
     * @param attribute
     */
    unApplyAttribute(attribute) {
      if (this.selection.isCollapsed) {
        const slot = this.selection.commonAncestorSlot;
        slot.removeAttribute(attribute);
        return;
      }
      this.selection.getSelectedScopes().forEach((i2) => {
        const contents = i2.slot.sliceContent(i2.startIndex, i2.endIndex);
        const childComponents = [];
        let hasString = false;
        contents.forEach((item) => {
          if (typeof item !== "string") {
            childComponents.push(item);
          } else {
            hasString = true;
          }
        });
        if (hasString) {
          i2.slot.removeAttribute(attribute);
        } else {
          childComponents.forEach((i3) => {
            i3.slots.toArray().forEach((slot) => {
              slot.removeAttribute(attribute);
            });
          });
        }
      });
    }
    /**
     * 根据选区清除属性
     */
    cleanAttributes(excludeAttributes = []) {
      this.selection.getSelectedScopes().forEach((i2) => {
        const contents = i2.slot.sliceContent(i2.startIndex, i2.endIndex);
        const childComponents = [];
        let hasString = false;
        contents.forEach((item) => {
          if (typeof item !== "string") {
            childComponents.push(item);
          } else {
            hasString = true;
          }
        });
        if (hasString) {
          i2.slot.cleanAttributes(excludeAttributes);
        } else {
          childComponents.forEach((i3) => {
            i3.slots.toArray().forEach((slot) => {
              slot.cleanAttributes(excludeAttributes);
            });
          });
        }
      });
    }
    /**
     * 删除指定组件
     * @param component
     */
    removeComponent(component) {
      const parentSlot = component === null || component === void 0 ? void 0 : component.parent;
      if (parentSlot) {
        const index = parentSlot.indexOf(component);
        this.selection.setBaseAndExtent(parentSlot, index, parentSlot, index + 1);
        return this.delete();
      }
      return false;
    }
    transformByRange(rule, abstractSelection, range) {
      const { startSlot, startOffset, endSlot, endOffset } = range;
      const selection = this.selection;
      const commonAncestorSlot = Selection.getCommonAncestorSlot(startSlot, endSlot);
      const commonAncestorComponent = Selection.getCommonAncestorComponent(startSlot, endSlot);
      if (!commonAncestorSlot || !commonAncestorComponent) {
        return false;
      }
      let stoppedComponent;
      if (commonAncestorSlot.parent !== commonAncestorComponent || abstractSelection.anchorSlot === commonAncestorSlot && abstractSelection.focusSlot === commonAncestorSlot) {
        stoppedComponent = commonAncestorComponent.parentComponent;
      } else {
        stoppedComponent = commonAncestorComponent;
      }
      const stoppedScope = {
        slot: startSlot,
        offset: Selection.getInlineContentStartIndex(startSlot, startOffset)
      };
      let startScope = {
        slot: endSlot,
        offset: Selection.getInlineContentEndIndex(endSlot, endOffset)
      };
      const parentComponent = startScope.slot.parent;
      if (parentComponent.separable) {
        if (startScope.slot !== parentComponent.slots.last) {
          const slotIndex = parentComponent.slots.indexOf(startScope.slot);
          const count = parentComponent.slots.length - slotIndex;
          const event = new Event(parentComponent, {
            index: slotIndex + 1,
            count: count - 1,
            toEnd: false
          });
          invokeListener(parentComponent, "onSlotRemove", event);
          if (!event.isPrevented) {
            const deletedSlots = parentComponent.slots.cut(slotIndex + 1, slotIndex + count);
            const newState = typeof parentComponent.state === "object" ? JSON.parse(JSON.stringify(parentComponent.state)) : parentComponent.state;
            let afterComponent = null;
            if (typeof rule.existingComponentTransformer === "function") {
              afterComponent = rule.existingComponentTransformer(parentComponent.name, deletedSlots, newState) || null;
            }
            if (!afterComponent) {
              afterComponent = this.registry.createComponentByData(parentComponent.name, {
                state: newState,
                slots: deletedSlots
              });
            }
            this.insertAfter(afterComponent, parentComponent);
          }
        }
      }
      let slots = [];
      let position = null;
      while (true) {
        const endPaths = selection.getPathsBySlot(startScope.slot);
        if (!endPaths) {
          break;
        }
        endPaths.push(startScope.offset);
        const startPaths = selection.getPathsBySlot(stoppedScope.slot);
        if (!startPaths) {
          break;
        }
        startPaths.push(stoppedScope.offset);
        if (!Selection.compareSelectionPaths(startPaths, endPaths)) {
          break;
        }
        const scope = startScope.slot.isEmpty ? {
          slot: startScope.slot,
          startIndex: 0,
          endIndex: 0
        } : getBlockRangeToBegin(startScope.slot, startScope.offset);
        const { slot, startIndex, endIndex } = scope;
        const parentComponent2 = slot.parent;
        if (!parentComponent2.separable && parentComponent2.slots.length > 1 && !slot.schema.includes(rule.target.instanceType)) {
          const componentInstances2 = slotsToComponents(this.textbus, slots, rule);
          componentInstances2.forEach((instance) => {
            this.insert(instance);
          });
          slots = [];
          startScope = selection.getPreviousPositionByPosition(slot, 0);
          position = null;
          continue;
        }
        selection.setBaseAndExtent(slot, startIndex, slot, endIndex);
        if (slot.isEmpty) {
          startScope = selection.getPreviousPositionByPosition(slot, 0);
          if (startScope.slot === slot && startScope.offset === startIndex) {
            if (position) {
              selection.setPosition(position.slot, position.offset);
            }
            break;
          }
          if (parentComponent2.separable || parentComponent2.slots.length === 1) {
            const delta = slot.toDelta();
            slots.unshift(...deltaToSlots(selection, slot, delta, rule, abstractSelection, 0));
            position = deleteUpBySlot(selection, slot, 0, stoppedComponent, false);
          } else {
            const componentInstances2 = slotsToComponents(this.textbus, slots, rule);
            slots = [];
            selection.selectComponentEnd(parentComponent2);
            componentInstances2.forEach((instance) => {
              this.insert(instance);
            });
            position = null;
          }
        } else {
          startScope = selection.getPreviousPositionByPosition(slot, startIndex);
          if (startScope.slot === slot && startScope.offset === startIndex) {
            if (position) {
              selection.setPosition(position.slot, position.offset);
            }
            break;
          }
          if (startIndex === endIndex) {
            const componentInstances2 = slotsToComponents(this.textbus, slots, rule);
            slots = [];
            componentInstances2.forEach((instance) => {
              this.insert(instance);
            });
            continue;
          }
          this.delete((deletedSlot) => {
            if (parentComponent2.separable || parentComponent2.slots.length === 1) {
              const delta2 = deletedSlot.toDelta();
              slots.unshift(...deltaToSlots(selection, slot, delta2, rule, abstractSelection, startIndex));
              if (startIndex > 0) {
                startScope = selection.getPreviousPositionByPosition(slot, startIndex);
                position = {
                  slot,
                  offset: startIndex
                };
                return;
              }
              position = deleteUpBySlot(selection, slot, 0, stoppedComponent, false);
              return;
            }
            position = null;
            let componentInstances2 = slotsToComponents(this.textbus, slots, rule);
            slots = [];
            selection.selectComponentEnd(parentComponent2);
            componentInstances2.forEach((instance) => {
              this.insert(instance);
            });
            const delta = deletedSlot.toDelta();
            const dumpSlots = deltaToSlots(selection, slot, delta, rule, abstractSelection, startIndex);
            componentInstances2 = slotsToComponents(this.textbus, dumpSlots, rule);
            componentInstances2.forEach((instance, index) => {
              selection.setPosition(slot, index + startIndex);
              this.insert(instance);
            });
            if (startIndex > 0) {
              startScope = selection.getPreviousPositionByPosition(slot, startIndex);
              position = {
                slot,
                offset: startIndex
              };
            }
          });
        }
        if (position) {
          selection.setPosition(position.slot, position.offset);
        }
        if (scope.slot === stoppedScope.slot && scope.endIndex === stoppedScope.offset) {
          break;
        }
      }
      const componentInstances = slotsToComponents(this.textbus, slots, rule);
      componentInstances.forEach((instance) => {
        this.insert(instance);
      });
      return true;
    }
  };
  Commander = __decorate$1([
    Injectable(),
    __metadata$1("design:paramtypes", [
      Selection,
      ViewAdapter,
      Textbus,
      Registry,
      RootComponentRef
    ])
  ], Commander);
  var Scheduler_1;
  var ChangeOrigin;
  (function(ChangeOrigin2) {
    ChangeOrigin2[ChangeOrigin2["History"] = 0] = "History";
    ChangeOrigin2[ChangeOrigin2["Local"] = 1] = "Local";
    ChangeOrigin2[ChangeOrigin2["Remote"] = 2] = "Remote";
  })(ChangeOrigin || (ChangeOrigin = {}));
  let Scheduler = Scheduler_1 = class Scheduler {
    /**
     * 最后一次文档变更是否包含本地变更
     */
    get lastChangesHasLocalUpdate() {
      return this._lastChangesHasLocalUpdate;
    }
    /**
     * 最后一次文档变更是否包含远程变更
     */
    get lastChangesHasRemoteUpdate() {
      return this._lastChangesHasRemoteUpdate;
    }
    constructor(rootComponentRef, viewAdapter, selection) {
      this.rootComponentRef = rootComponentRef;
      this.viewAdapter = viewAdapter;
      this.selection = selection;
      this._lastChangesHasLocalUpdate = true;
      this._lastChangesHasRemoteUpdate = false;
      this.changeFromRemote = false;
      this.changeFromHistory = false;
      this.instanceList = /* @__PURE__ */ new Set();
      this.docChangedEvent = new Subject();
      this.docChangeEvent = new Subject();
      this.localChangeBeforeEvent = new Subject();
      this.subs = [];
      this.onDocChanged = this.docChangedEvent.asObservable();
      this.onDocChange = this.docChangeEvent.asObservable();
      this.onLocalChangeBefore = this.localChangeBeforeEvent.asObservable();
      this.onDocFirstChangeFromLocal = this.onLocalChangeBefore.pipe(take(1));
    }
    /**
     * 远程更新文档事务
     * @param task 事务处理函数
     */
    remoteUpdateTransact(task) {
      this.changeFromRemote = true;
      task();
      this.changeFromRemote = false;
    }
    /**
     * 历史记录更新文档事务
     * @param task 事务处理函数
     */
    historyApplyTransact(task) {
      this.changeFromHistory = true;
      task();
      this.changeFromHistory = false;
    }
    /**
     * 启动调度器，并兼听文档变更自动渲染文档
     */
    run() {
      const rootComponent2 = this.rootComponentRef.component;
      const changeMarker = rootComponent2.changeMarker;
      let isRendered = true;
      this.subs.push(changeMarker.onChange.pipe(map((op) => {
        const from = this.changeFromRemote ? ChangeOrigin.Remote : this.changeFromHistory ? ChangeOrigin.History : ChangeOrigin.Local;
        if (isRendered) {
          isRendered = false;
          if (from === ChangeOrigin.Local) {
            this.localChangeBeforeEvent.next();
          }
          this.docChangeEvent.next();
        }
        return {
          from,
          operation: op
        };
      }), microTask()).subscribe((ops) => {
        isRendered = true;
        this._lastChangesHasRemoteUpdate = false;
        this._lastChangesHasLocalUpdate = false;
        ops.forEach((i2) => {
          if (i2.from === ChangeOrigin.Remote) {
            this._lastChangesHasRemoteUpdate = true;
          } else {
            this._lastChangesHasLocalUpdate = true;
          }
        });
        this.docChangedEvent.next(ops);
      }), changeMarker.onChildComponentRemoved.subscribe((instance) => {
        this.instanceList.add(instance);
      }), this.viewAdapter.onViewUpdated.pipe(microTask()).subscribe(() => {
        this.selection.restore(this._lastChangesHasLocalUpdate);
        this.instanceList.forEach((instance) => {
          let comp = instance;
          while (comp) {
            const parent = comp.parentComponent;
            if (parent) {
              comp = parent;
            } else {
              break;
            }
          }
          if (comp !== rootComponent2) {
            Scheduler_1.invokeChildComponentDestroyHook(comp);
          }
        });
        this.instanceList.clear();
      }));
    }
    /**
     * 销毁调度器
     */
    destroy() {
      this.subs.forEach((i2) => i2.unsubscribe());
      const component = this.rootComponentRef.component;
      if (component) {
        Scheduler_1.invokeChildComponentDestroyHook(component);
      }
      this.subs = [];
    }
    static invokeChildComponentDestroyHook(parent) {
      parent.slots.toArray().forEach((slot) => {
        slot.sliceContent().forEach((i2) => {
          if (typeof i2 !== "string") {
            Scheduler_1.invokeChildComponentDestroyHook(i2);
          }
        });
      });
      invokeListener(parent, "onDestroy");
    }
  };
  Scheduler = Scheduler_1 = __decorate$1([
    Injectable(),
    __metadata$1("design:paramtypes", [
      RootComponentRef,
      ViewAdapter,
      Selection
    ])
  ], Scheduler);
  class History {
  }
  function objToFormats(formatsObj, registry) {
    const formats = [];
    Object.keys(formatsObj).forEach((i2) => {
      const formatter = registry.getFormatter(i2);
      if (formatter) {
        const value = formatsObj[i2];
        if (Array.isArray(value)) {
          value.forEach((item) => {
            formats.push([formatter, item]);
          });
        } else {
          formats.push([formatter, formatsObj[i2]]);
        }
      }
    });
    return formats;
  }
  const historyErrorFn = makeError("History");
  let LocalHistory = class LocalHistory extends History {
    /**
     * 历史记录是否可回退
     */
    get canBack() {
      return this.historySequence.length > 0 && this.index > 0;
    }
    /**
     * 历史记录是否可重做
     */
    get canForward() {
      return this.historySequence.length > 0 && this.index < this.historySequence.length;
    }
    constructor(stackSize, scheduler, selection, registry) {
      super();
      this.stackSize = stackSize;
      this.scheduler = scheduler;
      this.selection = selection;
      this.registry = registry;
      this.index = 0;
      this.historySequence = [];
      this.changeEvent = new Subject();
      this.backEvent = new Subject();
      this.forwardEvent = new Subject();
      this.pushEvent = new Subject();
      this.subscription = null;
      this.forceChangeSubscription = null;
      this.onChange = this.changeEvent.asObservable();
      this.onBack = this.backEvent.asObservable();
      this.onForward = this.forwardEvent.asObservable();
      this.onPush = this.pushEvent.asObservable();
    }
    /**
     * 监听数据变化，并记录操作历史
     */
    listen() {
      this.record();
    }
    /**
     * 重做历史记录
     */
    forward() {
      if (this.canForward) {
        this.scheduler.historyApplyTransact(() => {
          const item = this.historySequence[this.index];
          this.apply(item, false);
          this.selection.usePaths(item.afterPaths);
        });
        this.index++;
        this.forwardEvent.next();
        this.changeEvent.next();
      }
    }
    /**
     * 撤消操作
     */
    back() {
      if (this.canBack) {
        this.scheduler.historyApplyTransact(() => {
          const item = this.historySequence[this.index - 1];
          this.apply(item, true);
          this.selection.usePaths(item.beforePaths);
        });
        this.index--;
        this.backEvent.next();
        this.changeEvent.next();
      }
    }
    /**
     * 清除历史记录
     */
    clear() {
      this.historySequence = [];
      this.index = 0;
      this.changeEvent.next();
    }
    /**
     * 销毁历史记录实例
     */
    destroy() {
      var _a;
      this.historySequence = [];
      (_a = this.forceChangeSubscription) === null || _a === void 0 ? void 0 : _a.unsubscribe();
      if (this.subscription) {
        this.subscription.unsubscribe();
      }
    }
    record() {
      let beforePaths = this.selection.getPaths();
      this.subscription = this.scheduler.onLocalChangeBefore.subscribe(() => {
        beforePaths = this.selection.getPaths();
      }).add(this.scheduler.onDocChanged.pipe(map((i2) => {
        const operations = [];
        for (const item of i2) {
          if (item.from !== ChangeOrigin.Local) {
            continue;
          }
          const operation = item.operation;
          const apply = operation.apply.filter((i3) => {
            return i3.type !== "apply" || i3.record;
          });
          const unApply = operation.unApply.filter((i3) => {
            return i3.type !== "apply" || i3.record;
          });
          if (apply.length && unApply.length) {
            operations.push({
              path: operation.path,
              apply,
              unApply
            });
          }
        }
        return operations;
      })).subscribe((operations) => {
        if (!operations.length) {
          return;
        }
        this.historySequence.length = this.index;
        this.index++;
        const afterPaths = this.selection.getPaths();
        this.historySequence.push({
          operations: operations.map((i2) => {
            return {
              path: [...i2.path],
              apply: i2.apply.map((j2) => {
                if (j2.type === "insert" || j2.type === "insertSlot") {
                  return Object.assign(Object.assign({}, j2), { ref: null });
                }
                return j2;
              }),
              unApply: i2.unApply.map((j2) => {
                if (j2.type === "insert" || j2.type === "insertSlot") {
                  return Object.assign(Object.assign({}, j2), { ref: null });
                }
                return j2;
              })
            };
          }),
          beforePaths,
          afterPaths
        });
        if (this.historySequence.length > this.stackSize) {
          this.historySequence.shift();
          this.index--;
        }
        beforePaths = afterPaths;
        this.pushEvent.next();
        this.changeEvent.next();
      }));
    }
    apply(historyItem, back) {
      let operations = historyItem.operations;
      if (back) {
        operations = [...operations].reverse();
      }
      operations.forEach((op) => {
        const path = [...op.path];
        const isFindSlot = path.length % 2 === 1;
        const actions = back ? op.unApply : op.apply;
        if (isFindSlot) {
          const slot = this.selection.findSlotByPaths(path);
          actions.forEach((action) => {
            if (action.type === "retain") {
              const formatsObj = action.formats;
              if (formatsObj) {
                const formats = objToFormats(formatsObj, this.registry);
                slot.retain(action.offset, formats);
              } else {
                slot.retain(action.offset);
              }
              return;
            }
            if (action.type === "delete") {
              slot.delete(action.count);
              return;
            }
            if (action.type === "apply") {
              slot.updateState((draft) => {
                pn(draft, action.patches);
              });
              return;
            }
            if (action.type === "attrSet") {
              const attribute = this.registry.getAttribute(action.name);
              if (attribute) {
                slot.setAttribute(attribute, action.value);
              }
              return;
            }
            if (action.type === "attrRemove") {
              const attribute = this.registry.getAttribute(action.name);
              if (attribute) {
                slot.removeAttribute(attribute);
              }
              return;
            }
            if (action.type === "insert") {
              const formatsObj = action.formats;
              let formats;
              if (formatsObj) {
                formats = objToFormats(formatsObj, this.registry);
              }
              if (typeof action.content === "string") {
                formats ? slot.insert(action.content, formats) : slot.insert(action.content);
              } else {
                const instance = this.registry.createComponent(action.content);
                if (!instance) {
                  throw historyErrorFn(`component \`${action.content.name}\` not registered, please add \`${action.content.name}\` component to the components configuration item.`);
                }
                formats ? slot.insert(instance, formats) : slot.insert(instance);
              }
            }
          });
        } else {
          const component = this.selection.findComponentByPaths(path);
          actions.forEach((action) => {
            if (action.type === "retain") {
              component.slots.retain(action.offset);
              return;
            }
            if (action.type === "delete") {
              component.slots.delete(action.count);
              return;
            }
            if (action.type === "insertSlot") {
              const slot = this.registry.createSlot(action.slot);
              component.slots.insert(slot);
              return;
            }
            if (action.type === "apply") {
              component.updateState((draft) => {
                return pn(draft, action.patches);
              });
            }
          });
        }
      });
    }
  };
  LocalHistory = __decorate$1([
    Injectable(),
    __param$1(0, Inject(HISTORY_STACK_SIZE)),
    __metadata$1("design:paramtypes", [
      Number,
      Scheduler,
      Selection,
      Registry
    ])
  ], LocalHistory);
  let Keyboard = class Keyboard {
    constructor(components, markdownDetect, commander, textbus, selection) {
      this.components = components;
      this.markdownDetect = markdownDetect;
      this.commander = commander;
      this.textbus = textbus;
      this.selection = selection;
      this.shortcutList = [];
      this.zenCodingInterceptors = [];
      components.forEach((component) => {
        const config = component.zenCoding;
        if (Array.isArray(config)) {
          config.forEach((i2) => this.zenCodingInterceptors.push(this.createZenCodingEx(component, i2)));
        } else if (config) {
          this.zenCodingInterceptors.push(this.createZenCodingEx(component, config));
        }
      });
    }
    /**
     * 注册输入语法糖
     * @param interceptor
     */
    addZenCodingInterceptor(interceptor) {
      this.zenCodingInterceptors.push(interceptor);
      return {
        remove: () => {
          const index = this.zenCodingInterceptors.indexOf(interceptor);
          if (index > -1) {
            this.zenCodingInterceptors.splice(index, 1);
          }
        }
      };
    }
    /**
     * 调用快捷键
     * @param keymapState 快捷键配置
     */
    execShortcut(keymapState) {
      if (!this.selection.isSelected) {
        return false;
      }
      const key = keymapState.key;
      const commonAncestorSlot = this.selection.commonAncestorSlot;
      if (this.markdownDetect && !keymapState.ctrlKey && !keymapState.shiftKey && !keymapState.altKey && commonAncestorSlot === this.selection.startSlot && commonAncestorSlot === this.selection.endSlot) {
        for (let i2 = this.zenCodingInterceptors.length - 1; i2 > -1; i2--) {
          const interceptor = this.zenCodingInterceptors[i2];
          const matchKey = interceptor.try(key);
          if (matchKey) {
            const activeSlotContents = commonAncestorSlot.sliceContent();
            let content = activeSlotContents[0];
            if (activeSlotContents.length > 1 || typeof content !== "string") {
              continue;
            }
            content = content.replace(/\n$/, "");
            const matchContent = interceptor.match(content);
            if (matchContent) {
              const r2 = interceptor.action(content);
              if (!r2) {
                break;
              }
              return true;
            }
          }
        }
      }
      const commonAncestorComponent = this.selection.commonAncestorComponent;
      if (commonAncestorComponent) {
        const is = this.handleShortcut(keymapState, commonAncestorComponent.shortcutList.map((s2) => this.createShortcutEx(s2)));
        if (is) {
          return true;
        }
      }
      return this.handleShortcut(keymapState, this.shortcutList);
    }
    /**
     * 注册快捷键
     * @param shortcut 快捷键配置
     */
    addShortcut(shortcut) {
      const shortcutEx = this.createShortcutEx(shortcut);
      this.shortcutList.push(shortcutEx);
      return {
        remove: () => {
          const index = this.shortcutList.indexOf(shortcutEx);
          if (index > -1) {
            this.shortcutList.splice(index, 1);
          }
        }
      };
    }
    handleShortcut(keymap, shortcutList) {
      for (let i2 = shortcutList.length - 1; i2 > -1; i2--) {
        const ex = shortcutList[i2];
        const config = ex.config;
        if (ex.test(keymap.key) && !!config.keymap.altKey === keymap.altKey && !!config.keymap.shiftKey === keymap.shiftKey && !!config.keymap.ctrlKey === keymap.ctrlKey) {
          const b2 = config.action(keymap.key);
          if (b2 !== false) {
            return true;
          }
        }
      }
      return false;
    }
    createZenCodingEx(component, config) {
      const selection = this.selection;
      const commander = this.commander;
      return {
        match(content) {
          return typeof config.match === "function" ? config.match(content) : config.match.test(content);
        },
        try(key) {
          if (typeof config.key === "string") {
            return key.toLowerCase() === config.key.toLowerCase();
          }
          if (typeof config.key === "function") {
            return config.key(key);
          }
          if (Array.isArray(config.key)) {
            return config.key.some((item) => item.toLowerCase() === key.toLowerCase());
          }
          return config.key.test(key);
        },
        action: (content) => {
          const commonAncestorSlot = selection.commonAncestorSlot;
          const initData = config.generateInitData(content, this.textbus);
          const newInstance = component.createInstance(this.textbus, initData);
          if (commonAncestorSlot.schema.includes(newInstance.type)) {
            selection.selectSlot(commonAncestorSlot);
            commander.delete();
            commander.insert(newInstance);
          } else {
            const parentComponent = commonAncestorSlot.parent;
            if (parentComponent && parentComponent.slots.length > 1) {
              return false;
            }
            const parentSlot = parentComponent === null || parentComponent === void 0 ? void 0 : parentComponent.parent;
            if (!parentSlot) {
              return false;
            }
            selection.selectComponent(parentComponent);
            commander.delete();
            commander.insert(newInstance);
          }
          const newSlot = newInstance.slots.first;
          if (newSlot) {
            selection.setPosition(newSlot, 0);
          } else if (newInstance.parent) {
            const index = newInstance.parent.indexOf(newInstance);
            selection.setPosition(newInstance.parent, index + 1);
          }
          return true;
        }
      };
    }
    createShortcutEx(config) {
      const key = config.keymap.key;
      return {
        config,
        test(k2) {
          if (typeof key === "string") {
            return k2.toLowerCase() === key.toLowerCase();
          } else if (Array.isArray(key)) {
            return key.some((v2) => {
              return k2.toLowerCase() === v2.toLowerCase();
            });
          } else if (typeof key.match === "function") {
            return key.match(k2);
          }
          return key.match.test(k2);
        }
      };
    }
  };
  Keyboard = __decorate$1([
    Injectable(),
    __param$1(0, Inject(COMPONENT_LIST)),
    __param$1(1, Inject(ZEN_CODING_DETECT)),
    __metadata$1("design:paramtypes", [
      Array,
      Boolean,
      Commander,
      Textbus,
      Selection
    ])
  ], Keyboard);
  var QueryStateType;
  (function(QueryStateType2) {
    QueryStateType2["Normal"] = "Normal";
    QueryStateType2["Disabled"] = "Disabled";
    QueryStateType2["Enabled"] = "Enabled";
  })(QueryStateType || (QueryStateType = {}));
  let Query = class Query {
    constructor(selection) {
      this.selection = selection;
    }
    /**
     * 查询格式在当前选区的状态
     * @param formatter 要查询的格式
     */
    queryFormat(formatter) {
      if (!this.selection.isSelected) {
        return {
          state: QueryStateType.Normal,
          value: null
        };
      }
      const states = this.selection.getSelectedScopes().map((i2) => {
        return this.getStatesByRange(i2.slot, formatter, i2.startIndex, i2.endIndex);
      });
      return this.mergeState(states);
    }
    /**
     * 查询属性在当前选区的状态
     * @param attribute
     */
    queryAttribute(attribute) {
      if (!this.selection.isSelected) {
        return {
          state: QueryStateType.Normal,
          value: null
        };
      }
      let ranges;
      if (this.selection.isCollapsed) {
        const c2 = this.selection.commonAncestorSlot;
        ranges = [{
          slot: c2,
          startIndex: 0,
          endIndex: c2.length
        }];
      } else {
        ranges = this.selection.getSelectedScopes();
      }
      const states = ranges.map((i2) => {
        const contents = i2.slot.sliceContent(i2.startIndex, i2.endIndex);
        const childComponents = [];
        let hasString = false;
        contents.forEach((item) => {
          if (typeof item !== "string") {
            childComponents.push(item);
          } else {
            hasString = true;
          }
        });
        if (hasString) {
          if (i2.slot.hasAttribute(attribute)) {
            return {
              state: QueryStateType.Enabled,
              value: i2.slot.getAttribute(attribute)
            };
          }
          return {
            state: QueryStateType.Normal,
            value: null
          };
        }
        const states2 = [];
        for (const component of childComponents) {
          const slots = component.slots;
          if (slots.length === 0) {
            if (i2.slot.hasAttribute(attribute)) {
              states2.push({
                state: QueryStateType.Enabled,
                value: i2.slot.getAttribute(attribute)
              });
            } else {
              return {
                state: QueryStateType.Normal,
                value: null
              };
            }
          }
          for (const slot of slots.toArray()) {
            if (slot.hasAttribute(attribute)) {
              states2.push({
                state: QueryStateType.Enabled,
                value: slot.getAttribute(attribute)
              });
            } else {
              return {
                state: QueryStateType.Normal,
                value: null
              };
            }
          }
        }
        return this.mergeState(states2);
      });
      return this.mergeState(states);
    }
    /**
     * 查询组件在选区内的状态
     * @param component 要查询的组件
     * @param filter 查询结构过滤函数，过滤不需要的数据
     */
    queryComponent(component, filter2) {
      if (!this.selection.isSelected) {
        return {
          state: QueryStateType.Normal,
          value: null
        };
      }
      const ranges = this.selection.getRanges();
      const states = ranges.map((item) => {
        var _a;
        let parent = Selection.getCommonAncestorComponent(item.startSlot, item.endSlot);
        while (parent) {
          if (parent.name === component.name) {
            if (!filter2 || filter2(parent)) {
              return {
                state: QueryStateType.Enabled,
                value: parent
              };
            }
          }
          parent = ((_a = parent.parent) === null || _a === void 0 ? void 0 : _a.parent) || null;
        }
        return {
          state: QueryStateType.Normal,
          value: null
        };
      });
      return this.mergeState(states);
    }
    /**
     * 查询当前选区是否包含在组件内
     * @param component 要查询的组件
     */
    queryWrappedComponent(component) {
      const selection = this.selection;
      if (!selection.isSelected || selection.isCollapsed) {
        return {
          state: QueryStateType.Normal,
          value: null
        };
      }
      const ranges = selection.getRanges();
      const instances = [];
      for (const range of ranges) {
        const { startSlot, endSlot, startOffset, endOffset } = range;
        if (startSlot !== endSlot || endOffset - startOffset > 1) {
          return {
            state: QueryStateType.Normal,
            value: null
          };
        }
        const instance = startSlot.getContentAtIndex(startOffset);
        if (typeof instance !== "string" && instance.name === component.name) {
          instances.push(instance);
        } else {
          return {
            state: QueryStateType.Normal,
            value: null
          };
        }
      }
      return {
        state: QueryStateType.Enabled,
        value: instances[0]
      };
    }
    getStatesByRange(slot, formatter, startIndex, endIndex) {
      if (startIndex === endIndex) {
        const format = startIndex === 0 ? slot.getFormatRangesByFormatter(formatter, 0, 1).shift() : slot.getFormatRangesByFormatter(formatter, startIndex - 1, endIndex).shift();
        if (format) {
          return {
            state: QueryStateType.Enabled,
            value: format.value
          };
        }
        return null;
      }
      const childContents = slot.sliceContent(startIndex, endIndex);
      const states = [];
      let index = startIndex;
      for (const child of childContents) {
        if (typeof child === "string" || child.slots.length === 0) {
          const formats = slot.getFormatRangesByFormatter(formatter, index, index + child.length);
          let s2 = index;
          for (const f2 of formats) {
            if (s2 !== f2.startIndex) {
              return {
                state: QueryStateType.Normal,
                value: null
              };
            }
            states.push({
              state: QueryStateType.Enabled,
              value: f2.value
            });
            s2 = f2.endIndex;
          }
          if (s2 !== index + child.length) {
            return {
              state: QueryStateType.Normal,
              value: null
            };
          }
        } else {
          child.slots.toArray().forEach((i2) => {
            states.push(this.getStatesByRange(i2, formatter, 0, i2.length));
          });
        }
        index += child.length;
      }
      return this.mergeState(states);
    }
    mergeState(states) {
      const states1 = states.filter((i2) => i2);
      const states2 = states1.filter((i2) => i2.state !== QueryStateType.Normal);
      if (states.length !== states2.length) {
        return {
          state: QueryStateType.Normal,
          value: null
        };
      }
      if (states2.length) {
        return {
          state: QueryStateType.Enabled,
          value: states2[0].value
        };
      }
      return {
        state: QueryStateType.Normal,
        value: null
      };
    }
  };
  Query = __decorate$1([
    Injectable(),
    __metadata$1("design:paramtypes", [Selection])
  ], Query);
  function createElement(tagName, options = {}) {
    const el = document.createElement(tagName);
    if (options.classes) {
      el.classList.add(...options.classes);
    }
    if (options.attrs) {
      Object.keys(options.attrs).forEach((key) => {
        el.setAttribute(key, options.attrs[key]);
      });
    }
    if (options.props) {
      Object.keys(options.props).forEach((key) => {
        el[key] = options.props[key];
      });
    }
    if (options.styles) {
      Object.assign(el.style, options.styles);
    }
    if (options.children) {
      options.children.filter((i2) => i2).forEach((item) => {
        el.appendChild(item);
      });
    }
    if (options.on) {
      Object.keys(options.on).forEach((key) => {
        el.addEventListener(key, options.on[key]);
      });
    }
    return el;
  }
  function getLayoutRectByRange(range) {
    let { startContainer, startOffset } = range;
    if (startContainer.nodeType === Node.TEXT_NODE) {
      if (startOffset > 0) {
        return range.getBoundingClientRect();
      }
      const parentNode = startContainer.parentNode;
      startOffset = Array.from(parentNode.childNodes).indexOf(startContainer);
      startContainer = parentNode;
    }
    const beforeNode = startContainer.childNodes[startOffset - 1];
    if (beforeNode) {
      if (beforeNode.nodeType === Node.ELEMENT_NODE && beforeNode.nodeName.toLowerCase() !== "br") {
        const rect2 = beforeNode.getBoundingClientRect();
        return {
          left: rect2.right,
          top: rect2.top,
          width: rect2.width,
          height: rect2.height
        };
      } else if (beforeNode.nodeType === Node.TEXT_NODE) {
        const range2 = document.createRange();
        range2.setStart(beforeNode, beforeNode.textContent.length);
        range2.setEnd(beforeNode, beforeNode.textContent.length);
        return range2.getBoundingClientRect();
      }
    }
    const offsetNode = startContainer.childNodes[startOffset];
    let isInsertBefore = false;
    if (!offsetNode) {
      const lastChild = startContainer.lastChild;
      if (lastChild && lastChild.nodeType === Node.ELEMENT_NODE) {
        const rect2 = lastChild.getBoundingClientRect();
        return {
          left: rect2.right,
          top: rect2.top,
          width: rect2.width,
          height: rect2.height
        };
      }
    }
    if (offsetNode) {
      if (offsetNode.nodeType === Node.ELEMENT_NODE && offsetNode.nodeName.toLowerCase() !== "br") {
        return offsetNode.getBoundingClientRect();
      }
      isInsertBefore = true;
    }
    const span = startContainer.ownerDocument.createElement("span");
    span.innerText = "​";
    span.style.display = "inline-block";
    if (isInsertBefore) {
      startContainer.insertBefore(span, offsetNode);
    } else {
      startContainer.appendChild(span);
    }
    const rect = span.getBoundingClientRect();
    startContainer.removeChild(span);
    return rect;
  }
  const isWindows = () => /win(dows|32|64)/i.test(navigator.userAgent);
  const isMac = () => /mac os/i.test(navigator.userAgent);
  const isSafari = () => /Safari/.test(navigator.userAgent) && !/Chrome/.test(navigator.userAgent);
  const isFirefox = () => /Firefox/.test(navigator.userAgent);
  const isMobileBrowser = () => /Android|iPhone|iPad/.test(navigator.userAgent);
  function __decorate(decorators, target, key, desc) {
    var c2 = arguments.length, r2 = c2 < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d2;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function")
      r2 = Reflect.decorate(decorators, target, key, desc);
    else
      for (var i2 = decorators.length - 1; i2 >= 0; i2--)
        if (d2 = decorators[i2])
          r2 = (c2 < 3 ? d2(r2) : c2 > 3 ? d2(target, key, r2) : d2(target, key)) || r2;
    return c2 > 3 && r2 && Object.defineProperty(target, key, r2), r2;
  }
  function __param(paramIndex, decorator) {
    return function(target, key) {
      decorator(target, key, paramIndex);
    };
  }
  function __metadata(metadataKey, metadataValue) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function")
      return Reflect.metadata(metadataKey, metadataValue);
  }
  typeof SuppressedError === "function" ? SuppressedError : function(error, suppressed, message) {
    var e = new Error(message);
    return e.name = "SuppressedError", e.error = error, e.suppressed = suppressed, e;
  };
  const EDITOR_OPTIONS = new InjectionToken("EDITOR_OPTIONS");
  const VIEW_CONTAINER = new InjectionToken("VIEW_CONTAINER");
  const VIEW_DOCUMENT = new InjectionToken("VIEW_DOCUMENT");
  const VIEW_MASK = new InjectionToken("VIEW_MASK");
  var Parser_1;
  let Parser = Parser_1 = class Parser {
    static parseHTML(html) {
      return new DOMParser().parseFromString(html, "text/html").body;
    }
    constructor(options, textbus) {
      this.options = options;
      this.textbus = textbus;
      const componentLoaders = [
        ...options.componentLoaders || []
      ];
      const formatLoaders = [
        ...options.formatLoaders || []
      ];
      const attributeLoaders = [
        ...options.attributeLoaders || []
      ];
      this.componentLoaders = componentLoaders;
      this.formatLoaders = formatLoaders;
      this.attributeLoaders = attributeLoaders;
    }
    /**
     * 使用指定的组件加载器解析一段 HTML 字符串或 DOM 元素
     * @param html
     * @param rootComponentLoader
     */
    parseDoc(html, rootComponentLoader) {
      const element = typeof html === "string" ? Parser_1.parseHTML(html) : html;
      return rootComponentLoader.read(element, this.textbus, (childSlot, slotRootElement, slotContentHostElement = slotRootElement) => {
        return this.readSlot(childSlot, slotRootElement, slotContentHostElement);
      });
    }
    /**
     * 将一段 HTML 或 DOM 元素解析到指定插槽
     * @param html
     * @param rootSlot
     */
    parse(html, rootSlot) {
      const element = typeof html === "string" ? Parser_1.parseHTML(html) : html;
      return this.readFormats(element, rootSlot);
    }
    readComponent(el, slot) {
      if (el.nodeType === Node.ELEMENT_NODE) {
        if (el.tagName === "BR") {
          slot.insert("\n");
          return;
        }
        for (const t2 of this.componentLoaders) {
          if (t2.match(el)) {
            const result = t2.read(el, this.textbus, (childSlot, slotRootElement, slotContentHostElement = slotRootElement) => {
              return this.readSlot(childSlot, slotRootElement, slotContentHostElement);
            });
            if (!result) {
              return;
            }
            if (result instanceof Slot) {
              result.toDelta().forEach((i2) => slot.insert(i2.insert, i2.formats));
              return;
            }
            slot.insert(result);
            return;
          }
        }
        this.readFormats(el, slot);
      } else if (el.nodeType === Node.TEXT_NODE) {
        this.readText(slot, el);
      }
    }
    readText(slot, el) {
      const textContent = el.textContent;
      if (/^\s*[\r\n\u200b]+\s*$/.test(textContent)) {
        return;
      }
      slot.insert(textContent);
    }
    readFormats(el, slot) {
      const formats = this.formatLoaders.filter((f2) => {
        return f2.match(el);
      }).map((f2) => {
        return f2.read(el);
      });
      const startIndex = slot.index;
      let startNode = el.firstChild;
      while (startNode) {
        this.readComponent(startNode, slot);
        startNode = startNode.nextSibling;
      }
      const endIndex = slot.index;
      this.applyFormats(slot, formats.map((i2) => {
        return {
          formatter: i2.formatter,
          value: i2.value,
          startIndex,
          endIndex
        };
      }));
      slot.retain(endIndex);
      return slot;
    }
    readSlot(childSlot, slotRootElement, slotContentElement) {
      if (slotRootElement.nodeType === Node.ELEMENT_NODE) {
        this.attributeLoaders.filter((a2) => {
          return a2.match(slotRootElement);
        }).forEach((a2) => {
          const r2 = a2.read(slotRootElement);
          childSlot.setAttribute(r2.attribute, r2.value);
        });
      }
      if (slotContentElement.nodeType === Node.ELEMENT_NODE) {
        this.readFormats(slotContentElement, childSlot);
      } else {
        this.readText(childSlot, slotContentElement);
      }
      return childSlot;
    }
    applyFormats(slot, formatItems) {
      slot.background(() => {
        formatItems.forEach((i2) => {
          slot.retain(i2.startIndex);
          slot.retain(i2.endIndex - i2.startIndex, i2.formatter, i2.value);
        });
      });
    }
  };
  Parser = Parser_1 = __decorate([
    Injectable(),
    __param(0, Inject(EDITOR_OPTIONS)),
    __metadata("design:paramtypes", [Object, Textbus])
  ], Parser);
  class Input {
  }
  class DomAdapter extends ViewAdapter {
    constructor(mount) {
      super();
      this.mount = mount;
      this.host = createElement("div", {
        styles: {
          cursor: "text",
          wordBreak: "break-all",
          boxSizing: "border-box",
          flex: 1,
          outline: "none"
        },
        attrs: {
          "data-textbus-view": VIEW_DOCUMENT
        },
        props: {
          id: "textbus-" + Number((Math.random() + "").substring(2)).toString(16)
        }
      });
      this.componentRootElementCaches = createBidirectionalMapping((a2) => {
        return a2 instanceof ComponentInstance;
      });
      this.slotRootNativeElementCaches = createBidirectionalMapping((a2) => {
        return a2 instanceof Slot;
      });
      this.slotRootVElementCaches = /* @__PURE__ */ new WeakMap();
    }
    render(rootComponent2, textbus) {
      const view = this.componentRender(rootComponent2);
      return this.mount(this.host, view, textbus);
    }
    copy() {
      document.execCommand("copy");
    }
    /**
     * 根据组件获取组件的根 DOM 节点
     * @param component
     */
    getNativeNodeByComponent(component) {
      return this.componentRootElementCaches.get(component) || null;
    }
    /**
     * 根据 DOM 节点，获对对应的组件根节点，如传入的 DOM 节点不为组件的根节点，则返回 null
     * @param node
     */
    getComponentByNativeNode(node) {
      return this.componentRootElementCaches.get(node) || null;
    }
    /**
     * 根据插槽获取插槽的根 DOM 节点
     * @param slot
     */
    getNativeNodeBySlot(slot) {
      return this.slotRootNativeElementCaches.get(slot) || null;
    }
    /**
     * 根据 DOM 节点，获对对应的插槽根节点，如传入的 DOM 节点不为插槽的根节点，则返回 null
     * @param node
     */
    getSlotByNativeNode(node) {
      return this.slotRootNativeElementCaches.get(node) || null;
    }
    /**
     * 获取插槽内容节点集合
     * @param slot
     */
    getNodesBySlot(slot) {
      const rootNativeNode = this.getNativeNodeBySlot(slot);
      if (!rootNativeNode) {
        return [];
      }
      const rootVNode = this.slotRootVElementCaches.get(slot);
      return getNodes(this, rootVNode, rootNativeNode, []);
    }
    /**
     * 获取原生节点的原始数据在文档中的位置
     * @param node
     */
    getLocationByNativeNode(node) {
      let slotRootNode = node;
      while (!this.slotRootNativeElementCaches.get(slotRootNode)) {
        slotRootNode = slotRootNode.parentNode;
        if (!slotRootNode) {
          return null;
        }
      }
      const slot = this.slotRootNativeElementCaches.get(slotRootNode);
      const rootVNode = this.slotRootVElementCaches.get(slot);
      return getLocation(node, slotRootNode, rootVNode);
    }
  }
  function getNodes(adapter, vElement, nativeNode, result) {
    if (vElement.location) {
      result.push(nativeNode);
    }
    for (let i2 = 0; i2 < vElement.children.length; i2++) {
      const vChild = vElement.children[i2];
      const nativeChild = nativeNode.childNodes[i2];
      if (vChild instanceof VElement) {
        getNodes(adapter, vChild, nativeChild, result);
      } else if (vChild instanceof VTextNode) {
        result.push(nativeChild);
      } else {
        result.push(adapter.getNativeNodeByComponent(vChild));
      }
    }
    return result;
  }
  function getLocation(target, tree, vNodeTree) {
    if (target === tree) {
      return Object.assign({}, vNodeTree.location);
    }
    const childNodes = tree.childNodes;
    for (let i2 = 0; i2 < childNodes.length; i2++) {
      const child = vNodeTree.children[i2];
      const nativeChild = tree.childNodes[i2];
      if (nativeChild === target) {
        if (child instanceof ComponentInstance) {
          const index = child.parent.indexOf(child);
          return {
            slot: child.parent,
            startIndex: index,
            endIndex: index + 1
          };
        }
        return child.location;
      } else if (child instanceof VElement) {
        let r2 = null;
        if (nativeChild.nodeType === Node.ELEMENT_NODE) {
          r2 = getLocation(target, nativeChild, child);
        }
        if (r2) {
          return r2;
        }
      }
    }
    return null;
  }
  let SelectionBridge = class SelectionBridge {
    constructor(config, textbus, controller, selection, rootComponentRef, input, domAdapter) {
      this.config = config;
      this.selection = selection;
      this.rootComponentRef = rootComponentRef;
      this.input = input;
      this.domAdapter = domAdapter;
      this.nativeSelection = document.getSelection();
      this.selectionChangeEvent = new Subject();
      this.subs = [];
      this.connector = null;
      this.ignoreSelectionChange = false;
      this.changeFromUser = false;
      this.docContainer = textbus.get(VIEW_DOCUMENT);
      this.onSelectionChange = this.selectionChangeEvent.asObservable().pipe(filter(() => {
        return !controller.readonly;
      }));
      this.sub = this.onSelectionChange.subscribe((r2) => {
        if (r2) {
          input.focus(r2, this.changeFromUser);
        } else {
          input.blur();
        }
      });
      this.sub.add(fromEvent(document, "focusin").subscribe((ev) => {
        let target = ev.target;
        if (/^(input|textarea|select)$/i.test(target.nodeName)) {
          if (target.tagName.toLowerCase() === "input" && /^(range|date)$/.test(target.type)) {
            return;
          }
          this.ignoreSelectionChange = true;
          return;
        }
        if (!config.useContentEditable) {
          while (target) {
            if (target.contentEditable === "true") {
              this.ignoreSelectionChange = true;
              return;
            }
            target = target.parentNode;
          }
        }
      }));
      this.sub.add(fromEvent(document, "focusout").subscribe(() => {
        this.ignoreSelectionChange = false;
      }));
    }
    connect(connector) {
      this.disConnect();
      this.connector = connector;
      this.syncSelection(connector);
      this.listen(connector);
    }
    disConnect() {
      this.connector = null;
      this.unListen();
    }
    getRect(location) {
      const { focus, anchor } = this.getPositionByRange({
        focusOffset: location.offset,
        anchorOffset: location.offset,
        focusSlot: location.slot,
        anchorSlot: location.slot
      });
      if (!focus || !anchor) {
        return null;
      }
      const nativeRange = document.createRange();
      nativeRange.setStart(focus.node, focus.offset);
      nativeRange.collapse();
      return getLayoutRectByRange(nativeRange);
    }
    restore(abstractSelection, formLocal) {
      this.changeFromUser = formLocal;
      if (this.ignoreSelectionChange || !this.connector) {
        return;
      }
      this.unListen();
      if (!abstractSelection) {
        this.nativeSelection.removeAllRanges();
        this.selectionChangeEvent.next(null);
        this.listen(this.connector);
        return;
      }
      const { focus, anchor } = this.getPositionByRange(abstractSelection);
      if (!focus || !anchor) {
        this.nativeSelection.removeAllRanges();
        this.selectionChangeEvent.next(null);
        this.listen(this.connector);
        return;
      }
      this.nativeSelection.setBaseAndExtent(anchor.node, anchor.offset, focus.node, focus.offset);
      if (this.nativeSelection.rangeCount) {
        const nativeRange = this.nativeSelection.getRangeAt(0);
        this.selectionChangeEvent.next(nativeRange);
      } else {
        this.selectionChangeEvent.next(null);
      }
      const bind = () => {
        if (this.connector) {
          this.listen(this.connector);
        }
      };
      if (typeof requestIdleCallback === "function") {
        requestIdleCallback(bind);
      } else {
        setTimeout(bind, 30);
      }
    }
    destroy() {
      this.sub.unsubscribe();
    }
    getPositionByRange(abstractSelection) {
      let focus;
      let anchor;
      try {
        focus = this.findSelectedNodeAndOffset(abstractSelection.focusSlot, abstractSelection.focusOffset);
        anchor = focus;
        if (abstractSelection.anchorSlot !== abstractSelection.focusSlot || abstractSelection.anchorOffset !== abstractSelection.focusOffset) {
          anchor = this.findSelectedNodeAndOffset(abstractSelection.anchorSlot, abstractSelection.anchorOffset);
        }
        return {
          focus,
          anchor
        };
      } catch (e) {
        return {
          focus: null,
          anchor: null
        };
      }
    }
    getPreviousLinePositionByCurrent(position) {
      return this.getLinePosition(position, false);
    }
    getNextLinePositionByCurrent(position) {
      return this.getLinePosition(position, true);
    }
    getLinePosition(currentPosition, toNext) {
      clearTimeout(this.cacheCaretPositionTimer);
      let p2;
      if (this.oldCaretPosition) {
        p2 = toNext ? this.getNextLinePositionByOffset(currentPosition, this.oldCaretPosition.left) : this.getPreviousLinePositionByOffset(currentPosition, this.oldCaretPosition.left);
      } else {
        this.oldCaretPosition = this.getRect(currentPosition);
        p2 = toNext ? this.getNextLinePositionByOffset(currentPosition, this.oldCaretPosition.left) : this.getPreviousLinePositionByOffset(currentPosition, this.oldCaretPosition.left);
      }
      this.cacheCaretPositionTimer = setTimeout(() => {
        this.oldCaretPosition = null;
      }, 3e3);
      return p2;
    }
    /**
     * 获取选区向上移动一行的位置。
     * @param currentPosition
     * @param startLeft 参考位置。
     */
    getPreviousLinePositionByOffset(currentPosition, startLeft) {
      let isToPrevLine = false;
      let loopCount = 0;
      let minLeft = startLeft;
      let focusSlot = currentPosition.slot;
      let focusOffset = currentPosition.offset;
      let minTop = this.getRect({
        slot: focusSlot,
        offset: focusOffset
      }).top;
      let position;
      let oldPosition;
      let oldLeft = 0;
      while (true) {
        loopCount++;
        position = this.selection.getPreviousPositionByPosition(focusSlot, focusOffset);
        focusSlot = position.slot;
        focusOffset = position.offset;
        const rect2 = this.getRect(position);
        if (!isToPrevLine) {
          if (rect2.left > minLeft || rect2.top + rect2.height <= minTop) {
            isToPrevLine = true;
          } else if (rect2.left === minLeft && rect2.top === minTop) {
            return position;
          }
          minLeft = rect2.left;
          minTop = rect2.top;
          oldPosition = position;
        }
        if (isToPrevLine) {
          if (rect2.left < startLeft) {
            return position;
          }
          if (oldPosition) {
            if (rect2.left >= oldLeft) {
              return oldPosition;
            }
          }
          oldLeft = rect2.left;
          oldPosition = position;
        }
        if (loopCount > 1e4) {
          break;
        }
      }
      return position || {
        offset: 0,
        slot: focusSlot
      };
    }
    /**
     * 获取选区向下移动一行的位置。
     * @param currentPosition
     * @param startLeft 参考位置。
     */
    getNextLinePositionByOffset(currentPosition, startLeft) {
      let isToNextLine = false;
      let loopCount = 0;
      let maxRight = startLeft;
      let focusSlot = currentPosition.slot;
      let focusOffset = currentPosition.offset;
      const rect = this.getRect({
        slot: focusSlot,
        offset: focusOffset
      });
      let minTop = rect.top;
      let oldPosition;
      let oldLeft = 0;
      while (true) {
        loopCount++;
        const position = this.selection.getNextPositionByPosition(focusSlot, focusOffset);
        focusSlot = position.slot;
        focusOffset = position.offset;
        const rect2 = this.getRect(position);
        if (!isToNextLine) {
          if (rect2.left < maxRight || rect2.top >= minTop + rect.height) {
            isToNextLine = true;
          } else if (rect2.left === maxRight && rect2.top === minTop) {
            return position;
          }
          maxRight = rect2.left;
          minTop = rect2.top;
          oldPosition = position;
        }
        if (isToNextLine) {
          if (rect2.left > startLeft) {
            return oldPosition;
          }
          if (oldPosition) {
            if (rect2.left <= oldLeft) {
              return oldPosition;
            }
          }
          oldPosition = position;
          oldLeft = rect2.left;
        }
        if (loopCount > 1e4) {
          break;
        }
      }
      return oldPosition || {
        offset: focusSlot.length,
        slot: focusSlot
      };
    }
    unListen() {
      this.subs.forEach((i2) => i2.unsubscribe());
      this.subs = [];
    }
    listen(connector) {
      if (!this.config.useContentEditable) {
        const selection = this.nativeSelection;
        this.subs.push(fromEvent(this.docContainer, "mousedown").subscribe((ev) => {
          if (this.ignoreSelectionChange || ev.button === 2) {
            return;
          }
          if (!ev.shiftKey) {
            selection.removeAllRanges();
          }
        }));
      }
      this.subs.push(fromEvent(document, "selectionchange").pipe().subscribe(() => {
        this.syncSelection(connector);
      }));
    }
    syncSelection(connector) {
      var _a;
      const selection = this.nativeSelection;
      this.changeFromUser = true;
      if (this.ignoreSelectionChange || this.input.composition || selection.rangeCount === 0 || !this.docContainer.contains(selection.anchorNode) || this.rootComponentRef.component.slots.length === 0) {
        return;
      }
      const rawRange = selection.getRangeAt(0);
      const nativeRange = rawRange.cloneRange();
      const isFocusEnd = selection.focusNode === nativeRange.endContainer && selection.focusOffset === nativeRange.endOffset;
      const isFocusStart = selection.focusNode === nativeRange.startContainer && selection.focusOffset === nativeRange.startOffset;
      if (!this.docContainer.contains(selection.focusNode)) {
        if (isFocusEnd) {
          const nativeNode = this.domAdapter.getNativeNodeBySlot(this.rootComponentRef.component.slots.first);
          if (!nativeNode) {
            return;
          }
          nativeRange.setEndAfter(nativeNode.lastChild);
        } else {
          const nativeNode = this.domAdapter.getNativeNodeBySlot(this.rootComponentRef.component.slots.last);
          if (!nativeNode) {
            return;
          }
          nativeRange.setStartBefore(nativeNode.firstChild);
        }
      }
      const startPosition = this.getCorrectedPosition(nativeRange.startContainer, nativeRange.startOffset, isFocusStart);
      const endPosition = nativeRange.collapsed ? startPosition : this.getCorrectedPosition(nativeRange.endContainer, nativeRange.endOffset, isFocusEnd);
      if ([Node.ELEMENT_NODE, Node.TEXT_NODE].includes((_a = nativeRange.commonAncestorContainer) === null || _a === void 0 ? void 0 : _a.nodeType) && startPosition && endPosition) {
        const abstractSelection = isFocusEnd ? {
          anchorSlot: startPosition.slot,
          anchorOffset: startPosition.offset,
          focusSlot: endPosition.slot,
          focusOffset: endPosition.offset
        } : {
          focusSlot: startPosition.slot,
          focusOffset: startPosition.offset,
          anchorSlot: endPosition.slot,
          anchorOffset: endPosition.offset
        };
        const { focus, anchor } = this.getPositionByRange(abstractSelection);
        if (focus && anchor) {
          let start = anchor;
          let end = focus;
          if (isFocusStart) {
            start = focus;
            end = anchor;
          }
          if (nativeRange.startContainer !== start.node || nativeRange.startOffset !== start.offset) {
            nativeRange.setStart(start.node, start.offset);
          }
          if (nativeRange.endContainer !== end.node || nativeRange.endOffset !== end.offset) {
            nativeRange.setEnd(end.node, end.offset);
          }
          connector.setSelection(abstractSelection);
          if (selection.isCollapsed && (rawRange.startContainer !== start.node || rawRange.startOffset !== start.offset || rawRange.endContainer !== end.node || rawRange.endOffset !== end.offset)) {
            rawRange.setStart(start.node, start.offset);
            rawRange.setEnd(end.node, end.offset);
          }
          this.selectionChangeEvent.next(nativeRange);
        } else {
          connector.setSelection(null);
        }
        return;
      }
      connector.setSelection(null);
    }
    findSelectedNodeAndOffset(slot, offset) {
      const prev = slot.getContentAtIndex(offset - 1);
      const nodes = this.domAdapter.getNodesBySlot(slot);
      if (prev) {
        if (typeof prev !== "string") {
          const nativeNode = this.domAdapter.getNativeNodeByComponent(prev);
          return {
            node: nativeNode.parentNode,
            offset: Array.from(nativeNode.parentNode.childNodes).indexOf(nativeNode) + 1
          };
        } else if (prev === "\n") {
          for (const node of nodes) {
            if (node instanceof Text) {
              continue;
            }
            if (node.nodeName === "BR") {
              const position = this.domAdapter.getLocationByNativeNode(node);
              if (position) {
                if (position.endIndex === offset) {
                  const parentNode = node.parentNode;
                  return {
                    node: parentNode,
                    offset: Array.from(parentNode.childNodes).indexOf(node) + 1
                  };
                }
              }
            }
          }
        }
      }
      const current = slot.getContentAtIndex(offset);
      if (current && typeof current !== "string") {
        const nativeNode = this.domAdapter.getNativeNodeByComponent(current);
        return {
          node: nativeNode.parentNode,
          offset: Array.from(nativeNode.parentNode.childNodes).indexOf(nativeNode)
        };
      }
      for (const node of nodes) {
        if (node instanceof Element) {
          if (node.tagName === "BR") {
            const position2 = this.domAdapter.getLocationByNativeNode(node);
            if (position2) {
              if (position2.startIndex === offset) {
                const parentNode = node.parentNode;
                return {
                  node: parentNode,
                  offset: Array.from(parentNode.childNodes).indexOf(node)
                };
              }
            }
          }
          continue;
        }
        const position = this.domAdapter.getLocationByNativeNode(node);
        if (position) {
          if (offset >= position.startIndex && offset <= position.endIndex) {
            return {
              node,
              offset: offset - position.startIndex
            };
          }
        }
      }
      return null;
    }
    getCorrectedPosition(node, offset, toAfter, excludeNodes = []) {
      excludeNodes.push(node);
      if (node.nodeType === Node.ELEMENT_NODE) {
        const containerPosition = this.domAdapter.getLocationByNativeNode(node);
        const childNode = node.childNodes[offset];
        if (childNode) {
          const childPosition = this.domAdapter.getLocationByNativeNode(childNode);
          if (childPosition) {
            if (containerPosition) {
              return {
                slot: childPosition.slot,
                offset: childPosition.startIndex
              };
            }
            return this.findFocusNode(childNode, toAfter, excludeNodes);
          }
          return this.findFocusNode(childNode, toAfter, excludeNodes);
        }
        const prevNode = node.childNodes[offset - 1];
        if (prevNode) {
          const prevPosition = this.domAdapter.getLocationByNativeNode(prevNode);
          if (prevPosition && containerPosition) {
            return {
              slot: prevPosition.slot,
              offset: prevPosition.endIndex
            };
          }
        }
        if (containerPosition) {
          return {
            slot: containerPosition.slot,
            offset: containerPosition.endIndex
          };
        }
        const nextNode = toAfter ? node.nextSibling : node.previousSibling;
        if (nextNode) {
          return this.findFocusNode(nextNode, toAfter, excludeNodes);
        }
        return this.findFocusNodeByParent(node, toAfter, excludeNodes);
      } else if (node.nodeType === Node.TEXT_NODE) {
        const containerPosition = this.domAdapter.getLocationByNativeNode(node);
        if (containerPosition) {
          return {
            slot: containerPosition.slot,
            offset: containerPosition.startIndex + offset
          };
        }
        const nextNode = toAfter ? node.nextSibling : node.previousSibling;
        if (nextNode) {
          return this.findFocusNode(nextNode, toAfter, excludeNodes);
        }
        return this.findFocusNodeByParent(node, toAfter, excludeNodes);
      }
      return null;
    }
    findFocusNode(node, toAfter = false, excludeNodes = []) {
      if (excludeNodes.includes(node)) {
        const next = toAfter ? node.nextSibling : node.previousSibling;
        if (next) {
          return this.findFocusNode(next, toAfter, excludeNodes);
        }
        return this.findFocusNodeByParent(node, toAfter, excludeNodes);
      }
      excludeNodes.push(node);
      const position = this.domAdapter.getLocationByNativeNode(node);
      if (position) {
        return {
          slot: position.slot,
          offset: toAfter ? position.startIndex : position.endIndex
        };
      }
      const firstChild = toAfter ? node.firstChild : node.lastChild;
      if (firstChild) {
        return this.findFocusNode(firstChild, toAfter, excludeNodes);
      }
      const nextSibling = toAfter ? node.nextSibling : node.previousSibling;
      if (nextSibling) {
        return this.findFocusNode(nextSibling, toAfter, excludeNodes);
      }
      return this.findFocusNodeByParent(node, toAfter, excludeNodes);
    }
    findFocusNodeByParent(node, toAfter, excludeNodes) {
      const parentNode = node.parentNode;
      if (parentNode) {
        const parentPosition = this.domAdapter.getLocationByNativeNode(parentNode);
        if (parentPosition) {
          return {
            slot: parentPosition.slot,
            offset: toAfter ? parentPosition.endIndex : parentPosition.startIndex
          };
        }
        excludeNodes.push(node);
        return this.findFocusNode(parentNode, toAfter, excludeNodes);
      }
      return null;
    }
  };
  SelectionBridge = __decorate([
    Injectable(),
    __param(0, Inject(EDITOR_OPTIONS)),
    __metadata("design:paramtypes", [
      Object,
      Textbus,
      Controller,
      Selection,
      RootComponentRef,
      Input,
      DomAdapter
    ])
  ], SelectionBridge);
  const iframeHTML = `
<!DOCTYPE html>
<html>
<head>
  <meta charset="UTF-8">
  <meta name="viewport" content="width=device-width, user-scalable=no, initial-scale=1.0, maximum-scale=1.0, minimum-scale=1.0">
  <meta http-equiv="X-UA-Compatible" content="ie=edge">
  <title>Textbus</title>
  <style>
    html {position: fixed; left:0; overflow: hidden}
    html, body{height: 100%;width:100%}
    body{margin:0; overflow: hidden}
    textarea{width: 2000px;height: 100%;opacity: 0; padding: 0; outline: none; border: none; position: absolute; left:0; top:0;}
  </style>
</head>
<body>
</body>
</html>
`;
  class ExperimentalCaret {
    get rect() {
      return this.caret.getBoundingClientRect();
    }
    set display(v2) {
      this._display = v2;
      this.caret.style.visibility = v2 ? "visible" : "hidden";
    }
    get display() {
      return this._display;
    }
    constructor(scheduler, editorMask) {
      this.scheduler = scheduler;
      this.editorMask = editorMask;
      this.compositionState = null;
      this.compositionElement = createElement("span", {
        styles: {
          textDecoration: "underline"
        }
      });
      this.timer = null;
      this.oldPosition = null;
      this._display = true;
      this.flashing = true;
      this.subs = [];
      this.subscription = new Subscription();
      this.positionChangeEvent = new Subject();
      this.styleChangeEvent = new Subject();
      this.oldRange = null;
      this.isFixed = false;
      this.onPositionChange = this.positionChangeEvent.pipe(distinctUntilChanged());
      this.onStyleChange = this.styleChangeEvent.asObservable();
      this.elementRef = createElement("div", {
        styles: {
          position: "absolute",
          width: "2px",
          pointerEvents: "none"
        },
        children: [
          this.caret = createElement("span", {
            styles: {
              width: "100%",
              height: "100%",
              position: "absolute",
              left: 0,
              top: 0
            }
          })
        ]
      });
      this.subscription.add(fromEvent(document, "mousedown").subscribe(() => {
        this.flashing = false;
      }), fromEvent(document, "mouseup").subscribe(() => {
        this.flashing = true;
      }));
      this.editorMask.appendChild(this.elementRef);
    }
    refresh(isFixedCaret = false) {
      this.isFixed = isFixedCaret;
      if (this.oldRange) {
        this.show(this.oldRange, false);
      }
      this.isFixed = false;
    }
    show(range, restart) {
      const oldRect = this.elementRef.getBoundingClientRect();
      this.oldPosition = {
        top: oldRect.top,
        left: oldRect.left,
        height: oldRect.height
      };
      this.oldRange = range;
      if (restart || this.scheduler.lastChangesHasLocalUpdate) {
        clearTimeout(this.timer);
      }
      this.updateCursorPosition(range);
      if (range.collapsed) {
        if (restart || this.scheduler.lastChangesHasLocalUpdate) {
          this.display = true;
          const toggleShowHide = () => {
            this.display = !this.display || !this.flashing;
            this.timer = setTimeout(toggleShowHide, 400);
          };
          clearTimeout(this.timer);
          this.timer = setTimeout(toggleShowHide, 400);
        }
      } else {
        this.display = false;
        clearTimeout(this.timer);
      }
    }
    hide() {
      this.display = false;
      clearTimeout(this.timer);
      this.positionChangeEvent.next(null);
    }
    destroy() {
      clearTimeout(this.timer);
      this.subscription.unsubscribe();
      this.subs.forEach((i2) => i2.unsubscribe());
    }
    correctScrollTop(scroller) {
      this.subs.forEach((i2) => i2.unsubscribe());
      this.subs = [];
      const scheduler = this.scheduler;
      let docIsChanged = true;
      function limitPosition(position) {
        const { top, bottom } = scroller.getLimit();
        const caretTop = position.top;
        if (caretTop + position.height > bottom) {
          const offset = caretTop - bottom + position.height;
          scroller.setOffset(offset);
        } else if (position.top < top) {
          scroller.setOffset(-(top - position.top));
        }
      }
      let isPressed = false;
      this.subs.push(scroller.onScroll.subscribe(() => {
        if (this.oldPosition) {
          const rect = this.rect;
          this.oldPosition.top = rect.top;
          this.oldPosition.left = rect.left;
          this.oldPosition.height = rect.height;
        }
      }), fromEvent(document, "mousedown", true).subscribe(() => {
        isPressed = true;
      }), fromEvent(document, "mouseup", true).subscribe(() => {
        isPressed = false;
      }), scheduler.onDocChange.subscribe(() => {
        docIsChanged = true;
      }), this.onPositionChange.subscribe((position) => {
        if (position) {
          if (docIsChanged) {
            if (scheduler.lastChangesHasLocalUpdate) {
              limitPosition(position);
            } else if (this.oldPosition) {
              const offset = Math.floor(position.top - this.oldPosition.top);
              scroller.setOffset(offset);
            }
          } else if (!isPressed) {
            if (this.isFixed && this.oldPosition) {
              const offset = Math.floor(position.top - this.oldPosition.top);
              scroller.setOffset(offset);
            } else {
              limitPosition(position);
            }
          }
        }
        docIsChanged = false;
      }));
    }
    updateCursorPosition(nativeRange) {
      const startContainer = nativeRange.startContainer;
      const node = startContainer.nodeType === Node.ELEMENT_NODE ? startContainer : startContainer.parentNode;
      if ((node === null || node === void 0 ? void 0 : node.nodeType) !== Node.ELEMENT_NODE) {
        this.positionChangeEvent.next(null);
        return;
      }
      if (this.compositionState) {
        const compositionElement = this.compositionElement;
        compositionElement.innerText = this.compositionState.data;
        nativeRange = nativeRange.cloneRange();
        nativeRange.insertNode(compositionElement);
        nativeRange.selectNodeContents(compositionElement);
        nativeRange.collapse();
      }
      const rect = getLayoutRectByRange(nativeRange);
      const { fontSize, lineHeight, color } = getComputedStyle(node);
      let height;
      if (isNaN(+lineHeight)) {
        const f2 = parseFloat(lineHeight);
        if (isNaN(f2)) {
          height = parseFloat(fontSize);
        } else {
          height = f2;
        }
      } else {
        height = parseFloat(fontSize) * parseFloat(lineHeight);
      }
      const boxHeight = Math.max(Math.floor(Math.max(height, rect.height)), 12);
      let rectTop = rect.top;
      if (rect.height < height) {
        rectTop -= (height - rect.height) / 2;
      }
      rectTop = Math.floor(rectTop);
      const containerRect = this.editorMask.getBoundingClientRect();
      const top = Math.floor(rectTop - containerRect.top);
      const left = Math.floor(rect.left - containerRect.left);
      Object.assign(this.elementRef.style, {
        left: left + "px",
        top: top + "px",
        height: boxHeight + "px",
        lineHeight: boxHeight + "px",
        fontSize
      });
      this.caret.style.backgroundColor = color;
      this.styleChangeEvent.next({
        height: boxHeight + "px",
        lineHeight: boxHeight + "px",
        fontSize
      });
      this.positionChangeEvent.next({
        left,
        top: rectTop,
        height: boxHeight
      });
    }
  }
  let MagicInput = class MagicInput extends Input {
    set disabled(b2) {
      this._disabled = b2;
      if (b2 && this.textarea) {
        this.textarea.disabled = b2;
      }
    }
    get disabled() {
      return this._disabled;
    }
    constructor(parser, keyboard, commander, selection, controller, scheduler, textbus) {
      super();
      this.parser = parser;
      this.keyboard = keyboard;
      this.commander = commander;
      this.selection = selection;
      this.controller = controller;
      this.scheduler = scheduler;
      this.textbus = textbus;
      this.composition = false;
      this.compositionState = null;
      this.caret = new ExperimentalCaret(this.scheduler, this.textbus.get(VIEW_MASK));
      this.isSafari = isSafari();
      this.isFirefox = isFirefox();
      this.isMac = isMac();
      this.isWindows = isWindows();
      this._disabled = false;
      this.container = this.createEditableFrame();
      this.subscription = new Subscription();
      this.textarea = null;
      this.isFocus = false;
      this.nativeFocus = false;
      this.ignoreComposition = false;
      this.onReady = new Promise((resolve2) => {
        this.subscription.add(fromEvent(this.container, "load").subscribe(() => {
          const doc2 = this.container.contentDocument;
          doc2.open();
          doc2.write(iframeHTML);
          doc2.close();
          this.doc = doc2;
          this.init();
          resolve2();
        }), controller.onReadonlyStateChange.subscribe(() => {
          if (controller.readonly) {
            this.blur();
          }
        }));
      });
      this.caret.elementRef.append(this.container);
    }
    focus(range, restart) {
      var _a;
      if (!this.disabled) {
        this.caret.show(range, restart);
      }
      if (this.controller.readonly) {
        return;
      }
      if (!this.isFocus) {
        (_a = this.textarea) === null || _a === void 0 ? void 0 : _a.focus();
        setTimeout(() => {
          var _a2, _b, _c;
          if (!this.nativeFocus && this.isFocus) {
            this.subscription.unsubscribe();
            (_b = (_a2 = this.textarea) === null || _a2 === void 0 ? void 0 : _a2.parentNode) === null || _b === void 0 ? void 0 : _b.removeChild(this.textarea);
            this.subscription = new Subscription();
            this.init();
            (_c = this.textarea) === null || _c === void 0 ? void 0 : _c.focus();
          }
        });
      }
      this.isFocus = true;
    }
    blur() {
      var _a;
      this.caret.hide();
      (_a = this.textarea) === null || _a === void 0 ? void 0 : _a.blur();
      this.isFocus = false;
    }
    destroy() {
      this.caret.destroy();
      this.subscription.unsubscribe();
    }
    init() {
      const doc2 = this.doc;
      const contentBody = doc2.body;
      const textarea = doc2.createElement("textarea");
      textarea.disabled = this.disabled;
      contentBody.appendChild(textarea);
      this.textarea = textarea;
      this.subscription.add(fromEvent(textarea, "blur").subscribe(() => {
        this.isFocus = false;
        this.nativeFocus = false;
        this.caret.hide();
      }), fromEvent(textarea, "focus").subscribe(() => {
        this.nativeFocus = true;
      }), this.caret.onStyleChange.subscribe((style) => {
        Object.assign(textarea.style, style);
      }));
      this.handleInput(textarea);
      this.handleShortcut(textarea);
      this.handleDefaultActions(textarea);
    }
    handleDefaultActions(textarea) {
      this.subscription.add(fromEvent(document, "copy").subscribe((ev) => {
        const selection = this.selection;
        if (!selection.isSelected) {
          return;
        }
        if (selection.startSlot === selection.endSlot && selection.endOffset - selection.startOffset === 1) {
          const content = selection.startSlot.getContentAtIndex(selection.startOffset);
          if (typeof content === "object") {
            const clipboardData = ev.clipboardData;
            const nativeSelection = document.getSelection();
            const range = nativeSelection.getRangeAt(0);
            const div = document.createElement("div");
            const fragment = range.cloneContents();
            div.append(fragment);
            clipboardData.setData("text/html", div.innerHTML);
            clipboardData.setData("text", div.innerText);
            ev.preventDefault();
          }
        }
      }), fromEvent(textarea, "paste").subscribe((ev) => {
        const text = ev.clipboardData.getData("Text");
        const files = Array.from(ev.clipboardData.files);
        if (files.length) {
          Promise.all(files.filter((i2) => {
            return /image/i.test(i2.type);
          }).map((item) => {
            const reader = new FileReader();
            return new Promise((resolve2) => {
              reader.onload = (event) => {
                resolve2(event.target.result);
              };
              reader.readAsDataURL(item);
            });
          })).then((urls) => {
            const html = urls.map((i2) => {
              return `<img src=${i2}>`;
            }).join("");
            this.handlePaste(html, text);
          });
          ev.preventDefault();
          return;
        }
        const div = this.doc.createElement("div");
        div.style.cssText = "width:1px; height:10px; overflow: hidden; position: fixed; left: 50%; top: 50%; opacity:0";
        div.contentEditable = "true";
        this.doc.body.appendChild(div);
        div.focus();
        setTimeout(() => {
          this.doc.body.removeChild(div);
          div.style.cssText = "";
          this.handlePaste(div, text);
        });
      }));
    }
    handlePaste(dom, text) {
      const slot = this.parser.parse(dom, new Slot([
        ContentType.BlockComponent,
        ContentType.InlineComponent,
        ContentType.Text
      ]));
      this.commander.paste(slot, text);
    }
    handleShortcut(textarea) {
      let isWriting = false;
      let isIgnore = false;
      this.subscription.add(fromEvent(textarea, "compositionstart").subscribe(() => {
        isWriting = true;
      }), fromEvent(textarea, "compositionend").subscribe(() => {
        isWriting = false;
      }), fromEvent(textarea, "beforeinput").subscribe((ev) => {
        if (this.isSafari) {
          if (ev.inputType === "insertFromComposition") {
            isIgnore = true;
          }
        }
      }), fromEvent(textarea, "keydown").pipe(filter(() => {
        if (this.isSafari && isIgnore) {
          isIgnore = false;
          return false;
        }
        return !isWriting;
      })).subscribe((ev) => {
        this.ignoreComposition = false;
        let key = ev.key;
        const keys = ")!@#$%^Z&*(";
        const b2 = key === "Process" && /Digit\d/.test(ev.code) && ev.shiftKey;
        if (b2) {
          key = keys.charAt(+ev.code.substring(5));
          ev.preventDefault();
        }
        const is = this.keyboard.execShortcut({
          key,
          altKey: ev.altKey,
          shiftKey: ev.shiftKey,
          ctrlKey: this.isMac ? ev.metaKey : ev.ctrlKey
        });
        if (is) {
          this.ignoreComposition = true;
          ev.preventDefault();
        }
      }));
    }
    handleInput(textarea) {
      let startIndex = 0;
      this.subscription.add(fromEvent(textarea, "compositionstart").pipe(filter(() => {
        return !this.ignoreComposition;
      })).subscribe(() => {
        if (!this.selection.isCollapsed) {
          this.commander.delete();
        }
        this.composition = true;
        this.caret.compositionState = this.compositionState = null;
        startIndex = this.selection.startOffset;
        const startSlot = this.selection.startSlot;
        const event = new Event(startSlot, {
          index: startIndex
        });
        invokeListener(startSlot.parent, "onCompositionStart", event);
      }), fromEvent(textarea, "compositionupdate").pipe(filter(() => {
        return !this.ignoreComposition;
      })).pipe(distinctUntilChanged((prev, next) => {
        return prev.data !== next.data;
      })).subscribe((ev) => {
        if (ev.data === " ") {
          return;
        }
        const startSlot = this.selection.startSlot;
        this.caret.compositionState = this.compositionState = {
          slot: startSlot,
          index: startIndex,
          data: ev.data
        };
        this.caret.refresh(true);
        const event = new Event(startSlot, {
          index: startIndex,
          data: ev.data
        });
        invokeListener(startSlot.parent, "onCompositionUpdate", event);
      }));
      let isCompositionEnd = false;
      this.subscription.add(merge(fromEvent(textarea, "beforeinput").pipe(filter((ev) => {
        ev.preventDefault();
        if (this.isFirefox && ev.inputType === "insertFromPaste") {
          return false;
        }
        if (this.isSafari) {
          isCompositionEnd = ev.inputType === "insertFromComposition";
          return ev.inputType === "insertText" || ev.inputType === "insertFromComposition";
        }
        return !ev.isComposing && !!ev.data;
      }), map((ev) => {
        return ev.data;
      })), this.isSafari ? new Observable() : fromEvent(textarea, "compositionend").pipe(filter(() => {
        return !this.ignoreComposition;
      })).pipe(map((ev) => {
        isCompositionEnd = true;
        ev.preventDefault();
        textarea.value = "";
        return ev.data;
      }))).subscribe((text) => {
        this.composition = false;
        this.caret.compositionState = this.compositionState = null;
        const compositionElement = this.caret.compositionElement;
        let nextSibling = compositionElement.nextSibling;
        while (nextSibling) {
          if (!nextSibling.textContent) {
            const next = nextSibling.nextSibling;
            nextSibling.remove();
            nextSibling = next;
            continue;
          }
          nextSibling.remove();
          break;
        }
        compositionElement.remove();
        if (text) {
          this.commander.write(text);
        }
        if (isCompositionEnd) {
          const startSlot = this.selection.startSlot;
          if (startSlot) {
            const event = new Event(startSlot, null);
            invokeListener(startSlot.parent, "onCompositionEnd", event);
          }
        }
        isCompositionEnd = false;
      }));
    }
    createEditableFrame() {
      return createElement("iframe", {
        attrs: {
          scrolling: "no"
        },
        styles: {
          border: "none",
          width: "100%",
          display: "block",
          height: "100%",
          position: "relative",
          top: this.isWindows ? "3px" : "0"
        }
      });
    }
  };
  MagicInput = __decorate([
    Injectable(),
    __metadata("design:paramtypes", [
      Parser,
      Keyboard,
      Commander,
      Selection,
      Controller,
      Scheduler,
      Textbus
    ])
  ], MagicInput);
  class CollaborateSelectionAwarenessDelegate {
  }
  let CollaborateCursor = class CollaborateCursor {
    constructor(textbus, nativeSelection, scheduler, selection, awarenessDelegate) {
      this.nativeSelection = nativeSelection;
      this.scheduler = scheduler;
      this.selection = selection;
      this.awarenessDelegate = awarenessDelegate;
      this.host = createElement("div", {
        styles: {
          position: "absolute",
          left: 0,
          top: 0,
          width: "100%",
          height: "100%",
          pointerEvents: "none",
          zIndex: 1
        }
      });
      this.canvasContainer = createElement("div", {
        styles: {
          position: "absolute",
          left: 0,
          top: 0,
          width: "100%",
          height: "100%",
          overflow: "hidden"
        }
      });
      this.canvas = createElement("canvas", {
        styles: {
          position: "absolute",
          opacity: 0.5,
          left: 0,
          top: 0,
          width: "100%",
          height: document.documentElement.clientHeight + "px",
          pointerEvents: "none"
        }
      });
      this.context = this.canvas.getContext("2d");
      this.tooltips = createElement("div", {
        styles: {
          position: "absolute",
          left: 0,
          top: 0,
          width: "100%",
          height: "100%",
          pointerEvents: "none",
          fontSize: "12px",
          zIndex: 10
        }
      });
      this.onRectsChange = new Subject();
      this.subscription = new Subscription();
      this.currentSelection = [];
      this.container = textbus.get(VIEW_CONTAINER);
      this.canvasContainer.append(this.canvas);
      this.host.append(this.canvasContainer, this.tooltips);
      this.container.prepend(this.host);
      this.subscription.add(this.onRectsChange.subscribe((rects) => {
        for (const rect of rects) {
          this.context.fillStyle = rect.color;
          this.context.beginPath();
          this.context.rect(rect.left, rect.top, rect.width, rect.height);
          this.context.fill();
          this.context.closePath();
        }
      }), fromEvent(window, "resize").subscribe(() => {
        this.canvas.style.height = document.documentElement.clientHeight + "px";
        this.refresh();
      }), this.scheduler.onDocChanged.subscribe(() => {
        this.refresh();
      }));
    }
    /**
     * 刷新协作光标，由于 Textbus 只会绘制可视区域的光标，当可视区域发生变化时，需要重新绘制
     */
    refresh() {
      this.draw(this.currentSelection);
    }
    destroy() {
      this.subscription.unsubscribe();
    }
    /**
     * 根据远程用户光标位置，绘制协作光标
     * @param paths
     */
    draw(paths) {
      this.currentSelection = paths;
      const containerRect = this.container.getBoundingClientRect();
      this.canvas.style.top = containerRect.top * -1 + "px";
      this.canvas.width = this.canvas.offsetWidth;
      this.canvas.height = this.canvas.offsetHeight;
      this.context.clearRect(0, 0, this.canvas.width, this.canvas.height);
      const users = [];
      paths.filter((i2) => {
        return i2.paths.anchor.length && i2.paths.focus.length;
      }).forEach((item) => {
        const anchorPaths = [...item.paths.anchor];
        const focusPaths = [...item.paths.focus];
        const anchorOffset = anchorPaths.pop();
        const anchorSlot = this.selection.findSlotByPaths(anchorPaths);
        const focusOffset = focusPaths.pop();
        const focusSlot = this.selection.findSlotByPaths(focusPaths);
        if (!anchorSlot || !focusSlot) {
          return;
        }
        const { focus, anchor } = this.nativeSelection.getPositionByRange({
          focusOffset,
          anchorOffset,
          focusSlot,
          anchorSlot
        });
        if (!focus || !anchor) {
          return;
        }
        const nativeRange = document.createRange();
        nativeRange.setStart(anchor.node, anchor.offset);
        nativeRange.setEnd(focus.node, focus.offset);
        if ((anchor.node !== focus.node || anchor.offset !== focus.offset) && nativeRange.collapsed) {
          nativeRange.setStart(focus.node, focus.offset);
          nativeRange.setEnd(anchor.node, anchor.offset);
        }
        let rects = false;
        if (this.awarenessDelegate) {
          rects = this.awarenessDelegate.getRects({
            focusOffset,
            anchorOffset,
            focusSlot,
            anchorSlot
          }, nativeRange);
        }
        if (!rects) {
          rects = nativeRange.getClientRects();
        }
        const selectionRects = [];
        for (let i2 = rects.length - 1; i2 >= 0; i2--) {
          const rect2 = rects[i2];
          selectionRects.push({
            id: item.id,
            color: item.color,
            username: item.username,
            left: rect2.left - containerRect.left,
            top: rect2.top,
            width: rect2.width,
            height: rect2.height
          });
        }
        this.onRectsChange.next(selectionRects);
        const cursorRange = nativeRange.cloneRange();
        cursorRange.setStart(focus.node, focus.offset);
        cursorRange.collapse(true);
        const cursorRect = getLayoutRectByRange(cursorRange);
        const rect = {
          id: item.id,
          username: item.username,
          color: item.color,
          left: cursorRect.left - containerRect.left,
          top: cursorRect.top - containerRect.top,
          width: 1,
          height: cursorRect.height
        };
        if (rect.left < 0 || rect.top < 0 || rect.left > containerRect.width) {
          return;
        }
        users.push(rect);
      });
      this.drawUserCursor(users);
    }
    drawUserCursor(rects) {
      for (let i2 = 0; i2 < rects.length; i2++) {
        const rect = rects[i2];
        const { cursor, userTip, anchor } = this.getUserCursor(i2);
        Object.assign(cursor.style, {
          left: rect.left + "px",
          top: rect.top + "px",
          width: rect.width + "px",
          height: rect.height + "px",
          background: rect.color,
          display: "block"
        });
        anchor.style.background = rect.color;
        userTip.innerText = rect.username;
        userTip.style.background = rect.color;
      }
      for (let i2 = rects.length; i2 < this.tooltips.children.length; i2++) {
        this.tooltips.removeChild(this.tooltips.children[i2]);
      }
    }
    getUserCursor(index) {
      let child = this.tooltips.children[index];
      if (child) {
        const anchor2 = child.children[0];
        return {
          cursor: child,
          anchor: anchor2,
          userTip: anchor2.children[0]
        };
      }
      const userTip = createElement("span", {
        styles: {
          position: "absolute",
          left: "50%",
          transform: "translateX(-50%)",
          marginBottom: "2px",
          bottom: "100%",
          whiteSpace: "nowrap",
          color: "#fff",
          boxShadow: "0 1px 2px rgba(0,0,0,.1)",
          opacity: 0.8,
          borderRadius: "3px",
          padding: "3px 5px",
          pointerEvents: "none"
        }
      });
      const anchor = createElement("span", {
        styles: {
          position: "absolute",
          top: "-2px",
          left: "-2px",
          width: "5px",
          height: "5px",
          borderRadius: "50%",
          pointerEvents: "auto",
          pointer: "cursor"
        },
        children: [userTip]
      });
      child = createElement("span", {
        styles: {
          position: "absolute"
        },
        children: [
          anchor
        ]
      });
      this.tooltips.append(child);
      return {
        cursor: child,
        anchor,
        userTip
      };
    }
  };
  CollaborateCursor = __decorate([
    Injectable(),
    __param(4, Optional()),
    __metadata("design:paramtypes", [
      Textbus,
      SelectionBridge,
      Scheduler,
      Selection,
      CollaborateSelectionAwarenessDelegate
    ])
  ], CollaborateCursor);
  class NativeCaret {
    set nativeRange(range) {
      this._nativeRange = range;
      if (range) {
        const r2 = range.cloneRange();
        r2.collapse(true);
        const rect = getLayoutRectByRange(r2);
        this.positionChangeEvent.next({
          left: rect.left,
          top: rect.top,
          height: rect.height
        });
      } else {
        this.positionChangeEvent.next(null);
      }
    }
    get nativeRange() {
      return this._nativeRange;
    }
    get rect() {
      if (this.nativeRange) {
        const range = this.nativeRange.cloneRange();
        range.collapse(true);
        return getLayoutRectByRange(range);
      }
      return {
        left: 0,
        top: 0,
        width: 0,
        height: 0
      };
    }
    constructor(scheduler) {
      this.scheduler = scheduler;
      this.oldPosition = null;
      this._nativeRange = null;
      this.subs = [];
      this.positionChangeEvent = new Subject();
      this.onPositionChange = this.positionChangeEvent.pipe(distinctUntilChanged());
    }
    refresh() {
    }
    correctScrollTop(scroller) {
      this.destroy();
      const scheduler = this.scheduler;
      let docIsChanged = true;
      function limitPosition(position) {
        const { top, bottom } = scroller.getLimit();
        const caretTop = position.top;
        if (caretTop + position.height > bottom) {
          const offset = caretTop - bottom + position.height;
          scroller.setOffset(offset);
        } else if (position.top < top) {
          scroller.setOffset(-(top - position.top));
        }
      }
      let isPressed = false;
      this.subs.push(scroller.onScroll.subscribe(() => {
        if (this.oldPosition) {
          const rect = this.rect;
          this.oldPosition.top = rect.top;
          this.oldPosition.left = rect.left;
          this.oldPosition.height = rect.height;
        }
      }), fromEvent(document, "mousedown", true).subscribe(() => {
        isPressed = true;
      }), fromEvent(document, "mouseup", true).subscribe(() => {
        isPressed = false;
      }), scheduler.onDocChange.subscribe(() => {
        docIsChanged = true;
      }), this.onPositionChange.subscribe((position) => {
        if (position) {
          if (docIsChanged) {
            if (scheduler.lastChangesHasLocalUpdate) {
              limitPosition(position);
            } else if (this.oldPosition) {
              const offset = Math.floor(position.top - this.oldPosition.top);
              scroller.setOffset(offset);
            }
          } else if (!isPressed) {
            if (this.oldPosition) {
              const offset = Math.floor(position.top - this.oldPosition.top);
              scroller.setOffset(offset);
            } else {
              limitPosition(position);
            }
          }
        }
        docIsChanged = false;
      }));
    }
    destroy() {
      this.subs.forEach((i2) => i2.unsubscribe());
      this.subs = [];
    }
  }
  let NativeInput = class NativeInput extends Input {
    set disabled(b2) {
      this._disabled = b2;
      if (this.controller.readonly) {
        this.documentView.contentEditable = "false";
        return;
      }
      this.documentView.contentEditable = b2 ? "false" : "true";
    }
    get disabled() {
      return this._disabled;
    }
    constructor(textbus, parser, scheduler, selection, keyboard, domAdapter, commander, controller) {
      super();
      this.parser = parser;
      this.scheduler = scheduler;
      this.selection = selection;
      this.keyboard = keyboard;
      this.domAdapter = domAdapter;
      this.commander = commander;
      this.controller = controller;
      this.caret = new NativeCaret(this.scheduler);
      this.composition = false;
      this.compositionState = null;
      this.onReady = Promise.resolve();
      this._disabled = false;
      this.nativeSelection = document.getSelection();
      this.subscription = new Subscription();
      this.nativeRange = null;
      this.isSafari = isSafari();
      this.isMac = isMac();
      this.isMobileBrowser = isMobileBrowser();
      this.ignoreComposition = false;
      this.documentView = textbus.get(VIEW_DOCUMENT);
      if (!controller.readonly) {
        this.documentView.contentEditable = "true";
      }
      this.subscription.add(controller.onReadonlyStateChange.subscribe(() => {
        this.documentView.contentEditable = controller.readonly ? "false" : "true";
      }));
      this.handleShortcut(this.documentView);
      this.handleInput(this.documentView);
      this.handleDefaultActions(this.documentView);
    }
    focus(nativeRange) {
      if (this.controller.readonly) {
        return;
      }
      this.caret.nativeRange = nativeRange;
      this.nativeRange = nativeRange;
    }
    blur() {
      if (this.nativeRange && this.nativeSelection.rangeCount > 0) {
        const current = this.nativeSelection.getRangeAt(0);
        if (current === this.nativeRange) {
          this.nativeSelection.removeAllRanges();
          this.nativeRange = null;
          return;
        }
      }
    }
    destroy() {
      this.caret.destroy();
      this.subscription.unsubscribe();
    }
    handleDefaultActions(textarea) {
      this.subscription.add(fromEvent(document, "copy").subscribe((ev) => {
        const selection = this.selection;
        if (!selection.isSelected) {
          return;
        }
        if (selection.startSlot === selection.endSlot && selection.endOffset - selection.startOffset === 1) {
          const content = selection.startSlot.getContentAtIndex(selection.startOffset);
          if (typeof content === "object") {
            const clipboardData = ev.clipboardData;
            const nativeSelection = document.getSelection();
            const range = nativeSelection.getRangeAt(0);
            const div = document.createElement("div");
            const fragment = range.cloneContents();
            div.append(fragment);
            clipboardData.setData("text/html", div.innerHTML);
            clipboardData.setData("text", div.innerText);
            ev.preventDefault();
          }
        }
      }), fromEvent(textarea, "paste").subscribe((ev) => {
        const text = ev.clipboardData.getData("Text");
        const files = Array.from(ev.clipboardData.files);
        if (files.length) {
          Promise.all(files.filter((i2) => {
            return /image/i.test(i2.type);
          }).map((item) => {
            const reader = new FileReader();
            return new Promise((resolve2) => {
              reader.onload = (event) => {
                resolve2(event.target.result);
              };
              reader.readAsDataURL(item);
            });
          })).then((urls) => {
            const html = urls.map((i2) => {
              return `<img src=${i2}>`;
            }).join("");
            this.handlePaste(html, text);
          });
          ev.preventDefault();
          return;
        }
        const div = document.createElement("div");
        div.style.cssText = "width:1px; height:10px; overflow: hidden; position: fixed; left: 50%; top: 50%; opacity:0";
        div.contentEditable = "true";
        document.body.appendChild(div);
        div.focus();
        setTimeout(() => {
          document.body.removeChild(div);
          div.style.cssText = "";
          this.handlePaste(div, text);
        });
      }));
    }
    handlePaste(dom, text) {
      const slot = this.parser.parse(dom, new Slot([
        ContentType.BlockComponent,
        ContentType.InlineComponent,
        ContentType.Text
      ]));
      this.commander.paste(slot, text);
    }
    handleShortcut(input) {
      let isWriting = false;
      let isIgnore = false;
      this.subscription.add(fromEvent(input, "compositionstart").subscribe(() => {
        isWriting = true;
      }), fromEvent(input, "compositionend").subscribe(() => {
        isWriting = false;
      }), fromEvent(input, "beforeinput").subscribe((ev) => {
        if (this.isSafari) {
          if (ev.inputType === "insertFromComposition") {
            isIgnore = true;
          }
        }
      }), fromEvent(input, "keydown").pipe(filter(() => {
        if (this.isSafari && isIgnore) {
          isIgnore = false;
          return false;
        }
        return !isWriting;
      })).subscribe((ev) => {
        this.ignoreComposition = false;
        let key = ev.key;
        const keys = ")!@#$%^Z&*(";
        const b2 = key === "Process" && /Digit\d/.test(ev.code) && ev.shiftKey;
        if (b2) {
          key = keys.charAt(+ev.code.substring(5));
          ev.preventDefault();
        }
        const is = this.keyboard.execShortcut({
          key,
          altKey: ev.altKey,
          shiftKey: ev.shiftKey,
          ctrlKey: this.isMac ? ev.metaKey : ev.ctrlKey
        });
        if (is) {
          this.ignoreComposition = true;
          ev.preventDefault();
        }
      }));
    }
    handleInput(input) {
      if (this.isMobileBrowser) {
        this.handleMobileInput(input);
      } else {
        this.handlePCInput(input);
      }
    }
    handleMobileInput(input) {
      let isCompositionStart = true;
      let startIndex;
      const compositionStart = () => {
        this.composition = true;
        this.compositionState = null;
        startIndex = this.selection.startOffset;
        const startSlot = this.selection.startSlot;
        const event = new Event(startSlot, {
          index: startIndex
        });
        invokeListener(startSlot.parent, "onCompositionStart", event);
      };
      const compositionUpdate = (data) => {
        const startSlot = this.selection.startSlot;
        this.compositionState = {
          slot: startSlot,
          index: startIndex,
          data
        };
        const event = new Event(startSlot, {
          index: startIndex,
          data
        });
        invokeListener(startSlot.parent, "onCompositionUpdate", event);
      };
      const compositionEnd = (data) => {
        this.composition = false;
        if (data) {
          this.commander.write(data);
        }
        const startSlot = this.selection.startSlot;
        if (startSlot) {
          const event = new Event(startSlot, null);
          invokeListener(startSlot.parent, "onCompositionEnd", event);
        }
      };
      this.subscription.add(fromEvent(input, "compositionstart").subscribe(() => {
        compositionStart();
      }), fromEvent(input, "compositionupdate").subscribe((ev) => {
        compositionUpdate(ev.data);
      }), fromEvent(input, "compositionend").subscribe((ev) => {
        compositionEnd(ev.data);
      }), fromEvent(input, "beforeinput").subscribe((ev) => {
        var _a;
        switch (ev.inputType) {
          case "insertText":
            if (ev.data) {
              this.commander.write(ev.data);
              ev.preventDefault();
            }
            break;
          case "insertCompositionText":
            if (isCompositionStart) {
              isCompositionStart = false;
              compositionStart();
            } else {
              compositionUpdate(ev.data || "");
            }
            break;
          case "deleteCompositionText":
            this.composition = false;
            break;
          case "deleteContentBackward": {
            this.composition = false;
            const range = ev.getTargetRanges()[0];
            if (!range) {
              break;
            }
            const location = this.domAdapter.getLocationByNativeNode(range.startContainer);
            const startSlot = this.selection.startSlot;
            if (startSlot) {
              this.selection.setBaseAndExtent(startSlot, location.startIndex + range.startOffset, startSlot, location.startIndex + range.endOffset);
              this.commander.delete();
            }
            break;
          }
          case "insertReplacementText": {
            this.composition = false;
            const range = ev.getTargetRanges()[0];
            const location = this.domAdapter.getLocationByNativeNode(range.startContainer);
            const startSlot = this.selection.startSlot;
            this.selection.setBaseAndExtent(startSlot, location.startIndex + range.startOffset, startSlot, location.startIndex + range.endOffset);
            this.commander.delete();
            const text = ((_a = ev.dataTransfer) === null || _a === void 0 ? void 0 : _a.getData("text")) || ev.data || null;
            if (text) {
              this.commander.write(text);
            }
            break;
          }
        }
      }));
    }
    handlePCInput(input) {
      let startIndex = 0;
      let isCompositionEnd = false;
      this.subscription.add(fromEvent(input, "compositionstart").pipe(filter(() => {
        return !this.ignoreComposition;
      })).subscribe(() => {
        this.composition = true;
        this.compositionState = null;
        startIndex = this.selection.startOffset;
        const startSlot = this.selection.startSlot;
        const event = new Event(startSlot, {
          index: startIndex
        });
        invokeListener(startSlot.parent, "onCompositionStart", event);
      }), fromEvent(input, "compositionupdate").pipe(filter(() => {
        return !this.ignoreComposition;
      })).subscribe((ev) => {
        const startSlot = this.selection.startSlot;
        this.compositionState = {
          slot: startSlot,
          index: startIndex,
          data: ev.data
        };
        const event = new Event(startSlot, {
          index: startIndex,
          data: ev.data
        });
        invokeListener(startSlot.parent, "onCompositionUpdate", event);
      }), merge(fromEvent(input, "beforeinput").pipe(map((ev) => {
        var _a;
        ev.preventDefault();
        if (ev.inputType === "insertCompositionText") {
          return null;
        }
        if (ev.inputType === "insertReplacementText") {
          const range = ev.getTargetRanges()[0];
          const location = this.domAdapter.getLocationByNativeNode(range.startContainer);
          const startSlot = this.selection.startSlot;
          this.selection.setBaseAndExtent(startSlot, location.startIndex + range.startOffset, startSlot, location.startIndex + range.endOffset);
          this.commander.delete();
          return ((_a = ev.dataTransfer) === null || _a === void 0 ? void 0 : _a.getData("text")) || ev.data || null;
        }
        isCompositionEnd = ev.inputType === "insertFromComposition";
        if (isCompositionEnd && this.composition) {
          return null;
        }
        if (this.isSafari) {
          if (ev.inputType === "insertText" || isCompositionEnd) {
            return ev.data;
          }
        }
        if (!ev.isComposing && !!ev.data) {
          return ev.data;
        }
        return null;
      }), filter((text) => {
        return text;
      })), this.isSafari ? new Observable() : fromEvent(input, "compositionend").pipe(filter(() => {
        return !this.ignoreComposition;
      })).pipe(filter(() => {
        return this.composition;
      }), map((ev) => {
        isCompositionEnd = true;
        ev.preventDefault();
        return ev.data;
      }), filter(() => {
        const b2 = this.ignoreComposition;
        this.ignoreComposition = false;
        return !b2;
      }))).subscribe((text) => {
        this.composition = false;
        this.compositionState = null;
        if (text) {
          this.commander.write(text);
        }
        if (isCompositionEnd) {
          const startSlot = this.selection.startSlot;
          if (startSlot) {
            const event = new Event(startSlot, null);
            invokeListener(startSlot.parent, "onCompositionEnd", event);
          }
        }
        isCompositionEnd = false;
      }));
    }
  };
  NativeInput = __decorate([
    Injectable(),
    __metadata("design:paramtypes", [
      Textbus,
      Parser,
      Scheduler,
      Selection,
      Keyboard,
      DomAdapter,
      Commander,
      Controller
    ])
  ], NativeInput);
  const browserErrorFn = makeError("BrowserModule");
  class BrowserModule {
    constructor(config) {
      this.config = config;
      const { mask, wrapper } = BrowserModule.createLayout();
      wrapper.prepend(config.adapter.host);
      if (config.minHeight) {
        config.adapter.host.style.minHeight = config.minHeight;
      }
      this.providers = [
        {
          provide: EDITOR_OPTIONS,
          useValue: config
        },
        {
          provide: VIEW_CONTAINER,
          useValue: wrapper
        },
        {
          provide: VIEW_DOCUMENT,
          useValue: config.adapter.host
        },
        {
          provide: VIEW_MASK,
          useValue: mask
        },
        {
          provide: NativeSelectionBridge,
          useExisting: SelectionBridge
        },
        {
          provide: Input,
          useClass: config.useContentEditable ? NativeInput : MagicInput
        },
        {
          provide: ViewAdapter,
          useFactory(v2) {
            return v2;
          },
          deps: [DomAdapter]
        },
        {
          provide: DomAdapter,
          useValue: config.adapter
        },
        {
          provide: FocusManager,
          useFactory: (input) => {
            const focusEvent = new Subject();
            const blurEvent = new Subject();
            input.caret.onPositionChange.pipe(map((p2) => !!p2), distinctUntilChanged()).subscribe((b2) => {
              if (b2) {
                focusEvent.next();
              } else {
                blurEvent.next();
              }
            });
            return {
              onFocus: focusEvent,
              onBlur: blurEvent
            };
          },
          deps: [Input]
        },
        Parser,
        SelectionBridge,
        CollaborateCursor
      ];
      this.workbench = wrapper;
    }
    /**
     * 解析 HTML 并返回一个组件实例
     * @param html 要解析的 HTML
     * @param rootComponentLoader 文档根组件加载器
     * @param textbus
     */
    readDocumentByHTML(html, rootComponentLoader, textbus) {
      const parser = textbus.get(Parser);
      const doc2 = parser.parseDoc(html, rootComponentLoader);
      if (doc2 instanceof ComponentInstance) {
        return doc2;
      }
      throw browserErrorFn("rootComponentLoader must return a component instance.");
    }
    /**
     * 将组件数据解析到组件实例中
     * @param data 要解析的 JSON 数据
     * @param rootComponent 根组件
     * @param textbus
     */
    readDocumentByComponentLiteral(data, rootComponent2, textbus) {
      const registry = textbus.get(Registry);
      return registry.createComponentByFactory(data, rootComponent2);
    }
    setup() {
      const host = this.config.renderTo();
      if (!(host instanceof HTMLElement)) {
        throw browserErrorFn("view container is not a HTMLElement");
      }
      host.append(this.workbench);
      return () => {
        this.workbench.remove();
      };
    }
    onAfterStartup(textbus) {
      if (this.config.autoFocus) {
        textbus.focus();
      }
    }
    static createLayout() {
      const mask = createElement("div", {
        attrs: {
          "data-textbus-view": VIEW_MASK
        },
        styles: {
          position: "absolute",
          left: 0,
          right: 0,
          top: 0,
          bottom: 0,
          zIndex: 1,
          pointerEvents: "none",
          overflow: "hidden"
        }
      });
      const wrapper = createElement("div", {
        attrs: {
          "data-textbus-view": VIEW_CONTAINER
        },
        styles: {
          display: "flex",
          minHeight: "100%",
          position: "relative",
          flexDirection: "column"
        },
        children: [mask]
      });
      return {
        wrapper,
        mask
      };
    }
  }
  const adapterError = makeError("VueAdapter");
  class Adapter extends DomAdapter {
    constructor(components, mount) {
      super(mount);
      this.onViewUpdated = new Subject();
      this.components = {};
      this.componentRefs = /* @__PURE__ */ new WeakMap();
      Object.keys(components).forEach((key) => {
        const vueComponent = components[key];
        const setup = vueComponent.setup;
        const self2 = this;
        vueComponent.setup = function(props) {
          const component = props.component;
          const vueInstance = getCurrentInstance();
          const sub = component.changeMarker.onChange.subscribe(() => {
            if (component.changeMarker.dirty) {
              vueInstance.proxy.$forceUpdate();
            }
          });
          onMounted(() => {
            if (props.rootRef.value) {
              self2.componentRootElementCaches.set(component, props.rootRef.value);
            } else {
              self2.componentRootElementCaches.remove(component);
            }
          });
          onUpdated(() => {
            component.changeMarker.rendered();
            self2.onViewUpdated.next();
          });
          onUnmounted(() => {
            sub.unsubscribe();
          });
          return setup(props);
        };
        this.components[key] = vueComponent;
      });
    }
    componentRender(component) {
      const comp = this.components[component.name] || this.components["*"];
      if (comp) {
        let rootRef = this.componentRefs.get(component);
        if (!rootRef) {
          rootRef = ref();
          this.componentRefs.set(component, rootRef);
        }
        return h$1(comp, {
          component,
          rootRef,
          key: component.id
        });
      }
      throw adapterError(`cannot found view component \`${component.name}\`!`);
    }
    slotRender(slot, slotHostRender, renderEnv) {
      const vElement = slot.toTree(slotHostRender, renderEnv);
      this.slotRootVElementCaches.set(slot, vElement);
      const vNodeToJSX = (vNode) => {
        const children = [];
        for (let i2 = 0; i2 < vNode.children.length; i2++) {
          const child = vNode.children[i2];
          if (child instanceof VElement) {
            children.push(vNodeToJSX(child));
          } else if (child instanceof VTextNode) {
            children.push(replaceEmpty(child.textContent));
          } else {
            children.push(this.componentRender(child));
          }
        }
        const props = Object.assign({}, Array.from(vNode.attrs).reduce((a2, b2) => {
          a2[b2[0]] = b2[1];
          return a2;
        }, {}));
        if (vNode.classes.size) {
          props.class = Array.from(vNode.classes).join(" ");
        }
        if (vNode.styles) {
          props.style = Array.from(vNode.styles).reduce((a2, b2) => {
            a2[b2[0]] = b2[1];
            return a2;
          }, {});
        }
        return h$1(vNode.tagName, props, ...children);
      };
      const refFn = (nativeNode) => {
        if (!nativeNode) {
          this.slotRootNativeElementCaches.remove(slot);
        } else {
          this.slotRootNativeElementCaches.set(slot, nativeNode);
        }
      };
      const currentRef = vElement.attrs.get("ref");
      if (currentRef) {
        vElement.attrs.set("ref", (v2) => {
          refFn(v2);
          if (typeof currentRef === "function") {
            currentRef(v2);
          } else if (!currentRef.value) {
            currentRef.value = v2;
          }
        });
      } else {
        vElement.attrs.set("ref", refFn);
      }
      slot.changeMarker.rendered();
      return vNodeToJSX(vElement);
    }
  }
  var MappingType = /* @__PURE__ */ ((MappingType2) => {
    MappingType2["MappingField"] = "mappingField";
    MappingType2["Comparator"] = "comparator";
    MappingType2["Brackets"] = "brackets";
    MappingType2["Logical"] = "logical";
    MappingType2["InputValue"] = "inputValue";
    return MappingType2;
  })(MappingType || {});
  var ComponentName = /* @__PURE__ */ ((ComponentName2) => {
    ComponentName2["Root"] = "root";
    return ComponentName2;
  })(ComponentName || {});
  const TextbusInjectToken = Symbol("Textbus");
  const AdapterInjectToken = Symbol("Adapter");
  const SuggestInjectToken = Symbol("Suggest");
  const SPACE = " ";
  const mappingFieldFormatter = new Formatter(MappingType.MappingField, {
    columned: true,
    inheritable: false,
    render(children) {
      return createVNode("span", { class: "meditor-comp-" + MappingType.MappingField }, children);
    }
  });
  const comparatorFormatter = new Formatter(MappingType.Comparator, {
    columned: true,
    inheritable: false,
    render(children) {
      return createVNode("span", { class: "meditor-comp-" + MappingType.Comparator }, children);
    }
  });
  const inputValueFormatter = new Formatter(MappingType.InputValue, {
    columned: true,
    inheritable: false,
    render(children) {
      return createVNode("span", { class: "meditor-comp-" + MappingType.InputValue }, children);
    }
  });
  const logicalFormatter = new Formatter(MappingType.Logical, {
    columned: true,
    inheritable: false,
    render(children) {
      return createVNode("span", { class: "meditor-comp-" + MappingType.Logical }, children);
    }
  });
  const log = (part) => (...args) => {
    console.log(`【${part}】`, ...args);
  };
  const bracketColors = [
    "#FF6B6B",
    "#FFD166",
    "#06D6A0",
    "#118AB2",
    "#073B4C",
    "#EF476F",
    "#FFD166",
    "#06D6A0",
    "#118AB2",
    "#073B4C",
    "#EF476F",
    "#FFD166",
    "#06D6A0",
    "#118AB2",
    "#073B4C",
    "#EF476F",
    "#FFD166",
    "#06D6A0",
    "#118AB2",
    "#073B4C",
    "#EF476F",
    "#FFD166",
    "#06D6A0",
    "#118AB2",
    "#073B4C",
    "#EF476F",
    "#FFD166",
    "#06D6A0",
    "#118AB2",
    "#073B4C",
    "#EF476F"
  ];
  const getABracketColor = () => {
    return bracketColors[Math.floor(Math.random() * bracketColors.length)];
  };
  const parseFetchRes2FieldMapping = (res, type) => {
    if (!res || !res[type]) {
      console.warn(`[MEditor]:parseMapping error '${type.toString()}' is not in res`);
      return [];
    }
    const { mappings, modules } = res[type];
    const getMapping = (key) => {
      const item = mappings[key];
      return {
        name: item.label,
        value: key,
        match: item.label + "|" + key + "|" + key.toUpperCase() + "|" + key.toLowerCase(),
        type: mappings[key].type
      };
    };
    const searchRes = modules["search"].map((item) => {
      return {
        title: item.title,
        mappings: item.mappings.map((item2) => {
          return getMapping(item2);
        }),
        render: (item2) => {
          return `${item2.name}(${item2.value})`;
        }
      };
    });
    return searchRes;
  };
  const bracketsFormatter = new Formatter(MappingType.Brackets, {
    columned: true,
    inheritable: false,
    render(children) {
      return createVNode("span", {
        class: "meditor-comp-" + MappingType.Brackets,
        style: {
          color: getABracketColor()
        }
      }, children);
    }
  });
  const getFormatters = () => {
    return [mappingFieldFormatter, comparatorFormatter, inputValueFormatter, logicalFormatter];
  };
  const getFormatter = (type) => {
    switch (type) {
      case MappingType.MappingField:
        return mappingFieldFormatter;
      case MappingType.Comparator:
        return comparatorFormatter;
      case MappingType.InputValue:
        return inputValueFormatter;
      case MappingType.Logical:
        return logicalFormatter;
      case MappingType.Brackets:
        return bracketsFormatter;
      default:
        return null;
    }
  };
  const rootComponent = defineComponent({
    name: ComponentName.Root,
    type: ContentType.InlineComponent,
    validate(_2, initData) {
      var _a;
      return {
        slots: [
          ((_a = initData == null ? void 0 : initData.slots) == null ? void 0 : _a[0]) ?? new Slot([
            ContentType.Text
          ])
        ]
      };
    },
    setup() {
      const instance = useContext();
      const selection = useContext(Selection);
      const self2 = useSelf();
      let isInsert = false;
      selection.onChange.subscribe(() => {
        var _a;
        if (selection.isCollapsed && !isInsert) {
          const { endOffset } = selection;
          const preText = ((_a = self2.slots.first.sliceContent(0, endOffset)) == null ? void 0 : _a[0]) ?? "";
          const suggest = instance.suggest;
          suggest.filter(preText);
        }
      });
      const commander = useContext(Commander);
      onBreak((ev) => {
        ev.preventDefault();
      });
      onContentInsert((e) => {
        var _a, _b;
        isInsert = true;
        const { content, index } = e.data;
        const suggest = instance.suggest;
        if (content === SPACE) {
          const preText = ((_a = e.target.sliceContent(0, index)) == null ? void 0 : _a[0]) ?? "";
          const lastSpaceIndex = preText.lastIndexOf(SPACE) ?? 0;
          const mappingType = suggest.filter(preText + SPACE);
          const formatter = getFormatter(mappingType);
          if (formatter) {
            e.target.applyFormat(formatter, {
              value: true,
              startIndex: lastSpaceIndex,
              endIndex: index
            });
          }
        } else if (content === "(") {
          e.preventDefault();
          const formatter = getFormatter(MappingType.Brackets);
          commander.insert("(  )", formatter);
          selection.toPrevious();
          selection.toPrevious();
        } else {
          const preText = (((_b = e.target.sliceContent(0, index)) == null ? void 0 : _b[0]) ?? "") + content;
          suggest.filter(preText);
        }
      });
      onContentInserted(() => {
        setTimeout(() => {
          isInsert = false;
        }, 0);
      });
      onContentDelete((e) => {
        var _a;
        isInsert = true;
        const { index } = e.data;
        const suggest = instance.suggest;
        const preText = ((_a = e.target.sliceContent(0, index)) == null ? void 0 : _a[0]) ?? "";
        suggest.filter(preText);
      });
      onContentDeleted(() => {
        setTimeout(() => {
          isInsert = false;
        }, 0);
      });
    }
  });
  const __vite_glob_0_0 = /* @__PURE__ */ Object.freeze(/* @__PURE__ */ Object.defineProperty({
    __proto__: null,
    default: rootComponent
  }, Symbol.toStringTag, { value: "Module" }));
  const _sfc_main = /* @__PURE__ */ defineComponent$1({
    name: ComponentName.Root,
    props: ["component", "rootRef"],
    setup(props) {
      const adapter = inject(AdapterInjectToken);
      return {
        slotRender() {
          const slot = props.component.slots.first;
          return adapter.slotRender(slot, (children) => {
            return createVNode("div", {
              "data-component": ComponentName.Root,
              ref: props.rootRef,
              class: "meditor-" + ComponentName.Root
            }, children);
          });
        }
      };
    }
  });
  const _export_sfc = (sfc, props) => {
    const target = sfc.__vccOpts || sfc;
    for (const [key, val] of props) {
      target[key] = val;
    }
    return target;
  };
  function _sfc_render(_ctx, _cache, $props, $setup, $data, $options) {
    return openBlock(), createBlock(resolveDynamicComponent(_ctx.slotRender()));
  }
  const root_view = /* @__PURE__ */ _export_sfc(_sfc_main, [["render", _sfc_render]]);
  const __vite_glob_1_0 = /* @__PURE__ */ Object.freeze(/* @__PURE__ */ Object.defineProperty({
    __proto__: null,
    default: root_view
  }, Symbol.toStringTag, { value: "Module" }));
  const componentModules = /* @__PURE__ */ Object.assign({
    "./root/root.ts": __vite_glob_0_0
  });
  const viewModules = /* @__PURE__ */ Object.assign({
    "./root/root.view.vue": __vite_glob_1_0
  });
  const getComponentList = () => {
    const obj = [];
    Object.keys(componentModules).forEach((item) => {
      obj.push(componentModules[item].default);
    });
    return obj;
  };
  const getAdapterComponents = () => {
    const obj = {};
    Object.keys(componentModules).forEach((item) => {
      const prefix = item.split("/").slice(0, -1).join("/");
      const name = item.split("/").slice(-1)[0].split(".")[0];
      obj[componentModules[item].default.name] = viewModules[prefix + "/" + name + ".view.vue"].default;
    });
    return obj;
  };
  const logicalMappings = {
    title: "逻辑运算符",
    render: (item) => {
      return item.name;
    },
    mappings: [
      {
        name: "and",
        value: "and"
      },
      {
        name: "or",
        value: "or"
      },
      {
        name: "not",
        value: "not"
      }
    ].map((item) => {
      return {
        ...item,
        match: `${item.name}|${item.name.toUpperCase()}`
      };
    })
  };
  const comparatorMappings = {
    title: "比较运算符",
    render: (item) => {
      return item.name;
    },
    mappings: [
      {
        name: "=",
        value: "="
      },
      {
        name: "!=",
        value: "!="
      },
      {
        name: ">=",
        value: ">="
      },
      {
        name: "<=",
        value: "<="
      },
      {
        name: ">",
        value: ">"
      },
      {
        name: "<",
        value: "<"
      },
      {
        name: "<>",
        value: "<>"
      },
      {
        name: "exist",
        value: "exist"
      },
      {
        name: "belong",
        value: "belong"
      },
      {
        name: "like",
        value: "like"
      }
    ].map((item) => {
      return {
        ...item,
        match: `${item.name}|${item.name.toUpperCase()}`
      };
    })
  };
  const EXIST_TEXT = "exist";
  const BELONG_TEXT = "belong";
  var MappingFieldType = /* @__PURE__ */ ((MappingFieldType2) => {
    MappingFieldType2["IP"] = "ip";
    MappingFieldType2["DATE"] = "date";
    MappingFieldType2["VALUE"] = "value";
    MappingFieldType2["STRING"] = "string";
    return MappingFieldType2;
  })(MappingFieldType || {});
  class Suggest {
    constructor(_config) {
      __publicField(this, "allMappings", /* @__PURE__ */ new Map());
      __publicField(this, "candiDateList", []);
      __publicField(this, "activeIndex", -1);
      __publicField(this, "loadingKey", null);
      __publicField(this, "_lastTimeStamp", (/* @__PURE__ */ new Date()).getTime());
      __publicField(this, "config");
      __publicField(this, "cacheMap", /* @__PURE__ */ new Map());
      __publicField(this, "signalMap", /* @__PURE__ */ new Set());
      this.config = _config;
      this.initData();
    }
    debugLog(...args) {
      var _a;
      if ((_a = this.config) == null ? void 0 : _a.debug)
        log("Suggest")(...args);
    }
    get wordElements() {
      const elements = this.config.wordElement();
      return elements;
    }
    /**
     * 当前待选的所有mappings
     * @types FieldMapping[]
     */
    get wordList() {
      return this.showList.map((item) => item.mappings).flat();
    }
    get showList() {
      return this.candiDateList;
    }
    /**
     * 当前选中的元素
     */
    get activeItem() {
      var _a;
      if (this.activeIndex === -1)
        return null;
      (_a = this.wordElements[this.activeIndex]) == null ? void 0 : _a.scrollIntoView({
        behavior: "smooth",
        block: "center"
      });
      return this.wordList[this.activeIndex];
    }
    /**
     * 当前是否正在loading
     */
    get loading() {
      return this.loadingKey !== null;
    }
    /**
     * 初始化数据
     */
    initData() {
      this.initFieldMapping();
      this.setMapping(MappingType.Logical, [logicalMappings]);
      this.setMapping(MappingType.Comparator, [comparatorMappings]);
    }
    initFieldMapping() {
      if (this.config.mapping instanceof Function) {
        this.setLoading(true);
        this.config.mapping().then((res) => {
          this.setMapping(MappingType.MappingField, res);
          this.setCandidateList(res ?? []);
        }).finally(() => {
          this.setLoading(false);
        });
      } else {
        this.setMapping(MappingType.MappingField, this.config.mapping ?? []);
        this.setCandidateList(this.config.mapping ?? []);
      }
    }
    /**
     * 将纯文本转换成格式化之后的数组
     * @param text
     * @example 'source_ip = 1.1.1.1 and dest_ip exist    '
     * ["source_ip","=","1.1.1.1","and","dest_ip","exist"]
     * @returns string
     */
    parseToStringArray(text) {
      return text.split(SPACE).filter((item) => item !== "");
    }
    /**
     * 传入一个非空字符串，返回对应的类型,匹配不到时返回 MappingType.InputValue
     * @param text 要解析的字符串
     * @return {MappingType} 
     */
    queryTypeByText(text) {
      var _a, _b, _c, _d;
      const info = (_a = `${text ?? ""}`) == null ? void 0 : _a.trim();
      const logical = (_b = this.allMappings.get(MappingType.Logical)) == null ? void 0 : _b.some((item) => item.mappings.map((item2) => item2.name).includes(text));
      const bracket = info === "(" || info === ")";
      if (bracket)
        return MappingType.Brackets;
      if (logical)
        return MappingType.Logical;
      const comparator2 = (_c = this.allMappings.get(MappingType.Comparator)) == null ? void 0 : _c.some((item) => item.mappings.map((item2) => item2.name).includes(text));
      if (comparator2)
        return MappingType.Comparator;
      const mappingField = (_d = this.allMappings.get(MappingType.MappingField)) == null ? void 0 : _d.find((item) => item.mappings.reduce((pre, cur) => {
        return [...pre, cur.name, cur.value];
      }, []).includes(text));
      if (mappingField)
        return MappingType.MappingField;
      return MappingType.InputValue;
    }
    /**
     * 根据当前字符串，推断下一个字符串的类型
     * 如果是undefined,或者null，或者空字符串。那么返回MappingField
     * @param { string } text 
     * @returns {MappingType}
     */
    queryNextType(text) {
      if (text === void 0 || text === null || text === "")
        return MappingType.MappingField;
      if (text === EXIST_TEXT || text === BELONG_TEXT.toLocaleUpperCase())
        return MappingType.Logical;
      const curType = this.queryTypeByText(text);
      const nextMappings = {
        [MappingType.MappingField]: MappingType.Comparator,
        [MappingType.Comparator]: MappingType.InputValue,
        [MappingType.InputValue]: MappingType.Logical,
        [MappingType.Logical]: MappingType.MappingField,
        [MappingType.Brackets]: MappingType.MappingField
      };
      return nextMappings[curType];
    }
    /**
     * 设置显示的列表
     * @param list 
     */
    setCandidateList(list) {
      this.candiDateList = list;
      this.config.onUpdate && this.config.onUpdate(list);
      this.blur();
    }
    /**
     * 根据传入的字段，返回对应的mapping。如果没有找到，返回默认值
     * @param text 
     * @returns 
     */
    queryMappingFieldInfo(text) {
      const mappings = this.allMappings.get(MappingType.MappingField);
      const defaultInfo = {
        name: text,
        value: text,
        type: "string"
        /* STRING */
      };
      const mapping = mappings == null ? void 0 : mappings.find((item) => item.mappings.find((item2) => item2.name === text || item2.value === text));
      const mappingItem = mapping == null ? void 0 : mapping.mappings.find((item) => item.name === text || item.value === text);
      return mappingItem ?? defaultInfo;
    }
    /**
     * 过滤搜索建议，返回光标前最后一个有效字段的类型
     * @param text 
     * @param options 
     * @example "source_ip = 123" return MappingType.InputValue
     * @example "source_ip = 123 an" return MappingType.Logical
     * @example "source_i" return MappingType.MappingField
     * @returns 
     */
    filter(text, _options) {
      const textArray = this.parseToStringArray(text);
      let mappingType = MappingType.MappingField;
      let curMappingType = null;
      let matchedList = null;
      if (textArray.length > 0) {
        const isEndWithSpace = text.endsWith(SPACE);
        if (isEndWithSpace) {
          const lastText = textArray[textArray.length - 1] ?? "";
          curMappingType = this.queryTypeByText(lastText);
          mappingType = this.queryNextType(lastText);
        } else {
          const preText = (textArray == null ? void 0 : textArray[textArray.length - 2]) ?? "";
          mappingType = this.queryNextType(preText);
        }
        let lastIndex = isEndWithSpace ? 1 : 2;
        const queryKey = `${textArray[textArray.length - lastIndex - 1]}-${textArray[textArray.length - lastIndex]}`;
        if (mappingType === MappingType.InputValue && !this.cacheMap.has(queryKey)) {
          const { signal, timeStamp } = this.addToSignalSet();
          const fileInfo = this.queryMappingFieldInfo(textArray[textArray.length - lastIndex - 1]);
          this.config.fetchQuery({
            operator: textArray[textArray.length - lastIndex],
            field: fileInfo,
            value: textArray[textArray.length - lastIndex + 1] ?? ""
          }, {
            canalSignal: signal
          }).then((res) => {
            this.setCandidateList(res);
            this.cacheMap.set(queryKey, res);
          }).finally(() => {
            this.cancelHandleSignal(timeStamp);
          }).catch(() => {
            console.warn("[suggest]手动取消了超时的网络请求，可以忽略该提示。");
          });
        } else {
          this.cancelHandleSignal((/* @__PURE__ */ new Date()).getTime());
          const mappings = mappingType === MappingType.InputValue ? this.cacheMap.get(queryKey) : this.allMappings.get(mappingType);
          if (mappings == null ? void 0 : mappings.length) {
            const queryText = textArray[textArray.length - 1];
            if (isEndWithSpace) {
              matchedList = mappings;
            } else {
              matchedList = mappings.reduce((pre, cur) => {
                const hasMatchField = cur.mappings.find((item) => {
                  var _a;
                  return (_a = item.match) == null ? void 0 : _a.includes(queryText);
                });
                if (hasMatchField) {
                  return [...pre, {
                    ...cur,
                    mappings: cur.mappings.filter((item) => {
                      var _a;
                      return (_a = item.match) == null ? void 0 : _a.includes(queryText);
                    })
                  }];
                }
                return pre;
              }, []);
            }
          }
        }
      }
      this.setCandidateList((matchedList === null ? this.allMappings.get(mappingType) : matchedList) ?? []);
      this.debugLog(curMappingType ?? mappingType);
      return curMappingType ?? mappingType;
    }
    /**
     *  flag :true/ false  开始/结束
     *  uid: 用于标识loading的唯一性
     */
    setLoading(status, uid2) {
      if (status && uid2) {
        this.loadingKey = uid2;
      } else {
        if ((uid2 ?? "") === "") {
          this.loadingKey = null;
        }
        if (this.loadingKey === uid2) {
          this.loadingKey = null;
        }
      }
    }
    /**
     * 解析纯文本字符串，返回对应的formatter 数组
     * @params {string} text
     * @example "source_ip = 123" return [{formatter: Formatter, value: "source_ip"}, {formatter: Formatter, value: "="}, {formatter: Formatter, value: "123"}]
     * @return [{formatter: Formatter, value: string}]
     */
    parseToFormatter(text) {
      const textArray = this.parseToStringArray(text);
      const formatterList = textArray.map((item) => {
        const mappingType = this.queryTypeByText(item);
        const formatter = getFormatter(mappingType);
        return {
          formatter,
          value: item
        };
      });
      return formatterList;
    }
    /**
     * 添加AbortCancel 到signalSet
     * @returns { signal: AbortSignal, timeStamp: number}
     */
    addToSignalSet() {
      const timeStamp = (/* @__PURE__ */ new Date()).getTime();
      const cancel = new AbortController();
      this.signalMap.add({
        t: timeStamp,
        cancel
      });
      this.setLoading(true, timeStamp);
      return { signal: cancel.signal, timeStamp: (/* @__PURE__ */ new Date()).getTime() };
    }
    /**
     * 取消当前请求之前的所有请求(包括当前)
     * @param timeStamp 
     */
    cancelHandleSignal(timeStamp) {
      this.signalMap.forEach((item) => {
        var _a, _b;
        if (item.t <= timeStamp) {
          (_b = (_a = item == null ? void 0 : item.cancel) == null ? void 0 : _a.abort) == null ? void 0 : _b.call(_a);
          this.setLoading(false, item.t);
          this.signalMap.delete(item);
        }
      });
    }
    /**
     * 设置字段mapping
     * @param mappings 
     */
    setMapping(mappingType, mappings) {
      if (this.allMappings.has(mappingType)) {
        this.allMappings.delete(mappingType);
      }
      this.allMappings.set(mappingType, mappings);
    }
    /**
     * 移除搜索建议的缓存值。
     * 
     */
    removeCache() {
      this.cacheMap.clear();
    }
    /**
     * 选中第一个
     * @returns 
     */
    focus() {
      if (this.wordList.length === 0)
        return;
      this.activeIndex = 0;
    }
    /**
     * 搜索建议失去焦点
     * @returns 
     */
    blur() {
      this.activeIndex = -1;
      return true;
    }
    /**
     * 当前选中值向后移动一个，如果是最后一个，则选中第一个
     * @returns 
     */
    toNext() {
      if (this.activeIndex === -1 || this.wordList.length === 0) {
        return false;
      }
      if (this.activeIndex === this.wordList.length - 1) {
        this.focus();
      } else {
        this.activeIndex++;
      }
    }
    /**
     * 当前选中值向前一个，如果是第一个，则失去焦点
     * @returns {boolean}
     */
    toPrevious() {
      if (this.activeIndex === -1 || this.wordList.length === 0) {
        return false;
      }
      if (this.activeIndex === 0) {
        return this.blur();
      } else {
        this.activeIndex--;
      }
      return false;
    }
    /**
     * arrowDown
     * 选择到下一行最近的一个元素,如果已经处于最后一行，选择最后一个元素
     * @returns 
     */
    toNextLine() {
      if (this.activeIndex === -1 && this.wordList.length) {
        return this.focus();
      } else {
        const operationElements = Array.from(this.wordElements).slice(this.activeIndex);
        if (operationElements.length === 0) {
          return this.blur();
        }
        const { offsetTop, offsetLeft } = operationElements[0];
        const nextLineFirstIndex = operationElements.findIndex((item) => {
          return item.offsetTop > offsetTop;
        });
        if (nextLineFirstIndex === -1) {
          this.activeIndex = this.wordList.length - 1;
          return;
        }
        const { offsetTop: nextOffset } = operationElements[nextLineFirstIndex];
        const secondLineFirstIndex = operationElements.findIndex((item) => {
          return item.offsetTop > nextOffset;
        });
        let nextLines = [];
        if (secondLineFirstIndex === -1) {
          nextLines = operationElements.slice(nextLineFirstIndex);
        } else {
          nextLines = operationElements.slice(nextLineFirstIndex, secondLineFirstIndex);
        }
        const nearlyElementIndex = nextLines.findIndex((item) => {
          return item.offsetLeft >= offsetLeft;
        });
        const _index = nearlyElementIndex === -1 ? secondLineFirstIndex === -1 ? this.wordList.length - 1 : this.activeIndex + secondLineFirstIndex - 1 : this.activeIndex + nextLineFirstIndex + nearlyElementIndex;
        this.activeIndex = _index;
        return true;
      }
    }
    /**
     * arrowUP 
     * 按下时，如果在第一行，则失去焦点，返回true
     * @returns {boolean} 是否应该返回焦点，即在第一行时按下了上键
     */
    toPreviousLine() {
      if (this.activeIndex === 0 || this.activeIndex == -1) {
        return this.blur();
      } else {
        const operationElement = Array.from(this.wordElements).slice(0, this.activeIndex + 1).reverse();
        const { offsetTop, offsetLeft } = operationElement[0];
        const previousLineFirstIndex = operationElement.findIndex((item) => {
          return item.offsetTop < offsetTop;
        });
        if (previousLineFirstIndex === -1) {
          this.activeIndex = 0;
          return false;
        }
        const { offsetTop: previousOffsetTop } = operationElement[previousLineFirstIndex];
        const secondLineFirstIndex = operationElement.findIndex((item) => {
          return item.offsetTop < previousOffsetTop;
        });
        let previousLines = [];
        if (secondLineFirstIndex === -1) {
          previousLines = operationElement.slice(previousLineFirstIndex);
        } else {
          previousLines = operationElement.slice(previousLineFirstIndex, secondLineFirstIndex);
        }
        const nearlyElementIndex = previousLines.findIndex((item) => {
          return item.offsetLeft <= offsetLeft;
        });
        if (nearlyElementIndex === -1) {
          this.activeIndex = this.activeIndex - secondLineFirstIndex;
        } else {
          this.activeIndex = operationElement.length - previousLineFirstIndex - nearlyElementIndex - 1;
        }
        return false;
      }
    }
  }
  async function createMEditor(config) {
    const { target, suggest, onSubmit } = config;
    const debugLog = (...args) => {
      if (config.debug) {
        log("MEditor")(...args);
      }
    };
    const adapter = new Adapter(
      getAdapterComponents(),
      (host, root) => {
        const app = createApp(root);
        app.provide(AdapterInjectToken, adapter);
        app.provide(TextbusInjectToken, textBus);
        app.provide(SuggestInjectToken, suggest);
        app.mount(host);
        return () => {
          app.unmount();
        };
      }
    );
    const realTarget = typeof target === "function" ? target() : target;
    const browserModule = new BrowserModule({
      renderTo: () => realTarget,
      adapter,
      autoFocus: true
    });
    const textBus = new Textbus({
      imports: [browserModule],
      components: getComponentList(),
      formatters: getFormatters()
    });
    const rootModel = rootComponent.createInstance(textBus);
    const editor = await textBus.render(rootModel);
    editor.suggest = suggest;
    debugLog("init editor");
    const keyboard = editor.get(Keyboard);
    const selection = editor.get(Selection);
    const commander = editor.get(Commander);
    let isLeaveFocus = false;
    const setActive = (active) => {
      var _a;
      const { endOffset, endSlot } = selection;
      const preText = ((_a = endSlot == null ? void 0 : endSlot.sliceContent(0, endOffset)) == null ? void 0 : _a[0]) ?? "";
      let nextTextIsSpace = ((endSlot == null ? void 0 : endSlot.getContentAtIndex(endOffset)) ?? "") === SPACE;
      const getNextSpaceIndex = () => {
        const str = (endSlot == null ? void 0 : endSlot.sliceContent()[0]).split("");
        let curIndex = str == null ? void 0 : str.length;
        for (let i2 = endOffset; i2 < (str == null ? void 0 : str.length); i2++) {
          if (str[i2] === SPACE) {
            curIndex = i2;
            break;
          }
        }
        return {
          nextSpaceIndex: curIndex,
          updateNextSpaceIndex: curIndex !== str.length
        };
      };
      const formatter = getFormatter(suggest.queryTypeByText(active.value));
      if (preText.endsWith(SPACE)) {
        if (formatter) {
          commander.insert(active.value, formatter, active.value);
        } else {
          commander.insert(active.value);
        }
      } else {
        let preSpaceIndex = preText.lastIndexOf(SPACE);
        const isFirstWord = preSpaceIndex === -1;
        if (isFirstWord) {
          preSpaceIndex = 0;
        }
        const insertValue = isFirstWord ? active.value : ` ${active.value}`;
        const { nextSpaceIndex, updateNextSpaceIndex } = getNextSpaceIndex();
        selection.setBaseAndExtent(endSlot, preSpaceIndex, endSlot, nextSpaceIndex);
        nextTextIsSpace = updateNextSpaceIndex;
        if (formatter) {
          commander.insert(insertValue, formatter, insertValue);
        } else {
          commander.insert(insertValue);
        }
      }
      if (!nextTextIsSpace) {
        commander.insert(SPACE);
      }
      selection.toNext();
      isLeaveFocus = false;
    };
    const registerKeyBoard = () => {
      keyboard.addShortcut({
        keymap: {
          key: "ArrowDown"
        },
        action() {
          if (isLeaveFocus) {
            suggest.toNextLine();
            isLeaveFocus = true;
          } else {
            isLeaveFocus = true;
            suggest.toNextLine();
          }
        }
      });
      keyboard.addShortcut({
        keymap: {
          key: "ArrowUp"
        },
        action() {
          const shouldLeave = suggest.toPreviousLine();
          if (shouldLeave) {
            isLeaveFocus = false;
            editor.focus();
          }
        }
      });
      keyboard.addShortcut({
        keymap: {
          key: ["ArrowLeft", "ArrowRight"]
        },
        action: (key) => {
          switch (key) {
            case "ArrowLeft":
              if (isLeaveFocus) {
                const shouldLeave = suggest.toPrevious();
                if (shouldLeave) {
                  isLeaveFocus = false;
                  editor.focus();
                }
              } else {
                selection.toPrevious();
              }
              break;
            case "ArrowRight":
              if (isLeaveFocus) {
                suggest.toNext();
              } else {
                selection.toNext();
              }
              break;
          }
        }
      });
      keyboard.addShortcut({
        keymap: {
          key: "Enter"
        },
        action() {
          var _a, _b, _c, _d;
          if (isLeaveFocus) {
            const active = suggest.activeItem;
            if (active) {
              setActive(active);
            }
            suggest.blur();
          } else {
            onSubmit(((_d = (_c = (_b = (_a = editor.getJSON()) == null ? void 0 : _a.slots) == null ? void 0 : _b[0]) == null ? void 0 : _c.content) == null ? void 0 : _d[0]) ?? "");
          }
        }
      });
    };
    const choose = (item) => {
      setActive(item);
      suggest.blur();
    };
    const setValue = (str) => {
      selection.selectAll();
      commander.delete();
      const formatterList = suggest.parseToFormatter(str);
      formatterList.forEach(({ formatter, value }) => {
        if (formatter) {
          commander.insert(value, formatter, value);
        } else {
          commander.insert(value);
        }
        commander.insert(SPACE);
      });
    };
    const getValue = () => {
      var _a, _b, _c, _d;
      const res = ((_d = (_c = (_b = (_a = editor.getJSON()) == null ? void 0 : _a.slots) == null ? void 0 : _b[0]) == null ? void 0 : _c.content) == null ? void 0 : _d[0]) ?? "";
      return res;
    };
    const setWidthAutoScroll = () => {
      const editorBox = realTarget;
      const editorWidth = editorBox.clientWidth;
      const scrollWidth = editorBox.scrollWidth;
      if (editorWidth < scrollWidth) {
        editorBox.scrollTo({
          left: scrollWidth,
          behavior: "smooth"
        });
      }
    };
    editor.onChange.subscribe(() => {
      isLeaveFocus = false;
      setWidthAutoScroll();
    });
    registerKeyBoard();
    return {
      editor,
      choose,
      setValue,
      getValue
    };
  }
  exports2.MappingFieldType = MappingFieldType;
  exports2.Suggest = Suggest;
  exports2.createMEditor = createMEditor;
  exports2.parseFetchRes2FieldMapping = parseFetchRes2FieldMapping;
  Object.defineProperty(exports2, Symbol.toStringTag, { value: "Module" });
});
